// Created using compCode v2.0
// 201801030 from composition "A" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// a();
function utopian_201801030_094309() {

// app.beginUndoGroup("A");

try {

// ANIMATION PRESETS START
	// A -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var a_comp_properties = {"name":"A","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var a_comp = app.project.items.addComp(a_comp_properties.name, a_comp_properties.width, a_comp_properties.height, 1, 30, 24);
		a_comp.time = 4.79166666666667;
		a_comp.bgColor = a_comp_properties.bgColor;
		a_comp.label = a_comp_properties.label;
		a_comp.resolutionFactor = [1, 1];
		a_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = a_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "A", varName "a_comp";
	a_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = a_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([222.960998535156,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([577.039001464844,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = a_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "A 01", varName "a01";
	var a01 = a_comp.layers.addShape();
		a01.name = "A 01";
		a01.enabled = false;
		a01.outPoint = 0.58333333333333;
		a01.moveToEnd();
		a01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		a01.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		a01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		a01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		a01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var a01Path = a01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var a01Path_keyTimesArray = [0, 0.375, 0.54166666666667];
			var a01Path_object = {};
				a01Path_object.closed = true;
				a01Path_object.vertices = [[[136, -156.75], [136, 196.75], [-135, 196.75], [-135, -156.75]], [[136, -156.75], [136, 152.75], [-135, 152.75], [-135, -156.75]], [[136, -124.75], [136, 152.75], [-135, 152.75], [-135, -124.75]]];
			addShapeKeyframes(a01Path, a01Path_keyTimesArray, a01Path_object);
			var a01Path_easeInSpeedArray = [0,0,0];
			var a01Path_easeInInfluArray = [0.1,100,0.1];
			var a01Path_easeOutSpeedArray = [0,0,0];
			var a01Path_easeOutInfluArray = [0.1,100,16.666666667];
			var a01Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var a01Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(a01Path, a01Path_keyTimesArray, [a01Path_easeInSpeedArray, a01Path_easeInInfluArray], [a01Path_easeOutSpeedArray, a01Path_easeOutInfluArray], [a01Path_keyInInterpolationType, a01Path_keyOutInterpolationType]);

		a01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		a01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		a01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		a01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		a01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		a01.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		a01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156862745,0.45882352941176,0.73725490196078,1]);
		a01.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1,-25.25]);
		a01.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		a01.selected = false;
	// Add Shape Layer "A 02", varName "a02";
	var a02 = a_comp.layers.addShape();
		a02.name = "A 02";
		a02.outPoint = 0.58333333333333;
		a02.moveToEnd();
		a02.trackMatteType = TrackMatteType.ALPHA;
		a02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		a02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		a02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		a02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		a02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var a02Path = a02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var a02Path_keyTimesArray = [0, 0.375, 0.54166666666667];
			var a02Path_object = {};
				a02Path_object.closed = true;
				a02Path_object.vertices = [[[136, -141.75], [-1.00001525878906, -141.25], [-135, -141.75]], [[136, -101.75], [-1.00001525878906, -101.25], [-135, -101.75]], [[136, -101.75], [2.24993896484375, 36], [-135, -101.75]]];
			addShapeKeyframes(a02Path, a02Path_keyTimesArray, a02Path_object);
			var a02Path_easeInSpeedArray = [0,0,0];
			var a02Path_easeInInfluArray = [16.666666667,100,16.666666667];
			var a02Path_easeOutSpeedArray = [0,0,0];
			var a02Path_easeOutInfluArray = [0.1,100,16.666666667];
			var a02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var a02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(a02Path, a02Path_keyTimesArray, [a02Path_easeInSpeedArray, a02Path_easeInInfluArray], [a02Path_easeOutSpeedArray, a02Path_easeOutInfluArray], [a02Path_keyInInterpolationType, a02Path_keyOutInterpolationType]);

		a02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		a02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		a02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		a02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		a02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		a02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		a02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		a02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1,-25.25]);
		a02.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		a02.property("ADBE Transform Group").property("ADBE Rotate Z").setValue(180);
		a02.selected = false;
	// Add Shape Layer "A 03", varName "a03";
	var a03 = a_comp.layers.addShape();
		a03.name = "A 03";
		a03.enabled = false;
		a03.outPoint = 0.58333333333333;
		a03.moveToEnd();
		a03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		a03.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		a03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		a03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		a03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var a03Path = a03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var a03Path_keyTimesArray = [0, 0.375, 0.54166666666667];
			var a03Path_object = {};
				a03Path_object.closed = true;
				a03Path_object.vertices = [[[136, -156.75], [136, 196.75], [-135, 196.75], [-135, -156.75]], [[136, -156.75], [136, 152.75], [-135, 152.75], [-135, -156.75]], [[136, -124.75], [136, 152.75], [-135, 152.75], [-135, -124.75]]];
			addShapeKeyframes(a03Path, a03Path_keyTimesArray, a03Path_object);
			var a03Path_easeInSpeedArray = [0,0,0];
			var a03Path_easeInInfluArray = [0.1,100,0.1];
			var a03Path_easeOutSpeedArray = [0,0,0];
			var a03Path_easeOutInfluArray = [0.1,100,16.666666667];
			var a03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var a03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(a03Path, a03Path_keyTimesArray, [a03Path_easeInSpeedArray, a03Path_easeInInfluArray], [a03Path_easeOutSpeedArray, a03Path_easeOutInfluArray], [a03Path_keyInInterpolationType, a03Path_keyOutInterpolationType]);

		a03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		a03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		a03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156862745,0.45882352941176,0.73725490196078,1]);
		a03.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1,-25.25]);
		a03.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		a03.selected = false;
	// Add Shape Layer "A 04", varName "a04";
	var a04 = a_comp.layers.addShape();
		a04.name = "A 04";
		a04.outPoint = 0.58333333333333;
		a04.moveToEnd();
		a04.trackMatteType = TrackMatteType.ALPHA;
		a04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		a04.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		a04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		a04.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		a04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var a04Path = a04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var a04Path_keyTimesArray = [0, 0.375, 0.54166666666667];
			var a04Path_object = {};
				a04Path_object.closed = true;
				a04Path_object.vertices = [[[136, -156.75], [1, 180.75], [-135, -156.75]], [[136, -156.75], [-2.00001525878906, 152.75], [-135, -156.75]], [[136, -124.75], [-0.50001525878906, 14.75], [-135, -124.75]]];
			addShapeKeyframes(a04Path, a04Path_keyTimesArray, a04Path_object);
			var a04Path_easeInSpeedArray = [0,0,0];
			var a04Path_easeInInfluArray = [16.666666667,100,16.666666667];
			var a04Path_easeOutSpeedArray = [0,0,0];
			var a04Path_easeOutInfluArray = [0.1,100,16.666666667];
			var a04Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var a04Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(a04Path, a04Path_keyTimesArray, [a04Path_easeInSpeedArray, a04Path_easeInInfluArray], [a04Path_easeOutSpeedArray, a04Path_easeOutInfluArray], [a04Path_keyInInterpolationType, a04Path_keyOutInterpolationType]);

		a04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		a04.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		a04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		a04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		a04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		a04.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		a04.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		a04.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1,-25.25]);
		a04.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		a04.selected = false;
	// Add Shape Layer "A 05", varName "a05";
	var a05 = a_comp.layers.addShape();
		a05.name = "A 05";
		a05.outPoint = 0.58333333333333;
		a05.moveToEnd();
		a05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		a05.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		a05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		a05.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		a05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var a05Path = a05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var a05Path_keyTimesArray = [0, 0.375, 0.54166666666667];
			var a05Path_object = {};
				a05Path_object.closed = true;
				a05Path_object.vertices = [[[136, -156.75], [136, 188.75], [-135, 188.75], [-135, -156.75]], [[136, -156.75], [136, 152.75], [-135, 152.75], [-135, -156.75]], [[136, -124.75], [136, 152.75], [-135, 152.75], [-135, -124.75]]];
			addShapeKeyframes(a05Path, a05Path_keyTimesArray, a05Path_object);
			var a05Path_easeInSpeedArray = [0,0,0];
			var a05Path_easeInInfluArray = [0.1,100,0.1];
			var a05Path_easeOutSpeedArray = [0,0,0];
			var a05Path_easeOutInfluArray = [0.1,100,16.666666667];
			var a05Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var a05Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(a05Path, a05Path_keyTimesArray, [a05Path_easeInSpeedArray, a05Path_easeInInfluArray], [a05Path_easeOutSpeedArray, a05Path_easeOutInfluArray], [a05Path_keyInInterpolationType, a05Path_keyOutInterpolationType]);

		a05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		a05.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		a05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		a05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		a05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		a05.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		a05.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		a05.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1,-25.25]);
		var a05Position1 = a05.property("ADBE Transform Group").property("ADBE Position");
			var a05Position1_keyTimesArray = [0,0.375];
			var a05Position1_valuesArray = [[400,539,0],[400,526,0]];
			a05Position1.setValuesAtTimes(a05Position1_keyTimesArray, a05Position1_valuesArray);
			var a05Position1_inSpatialTangents = [[0,0,0],[0,0,0]];
			var a05Position1_outSpatialTangents = [[0,0,0],[0,0,0]];
			applySpatialTangents(a05Position1, a05Position1_keyTimesArray, a05Position1_inSpatialTangents, a05Position1_outSpatialTangents);
			var a05Position1_easeInSpeedArray = [0,0];
			var a05Position1_easeInInfluArray = [0.1,100];
			var a05Position1_easeOutSpeedArray = [0,0];
			var a05Position1_easeOutInfluArray = [0.1,16.666666667];
			var a05Position1_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var a05Position1_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(a05Position1, a05Position1_keyTimesArray, [a05Position1_easeInSpeedArray, a05Position1_easeInInfluArray], [a05Position1_easeOutSpeedArray, a05Position1_easeOutInfluArray], [a05Position1_keyInInterpolationType, a05Position1_keyOutInterpolationType]);

		a05.selected = false;
	// Add Shape Layer "A 06", varName "a06";
	var a06 = a_comp.layers.addShape();
		a06.name = "A 06";
		a06.inPoint = 0.58333333333333;
		a06.outPoint = 30;
		a06.moveToEnd();
		a06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		a06.property("ADBE Root Vectors Group").property(1).name = "Group 2";
		a06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		a06.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var a06Path = a06.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var a06Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var a06Path_object = {};
				a06Path_object.closed = true;
				a06Path_object.vertices = [[[-40.4332885742188, -11.5308837890625], [39.1344604492188, -11.5308837890625], [-0.6494140625, -92.2222900390625]], [[-45.4332885742188, -7.5308837890625], [44.1344604492188, -7.5308837890625], [-0.6494140625, -108.222290039062]]];
			addShapeKeyframes(a06Path, a06Path_keyTimesArray, a06Path_object);
			var a06Path_easeInSpeedArray = [0,0];
			var a06Path_easeInInfluArray = [0.1,100];
			var a06Path_easeOutSpeedArray = [0,0];
			var a06Path_easeOutInfluArray = [0.1,0.1];
			var a06Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var a06Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(a06Path, a06Path_keyTimesArray, [a06Path_easeInSpeedArray, a06Path_easeInInfluArray], [a06Path_easeOutSpeedArray, a06Path_easeOutInfluArray], [a06Path_keyInInterpolationType, a06Path_keyOutInterpolationType]);

		a06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		a06.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		a06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		a06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		a06.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		a06.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		a06.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var a06Path3 = a06.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var a06Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var a06Path3_object = {};
				a06Path3_object.closed = false;
				a06Path3_object.vertices = [[[56.4091796875, 27.3220825195312], [-57.7122802734375, 27.3220825195312], [-97.2703247070312, 109.015075683594], [95.9671936035156, 109.015075683594], [56.4091186523438, 27.3220825195312]], [[61.4091796875, 31.3220825195312], [-62.7122802734375, 31.3220825195312], [-97.2703247070312, 109.015075683594], [95.9671936035156, 109.015075683594], [61.4091186523438, 31.3220825195312]]];
			addShapeKeyframes(a06Path3, a06Path3_keyTimesArray, a06Path3_object);
			var a06Path3_easeInSpeedArray = [0,0];
			var a06Path3_easeInInfluArray = [0.1,100];
			var a06Path3_easeOutSpeedArray = [0,0];
			var a06Path3_easeOutInfluArray = [0.1,0.1];
			var a06Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var a06Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(a06Path3, a06Path3_keyTimesArray, [a06Path3_easeInSpeedArray, a06Path3_easeInInfluArray], [a06Path3_easeOutSpeedArray, a06Path3_easeOutInfluArray], [a06Path3_keyInInterpolationType, a06Path3_keyOutInterpolationType]);

		a06.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		a06.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		a06.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		a06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		a06.property("ADBE Root Vectors Group").property(3).name = "Group 1";
		a06.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		a06.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var a06Path5 = a06.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var a06Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var a06Path5_object = {};
				a06Path5_object.closed = true;
				a06Path5_object.vertices = [[[20.1518859863281, -138.99609375], [20.1518859863281, -138.99609375], [-0.6494140625, -185.774200439453], [-21.4550170898438, -139.000427246094], [-156.156265258789, 147.863708496094], [154.853134155273, 147.863708496094]], [[20.1518859863281, -154.99609375], [20.1518859863281, -154.99609375], [-0.6494140625, -201.774200439453], [-21.4550170898438, -155.000427246094], [-156.156265258789, 147.863708496094], [154.853134155273, 147.863708496094]]];
			addShapeKeyframes(a06Path5, a06Path5_keyTimesArray, a06Path5_object);
			var a06Path5_easeInSpeedArray = [0,0];
			var a06Path5_easeInInfluArray = [0.1,100];
			var a06Path5_easeOutSpeedArray = [0,0];
			var a06Path5_easeOutInfluArray = [0.1,0.1];
			var a06Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var a06Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(a06Path5, a06Path5_keyTimesArray, [a06Path5_easeInSpeedArray, a06Path5_easeInInfluArray], [a06Path5_easeOutSpeedArray, a06Path5_easeOutInfluArray], [a06Path5_keyInInterpolationType, a06Path5_keyOutInterpolationType]);

		a06.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		a06.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		a06.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		a06.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		a06.selected = false;
	// Apply parents
		a02.setParentWithJump(a05);
		a04.setParentWithJump(a05);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			a02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			a02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			a04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			a04.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			a05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			a05.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			a06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			a06.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			a06.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

a_comp.openInViewer();

return {
	compItem : a_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function applySpatialTangents(property, keyTimesArray, inSpatialTangentsArray, outSpatialTangentsArray) {
	for (var sp = 0, spl = keyTimesArray.length; sp < spl; sp ++) {
		property.setSpatialTangentsAtKey(sp+1, inSpatialTangentsArray[sp], outSpatialTangentsArray[sp]);
	}
}
function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

