// Created using compCode v2.0
// 201801030 from composition "B" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// b();
function utopian_201801030_094309() {

// app.beginUndoGroup("B");

try {

// ANIMATION PRESETS START
	// B -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var b_comp_properties = {"name":"B","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":5,"frameRate":24};
	var b_comp = app.project.items.addComp(b_comp_properties.name, b_comp_properties.width, b_comp_properties.height, 1, 30, 24);
		b_comp.time = 1.25;
		b_comp.bgColor = b_comp_properties.bgColor;
		b_comp.label = b_comp_properties.label;
		b_comp.resolutionFactor = [1, 1];
		b_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = b_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "B", varName "b_comp";
	b_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = b_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([261.555999755859,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([538.942016601562,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = b_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "B 01", varName "b01";
	var b01 = b_comp.layers.addShape();
		b01.name = "B 01";
		b01.outPoint = 0.625;
		b01.moveToEnd();
		b01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		b01.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		b01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		b01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		b01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var b01Path = b01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var b01Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.625];
			var b01Path_object = {};
				b01Path_object.closed = true;
				b01Path_object.vertices = [[[83.390625, 0.25], [83.1953125, 155.25], [-80.9453125, 155.25], [-80.75, 0.25]], [[115.390625, 0.25], [115.1953125, 155.25], [14.8046875, 155.25], [15, 0.25]], [[115.390625, 0.25], [115.1953125, 155.25], [14.8046875, 155.25], [15, 0.25]], [[78.390625, 0.25], [78.1953125, 155.25], [-40.9453125, 155.25], [-40.75, 0.25]]];
			addShapeKeyframes(b01Path, b01Path_keyTimesArray, b01Path_object);
			var b01Path_easeInSpeedArray = [0,0,0,0];
			var b01Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var b01Path_easeOutSpeedArray = [0,0,0,0];
			var b01Path_easeOutInfluArray = [0.1,16.666666667,100,16.666666667];
			var b01Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var b01Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(b01Path, b01Path_keyTimesArray, [b01Path_easeInSpeedArray, b01Path_easeInInfluArray], [b01Path_easeOutSpeedArray, b01Path_easeOutInfluArray], [b01Path_keyInInterpolationType, b01Path_keyOutInterpolationType]);

		b01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		b01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		b01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		b01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		b01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		b01.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		b01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		b01.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-48.8046875,-27.25]);
		b01.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-67.1796875,-27,0]);
		b01.property("ADBE Transform Group").property("ADBE Position").setValue([322.8203125,499,0]);
		b01.selected = false;
	// Add Shape Layer "B 02", varName "b02";
	var b02 = b_comp.layers.addShape();
		b02.name = "B 02";
		b02.outPoint = 0.625;
		b02.moveToEnd();
		b02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		b02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		b02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		b02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		b02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var b02Path = b02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var b02Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.625];
			var b02Path_object = {};
				b02Path_object.closed = true;
				b02Path_object.vertices = [[[83.1953125, -154.75], [83.1953125, 155.25], [-80.9453125, 155.25], [-80.9453125, -154.75]], [[115.1953125, -154.75], [115.1953125, 155.25], [15.0546875, 155.25], [15.0546875, -154.75]], [[116.1953125, -154.75], [115.390625, 0.25], [15, 0.25], [15.8046875, -154.75]], [[102.1953125, -154.75], [102.1953125, 0.25], [-40.9453125, 0.25], [-40.9453125, -154.75]]];
			addShapeKeyframes(b02Path, b02Path_keyTimesArray, b02Path_object);
			var b02Path_easeInSpeedArray = [0,0,0,0];
			var b02Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var b02Path_easeOutSpeedArray = [0,0,0,0];
			var b02Path_easeOutInfluArray = [0.1,16.666666667,100,16.666666667];
			var b02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var b02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(b02Path, b02Path_keyTimesArray, [b02Path_easeInSpeedArray, b02Path_easeInInfluArray], [b02Path_easeOutSpeedArray, b02Path_easeOutInfluArray], [b02Path_keyInInterpolationType, b02Path_keyOutInterpolationType]);

		b02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		b02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		b02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		b02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		b02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		b02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		b02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		b02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-48.8046875,-27.25]);
		b02.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-67.1796875,-27,0]);
		b02.property("ADBE Transform Group").property("ADBE Position").setValue([322.8203125,499,0]);
		b02.selected = false;
	// Add Shape Layer "B 03", varName "b03";
	var b03 = b_comp.layers.addShape();
		b03.name = "B 03";
		b03.inPoint = 0.625;
		b03.outPoint = 30;
		b03.moveToEnd();
		b03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		b03.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		b03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		b03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var b03Path = b03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var b03Path_keyTimesArray = [0.625, 0.95833333333333];
			var b03Path_object = {};
				b03Path_object.closed = false;
				b03Path_object.vertices = [[[-30.7324829101562, -163.284851074219], [-53.4589538574219, -163.284851074219], [-76.3076171875, -163.284851074219], [-76.3076171875, -46.7388610839844], [-30.7324829101562, -46.7388610839844], [-30.7324829101562, -46.8511047363281], [25.3822326660156, -105.011871337891], [-30.7325134277344, -163.181274414062], [-30.7325134277344, -163.284881591797]], [[-16.7324829101562, -163.284851074219], [-39.4589538574219, -163.284851074219], [-78.3076171875, -163.284851074219], [-78.3076171875, -46.7388610839844], [-16.7324829101562, -46.7388610839844], [-16.7324829101562, -46.8511047363281], [39.3822326660156, -105.011871337891], [-16.7325134277344, -163.181274414062], [-16.7325134277344, -163.284881591797]]];
				b03Path_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 31.4501647949219], [31.1739196777344, 1.14385986328125], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 31.4501647949219], [31.1739196777344, 1.14385986328125], [0, 0]]];
				b03Path_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [31.1781921386719, -1.14389038085938], [0, -31.4544677734375], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [31.1781921386719, -1.14389038085938], [0, -31.4544677734375], [0, 0], [0, 0]]];
			addShapeKeyframes(b03Path, b03Path_keyTimesArray, b03Path_object);
			var b03Path_easeInSpeedArray = [0,0];
			var b03Path_easeInInfluArray = [16.666666667,100];
			var b03Path_easeOutSpeedArray = [0,0];
			var b03Path_easeOutInfluArray = [0.1,16.666666667];
			var b03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var b03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(b03Path, b03Path_keyTimesArray, [b03Path_easeInSpeedArray, b03Path_easeInInfluArray], [b03Path_easeOutSpeedArray, b03Path_easeOutInfluArray], [b03Path_keyInInterpolationType, b03Path_keyOutInterpolationType]);

		b03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		b03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		b03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		b03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		b03.property("ADBE Root Vectors Group").property(2).name = "Group 6";
		b03.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		b03.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var b03Path3 = b03.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var b03Path3_keyTimesArray = [0.625, 0.95833333333333];
			var b03Path3_object = {};
				b03Path3_object.closed = false;
				b03Path3_object.vertices = [[[8.36654663085938, -7.89019775390625], [8.36654663085938, -7.89019775390625], [8.11618041992188, -7.89019775390625], [-32.8907470703125, -7.89019775390625], [-63.7394104003906, -7.89019775390625], [8.12049865722656, -7.89019775390625], [-32.886474609375, -7.89019775390625], [-63.735107421875, -7.89019775390625], [-76.3076477050781, -7.89019775390625], [-63.7437744140625, -7.89019775390625], [-76.3076477050781, -7.89019775390625], [-76.3076477050781, 108.6298828125], [-63.7653503417969, 108.6298828125], [8.04705810546875, 108.6298828125], [8.04705810546875, 108.52197265625], [64.1617736816406, 50.3568725585938], [8.366455078125, -7.89022827148438]], [[22.3665466308594, -7.89019775390625], [22.3665466308594, -7.89019775390625], [22.1161804199219, -7.89019775390625], [-18.8907470703125, -7.89019775390625], [-57.7394104003906, -7.89019775390625], [22.1204833984375, -7.89019775390625], [-18.886474609375, -7.89019775390625], [-57.735107421875, -7.89019775390625], [-78.3076477050781, -7.89019775390625], [-57.7437744140625, -7.89019775390625], [-78.3076477050781, -7.89019775390625], [-78.3076477050781, 108.6298828125], [-57.7653503417969, 108.6298828125], [22.0470581054688, 108.6298828125], [22.0470581054688, 108.52197265625], [78.1617736816406, 50.3568725585938], [22.366455078125, -7.89022827148438]]];
				b03Path3_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 31.4544677734375], [31.0228271484375, 1.30789184570312]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 31.4544677734375], [31.0228271484375, 1.30789184570312]]];
				b03Path3_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [31.1738891601562, -1.1439208984375], [0, -31.3465576171875], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [31.1738891601562, -1.1439208984375], [0, -31.3465576171875], [0, 0]]];
			addShapeKeyframes(b03Path3, b03Path3_keyTimesArray, b03Path3_object);
			var b03Path3_easeInSpeedArray = [0,0];
			var b03Path3_easeInInfluArray = [16.666666667,100];
			var b03Path3_easeOutSpeedArray = [0,0];
			var b03Path3_easeOutInfluArray = [0.1,16.666666667];
			var b03Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var b03Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(b03Path3, b03Path3_keyTimesArray, [b03Path3_easeInSpeedArray, b03Path3_easeInInfluArray], [b03Path3_easeOutSpeedArray, b03Path3_easeOutInfluArray], [b03Path3_keyInInterpolationType, b03Path3_keyOutInterpolationType]);

		b03.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		b03.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		b03.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		b03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		b03.property("ADBE Root Vectors Group").property(3).name = "Group 3";
		b03.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		b03.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var b03Path5 = b03.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var b03Path5_keyTimesArray = [0.625, 0.95833333333333];
			var b03Path5_object = {};
				b03Path5_object.closed = false;
				b03Path5_object.vertices = [[[39.8253173828125, -40.6611938476562], [64.2308959960938, -105.007537841797], [-32.8907470703125, -202.129211425781], [-114.012390136719, -202.129211425781], [-115.156280517578, -202.129211425781], [-115.156280517578, 147.508728027344], [-114.012390136719, 147.508728027344], [8.11614990234375, 147.508728027344], [8.11614990234375, 147.452575683594], [103.079528808594, 50.3870391845703], [39.8252563476562, -40.6612548828125]], [[53.8253173828125, -40.6611938476562], [78.2308959960938, -105.007537841797], [-18.8907470703125, -202.129211425781], [-116.012390136719, -202.129211425781], [-117.156280517578, -202.129211425781], [-117.156280517578, 147.508728027344], [-116.012390136719, 147.508728027344], [22.1161499023438, 147.508728027344], [22.1161499023438, 147.452575683594], [117.079528808594, 50.3870391845703], [53.8252563476562, -40.6612548828125]]];
				b03Path5_object.inTangents = [[[0, 0], [0, 24.6861877441406], [53.6370239257812, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 52.9118499755859], [36.9364624023438, 13.7480926513672]], [[0, 0], [0, 24.6861877441406], [53.6370239257812, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 52.9118499755859], [36.9364624023438, 13.7480926513672]]];
				b03Path5_object.outTangents = [[[15.1725463867188, -17.1322631835938], [0, -53.6413879394531], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [52.6399230957031, -1.15252685546875], [0, -41.7320861816406], [0, 0]], [[15.1725463867188, -17.1322631835938], [0, -53.6413879394531], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [52.6399230957031, -1.15252685546875], [0, -41.7320861816406], [0, 0]]];
			addShapeKeyframes(b03Path5, b03Path5_keyTimesArray, b03Path5_object);
			var b03Path5_easeInSpeedArray = [0,0];
			var b03Path5_easeInInfluArray = [16.666666667,100];
			var b03Path5_easeOutSpeedArray = [0,0];
			var b03Path5_easeOutInfluArray = [0.1,16.666666667];
			var b03Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var b03Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(b03Path5, b03Path5_keyTimesArray, [b03Path5_easeInSpeedArray, b03Path5_easeInInfluArray], [b03Path5_easeOutSpeedArray, b03Path5_easeOutInfluArray], [b03Path5_keyInInterpolationType, b03Path5_keyOutInterpolationType]);

		b03.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		b03.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		b03.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		b03.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		b03.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			b01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			b01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			b02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			b02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			b03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			b03.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			b03.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

b_comp.openInViewer();

return {
	compItem : b_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

