// Created using compCode v2.0
// 201801030 from composition "H" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// h();
function utopian_201801030_094309() {

// app.beginUndoGroup("H");

try {

// ANIMATION PRESETS START
	// H -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var h_comp_properties = {"name":"H","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":5,"frameRate":24};
	var h_comp = app.project.items.addComp(h_comp_properties.name, h_comp_properties.width, h_comp_properties.height, 1, 30, 24);
		h_comp.time = 0.875;
		h_comp.bgColor = h_comp_properties.bgColor;
		h_comp.label = h_comp_properties.label;
		h_comp.resolutionFactor = [1, 1];
		h_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = h_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "H", varName "h_comp";
	h_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = h_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([223.210006713867,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([576.789978027344,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = h_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "H 01", varName "h01";
	var h01 = h_comp.layers.addShape();
		h01.name = "H 01";
		h01.outPoint = 0.58333333333333;
		h01.moveToEnd();
		h01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		h01.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		h01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		h01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		h01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var h01Path = h01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var h01Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var h01Path_object = {};
				h01Path_object.closed = true;
				h01Path_object.vertices = [[[135.646484375, -2.57421875], [135.402465820312, 134.967041015625], [-135.890502929688, 134.967041015625], [-135.646484375, -2.57421875]], [[135.646484375, -2.57421875], [135.29296875, 151.07421875], [-136, 151.07421875], [-135.646484375, -2.57421875]], [[135.646484375, -2.57421875], [135.29296875, 151.07421875], [-136, 151.07421875], [-135.646484375, -2.57421875]], [[135.646484375, -2.57421875], [135.29296875, 136.07421875], [-136, 136.07421875], [-135.646484375, -2.57421875]]];
			addShapeKeyframes(h01Path, h01Path_keyTimesArray, h01Path_object);
			var h01Path_easeInSpeedArray = [0,0,0,0];
			var h01Path_easeInInfluArray = [16.666666667,100,0.1,0.1];
			var h01Path_easeOutSpeedArray = [0,0,0,0];
			var h01Path_easeOutInfluArray = [0.1,0.1,100,0.1];
			var h01Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var h01Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(h01Path, h01Path_keyTimesArray, [h01Path_easeInSpeedArray, h01Path_easeInInfluArray], [h01Path_easeOutSpeedArray, h01Path_easeOutInfluArray], [h01Path_keyInInterpolationType, h01Path_keyOutInterpolationType]);

		h01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		h01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		h01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		h01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		h01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		h01.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		h01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		h01.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([0.646484375,-23.07421875]);
		h01.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([0.646484375,-23.07421875,0]);
		h01.property("ADBE Transform Group").property("ADBE Position").setValue([0.646484375,-23.07421875,0]);
		h01.selected = false;
	// Add Shape Layer "H 02", varName "h02";
	var h02 = h_comp.layers.addShape();
		h02.name = "H 02";
		h02.outPoint = 0.58333333333333;
		h02.moveToEnd();
		h02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		h02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		h02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		h02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		h02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var h02Path = h02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var h02Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var h02Path_object = {};
				h02Path_object.closed = true;
				h02Path_object.vertices = [[[135.402465820312, -141.179244995117], [135.402465820312, 134.967056274414], [-135.890502929688, 134.967056274414], [-135.890502929688, -141.179244995117]], [[135.29296875, -160.07421875], [135.29296875, 151.07421875], [-136, 151.07421875], [-136, -160.07421875]], [[135.29296875, -160.07421875], [135.29296875, 151.07421875], [-136, 151.07421875], [-136, -160.07421875]], [[135.29296875, -145.07421875], [135.29296875, 136.07421875], [-136, 136.07421875], [-136, -145.07421875]]];
			addShapeKeyframes(h02Path, h02Path_keyTimesArray, h02Path_object);
			var h02Path_easeInSpeedArray = [0,0,0,0];
			var h02Path_easeInInfluArray = [16.666666667,100,0.1,0.1];
			var h02Path_easeOutSpeedArray = [0,0,0,0];
			var h02Path_easeOutInfluArray = [0.1,0.1,100,0.1];
			var h02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var h02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(h02Path, h02Path_keyTimesArray, [h02Path_easeInSpeedArray, h02Path_easeInInfluArray], [h02Path_easeOutSpeedArray, h02Path_easeOutInfluArray], [h02Path_keyInInterpolationType, h02Path_keyOutInterpolationType]);

		h02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		h02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		h02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		h02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		h02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		h02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		h02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		h02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([0.646484375,-23.07421875]);
		h02.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([0.646484375,-23.07421875,0]);
		var h02Position1 = h02.property("ADBE Transform Group").property("ADBE Position");
			var h02Position1_keyTimesArray = [0,0.33333333333333];
			var h02Position1_valuesArray = [[0.64648437499994,-14.3986707313282,0],[0.646484375,-23.07421875,0]];
			h02Position1.setValuesAtTimes(h02Position1_keyTimesArray, h02Position1_valuesArray);
			var h02Position1_inSpatialTangents = [[0,0,0],[0,0,0]];
			var h02Position1_outSpatialTangents = [[0,0,0],[0,0,0]];
			applySpatialTangents(h02Position1, h02Position1_keyTimesArray, h02Position1_inSpatialTangents, h02Position1_outSpatialTangents);
			var h02Position1_easeInSpeedArray = [0,0];
			var h02Position1_easeInInfluArray = [99.8134665776677,100];
			var h02Position1_easeOutSpeedArray = [0,0];
			var h02Position1_easeOutInfluArray = [0.1,0.1];
			var h02Position1_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var h02Position1_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(h02Position1, h02Position1_keyTimesArray, [h02Position1_easeInSpeedArray, h02Position1_easeInInfluArray], [h02Position1_easeOutSpeedArray, h02Position1_easeOutInfluArray], [h02Position1_keyInInterpolationType, h02Position1_keyOutInterpolationType]);

		h02.selected = false;
	// Add Shape Layer "H 03", varName "h03";
	var h03 = h_comp.layers.addShape();
		h03.name = "H 03";
		h03.inPoint = 0.58333333333333;
		h03.outPoint = 30;
		h03.moveToEnd();
		h03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		h03.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		h03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		h03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var h03Path = h03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var h03Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var h03Path_object = {};
				h03Path_object.closed = true;
				h03Path_object.vertices = [[[-116.307586669922, -7.69729614257812], [-116.307586669922, 105.745056152344], [-77.4589233398438, 105.745056152344], [-77.4589233398438, 64.8964233398438], [77.9356689453125, 64.8964233398438], [77.9356689453125, 105.745056152344], [116.784301757812, 105.745056152344], [116.784301757812, -7.69732666015625]], [[-116.307586669922, -7.69729614257812], [-116.307586669922, 108.745056152344], [-77.4589233398438, 108.745056152344], [-77.4589233398438, 69.8964233398438], [77.9356689453125, 69.8964233398438], [77.9356689453125, 108.745056152344], [116.784301757812, 108.745056152344], [116.784301757812, -7.69732666015625]]];
			addShapeKeyframes(h03Path, h03Path_keyTimesArray, h03Path_object);
			var h03Path_easeInSpeedArray = [0,0];
			var h03Path_easeInInfluArray = [0.1,100];
			var h03Path_easeOutSpeedArray = [0,0];
			var h03Path_easeOutInfluArray = [0.1,0.1];
			var h03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var h03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(h03Path, h03Path_keyTimesArray, [h03Path_easeInSpeedArray, h03Path_easeInInfluArray], [h03Path_easeOutSpeedArray, h03Path_easeOutInfluArray], [h03Path_keyInInterpolationType, h03Path_keyOutInterpolationType]);

		h03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		h03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		h03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		h03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		h03.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		h03.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		h03.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var h03Path3 = h03.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var h03Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var h03Path3_object = {};
				h03Path3_object.closed = true;
				h03Path3_object.vertices = [[[77.9356689453125, -160.195526123047], [77.9356689453125, -160.195526123047], [77.9356689453125, -119.346862792969], [-77.4589538574219, -119.346862792969], [-77.4589538574219, -160.195556640625], [-116.3076171875, -160.195556640625], [-116.3076171875, -46.6495666503906], [116.784301757812, -46.6495666503906], [116.784301757812, -160.195587158203]], [[77.9356689453125, -163.195526123047], [77.9356689453125, -163.195526123047], [77.9356689453125, -124.346862792969], [-77.4589538574219, -124.346862792969], [-77.4589538574219, -163.195556640625], [-116.3076171875, -163.195556640625], [-116.3076171875, -46.6495666503906], [116.784301757812, -46.6495666503906], [116.784301757812, -163.195587158203]]];
			addShapeKeyframes(h03Path3, h03Path3_keyTimesArray, h03Path3_object);
			var h03Path3_easeInSpeedArray = [0,0];
			var h03Path3_easeInInfluArray = [0.1,100];
			var h03Path3_easeOutSpeedArray = [0,0];
			var h03Path3_easeOutInfluArray = [0.1,0.1];
			var h03Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var h03Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(h03Path3, h03Path3_keyTimesArray, [h03Path3_easeInSpeedArray, h03Path3_easeInInfluArray], [h03Path3_easeOutSpeedArray, h03Path3_easeOutInfluArray], [h03Path3_keyInInterpolationType, h03Path3_keyOutInterpolationType]);

		h03.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		h03.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		h03.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		h03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		h03.property("ADBE Root Vectors Group").property(3).name = "Group 3";
		h03.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		h03.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var h03Path5 = h03.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var h03Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var h03Path5_object = {};
				h03Path5_object.closed = true;
				h03Path5_object.vertices = [[[39.0870361328125, -199.044189453125], [39.0870361328125, -160.195526123047], [-38.6102905273438, -160.195526123047], [-38.6102905273438, -199.044219970703], [-155.156280517578, -199.044219970703], [-155.156280517578, 144.593688964844], [-38.6102905273438, 144.593688964844], [-38.6102905273438, 105.744995117188], [39.0869750976562, 105.744995117188], [39.0869750976562, 144.593688964844], [155.632934570312, 144.593688964844], [155.632934570312, -199.044281005859]], [[39.0870361328125, -202.044189453125], [39.0870361328125, -163.195526123047], [-38.6102905273438, -163.195526123047], [-38.6102905273438, -202.044219970703], [-155.156280517578, -202.044219970703], [-155.156280517578, 147.593688964844], [-38.6102905273438, 147.593688964844], [-38.6102905273438, 108.744995117188], [39.0869750976562, 108.744995117188], [39.0869750976562, 147.593688964844], [155.632934570312, 147.593688964844], [155.632934570312, -202.044281005859]]];
			addShapeKeyframes(h03Path5, h03Path5_keyTimesArray, h03Path5_object);
			var h03Path5_easeInSpeedArray = [0,0];
			var h03Path5_easeInInfluArray = [0.1,100];
			var h03Path5_easeOutSpeedArray = [0,0];
			var h03Path5_easeOutInfluArray = [0.1,0.1];
			var h03Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var h03Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(h03Path5, h03Path5_keyTimesArray, [h03Path5_easeInSpeedArray, h03Path5_easeInInfluArray], [h03Path5_easeOutSpeedArray, h03Path5_easeOutInfluArray], [h03Path5_keyInInterpolationType, h03Path5_keyOutInterpolationType]);

		h03.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		h03.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		h03.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		h03.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		h03.selected = false;
	// Apply parents
		h01.setParentWithJump(h02);
		h02.setParentWithJump(h03);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			h01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			h01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			h02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			h02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			h03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			h03.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			h03.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

h_comp.openInViewer();

return {
	compItem : h_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function applySpatialTangents(property, keyTimesArray, inSpatialTangentsArray, outSpatialTangentsArray) {
	for (var sp = 0, spl = keyTimesArray.length; sp < spl; sp ++) {
		property.setSpatialTangentsAtKey(sp+1, inSpatialTangentsArray[sp], outSpatialTangentsArray[sp]);
	}
}
function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

