// Created using compCode v2.0
// 201801030 from composition "M" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// m();
function utopian_201801030_094309() {

// app.beginUndoGroup("M");

try {

// ANIMATION PRESETS START
	// M -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var m_comp_properties = {"name":"M","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var m_comp = app.project.items.addComp(m_comp_properties.name, m_comp_properties.width, m_comp_properties.height, 1, 30, 24);
		m_comp.time = 0.875;
		m_comp.bgColor = m_comp_properties.bgColor;
		m_comp.label = m_comp_properties.label;
		m_comp.resolutionFactor = [1, 1];
		m_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = m_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "M", varName "m_comp";
	m_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = m_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([187.104995727539,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([613.393005371094,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = m_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "M 01", varName "m01";
	var m01 = m_comp.layers.addShape();
		m01.name = "M 01";
		m01.startTime = 0.04166666666667;
		m01.inPoint = 0;
		m01.outPoint = 0.41666666666667;
		m01.moveToEnd();
		m01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		m01.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		m01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		m01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		m01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var m01Path = m01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var m01Path_keyTimesArray = [-0.08333333333333, 0, 0.33333333333333];
			var m01Path_object = {};
				m01Path_object.closed = true;
				m01Path_object.vertices = [[[46.7890625, 115.8203125], [46.89453125, 168.1796875], [-47.89453125, 168.1796875], [-48, 115.8203125]], [[47.1314849853516, 3.32083129882812], [46.89453125, 240.508758544922], [-47.89453125, 240.508758544922], [-46.9673309326172, 3.32083129882812]], [[46.7890625, 66.8203125], [46.89453125, 158.1796875], [-47.89453125, 158.1796875], [-47, 66.8203125]]];
			addShapeKeyframes(m01Path, m01Path_keyTimesArray, m01Path_object);
			var m01Path_easeInSpeedArray = [0,0,0];
			var m01Path_easeInInfluArray = [16.666666667,16.666666667,100];
			var m01Path_easeOutSpeedArray = [0,0,0];
			var m01Path_easeOutInfluArray = [16.666666667,0.1,0.1];
			var m01Path_keyInInterpolationType = [KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var m01Path_keyOutInterpolationType = [KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(m01Path, m01Path_keyTimesArray, [m01Path_easeInSpeedArray, m01Path_easeInInfluArray], [m01Path_easeOutSpeedArray, m01Path_easeOutInfluArray], [m01Path_keyInInterpolationType, m01Path_keyOutInterpolationType]);

		m01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		m01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		m01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		m01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		m01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		m01.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		m01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		m01.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		m01.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		m01.selected = false;
	// Add Shape Layer "M 02", varName "m02";
	var m02 = m_comp.layers.addShape();
		m02.name = "M 02";
		m02.startTime = 0.04166666666667;
		m02.inPoint = 0;
		m02.outPoint = 0.41666666666667;
		m02.moveToEnd();
		m02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		m02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		m02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		m02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		m02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var m02Path = m02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var m02Path_keyTimesArray = [-0.08333333333333, 0, 0.33333333333333];
			var m02Path_object = {};
				m02Path_object.closed = true;
				m02Path_object.vertices = [[[46.7890625, 115.8203125], [46.89453125, 168.1796875], [-47.89453125, 168.1796875], [-48, 115.8203125]], [[47.89453125, -138.1796875], [46.89453125, 243.1796875], [-47.89453125, 243.1796875], [-46.89453125, -138.1796875]], [[47.89453125, -151.1796875], [46.89453125, 158.1796875], [-47.89453125, 158.1796875], [-46.89453125, -151.1796875]]];
			addShapeKeyframes(m02Path, m02Path_keyTimesArray, m02Path_object);
			var m02Path_easeInSpeedArray = [0,0,0];
			var m02Path_easeInInfluArray = [16.666666667,0.1,100];
			var m02Path_easeOutSpeedArray = [0,0,0];
			var m02Path_easeOutInfluArray = [16.666666667,0.1,0.1];
			var m02Path_keyInInterpolationType = [KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var m02Path_keyOutInterpolationType = [KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(m02Path, m02Path_keyTimesArray, [m02Path_easeInSpeedArray, m02Path_easeInInfluArray], [m02Path_easeOutSpeedArray, m02Path_easeOutInfluArray], [m02Path_keyInInterpolationType, m02Path_keyOutInterpolationType]);

		m02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		m02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		m02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		m02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		m02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		m02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		m02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		m02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		m02.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		m02.selected = false;
	// Add Shape Layer "M 03", varName "m03";
	var m03 = m_comp.layers.addShape();
		m03.name = "M 03";
		m03.startTime = 0.04166666666667;
		m03.inPoint = 0.41666666666667;
		m03.outPoint = 0.58333333333333;
		m03.moveToEnd();
		m03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		m03.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		m03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		m03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		m03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var m03Path = m03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var m03Path_keyTimesArray = [0.41666666666667, 0.54166666666667];
			var m03Path_object = {};
				m03Path_object.closed = true;
				m03Path_object.vertices = [[[46.7890625, 66.8203125], [46.89453125, 158.1796875], [-47.89453125, 158.1796875], [-47, 66.8203125]], [[51.7890625, 66.8203125], [46.89453125, 158.1796875], [-47.89453125, 158.1796875], [-51, 66.8203125]]];
			addShapeKeyframes(m03Path, m03Path_keyTimesArray, m03Path_object);
			var m03Path_easeInSpeedArray = [0,0];
			var m03Path_easeInInfluArray = [0.1,0.1];
			var m03Path_easeOutSpeedArray = [0,0];
			var m03Path_easeOutInfluArray = [100,0.1];
			var m03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var m03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(m03Path, m03Path_keyTimesArray, [m03Path_easeInSpeedArray, m03Path_easeInInfluArray], [m03Path_easeOutSpeedArray, m03Path_easeOutInfluArray], [m03Path_keyInInterpolationType, m03Path_keyOutInterpolationType]);

		m03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		m03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		m03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		m03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		m03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		m03.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		m03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		m03.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		m03.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		m03.selected = false;
	// Add Shape Layer "M 04", varName "m04";
	var m04 = m_comp.layers.addShape();
		m04.name = "M 04";
		m04.startTime = 0.20833333333333;
		m04.inPoint = 0.41666666666667;
		m04.outPoint = 0.58333333333333;
		m04.moveToEnd();
		m04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		m04.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		m04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		m04.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		m04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var m04Path = m04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var m04Path_keyTimesArray = [0.41666666666667, 0.54166666666667];
			var m04Path_object = {};
				m04Path_object.closed = true;
				m04Path_object.vertices = [[[48.89453125, -151.1796875], [46.89453125, 158.1796875], [-47.89453125, 158.1796875], [-45.89453125, -151.1796875]], [[62.89453125, -151.1796875], [46.89453125, 158.1796875], [-47.89453125, 158.1796875], [-31.89453125, -151.1796875]]];
			addShapeKeyframes(m04Path, m04Path_keyTimesArray, m04Path_object);
			var m04Path_easeInSpeedArray = [0,0];
			var m04Path_easeInInfluArray = [0.1,0.1];
			var m04Path_easeOutSpeedArray = [0,0];
			var m04Path_easeOutInfluArray = [100,16.666666667];
			var m04Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var m04Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(m04Path, m04Path_keyTimesArray, [m04Path_easeInSpeedArray, m04Path_easeInInfluArray], [m04Path_easeOutSpeedArray, m04Path_easeOutInfluArray], [m04Path_keyInInterpolationType, m04Path_keyOutInterpolationType]);

		m04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		m04.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		m04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		m04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		m04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		m04.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		m04.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		m04.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		m04.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		m04.selected = false;
	// Add Shape Layer "M 05", varName "m05";
	var m05 = m_comp.layers.addShape();
		m05.name = "M 05";
		m05.startTime = 0.20833333333333;
		m05.inPoint = 0.41666666666667;
		m05.outPoint = 0.58333333333333;
		m05.moveToEnd();
		m05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		m05.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		m05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		m05.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		m05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var m05Path = m05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var m05Path_keyTimesArray = [0.41666666666667, 0.54166666666667];
			var m05Path_object = {};
				m05Path_object.closed = true;
				m05Path_object.vertices = [[[45.89453125, -151.1796875], [46.89453125, 158.1796875], [-47.89453125, 158.1796875], [-48.89453125, -151.1796875]], [[31.89453125, -151.1796875], [46.89453125, 158.1796875], [-47.89453125, 158.1796875], [-62.89453125, -151.1796875]]];
			addShapeKeyframes(m05Path, m05Path_keyTimesArray, m05Path_object);
			var m05Path_easeInSpeedArray = [0,0];
			var m05Path_easeInInfluArray = [0.1,0.1];
			var m05Path_easeOutSpeedArray = [0,0];
			var m05Path_easeOutInfluArray = [100,16.666666667];
			var m05Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var m05Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(m05Path, m05Path_keyTimesArray, [m05Path_easeInSpeedArray, m05Path_easeInInfluArray], [m05Path_easeOutSpeedArray, m05Path_easeOutInfluArray], [m05Path_keyInInterpolationType, m05Path_keyOutInterpolationType]);

		m05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		m05.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		m05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		m05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		m05.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		m05.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		m05.selected = false;
	// Add Shape Layer "M 06", varName "m06";
	var m06 = m_comp.layers.addShape();
		m06.name = "M 06";
		m06.startTime = -0.08333333333333;
		m06.inPoint = 0.58333333333333;
		m06.outPoint = 30;
		m06.moveToEnd();
		m06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		m06.property("ADBE Root Vectors Group").property(1).name = "Group 2";
		m06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		m06.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var m06Path = m06.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var m06Path_keyTimesArray = [-0.08333333333333, 0.54166666666667, 0.58333333333333, 0.91666666666667];
			var m06Path_object = {};
				m06Path_object.closed = true;
				m06Path_object.vertices = [[[42.7313537597656, 108.7451171875], [137.979614257812, -163.195556640625], [59.6822814941406, -163.195556640625], [-30.882568359375, 107.652954101562], [-31.2408447265625, 108.745056152344]], [[42.7313537597656, 108.7451171875], [127.979614257812, -163.195556640625], [49.6822814941406, -163.195556640625], [-30.882568359375, 107.652954101562], [-31.2408447265625, 108.745056152344]], [[42.7313537597656, 108.7451171875], [132.979629516602, -163.195556640625], [54.6823120117188, -163.195556640625], [-30.882568359375, 107.652954101562], [-31.2408447265625, 108.745056152344]], [[42.7313537597656, 108.7451171875], [137.979614257812, -163.195556640625], [59.6822814941406, -163.195556640625], [-30.882568359375, 107.652954101562], [-31.2408447265625, 108.745056152344]]];
			addShapeKeyframes(m06Path, m06Path_keyTimesArray, m06Path_object);
			var m06Path_easeInSpeedArray = [0,0,0,0];
			var m06Path_easeInInfluArray = [16.666666667,16.666666667,0.1,100];
			var m06Path_easeOutSpeedArray = [0,0,0,0];
			var m06Path_easeOutInfluArray = [16.666666667,16.666666667,0.1,16.666666667];
			var m06Path_keyInInterpolationType = [KeyframeInterpolationType.LINEAR,KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var m06Path_keyOutInterpolationType = [KeyframeInterpolationType.HOLD,KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(m06Path, m06Path_keyTimesArray, [m06Path_easeInSpeedArray, m06Path_easeInInfluArray], [m06Path_easeOutSpeedArray, m06Path_easeOutInfluArray], [m06Path_keyInInterpolationType, m06Path_keyOutInterpolationType]);

		m06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		m06.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		m06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		m06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		m06.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		m06.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		m06.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var m06Path3 = m06.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var m06Path3_keyTimesArray = [-0.08333333333333, 0.54166666666667, 0.58333333333333, 0.91666666666667];
			var m06Path3_object = {};
				m06Path3_object.closed = true;
				m06Path3_object.vertices = [[[152.370910644531, 108.7451171875], [152.370910644531, -96.3585815429688], [84.7742309570312, 108.745056152344]], [[101.370910644531, 108.490234375], [142.370910644531, -96.3585815429688], [84.7742309570312, 108.745056152344]], [[138.370941162109, 108.7451171875], [147.37092590332, -96.3585815429688], [84.7742309570312, 108.745056152344]], [[152.370910644531, 108.7451171875], [152.370910644531, -96.3585815429688], [84.7742309570312, 108.745056152344]]];
			addShapeKeyframes(m06Path3, m06Path3_keyTimesArray, m06Path3_object);
			var m06Path3_easeInSpeedArray = [0,0,0,0];
			var m06Path3_easeInInfluArray = [16.666666667,16.666666667,0.1,100];
			var m06Path3_easeOutSpeedArray = [0,0,0,0];
			var m06Path3_easeOutInfluArray = [16.666666667,16.666666667,0.1,16.666666667];
			var m06Path3_keyInInterpolationType = [KeyframeInterpolationType.LINEAR,KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var m06Path3_keyOutInterpolationType = [KeyframeInterpolationType.HOLD,KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(m06Path3, m06Path3_keyTimesArray, [m06Path3_easeInSpeedArray, m06Path3_easeInInfluArray], [m06Path3_easeOutSpeedArray, m06Path3_easeOutInfluArray], [m06Path3_keyInInterpolationType, m06Path3_keyOutInterpolationType]);

		m06.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		m06.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		m06.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		m06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		m06.property("ADBE Root Vectors Group").property(3).name = "Group 4";
		m06.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		m06.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var m06Path5 = m06.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var m06Path5_keyTimesArray = [-0.08333333333333, 0.54166666666667, 0.58333333333333, 0.91666666666667];
			var m06Path5_object = {};
				m06Path5_object.closed = true;
				m06Path5_object.vertices = [[[-153.307586669922, 108.7451171875], [-77.077880859375, 108.7451171875], [-153.307601928711, -96.3585815429688]], [[-92.3075866699219, 108.490234375], [-77.077880859375, 108.7451171875], [-143.307601928711, -96.3585815429688]], [[-139.307571411133, 108.7451171875], [-77.077880859375, 108.7451171875], [-148.307601928711, -96.3585815429688]], [[-153.307586669922, 108.7451171875], [-77.077880859375, 108.7451171875], [-153.307601928711, -96.3585815429688]]];
			addShapeKeyframes(m06Path5, m06Path5_keyTimesArray, m06Path5_object);
			var m06Path5_easeInSpeedArray = [0,0,0,0];
			var m06Path5_easeInInfluArray = [16.666666667,16.666666667,0.1,100];
			var m06Path5_easeOutSpeedArray = [0,0,0,0];
			var m06Path5_easeOutInfluArray = [16.666666667,16.666666667,0.1,16.666666667];
			var m06Path5_keyInInterpolationType = [KeyframeInterpolationType.LINEAR,KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var m06Path5_keyOutInterpolationType = [KeyframeInterpolationType.HOLD,KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(m06Path5, m06Path5_keyTimesArray, [m06Path5_easeInSpeedArray, m06Path5_easeInInfluArray], [m06Path5_easeOutSpeedArray, m06Path5_easeOutInfluArray], [m06Path5_keyInInterpolationType, m06Path5_keyOutInterpolationType]);

		m06.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		m06.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		m06.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		m06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		m06.property("ADBE Root Vectors Group").property(4).name = "Group 5";
		m06.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		m06.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var m06Path7 = m06.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var m06Path7_keyTimesArray = [-0.08333333333333, 0.54166666666667, 0.58333333333333, 0.91666666666667];
			var m06Path7_object = {};
				m06Path7_object.closed = true;
				m06Path7_object.vertices = [[[-17.1991577148438, -55.4120788574219], [-17.1948852539062, -55.425048828125], [-22.3185729980469, -71.3012084960938], [-52.1198120117188, -163.195556640625], [-134.604187011719, -163.195556640625], [-54.7140502929688, 60.339599609375]], [[-17.1991577148438, -55.4120788574219], [-17.1948852539062, -55.425048828125], [-12.3185729980469, -71.3012084960938], [-42.1198120117188, -163.195556640625], [-124.604187011719, -163.195556640625], [-54.7140502929688, 60.339599609375]], [[-17.1991577148438, -55.4120788574219], [-17.1948852539062, -55.425048828125], [-22.3185729980469, -71.3012084960938], [-47.1198120117188, -163.195556640625], [-129.604187011719, -163.195556640625], [-54.7140502929688, 60.339599609375]], [[-17.1991577148438, -55.4120788574219], [-17.1948852539062, -55.425048828125], [-22.3185729980469, -71.3012084960938], [-52.1198120117188, -163.195556640625], [-134.604187011719, -163.195556640625], [-54.7140502929688, 60.339599609375]]];
			addShapeKeyframes(m06Path7, m06Path7_keyTimesArray, m06Path7_object);
			var m06Path7_easeInSpeedArray = [0,0,0,0];
			var m06Path7_easeInInfluArray = [16.666666667,16.666666667,0.1,100];
			var m06Path7_easeOutSpeedArray = [0,0,0,0];
			var m06Path7_easeOutInfluArray = [16.666666667,16.666666667,0.1,16.666666667];
			var m06Path7_keyInInterpolationType = [KeyframeInterpolationType.LINEAR,KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var m06Path7_keyOutInterpolationType = [KeyframeInterpolationType.HOLD,KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(m06Path7, m06Path7_keyTimesArray, [m06Path7_easeInSpeedArray, m06Path7_easeInInfluArray], [m06Path7_easeOutSpeedArray, m06Path7_easeOutInfluArray], [m06Path7_keyInInterpolationType, m06Path7_keyOutInterpolationType]);

		m06.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		m06.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		m06.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		m06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		m06.property("ADBE Root Vectors Group").property(5).name = "Group 1";
		m06.property("ADBE Root Vectors Group").property(5).property(2).addProperty("ADBE Vector Shape - Group");
		m06.property("ADBE Root Vectors Group").property(5).property(2).property(1).name = "Path 1";
		var m06Path9 = m06.property("ADBE Root Vectors Group").property(5).property(2).property(1).property("ADBE Vector Shape");
			var m06Path9_keyTimesArray = [-0.08333333333333, 0.54166666666667, 0.58333333333333, 0.91666666666667];
			var m06Path9_object = {};
				m06Path9_object.closed = true;
				m06Path9_object.vertices = [[[2.794921875, -116.391540527344], [-24.9775390625, -202.044219970703], [-192.156265258789, -202.044219970703], [-192.156265258789, 147.593688964844], [191.219467163086, 147.593688964844], [191.219467163086, -202.044250488281], [30.9558715820312, -202.281677246094]], [[2.794921875, -116.391540527344], [-14.9775390625, -202.044219970703], [-182.156265258789, -202.044219970703], [-131.156265258789, 147.338806152344], [140.219467163086, 147.338806152344], [181.219467163086, -202.044250488281], [20.9558715820312, -202.281677246094]], [[2.79490661621094, -116.391540527344], [-19.9775390625, -202.044219970703], [-187.156265258789, -202.044219970703], [-178.15625, 147.593688964844], [177.219467163086, 147.593688964844], [186.219467163086, -202.044250488281], [25.9558715820312, -202.281677246094]], [[2.794921875, -116.391540527344], [-24.9775390625, -202.044219970703], [-192.156265258789, -202.044219970703], [-192.156265258789, 147.593688964844], [191.219467163086, 147.593688964844], [191.219467163086, -202.044250488281], [30.9558715820312, -202.281677246094]]];
			addShapeKeyframes(m06Path9, m06Path9_keyTimesArray, m06Path9_object);
			var m06Path9_easeInSpeedArray = [0,0,0,0];
			var m06Path9_easeInInfluArray = [16.666666667,16.666666667,0.1,100];
			var m06Path9_easeOutSpeedArray = [0,0,0,0];
			var m06Path9_easeOutInfluArray = [16.666666667,16.666666667,0.1,16.666666667];
			var m06Path9_keyInInterpolationType = [KeyframeInterpolationType.LINEAR,KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var m06Path9_keyOutInterpolationType = [KeyframeInterpolationType.HOLD,KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(m06Path9, m06Path9_keyTimesArray, [m06Path9_easeInSpeedArray, m06Path9_easeInInfluArray], [m06Path9_easeOutSpeedArray, m06Path9_easeOutInfluArray], [m06Path9_keyInInterpolationType, m06Path9_keyOutInterpolationType]);

		m06.property("ADBE Root Vectors Group").property(5).property(2).addProperty("ADBE Vector Graphic - Fill");
		m06.property("ADBE Root Vectors Group").property(5).property(2).property(2).name = "Fill 1";
		m06.property("ADBE Root Vectors Group").property(5).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		m06.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		m06.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			m01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			m01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			m02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			m02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			m03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			m03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			m04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			m04.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			m05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			m06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			m06.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			m06.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			m06.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			m06.property("ADBE Root Vectors Group").property(5).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

m_comp.openInViewer();

return {
	compItem : m_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

