// Created using compCode v2.0
// 201801030 from composition "O" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// o();
function utopian_201801030_094309() {

// app.beginUndoGroup("O");

try {

// ANIMATION PRESETS START
	// O -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var o_comp_properties = {"name":"O","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":6,"frameRate":24};
	var o_comp = app.project.items.addComp(o_comp_properties.name, o_comp_properties.width, o_comp_properties.height, 1, 30, 24);
		o_comp.time = 0.45833333333333;
		o_comp.bgColor = o_comp_properties.bgColor;
		o_comp.label = o_comp_properties.label;
		o_comp.resolutionFactor = [1, 1];
		o_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = o_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "O", varName "o_comp";
	o_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = o_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([200.302001953125,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([599.697998046875,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = o_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "O 01", varName "o01";
	var o01 = o_comp.layers.addShape();
		o01.name = "O 01";
		o01.startTime = 0.04166666666667;
		o01.inPoint = 0;
		o01.outPoint = 0.58333333333333;
		o01.moveToEnd();
		o01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		o01.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		o01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		o01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		o01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var o01Path = o01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var o01Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var o01Path_object = {};
				o01Path_object.closed = true;
				o01Path_object.vertices = [[[46.7890625, 64.5703125], [46.7890625, 128.9296875], [-48, 128.9296875], [-48, 64.5703125]], [[47.89453125, 2.5703125], [46.7890625, 156.9296875], [-48, 156.9296875], [-46.89453125, 2.5703125]], [[47.89453125, 2.5703125], [46.7890625, 156.9296875], [-48, 156.9296875], [-46.89453125, 2.5703125]], [[52.89453125, 2.5703125], [40.7890625, 156.9296875], [-62, 156.9296875], [-49.89453125, 2.5703125]]];
			addShapeKeyframes(o01Path, o01Path_keyTimesArray, o01Path_object);
			var o01Path_easeInSpeedArray = [0,0,0,0];
			var o01Path_easeInInfluArray = [0.1,100,100,0.1];
			var o01Path_easeOutSpeedArray = [0,0,0,0];
			var o01Path_easeOutInfluArray = [0.1,0.1,0.1,16.666666667];
			var o01Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var o01Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(o01Path, o01Path_keyTimesArray, [o01Path_easeInSpeedArray, o01Path_easeInInfluArray], [o01Path_easeOutSpeedArray, o01Path_easeOutInfluArray], [o01Path_keyInInterpolationType, o01Path_keyOutInterpolationType]);

		o01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		o01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		o01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		o01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		o01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		o01.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		o01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		o01.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		o01.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		o01.selected = false;
	// Add Shape Layer "O 02", varName "o02";
	var o02 = o_comp.layers.addShape();
		o02.name = "O 02";
		o02.startTime = 0.04166666666667;
		o02.inPoint = 0;
		o02.outPoint = 0.58333333333333;
		o02.moveToEnd();
		o02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		o02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		o02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		o02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		o02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var o02Path = o02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var o02Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var o02Path_object = {};
				o02Path_object.closed = true;
				o02Path_object.vertices = [[[47.89453125, -125.1796875], [47.578125, -60.8203125], [-47.2109375, -60.8203125], [-46.89453125, -125.1796875]], [[47.89453125, -153.1796875], [46.7890625, 1.1796875], [-48, 1.1796875], [-46.89453125, -153.1796875]], [[47.89453125, -153.1796875], [46.7890625, 1.1796875], [-48, 1.1796875], [-46.89453125, -153.1796875]], [[64.89453125, -153.1796875], [52.7890625, 1.1796875], [-50, 1.1796875], [-37.89453125, -153.1796875]]];
			addShapeKeyframes(o02Path, o02Path_keyTimesArray, o02Path_object);
			var o02Path_easeInSpeedArray = [0,0,0,0];
			var o02Path_easeInInfluArray = [0.1,100,100,0.1];
			var o02Path_easeOutSpeedArray = [0,0,0,0];
			var o02Path_easeOutInfluArray = [0.1,0.1,0.1,16.666666667];
			var o02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var o02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(o02Path, o02Path_keyTimesArray, [o02Path_easeInSpeedArray, o02Path_easeInInfluArray], [o02Path_easeOutSpeedArray, o02Path_easeOutInfluArray], [o02Path_keyInInterpolationType, o02Path_keyOutInterpolationType]);

		o02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		o02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		o02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		o02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		o02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		o02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		o02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		o02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		o02.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([6.052734375,-125.1796875,0]);
		o02.property("ADBE Transform Group").property("ADBE Position").setValue([6.052734375,-124.1796875,0]);
		o02.selected = false;
	// Add Shape Layer "O 03", varName "o03";
	var o03 = o_comp.layers.addShape();
		o03.name = "O 03";
		o03.startTime = 0.04166666666667;
		o03.inPoint = 0;
		o03.outPoint = 0.58333333333333;
		o03.moveToEnd();
		o03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		o03.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		o03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		o03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		o03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var o03Path = o03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var o03Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var o03Path_object = {};
				o03Path_object.closed = true;
				o03Path_object.vertices = [[[47.89453125, -125.1796875], [46.89453125, 129.1796875], [-47.89453125, 129.1796875], [-46.89453125, -125.1796875]], [[47.89453125, -153.1796875], [46.89453125, 157.1796875], [-47.89453125, 157.1796875], [-46.89453125, -153.1796875]], [[47.89453125, -153.1796875], [46.89453125, 157.1796875], [-47.89453125, 157.1796875], [-46.89453125, -153.1796875]], [[59.89453125, -153.1796875], [34.89453125, 157.1796875], [-59.89453125, 157.1796875], [-34.89453125, -153.1796875]]];
			addShapeKeyframes(o03Path, o03Path_keyTimesArray, o03Path_object);
			var o03Path_easeInSpeedArray = [0,0,0,0];
			var o03Path_easeInInfluArray = [0.1,100,0.1,0.1];
			var o03Path_easeOutSpeedArray = [0,0,0,0];
			var o03Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var o03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var o03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(o03Path, o03Path_keyTimesArray, [o03Path_easeInSpeedArray, o03Path_easeInInfluArray], [o03Path_easeOutSpeedArray, o03Path_easeOutInfluArray], [o03Path_keyInInterpolationType, o03Path_keyOutInterpolationType]);

		o03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		o03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		o03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		o03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		o03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		o03.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		o03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		o03.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		o03.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		o03.selected = false;
	// Add Shape Layer "O 04", varName "o04";
	var o04 = o_comp.layers.addShape();
		o04.name = "O 04";
		o04.inPoint = 0.58333333333333;
		o04.outPoint = 30;
		o04.moveToEnd();
		o04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		o04.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		o04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		o04.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var o04Path = o04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var o04Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var o04Path_object = {};
				o04Path_object.closed = false;
				o04Path_object.vertices = [[[131.420043945312, -8.9381103515625], [-131.09326171875, -8.9381103515625], [0.163330078125, 109.938781738281], [131.419982910156, -8.9381103515625]], [[137.420043945312, -8.9381103515625], [-137.09326171875, -8.9381103515625], [0.163330078125, 109.938781738281], [137.419982910156, -8.9381103515625]]];
				o04Path_object.inTangents = [[[0, 0], [0, 0], [-69.8671264648438, 0], [-9.61724853515625, 67.2081909179688]], [[0, 0], [0, 0], [-69.8671264648438, 0], [-9.61724853515625, 67.2081909179688]]];
				o04Path_object.outTangents = [[[0, 0], [9.6171875, 67.2081909179688], [69.8671569824219, 0], [0, 0]], [[0, 0], [9.6171875, 67.2081909179688], [69.8671569824219, 0], [0, 0]]];
			addShapeKeyframes(o04Path, o04Path_keyTimesArray, o04Path_object);
			var o04Path_easeInSpeedArray = [0,0];
			var o04Path_easeInInfluArray = [0.1,100];
			var o04Path_easeOutSpeedArray = [0,0];
			var o04Path_easeOutInfluArray = [0.1,0.1];
			var o04Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var o04Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(o04Path, o04Path_keyTimesArray, [o04Path_easeInSpeedArray, o04Path_easeInInfluArray], [o04Path_easeOutSpeedArray, o04Path_easeOutInfluArray], [o04Path_keyInInterpolationType, o04Path_keyOutInterpolationType]);

		o04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		o04.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		o04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		o04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		o04.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		o04.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		o04.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var o04Path3 = o04.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var o04Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var o04Path3_object = {};
				o04Path3_object.closed = false;
				o04Path3_object.vertices = [[[0.1590576171875, -167.436309814453], [-131.097564697266, -48.5594177246094], [131.415649414062, -48.5594177246094], [0.15902709960938, -167.436340332031]], [[0.1590576171875, -167.436309814453], [-137.097564697266, -48.5594177246094], [137.415649414062, -48.5594177246094], [0.15902709960938, -167.436340332031]]];
				o04Path3_object.inTangents = [[[0, 0], [9.61721801757812, -67.2124938964844], [0, 0], [69.8671569824219, 0]], [[0, 0], [9.61721801757812, -67.2124938964844], [0, 0], [69.8671569824219, 0]]];
				o04Path3_object.outTangents = [[[-69.8671264648438, 0], [0, 0], [-9.6129150390625, -67.2125244140625], [0, 0]], [[-69.8671264648438, 0], [0, 0], [-9.6129150390625, -67.2125244140625], [0, 0]]];
			addShapeKeyframes(o04Path3, o04Path3_keyTimesArray, o04Path3_object);
			var o04Path3_easeInSpeedArray = [0,0];
			var o04Path3_easeInInfluArray = [0.1,100];
			var o04Path3_easeOutSpeedArray = [0,0];
			var o04Path3_easeOutInfluArray = [0.1,0.1];
			var o04Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var o04Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(o04Path3, o04Path3_keyTimesArray, [o04Path3_easeInSpeedArray, o04Path3_easeInInfluArray], [o04Path3_easeOutSpeedArray, o04Path3_easeOutInfluArray], [o04Path3_keyInInterpolationType, o04Path3_keyOutInterpolationType]);

		o04.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		o04.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		o04.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		o04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		o04.property("ADBE Root Vectors Group").property(3).name = "Group 5";
		o04.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		o04.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var o04Path5 = o04.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var o04Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var o04Path5_object = {};
				o04Path5_object.closed = false;
				o04Path5_object.vertices = [[[0.1590576171875, -207.066284179688], [-172.156265258789, -28.7466430664062], [0.1590576171875, 149.568725585938], [172.474349975586, -28.7466430664062], [0.15904235839844, -207.066314697266]], [[0.1590576171875, -207.066284179688], [-178.156265258789, -28.7466430664062], [0.1590576171875, 149.568725585938], [178.474349975586, -28.7466430664062], [0.15902709960938, -207.066314697266]]];
				o04Path5_object.inTangents = [[[0, 0], [0, -98.4813232421875], [-98.4770202636719, 0], [0, 98.4813842773438], [98.4856567382812, 0]], [[0, 0], [0, -98.4813232421875], [-98.4770202636719, 0], [0, 98.4813842773438], [98.4856719970703, 0]]];
				o04Path5_object.outTangents = [[[-98.4770202636719, 0], [0, 98.47705078125], [98.4813690185547, 0], [0, -98.4813537597656], [0, 0]], [[-98.4770202636719, 0], [0, 98.47705078125], [98.4813690185547, 0], [0, -98.4813537597656], [0, 0]]];
			addShapeKeyframes(o04Path5, o04Path5_keyTimesArray, o04Path5_object);
			var o04Path5_easeInSpeedArray = [0,0];
			var o04Path5_easeInInfluArray = [0.1,100];
			var o04Path5_easeOutSpeedArray = [0,0];
			var o04Path5_easeOutInfluArray = [0.1,0.1];
			var o04Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var o04Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(o04Path5, o04Path5_keyTimesArray, [o04Path5_easeInSpeedArray, o04Path5_easeInInfluArray], [o04Path5_easeOutSpeedArray, o04Path5_easeOutInfluArray], [o04Path5_keyInInterpolationType, o04Path5_keyOutInterpolationType]);

		o04.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		o04.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		o04.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		o04.property("ADBE Transform Group").property("ADBE Position").setValue([400,529,0]);
		o04.selected = false;
	// Apply parents
		o01.setParentWithJump(o04);
		o02.setParentWithJump(o04);
		o03.setParentWithJump(o04);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			o01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			o01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			o02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			o02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			o03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			o03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			o04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			o04.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			o04.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

o_comp.openInViewer();

return {
	compItem : o_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

