// Created using compCode v2.0
// 201801030 from composition "P" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// p();
function utopian_201801030_094309() {

// app.beginUndoGroup("P");

try {

// ANIMATION PRESETS START
	// P -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var p_comp_properties = {"name":"P","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":6,"frameRate":24};
	var p_comp = app.project.items.addComp(p_comp_properties.name, p_comp_properties.width, p_comp_properties.height, 1, 30, 24);
		p_comp.time = 0.25;
		p_comp.bgColor = p_comp_properties.bgColor;
		p_comp.label = p_comp_properties.label;
		p_comp.resolutionFactor = [1, 1];
		p_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = p_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "P", varName "p_comp";
	p_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = p_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([246.11799621582,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([554.380004882812,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = p_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "P 01", varName "p01";
	var p01 = p_comp.layers.addShape();
		p01.name = "P 01";
		p01.outPoint = 0.58333333333333;
		p01.moveToEnd();
		p01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		p01.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		p01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		p01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var p01Path = p01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var p01Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var p01Path_object = {};
				p01Path_object.closed = false;
				p01Path_object.vertices = [[[14.9909362792969, -119.143737792969], [6.82839965820312, -119.143737792969], [6.82839965820312, -118.902038574219], [6.82839965820312, 36.3717346191406], [14.9909057617188, 36.3717346191406], [92.688232421875, -39.9658813476562], [14.9909057617188, -119.143798828125]], [[14.9909362792969, -47.3937377929688], [6.82839965820312, -47.3937377929688], [6.82839965820312, -47.1520385742188], [6.82839965820312, 108.121734619141], [14.9909057617188, 108.121734619141], [92.688232421875, 31.7841186523438], [14.9909057617188, -47.393798828125]], [[14.9909362792969, -47.3937377929688], [6.82839965820312, -47.3937377929688], [6.82839965820312, -47.1520385742188], [6.82839965820312, 108.121734619141], [14.9909057617188, 108.121734619141], [92.688232421875, 31.7841186523438], [14.9909057617188, -47.393798828125]], [[14.9909362792969, -46.3937377929688], [6.82839965820312, -46.3937377929688], [6.82839965820312, -46.1520385742188], [6.82839965820312, 104.121734619141], [14.9909057617188, 104.121734619141], [92.688232421875, 28.7841186523438], [14.9909057617188, -46.393798828125]]];
				p01Path_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]]];
				p01Path_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]]];
			addShapeKeyframes(p01Path, p01Path_keyTimesArray, p01Path_object);
			var p01Path_easeInSpeedArray = [0,0,0,0];
			var p01Path_easeInInfluArray = [0.1,100,16.666666667,0.1];
			var p01Path_easeOutSpeedArray = [0,0,0,0];
			var p01Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var p01Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var p01Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(p01Path, p01Path_keyTimesArray, [p01Path_easeInSpeedArray, p01Path_easeInInfluArray], [p01Path_easeOutSpeedArray, p01Path_easeOutInfluArray], [p01Path_keyInInterpolationType, p01Path_keyOutInterpolationType]);

		p01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		p01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		p01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		p01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		p01.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		p01.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		p01.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var p01Path3 = p01.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var p01Path3_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var p01Path3_object = {};
				p01Path3_object.closed = false;
				p01Path3_object.vertices = [[[14.2226104736328, -158.221160888672], [-30.5, -158.221160888672], [-30.437744140625, 75.7691650390625], [6.828369140625, 75.2247314453125], [14.2225646972656, 75.2247314453125], [131.536865234375, -40.7299041748047], [14.2225494384766, -158.221221923828]], [[14.2226104736328, -86.4711608886719], [-30.5, -86.4711608886719], [-30.437744140625, 147.519165039062], [6.828369140625, 146.974731445312], [14.2225646972656, 146.974731445312], [131.536865234375, 31.0201110839844], [14.2225494384766, -86.4712219238281]], [[14.2226104736328, -86.4711608886719], [-30.5, -86.4711608886719], [-30.437744140625, 147.519165039062], [6.828369140625, 146.974731445312], [14.2225646972656, 146.974731445312], [131.536865234375, 31.0201110839844], [14.2225494384766, -86.4712219238281]], [[14.2226104736328, -85.4711608886719], [-30.5, -85.4711608886719], [-30.437744140625, 143.519165039062], [6.828369140625, 142.974731445312], [14.2225646972656, 142.974731445312], [131.536865234375, 28.0201110839844], [14.2225494384766, -85.4712219238281]]];
				p01Path3_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7866058349609], [64.7909698486328, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7865905761719], [64.7909698486328, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7865905761719], [64.7909698486328, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7865905761719], [64.7909698486328, 0]]];
				p01Path3_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [64.7909545898438, 0], [0, -64.7909393310547], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909545898438, 0], [0, -64.7909545898438], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909545898438, 0], [0, -64.7909545898438], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909545898438, 0], [0, -64.7909545898438], [0, 0]]];
			addShapeKeyframes(p01Path3, p01Path3_keyTimesArray, p01Path3_object);
			var p01Path3_easeInSpeedArray = [0,0,0,0];
			var p01Path3_easeInInfluArray = [0.1,100,16.666666667,0.1];
			var p01Path3_easeOutSpeedArray = [0,0,0,0];
			var p01Path3_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var p01Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var p01Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(p01Path3, p01Path3_keyTimesArray, [p01Path3_easeInSpeedArray, p01Path3_easeInInfluArray], [p01Path3_easeOutSpeedArray, p01Path3_easeOutInfluArray], [p01Path3_keyInInterpolationType, p01Path3_keyOutInterpolationType]);

		p01.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		p01.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		p01.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		p01.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([51.5184326171875,-85.2260284423828,0]);
		p01.property("ADBE Transform Group").property("ADBE Position").setValue([51.5184326171875,-83.2260284423828,0]);
		p01.selected = false;
	// Add Shape Layer "P 02", varName "p02";
	var p02 = p_comp.layers.addShape();
		p02.name = "P 02";
		p02.outPoint = 0.58333333333333;
		p02.moveToEnd();
		p02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		p02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		p02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		p02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		p02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var p02Path = p02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var p02Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var p02Path_object = {};
				p02Path_object.closed = true;
				p02Path_object.vertices = [[[-8.462890625, -110], [-8.462890625, 85.3671875], [-112.537109375, 85.18359375], [-112.537109375, -110.18359375]], [[-9.462890625, -156], [-9.462890625, 156.3671875], [-112.537109375, 156.18359375], [-112.537109375, -156.18359375]], [[-9.462890625, -156], [-9.462890625, 156.3671875], [-112.537109375, 156.18359375], [-112.537109375, -156.18359375]], [[-9.462890625, -153.25], [-9.462890625, 153.1171875], [-112.537109375, 152.93359375], [-112.537109375, -153.43359375]]];
			addShapeKeyframes(p02Path, p02Path_keyTimesArray, p02Path_object);
			var p02Path_easeInSpeedArray = [0,0,0,0];
			var p02Path_easeInInfluArray = [0.1,100,100,16.666666667];
			var p02Path_easeOutSpeedArray = [0,0,0,0];
			var p02Path_easeOutInfluArray = [0.1,0.1,0.1,16.666666667];
			var p02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var p02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(p02Path, p02Path_keyTimesArray, [p02Path_easeInSpeedArray, p02Path_easeInInfluArray], [p02Path_easeOutSpeedArray, p02Path_easeOutInfluArray], [p02Path_keyInInterpolationType, p02Path_keyOutInterpolationType]);

		p02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		p02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		p02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		p02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		p02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		p02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		p02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		p02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1.462890625,-26.81640625]);
		p02.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		p02.selected = false;
	// Add Shape Layer "P 03", varName "p03";
	var p03 = p_comp.layers.addShape();
		p03.name = "P 03";
		p03.outPoint = 0.58333333333333;
		p03.moveToEnd();
		p03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		p03.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		p03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		p03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		p03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var p03Path = p03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var p03Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var p03Path_object = {};
				p03Path_object.closed = true;
				p03Path_object.vertices = [[[112.537109375, -110.18359375], [112.537109375, 85.18359375], [-112.537109375, 85.18359375], [-112.537109375, -110.18359375]], [[112.537109375, -156.18359375], [112.537109375, 156.18359375], [-112.537109375, 156.18359375], [-112.537109375, -156.18359375]], [[112.537109375, -156.18359375], [112.537109375, 156.18359375], [-112.537109375, 156.18359375], [-112.537109375, -156.18359375]], [[112.537109375, -153.18359375], [112.537109375, 153.18359375], [-112.537109375, 153.18359375], [-112.537109375, -153.18359375]]];
			addShapeKeyframes(p03Path, p03Path_keyTimesArray, p03Path_object);
			var p03Path_easeInSpeedArray = [0,0,0,0];
			var p03Path_easeInInfluArray = [0.1,100,16.666666667,0.1];
			var p03Path_easeOutSpeedArray = [0,0,0,0];
			var p03Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var p03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var p03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(p03Path, p03Path_keyTimesArray, [p03Path_easeInSpeedArray, p03Path_easeInInfluArray], [p03Path_easeOutSpeedArray, p03Path_easeOutInfluArray], [p03Path_keyInInterpolationType, p03Path_keyOutInterpolationType]);

		p03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		p03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		p03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		p03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		p03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		p03.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		p03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		p03.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1.462890625,-26.81640625]);
		p03.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		p03.selected = false;
	// Add Shape Layer "P 05", varName "p05";
	var p05 = p_comp.layers.addShape();
		p05.name = "P 05";
		p05.inPoint = 0.58333333333333;
		p05.outPoint = 30;
		p05.moveToEnd();
		p05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		p05.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		p05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		p05.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var p05Path = p05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var p05Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var p05Path_object = {};
				p05Path_object.closed = false;
				p05Path_object.vertices = [[[14.9909362792969, -154.143737792969], [6.82839965820312, -154.143737792969], [6.82839965820312, -153.902038574219], [6.82839965820312, -2.62826538085938], [14.9909057617188, -2.62826538085938], [92.688232421875, -78.9658813476562], [14.9909057617188, -154.143798828125]], [[14.9909362792969, -163.143737792969], [6.82839965820312, -163.143737792969], [6.82839965820312, -162.902038574219], [6.82839965820312, -7.62826538085938], [14.9909057617188, -7.62826538085938], [92.688232421875, -83.9658813476562], [14.9909057617188, -163.143798828125]]];
				p05Path_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]]];
				p05Path_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]]];
			addShapeKeyframes(p05Path, p05Path_keyTimesArray, p05Path_object);
			var p05Path_easeInSpeedArray = [0,0];
			var p05Path_easeInInfluArray = [0.1,100];
			var p05Path_easeOutSpeedArray = [0,0];
			var p05Path_easeOutInfluArray = [0.1,0.1];
			var p05Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var p05Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(p05Path, p05Path_keyTimesArray, [p05Path_easeInSpeedArray, p05Path_easeInInfluArray], [p05Path_easeOutSpeedArray, p05Path_easeOutInfluArray], [p05Path_keyInInterpolationType, p05Path_keyOutInterpolationType]);

		p05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		p05.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		p05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		p05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		p05.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		p05.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		p05.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var p05Path3 = p05.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var p05Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var p05Path3_object = {};
				p05Path3_object.closed = false;
				p05Path3_object.vertices = [[[-32.0245666503906, -153.902008056641], [-93.0558166503906, -153.902008056641], [-93.0558166503906, 99.2745971679688], [-32.0245666503906, 99.2745971679688], [-32.0245666503906, -153.902038574219]], [[-32.0245666503906, -162.902008056641], [-93.0558166503906, -162.902008056641], [-93.0558166503906, 108.274597167969], [-32.0245666503906, 108.274597167969], [-32.0245666503906, -162.902038574219]]];
			addShapeKeyframes(p05Path3, p05Path3_keyTimesArray, p05Path3_object);
			var p05Path3_easeInSpeedArray = [0,0];
			var p05Path3_easeInInfluArray = [0.1,100];
			var p05Path3_easeOutSpeedArray = [0,0];
			var p05Path3_easeOutInfluArray = [0.1,0.1];
			var p05Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var p05Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(p05Path3, p05Path3_keyTimesArray, [p05Path3_easeInSpeedArray, p05Path3_easeInInfluArray], [p05Path3_easeOutSpeedArray, p05Path3_easeOutInfluArray], [p05Path3_keyInInterpolationType, p05Path3_keyOutInterpolationType]);

		p05.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		p05.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		p05.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		p05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		p05.property("ADBE Root Vectors Group").property(3).name = "Group 3";
		p05.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		p05.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var p05Path5 = p05.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var p05Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var p05Path5_object = {};
				p05Path5_object.closed = false;
				p05Path5_object.vertices = [[[14.2225952148438, -193.221160888672], [-133.156280517578, -193.221160888672], [-133.156280517578, 99.2745971679688], [-133.156280517578, 138.59375], [-93.0558166503906, 138.59375], [-32.0245971679688, 138.59375], [-1.74853515625, 138.59375], [6.828369140625, 138.59375], [6.828369140625, 36.2247467041016], [14.2225646972656, 36.2247467041016], [131.536865234375, -79.7299041748047], [14.2225341796875, -193.221221923828]], [[14.2225952148438, -202.221160888672], [-133.156280517578, -202.221160888672], [-133.156280517578, 108.274597167969], [-133.156280517578, 147.59375], [-93.0558166503906, 147.59375], [-32.0245971679688, 147.59375], [-1.74853515625, 147.59375], [6.828369140625, 147.59375], [6.828369140625, 31.2247314453125], [14.2225646972656, 31.2247314453125], [131.536865234375, -84.7298889160156], [14.2225341796875, -202.221221923828]]];
				p05Path5_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7865600585938], [64.7909545898438, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7865905761719], [64.7909545898438, 0]]];
				p05Path5_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909393310547], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909545898438], [0, 0]]];
			addShapeKeyframes(p05Path5, p05Path5_keyTimesArray, p05Path5_object);
			var p05Path5_easeInSpeedArray = [0,0];
			var p05Path5_easeInInfluArray = [0.1,100];
			var p05Path5_easeOutSpeedArray = [0,0];
			var p05Path5_easeOutInfluArray = [0.1,0.1];
			var p05Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var p05Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(p05Path5, p05Path5_keyTimesArray, [p05Path5_easeInSpeedArray, p05Path5_easeInInfluArray], [p05Path5_easeOutSpeedArray, p05Path5_easeOutInfluArray], [p05Path5_keyInInterpolationType, p05Path5_keyOutInterpolationType]);

		p05.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		p05.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		p05.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		p05.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		p05.selected = false;
	// Apply parents
		p01.setParentWithJump(p05);
		p02.setParentWithJump(p05);
		p03.setParentWithJump(p05);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			p01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			p01.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			p02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			p02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			p03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			p03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			p05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			p05.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			p05.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

p_comp.openInViewer();

return {
	compItem : p_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

