// Created using compCode v2.0
// 201801030 from composition "U" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// u();
function utopian_201801030_094309() {

// app.beginUndoGroup("U");

try {

// ANIMATION PRESETS START
	// U -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var u_comp_properties = {"name":"U","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var u_comp = app.project.items.addComp(u_comp_properties.name, u_comp_properties.width, u_comp_properties.height, 1, 30, 24);
		u_comp.time = 0.29166666666667;
		u_comp.bgColor = u_comp_properties.bgColor;
		u_comp.label = u_comp_properties.label;
		u_comp.resolutionFactor = [1, 1];
		u_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = u_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "U", varName "u_comp";
	u_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = u_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([241.884994506836,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([558.114990234375,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = u_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "U 01", varName "u01";
	var u01 = u_comp.layers.addShape();
		u01.name = "U 01";
		u01.outPoint = 0.58333333333333;
		u01.moveToEnd();
		u01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		u01.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		u01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		u01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		u01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var u01Path = u01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var u01Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var u01Path_object = {};
				u01Path_object.closed = true;
				u01Path_object.vertices = [[[118.298828125, -143.162109375], [118.298828125, 239.162109375], [-114.298828125, 239.162109375], [-114.298828125, -143.162109375]], [[118.298828125, -155.162109375], [118.298828125, 155.162109375], [-114.298828125, 155.162109375], [-114.298828125, -155.162109375]], [[118.298828125, -155.162109375], [118.298828125, 155.162109375], [-114.298828125, 155.162109375], [-114.298828125, -155.162109375]], [[118.298828125, -143.162109375], [118.298828125, 119.162109375], [-114.298828125, 119.162109375], [-114.298828125, -143.162109375]]];
			addShapeKeyframes(u01Path, u01Path_keyTimesArray, u01Path_object);
			var u01Path_easeInSpeedArray = [0,0,0,0];
			var u01Path_easeInInfluArray = [0.1,100,0.1,0.1];
			var u01Path_easeOutSpeedArray = [0,0,0,0];
			var u01Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var u01Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var u01Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(u01Path, u01Path_keyTimesArray, [u01Path_easeInSpeedArray, u01Path_easeInInfluArray], [u01Path_easeOutSpeedArray, u01Path_easeOutInfluArray], [u01Path_keyInInterpolationType, u01Path_keyOutInterpolationType]);

		u01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		u01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		u01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		u01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		u01.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-2.701171875,-26.837890625]);
		u01.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		u01.selected = false;
	// Add Shape Layer "U 02", varName "u02";
	var u02 = u_comp.layers.addShape();
		u02.name = "U 02";
		u02.enabled = false;
		u02.outPoint = 0.58333333333333;
		u02.moveToEnd();
		u02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		u02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		u02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		u02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		u02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var u02Path = u02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var u02Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var u02Path_object = {};
				u02Path_object.closed = true;
				u02Path_object.vertices = [[[118.298828125, -143.162109375], [118.298828125, 239.162109375], [-114.298828125, 239.162109375], [-114.298828125, -143.162109375]], [[118.298828125, -155.162109375], [118.298828125, 155.162109375], [-114.298828125, 155.162109375], [-114.298828125, -155.162109375]], [[118.298828125, -155.162109375], [118.298828125, 155.162109375], [-114.298828125, 155.162109375], [-114.298828125, -155.162109375]], [[118.298828125, -143.162109375], [118.298828125, 119.162109375], [-114.298828125, 119.162109375], [-114.298828125, -143.162109375]]];
			addShapeKeyframes(u02Path, u02Path_keyTimesArray, u02Path_object);
			var u02Path_easeInSpeedArray = [0,0,0,0];
			var u02Path_easeInInfluArray = [0.1,100,0.1,0.1];
			var u02Path_easeOutSpeedArray = [0,0,0,0];
			var u02Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var u02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var u02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(u02Path, u02Path_keyTimesArray, [u02Path_easeInSpeedArray, u02Path_easeInInfluArray], [u02Path_easeOutSpeedArray, u02Path_easeOutInfluArray], [u02Path_keyInInterpolationType, u02Path_keyOutInterpolationType]);

		u02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		u02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		u02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		u02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-2.701171875,-26.837890625]);
		u02.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		u02.selected = false;
	// Add Shape Layer "U 03", varName "u03";
	var u03 = u_comp.layers.addShape();
		u03.name = "U 03";
		u03.outPoint = 0.58333333333333;
		u03.moveToEnd();
		u03.trackMatteType = TrackMatteType.ALPHA;
		u03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		u03.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		u03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		u03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var u03Path = u03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var u03Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var u03Path_object = {};
				u03Path_object.closed = true;
				u03Path_object.vertices = [[[-137.15625, -258.728332519531], [-137.15625, -41.9226531982422], [-0.54278564453125, 94.6908264160156], [-0.54278564453125, 94.6908264160156], [136.074951171875, -41.9226531982422], [136.074951171875, -258.728363037109]], [[-137.15625, -201.585479736328], [-137.15625, 15.2201995849609], [-0.54278564453125, 151.833679199219], [-0.54278564453125, 151.833679199219], [136.074951171875, 15.2201995849609], [136.074951171875, -201.585510253906]], [[-137.15625, -201.585479736328], [-137.15625, 15.2201995849609], [-0.54278564453125, 151.833679199219], [-0.54278564453125, 151.833679199219], [136.074951171875, 15.2201995849609], [136.074951171875, -201.585510253906]], [[-137.15625, -201.585479736328], [-137.15625, -32.3988647460938], [-0.54278564453125, 94.6907958984375], [-0.54278564453125, 94.6907958984375], [136.074951171875, -32.3988647460938], [136.074951171875, -201.585510253906]]];
				u03Path_object.inTangents = [[[0, 0], [0, 0], [-75.4484252929688, 0], [0, 0], [0, 75.4484405517578], [0, 0]], [[0, 0], [0, 0], [-75.4484252929688, 0], [0, 0], [0, 75.4484405517578], [0, 0]], [[0, 0], [0, 0], [-75.4484252929688, 0], [0, 0], [0, 75.4484405517578], [0, 0]], [[0, 0], [0, 0], [-75.4484252929688, 0], [0, 0], [0, 75.4484558105469], [0, 0]]];
				u03Path_object.outTangents = [[[0, 0], [0, 75.4484405517578], [0, 0], [75.4526977539062, 0], [0, 0], [0, 0]], [[0, 0], [0, 75.4484405517578], [0, 0], [75.4526977539062, 0], [0, 0], [0, 0]], [[0, 0], [0, 75.4484405517578], [0, 0], [75.4526977539062, 0], [0, 0], [0, 0]], [[0, 0], [0, 75.4484558105469], [0, 0], [75.4526977539062, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(u03Path, u03Path_keyTimesArray, u03Path_object);
			var u03Path_easeInSpeedArray = [0,0,0,0];
			var u03Path_easeInInfluArray = [0.1,100,16.666666667,0.1];
			var u03Path_easeOutSpeedArray = [0,0,0,0];
			var u03Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var u03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var u03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(u03Path, u03Path_keyTimesArray, [u03Path_easeInSpeedArray, u03Path_easeInInfluArray], [u03Path_easeOutSpeedArray, u03Path_easeOutInfluArray], [u03Path_keyInInterpolationType, u03Path_keyOutInterpolationType]);

		u03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		u03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		u03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		u03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		u03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		u03.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		u03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		u03.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-0.5406494140625,-24.8759155273438,0]);
		u03.property("ADBE Transform Group").property("ADBE Position").setValue([-0.5406494140625,51.1240844726562,0]);
		u03.property("ADBE Transform Group").property("ADBE Scale").setValue([84,84,100]);
		u03.property("ADBE Transform Group").property("ADBE Rotate Z").setValue(180);
		u03.selected = false;
	// Add Shape Layer "U 04", varName "u04";
	var u04 = u_comp.layers.addShape();
		u04.name = "U 04";
		u04.outPoint = 0.58333333333333;
		u04.moveToEnd();
		u04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		u04.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		u04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		u04.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		u04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var u04Path = u04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var u04Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var u04Path_object = {};
				u04Path_object.closed = true;
				u04Path_object.vertices = [[[118.298828125, -143.162109375], [118.298828125, 239.162109375], [1.701171875, 239.162109375], [1.701171875, -143.162109375]], [[118.298828125, -155.162109375], [118.298828125, 155.162109375], [1.701171875, 155.162109375], [1.701171875, -155.162109375]], [[118.298828125, -155.162109375], [118.298828125, 155.162109375], [1.701171875, 155.162109375], [1.701171875, -155.162109375]], [[118.298828125, -143.162109375], [118.298828125, 119.162109375], [1.701171875, 119.162109375], [1.701171875, -143.162109375]]];
			addShapeKeyframes(u04Path, u04Path_keyTimesArray, u04Path_object);
			var u04Path_easeInSpeedArray = [0,0,0,0];
			var u04Path_easeInInfluArray = [0.1,100,0.1,0.1];
			var u04Path_easeOutSpeedArray = [0,0,0,0];
			var u04Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var u04Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var u04Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(u04Path, u04Path_keyTimesArray, [u04Path_easeInSpeedArray, u04Path_easeInInfluArray], [u04Path_easeOutSpeedArray, u04Path_easeOutInfluArray], [u04Path_keyInInterpolationType, u04Path_keyOutInterpolationType]);

		u04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		u04.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		u04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		u04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		u04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		u04.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		u04.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		u04.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-2.701171875,-26.837890625]);
		u04.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		u04.selected = false;
	// Add Shape Layer "U 05", varName "u05";
	var u05 = u_comp.layers.addShape();
		u05.name = "U 05";
		u05.outPoint = 0.58333333333333;
		u05.moveToEnd();
		u05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		u05.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		u05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		u05.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		u05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var u05Path = u05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var u05Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var u05Path_object = {};
				u05Path_object.closed = true;
				u05Path_object.vertices = [[[118.298828125, -143.162109375], [118.298828125, 239.162109375], [-114.298828125, 239.162109375], [-114.298828125, -143.162109375]], [[118.298828125, -155.162109375], [118.298828125, 155.162109375], [-114.298828125, 155.162109375], [-114.298828125, -155.162109375]], [[118.298828125, -155.162109375], [118.298828125, 155.162109375], [-114.298828125, 155.162109375], [-114.298828125, -155.162109375]], [[118.298828125, -143.162109375], [118.298828125, 119.162109375], [-114.298828125, 119.162109375], [-114.298828125, -143.162109375]]];
			addShapeKeyframes(u05Path, u05Path_keyTimesArray, u05Path_object);
			var u05Path_easeInSpeedArray = [0,0,0,0];
			var u05Path_easeInInfluArray = [0.1,100,0.1,0.1];
			var u05Path_easeOutSpeedArray = [0,0,0,0];
			var u05Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var u05Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var u05Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(u05Path, u05Path_keyTimesArray, [u05Path_easeInSpeedArray, u05Path_easeInInfluArray], [u05Path_easeOutSpeedArray, u05Path_easeOutInfluArray], [u05Path_keyInInterpolationType, u05Path_keyOutInterpolationType]);

		u05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		u05.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		u05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		u05.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-2.701171875,-26.837890625]);
		u05.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		u05.selected = false;
	// Add Shape Layer "U 06", varName "u06";
	var u06 = u_comp.layers.addShape();
		u06.name = "U 06";
		u06.inPoint = 0.58333333333333;
		u06.outPoint = 30;
		u06.moveToEnd();
		u06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		u06.property("ADBE Root Vectors Group").property(1).name = "Group 2";
		u06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		u06.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var u06Path = u06.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var u06Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var u06Path_object = {};
				u06Path_object.closed = true;
				u06Path_object.vertices = [[[18.2383728027344, 91.67578125], [95.9356689453125, 0.50088500976562], [95.9356689453125, -158.318115234375], [18.2383422851562, -158.318115234375]], [[18.2383728027344, 107.67578125], [95.9356689453125, 12.5008544921875], [95.9356689453125, -162.318115234375], [18.2383422851562, -162.318115234375]]];
				u06Path_object.inTangents = [[[0, 0], [0, 46.9852905273438], [0, 0], [0, 0]], [[0, 0], [0, 46.9852905273438], [0, 0], [0, 0]]];
				u06Path_object.outTangents = [[[44.3305969238281, -8.99992370605469], [0, 0], [0, 0], [0, 0]], [[44.3305969238281, -8.99993896484375], [0, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(u06Path, u06Path_keyTimesArray, u06Path_object);
			var u06Path_easeInSpeedArray = [0,0];
			var u06Path_easeInInfluArray = [0.1,100];
			var u06Path_easeOutSpeedArray = [0,0];
			var u06Path_easeOutInfluArray = [0.1,0.1];
			var u06Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var u06Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(u06Path, u06Path_keyTimesArray, [u06Path_easeInSpeedArray, u06Path_easeInInfluArray], [u06Path_easeOutSpeedArray, u06Path_easeOutInfluArray], [u06Path_keyInInterpolationType, u06Path_keyOutInterpolationType]);

		u06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		u06.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		u06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		u06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		u06.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		u06.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		u06.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var u06Path3 = u06.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var u06Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var u06Path3_object = {};
				u06Path3_object.closed = true;
				u06Path3_object.vertices = [[[-98.3075866699219, -158.318115234375], [-98.3075866699219, 0.50088500976562], [-20.6102905273438, 91.6757507324219], [-20.6102905273438, -158.318145751953]], [[-98.3075866699219, -162.318115234375], [-98.3075866699219, 12.5008544921875], [-20.6102905273438, 107.675720214844], [-20.6102905273438, -162.318145751953]]];
				u06Path3_object.inTangents = [[[0, 0], [0, 0], [-44.3306274414062, -8.99992370605469], [0, 0]], [[0, 0], [0, 0], [-44.3306274414062, -8.99993896484375], [0, 0]]];
				u06Path3_object.outTangents = [[[0, 0], [0, 46.9852905273438], [0, 0], [0, 0]], [[0, 0], [0, 46.9852905273438], [0, 0], [0, 0]]];
			addShapeKeyframes(u06Path3, u06Path3_keyTimesArray, u06Path3_object);
			var u06Path3_easeInSpeedArray = [0,0];
			var u06Path3_easeInInfluArray = [0.1,100];
			var u06Path3_easeOutSpeedArray = [0,0];
			var u06Path3_easeOutInfluArray = [0.1,0.1];
			var u06Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var u06Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(u06Path3, u06Path3_keyTimesArray, [u06Path3_easeInSpeedArray, u06Path3_easeInInfluArray], [u06Path3_easeOutSpeedArray, u06Path3_easeOutInfluArray], [u06Path3_keyInInterpolationType, u06Path3_keyOutInterpolationType]);

		u06.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		u06.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		u06.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		u06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		u06.property("ADBE Root Vectors Group").property(3).name = "Group 1";
		u06.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		u06.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var u06Path5 = u06.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var u06Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var u06Path5_object = {};
				u06Path5_object.closed = true;
				u06Path5_object.vertices = [[[-137.15625, -197.585479736328], [-137.15625, 3.22024536132812], [-0.54278564453125, 135.833679199219], [-0.54278564453125, 135.833679199219], [136.074951171875, 3.22024536132812], [136.074951171875, -197.585510253906]], [[-137.15625, -201.585479736328], [-137.15625, 15.2201995849609], [-0.54278564453125, 151.833679199219], [-0.54278564453125, 151.833679199219], [136.074951171875, 15.2201995849609], [136.074951171875, -201.585510253906]]];
				u06Path5_object.inTangents = [[[0, 0], [0, 0], [-75.4484252929688, 0], [0, 0], [0, 75.4483947753906], [0, 0]], [[0, 0], [0, 0], [-75.4484252929688, 0], [0, 0], [0, 75.4484405517578], [0, 0]]];
				u06Path5_object.outTangents = [[[0, 0], [0, 75.4483947753906], [0, 0], [75.4526977539062, 0], [0, 0], [0, 0]], [[0, 0], [0, 75.4484405517578], [0, 0], [75.4526977539062, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(u06Path5, u06Path5_keyTimesArray, u06Path5_object);
			var u06Path5_easeInSpeedArray = [0,0];
			var u06Path5_easeInInfluArray = [0.1,100];
			var u06Path5_easeOutSpeedArray = [0,0];
			var u06Path5_easeOutInfluArray = [0.1,0.1];
			var u06Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var u06Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(u06Path5, u06Path5_keyTimesArray, [u06Path5_easeInSpeedArray, u06Path5_easeInInfluArray], [u06Path5_easeOutSpeedArray, u06Path5_easeOutInfluArray], [u06Path5_keyInInterpolationType, u06Path5_keyOutInterpolationType]);

		u06.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		u06.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		u06.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		u06.property("ADBE Transform Group").property("ADBE Position").setValue([400,527,0]);
		u06.selected = false;
	// Apply parents
		u01.setParentWithJump(u06);
		u02.setParentWithJump(u06);
		u03.setParentWithJump(u06);
		u04.setParentWithJump(u06);
		u05.setParentWithJump(u06);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			u01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			u03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			u03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			u04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			u04.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			u05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			u06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			u06.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			u06.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

u_comp.openInViewer();

return {
	compItem : u_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

