// Created using compCode v2.0
// 201801030 from composition "W" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// w();
function utopian_201801030_094309() {

// app.beginUndoGroup("W");

try {

// ANIMATION PRESETS START
	// W -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var w_comp_properties = {"name":"W","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":9,"frameRate":24};
	var w_comp = app.project.items.addComp(w_comp_properties.name, w_comp_properties.width, w_comp_properties.height, 1, 30, 24);
		w_comp.time = 0.16666666666667;
		w_comp.bgColor = w_comp_properties.bgColor;
		w_comp.label = w_comp_properties.label;
		w_comp.resolutionFactor = [1, 1];
		w_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = w_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "W", varName "w_comp";
	w_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = w_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([164.695007324219,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([635.304992675781,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = w_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	//Create new Null layer "w01" and replace its source with varName "null10_null";
	var w01 = w_comp.layers.addNull();
	var w01_source = w01.source;
		w01.replaceSource(null10_null, true);
		w01_source.remove();
		w01.name = "W 01";
		w01.enabled = false;
		w01.moveToEnd();
		w01.property("ADBE Transform Group").property("ADBE Position").setValue([6,-52,0]);
		w01.property("ADBE Transform Group").property("ADBE Rotate Z").setValue(180);
		w01.selected = false;
	// Add Shape Layer "W 02", varName "w02";
	var w02 = w_comp.layers.addShape();
		w02.name = "W 02";
		w02.startTime = 0.04166666666667;
		w02.inPoint = 0;
		w02.outPoint = 0.41666666666667;
		w02.moveToEnd();
		w02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		w02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		w02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		w02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		w02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var w02Path = w02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var w02Path_keyTimesArray = [-0.08333333333333, 0, 0.33333333333333];
			var w02Path_object = {};
				w02Path_object.closed = true;
				w02Path_object.vertices = [[[46.7890625, 115.8203125], [46.89453125, 168.1796875], [-47.89453125, 168.1796875], [-48, 115.8203125]], [[47.1314849853516, 3.32083129882812], [46.89453125, 240.508758544922], [-47.89453125, 240.508758544922], [-46.9673309326172, 3.32083129882812]], [[46.7890625, 66.8203125], [46.89453125, 164.1796875], [-47.89453125, 164.1796875], [-47, 66.8203125]]];
			addShapeKeyframes(w02Path, w02Path_keyTimesArray, w02Path_object);
			var w02Path_easeInSpeedArray = [0,0,0];
			var w02Path_easeInInfluArray = [16.666666667,16.666666667,100];
			var w02Path_easeOutSpeedArray = [0,0,0];
			var w02Path_easeOutInfluArray = [16.666666667,0.1,0.1];
			var w02Path_keyInInterpolationType = [KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var w02Path_keyOutInterpolationType = [KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(w02Path, w02Path_keyTimesArray, [w02Path_easeInSpeedArray, w02Path_easeInInfluArray], [w02Path_easeOutSpeedArray, w02Path_easeOutInfluArray], [w02Path_keyInInterpolationType, w02Path_keyOutInterpolationType]);

		w02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		w02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		w02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		w02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		w02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		w02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		w02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		w02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		w02.property("ADBE Transform Group").property("ADBE Position").setValue([0,1,0]);
		w02.selected = false;
	// Add Shape Layer "W 03", varName "w03";
	var w03 = w_comp.layers.addShape();
		w03.name = "W 03";
		w03.startTime = 0.04166666666667;
		w03.inPoint = 0;
		w03.outPoint = 0.41666666666667;
		w03.moveToEnd();
		w03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		w03.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		w03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		w03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		w03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var w03Path = w03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var w03Path_keyTimesArray = [-0.08333333333333, 0, 0.33333333333333];
			var w03Path_object = {};
				w03Path_object.closed = true;
				w03Path_object.vertices = [[[46.7890625, 115.8203125], [46.89453125, 168.1796875], [-47.89453125, 168.1796875], [-48, 115.8203125]], [[47.89453125, -138.1796875], [46.89453125, 243.1796875], [-47.89453125, 243.1796875], [-46.89453125, -138.1796875]], [[47.89453125, -151.1796875], [46.89453125, 164.1796875], [-47.89453125, 164.1796875], [-46.89453125, -151.1796875]]];
			addShapeKeyframes(w03Path, w03Path_keyTimesArray, w03Path_object);
			var w03Path_easeInSpeedArray = [0,0,0];
			var w03Path_easeInInfluArray = [16.666666667,0.1,100];
			var w03Path_easeOutSpeedArray = [0,0,0];
			var w03Path_easeOutInfluArray = [16.666666667,0.1,0.1];
			var w03Path_keyInInterpolationType = [KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var w03Path_keyOutInterpolationType = [KeyframeInterpolationType.HOLD,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(w03Path, w03Path_keyTimesArray, [w03Path_easeInSpeedArray, w03Path_easeInInfluArray], [w03Path_easeOutSpeedArray, w03Path_easeOutInfluArray], [w03Path_keyInInterpolationType, w03Path_keyOutInterpolationType]);

		w03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		w03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		w03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		w03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		w03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		w03.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		w03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		w03.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		w03.property("ADBE Transform Group").property("ADBE Position").setValue([0,1,0]);
		w03.selected = false;
	// Add Shape Layer "W 04", varName "w04";
	var w04 = w_comp.layers.addShape();
		w04.name = "W 04";
		w04.startTime = 0.04166666666667;
		w04.inPoint = 0.41666666666667;
		w04.outPoint = 0.58333333333333;
		w04.moveToEnd();
		w04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		w04.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		w04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		w04.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		w04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var w04Path = w04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var w04Path_keyTimesArray = [0.41666666666667, 0.54166666666667];
			var w04Path_object = {};
				w04Path_object.closed = true;
				w04Path_object.vertices = [[[46.7890625, 66.8203125], [46.89453125, 164.1796875], [-47.89453125, 164.1796875], [-47, 66.8203125]], [[49.7890625, 66.8203125], [46.89453125, 164.1796875], [-47.89453125, 164.1796875], [-50, 66.8203125]]];
			addShapeKeyframes(w04Path, w04Path_keyTimesArray, w04Path_object);
			var w04Path_easeInSpeedArray = [0,0];
			var w04Path_easeInInfluArray = [0.1,0.1];
			var w04Path_easeOutSpeedArray = [0,0];
			var w04Path_easeOutInfluArray = [100,0.1];
			var w04Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var w04Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(w04Path, w04Path_keyTimesArray, [w04Path_easeInSpeedArray, w04Path_easeInInfluArray], [w04Path_easeOutSpeedArray, w04Path_easeOutInfluArray], [w04Path_keyInInterpolationType, w04Path_keyOutInterpolationType]);

		w04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		w04.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		w04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		w04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		w04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		w04.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		w04.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		w04.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		w04.property("ADBE Transform Group").property("ADBE Position").setValue([0,1,0]);
		w04.selected = false;
	// Add Shape Layer "W 05", varName "w05";
	var w05 = w_comp.layers.addShape();
		w05.name = "W 05";
		w05.startTime = 0.20833333333333;
		w05.inPoint = 0.41666666666667;
		w05.outPoint = 0.58333333333333;
		w05.moveToEnd();
		w05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		w05.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		w05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		w05.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		w05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var w05Path = w05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var w05Path_keyTimesArray = [0.41666666666667, 0.54166666666667];
			var w05Path_object = {};
				w05Path_object.closed = true;
				w05Path_object.vertices = [[[48.89453125, -151.1796875], [46.89453125, 164.1796875], [-47.89453125, 164.1796875], [-45.89453125, -151.1796875]], [[58.89453125, -151.1796875], [47.39453125, 164.1796875], [-47.39453125, 164.1796875], [-35.89453125, -151.1796875]]];
			addShapeKeyframes(w05Path, w05Path_keyTimesArray, w05Path_object);
			var w05Path_easeInSpeedArray = [0,0];
			var w05Path_easeInInfluArray = [0.1,0.1];
			var w05Path_easeOutSpeedArray = [0,0];
			var w05Path_easeOutInfluArray = [100,16.666666667];
			var w05Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var w05Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(w05Path, w05Path_keyTimesArray, [w05Path_easeInSpeedArray, w05Path_easeInInfluArray], [w05Path_easeOutSpeedArray, w05Path_easeOutInfluArray], [w05Path_keyInInterpolationType, w05Path_keyOutInterpolationType]);

		w05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		w05.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		w05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		w05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		w05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		w05.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		w05.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		w05.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		w05.property("ADBE Transform Group").property("ADBE Position").setValue([0,1,0]);
		w05.selected = false;
	// Add Shape Layer "W 06", varName "w06";
	var w06 = w_comp.layers.addShape();
		w06.name = "W 06";
		w06.startTime = 0.20833333333333;
		w06.inPoint = 0.41666666666667;
		w06.outPoint = 0.58333333333333;
		w06.moveToEnd();
		w06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		w06.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		w06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		w06.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		w06.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var w06Path = w06.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var w06Path_keyTimesArray = [0.41666666666667, 0.54166666666667];
			var w06Path_object = {};
				w06Path_object.closed = true;
				w06Path_object.vertices = [[[45.89453125, -151.1796875], [46.89453125, 158.1796875], [-47.89453125, 158.1796875], [-48.89453125, -151.1796875]], [[35.89453125, -151.1796875], [46.39453125, 158.1796875], [-48.39453125, 158.1796875], [-58.89453125, -151.1796875]]];
			addShapeKeyframes(w06Path, w06Path_keyTimesArray, w06Path_object);
			var w06Path_easeInSpeedArray = [0,0];
			var w06Path_easeInInfluArray = [0.1,0.1];
			var w06Path_easeOutSpeedArray = [0,0];
			var w06Path_easeOutInfluArray = [100,16.666666667];
			var w06Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var w06Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(w06Path, w06Path_keyTimesArray, [w06Path_easeInSpeedArray, w06Path_easeInInfluArray], [w06Path_easeOutSpeedArray, w06Path_easeOutInfluArray], [w06Path_keyInInterpolationType, w06Path_keyOutInterpolationType]);

		w06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		w06.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		w06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		w06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		w06.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		w06.property("ADBE Transform Group").property("ADBE Position").setValue([0,1,0]);
		w06.selected = false;
	// Add Shape Layer "W 07", varName "w07";
	var w07 = w_comp.layers.addShape();
		w07.name = "W 07";
		w07.inPoint = 0.58333333333333;
		w07.outPoint = 30;
		w07.moveToEnd();
		w07.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		w07.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		w07.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		w07.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var w07Path = w07.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var w07Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var w07Path_object = {};
				w07Path_object.closed = false;
				w07Path_object.vertices = [[[149.083084106445, -167.589752197266], [73.2677764892578, -167.589752197266], [20.8651428222656, -31.1878051757812], [65.2454528808594, 54.046142578125], [149.083023071289, -167.589782714844]], [[155.393737792969, -167.589752197266], [79.5784301757812, -167.589752197266], [20.8651428222656, -31.1878051757812], [58.777099609375, 54.046142578125], [155.393676757812, -167.589782714844]]];
			addShapeKeyframes(w07Path, w07Path_keyTimesArray, w07Path_object);
			var w07Path_easeInSpeedArray = [0,0];
			var w07Path_easeInInfluArray = [16.666666667,100];
			var w07Path_easeOutSpeedArray = [0,0];
			var w07Path_easeOutInfluArray = [0.1,0.1];
			var w07Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var w07Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(w07Path, w07Path_keyTimesArray, [w07Path_easeInSpeedArray, w07Path_easeInInfluArray], [w07Path_easeOutSpeedArray, w07Path_easeOutInfluArray], [w07Path_keyInInterpolationType, w07Path_keyOutInterpolationType]);

		w07.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		w07.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		w07.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		w07.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		w07.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		w07.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		w07.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var w07Path3 = w07.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var w07Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var w07Path3_object = {};
				w07Path3_object.closed = false;
				w07Path3_object.vertices = [[[31.6565704345703, -167.589752197266], [-31.6839294433594, -167.589752197266], [0.0638427734375, -77.9658813476562], [31.6565399169922, -167.589782714844]], [[37.9672241210938, -167.589752197266], [-37.8394775390625, -167.589752197266], [0.0638427734375, -77.9658813476562], [37.9671936035156, -167.589782714844]]];
			addShapeKeyframes(w07Path3, w07Path3_keyTimesArray, w07Path3_object);
			var w07Path3_easeInSpeedArray = [0,0];
			var w07Path3_easeInInfluArray = [16.666666667,100];
			var w07Path3_easeOutSpeedArray = [0,0];
			var w07Path3_easeOutInfluArray = [0.1,0.1];
			var w07Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var w07Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(w07Path3, w07Path3_keyTimesArray, [w07Path3_easeInSpeedArray, w07Path3_easeInInfluArray], [w07Path3_easeOutSpeedArray, w07Path3_easeOutInfluArray], [w07Path3_keyInInterpolationType, w07Path3_keyOutInterpolationType]);

		w07.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		w07.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		w07.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		w07.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		w07.property("ADBE Root Vectors Group").property(3).name = "Group 3";
		w07.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		w07.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var w07Path5 = w07.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var w07Path5_keyTimesArray = [0.58333333333333, 0.91666666666667, 0.95833333333333];
			var w07Path5_object = {};
				w07Path5_object.closed = false;
				w07Path5_object.vertices = [[[-73.2951507568359, -167.589752197266], [-149.114807128906, -167.589752197266], [-65.1177368164062, 54.046142578125], [-20.7417602539062, -31.1878051757812], [-73.2952117919922, -167.589782714844]], [[-79.45068359375, -167.589752197266], [-155.27033996582, -167.589752197266], [-58.6494140625, 54.046142578125], [-20.7417602539062, -31.1878051757812], [-79.4507446289062, -167.589782714844]], [[-79.45068359375, -167.589752197266], [-155.27033996582, -167.589752197266], [-58.6494140625, 54.046142578125], [-20.7417602539062, -31.1878051757812], [-79.4507446289062, -167.589782714844]]];
			addShapeKeyframes(w07Path5, w07Path5_keyTimesArray, w07Path5_object);
			var w07Path5_easeInSpeedArray = [0,0,0];
			var w07Path5_easeInInfluArray = [16.666666667,100,16.666666667];
			var w07Path5_easeOutSpeedArray = [0,0,0];
			var w07Path5_easeOutInfluArray = [0.1,0.1,16.666666667];
			var w07Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var w07Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(w07Path5, w07Path5_keyTimesArray, [w07Path5_easeInSpeedArray, w07Path5_easeInInfluArray], [w07Path5_easeOutSpeedArray, w07Path5_easeOutInfluArray], [w07Path5_keyInInterpolationType, w07Path5_keyOutInterpolationType]);

		w07.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		w07.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		w07.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		w07.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		w07.property("ADBE Root Vectors Group").property(4).name = "Group 4";
		w07.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		w07.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var w07Path7 = w07.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var w07Path7_keyTimesArray = [0.58333333333333, 0.875, 0.91666666666667];
			var w07Path7_object = {};
				w07Path7_object.closed = false;
				w07Path7_object.vertices = [[[-208.000717163086, -206.438415527344], [-65.1177368164062, 147.593688964844], [0.06382751464844, 15.5859375], [65.2454071044922, 147.593688964844], [207.973220825195, -206.4384765625], [-208.000869750977, -206.4384765625]], [[-214.122268676758, -206.438415527344], [-58.6851348876953, 147.593688964844], [0.0638427734375, 15.5859375], [58.8127899169922, 147.593688964844], [214.249038696289, -206.4384765625], [-214.122421264648, -206.4384765625]], [[-214.15625, -206.438415527344], [-58.6494140625, 147.593688964844], [0.0638427734375, 15.5859375], [58.7770690917969, 147.593688964844], [214.283874511719, -206.4384765625], [-214.156402587891, -206.4384765625]]];
			addShapeKeyframes(w07Path7, w07Path7_keyTimesArray, w07Path7_object);
			var w07Path7_easeInSpeedArray = [0,1,0];
			var w07Path7_easeInInfluArray = [16.666666667,16.666666667,100];
			var w07Path7_easeOutSpeedArray = [0,1,0];
			var w07Path7_easeOutInfluArray = [0.1,16.666666667,0.1];
			var w07Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var w07Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(w07Path7, w07Path7_keyTimesArray, [w07Path7_easeInSpeedArray, w07Path7_easeInInfluArray], [w07Path7_easeOutSpeedArray, w07Path7_easeOutInfluArray], [w07Path7_keyInInterpolationType, w07Path7_keyOutInterpolationType]);

		w07.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		w07.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		w07.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		w07.property("ADBE Transform Group").property("ADBE Position").setValue([400,532,0]);
		w07.selected = false;
	// Apply parents
		w01.setParentWithJump(w07);
		w02.setParentWithJump(w01);
		w03.setParentWithJump(w01);
		w04.setParentWithJump(w01);
		w05.setParentWithJump(w01);
		w06.setParentWithJump(w01);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			w02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			w02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			w03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			w03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			w04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			w04.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			w05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			w05.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			w06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			w07.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			w07.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			w07.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			w07.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

w_comp.openInViewer();

return {
	compItem : w_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

