// Created using compCode v2.0
// 201801030 from composition "Ø" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode();
function utopian_201801030_094309() {

// app.beginUndoGroup(File.decode("%C3%98"));

try {

// ANIMATION PRESETS START
	// Ø -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercaseAccents_folder_properties = {"name":"02 Uppercase Accents","typeName":"Folder","label":9,"comment":""};
	var uppercaseAccents_folder = findProjectItem(utopian_folder, false, uppercaseAccents_folder_properties);
	if (uppercaseAccents_folder === null) {
		uppercaseAccents_folder = app.project.items.addFolder(uppercaseAccents_folder_properties.name);
		uppercaseAccents_folder.label = uppercaseAccents_folder_properties.label;
		uppercaseAccents_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode_comp_properties = {"name":"Ø","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":6,"frameRate":24};
	var compcode_comp = app.project.items.addComp(compcode_comp_properties.name, compcode_comp_properties.width, compcode_comp_properties.height, 1, 30, 24);
		compcode_comp.time = 1.375;
		compcode_comp.bgColor = compcode_comp_properties.bgColor;
		compcode_comp.label = compcode_comp_properties.label;
		compcode_comp.resolutionFactor = [1, 1];
		compcode_comp.parentFolder = uppercaseAccents_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "Ø", varName "compcode_comp";
	compcode_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([200.302001953125,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([600.195983886719,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "Ø 01", varName "compcode01";
	var compcode01 = compcode_comp.layers.addShape();
		compcode01.name = File.decode("%C3%98%2001");
		compcode01.startTime = 0.04166666666667;
		compcode01.inPoint = 0;
		compcode01.outPoint = 0.58333333333333;
		compcode01.moveToEnd();
		compcode01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode01.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode01Path = compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode01Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode01Path_object = {};
				compcode01Path_object.closed = true;
				compcode01Path_object.vertices = [[[46.7890625, 64.5703125], [46.7890625, 128.9296875], [-48, 128.9296875], [-48, 64.5703125]], [[47.89453125, 2.5703125], [46.7890625, 156.9296875], [-48, 156.9296875], [-46.89453125, 2.5703125]], [[47.89453125, 2.5703125], [46.7890625, 156.9296875], [-48, 156.9296875], [-46.89453125, 2.5703125]], [[52.89453125, 2.5703125], [40.7890625, 156.9296875], [-62, 156.9296875], [-49.89453125, 2.5703125]]];
			addShapeKeyframes(compcode01Path, compcode01Path_keyTimesArray, compcode01Path_object);
			var compcode01Path_easeInSpeedArray = [0,0,0,0];
			var compcode01Path_easeInInfluArray = [0.1,100,100,0.1];
			var compcode01Path_easeOutSpeedArray = [0,0,0,0];
			var compcode01Path_easeOutInfluArray = [0.1,0.1,0.1,16.666666667];
			var compcode01Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode01Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode01Path, compcode01Path_keyTimesArray, [compcode01Path_easeInSpeedArray, compcode01Path_easeInInfluArray], [compcode01Path_easeOutSpeedArray, compcode01Path_easeOutInfluArray], [compcode01Path_keyInInterpolationType, compcode01Path_keyOutInterpolationType]);

		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode01.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		compcode01.property("ADBE Transform Group").property("ADBE Position").setValue([400,527,0]);
		compcode01.selected = false;
	// Add Shape Layer "Ø 02", varName "compcode02";
	var compcode02 = compcode_comp.layers.addShape();
		compcode02.name = File.decode("%C3%98%2002");
		compcode02.startTime = 0.04166666666667;
		compcode02.inPoint = 0;
		compcode02.outPoint = 0.58333333333333;
		compcode02.moveToEnd();
		compcode02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode02Path = compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode02Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode02Path_object = {};
				compcode02Path_object.closed = true;
				compcode02Path_object.vertices = [[[47.89453125, -125.1796875], [47.578125, -60.8203125], [-47.2109375, -60.8203125], [-46.89453125, -125.1796875]], [[47.89453125, -153.1796875], [46.7890625, 1.1796875], [-48, 1.1796875], [-46.89453125, -153.1796875]], [[47.89453125, -153.1796875], [46.7890625, 1.1796875], [-48, 1.1796875], [-46.89453125, -153.1796875]], [[64.89453125, -153.1796875], [52.7890625, 1.1796875], [-50, 1.1796875], [-37.89453125, -153.1796875]]];
			addShapeKeyframes(compcode02Path, compcode02Path_keyTimesArray, compcode02Path_object);
			var compcode02Path_easeInSpeedArray = [0,0,0,0];
			var compcode02Path_easeInInfluArray = [0.1,100,100,0.1];
			var compcode02Path_easeOutSpeedArray = [0,0,0,0];
			var compcode02Path_easeOutInfluArray = [0.1,0.1,0.1,16.666666667];
			var compcode02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode02Path, compcode02Path_keyTimesArray, [compcode02Path_easeInSpeedArray, compcode02Path_easeInInfluArray], [compcode02Path_easeOutSpeedArray, compcode02Path_easeOutInfluArray], [compcode02Path_keyInInterpolationType, compcode02Path_keyOutInterpolationType]);

		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		compcode02.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([6.052734375,-125.1796875,0]);
		compcode02.property("ADBE Transform Group").property("ADBE Position").setValue([406.052734375,401.8203125,0]);
		compcode02.selected = false;
	// Add Shape Layer "Ø 03", varName "compcode03";
	var compcode03 = compcode_comp.layers.addShape();
		compcode03.name = File.decode("%C3%98%2003");
		compcode03.startTime = 0.04166666666667;
		compcode03.inPoint = 0;
		compcode03.outPoint = 0.58333333333333;
		compcode03.moveToEnd();
		compcode03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode03.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode03Path = compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode03Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode03Path_object = {};
				compcode03Path_object.closed = true;
				compcode03Path_object.vertices = [[[47.89453125, -125.1796875], [46.89453125, 129.1796875], [-47.89453125, 129.1796875], [-46.89453125, -125.1796875]], [[47.89453125, -153.1796875], [46.89453125, 157.1796875], [-47.89453125, 157.1796875], [-46.89453125, -153.1796875]], [[47.89453125, -153.1796875], [46.89453125, 157.1796875], [-47.89453125, 157.1796875], [-46.89453125, -153.1796875]], [[59.89453125, -153.1796875], [34.89453125, 157.1796875], [-59.89453125, 157.1796875], [-34.89453125, -153.1796875]]];
			addShapeKeyframes(compcode03Path, compcode03Path_keyTimesArray, compcode03Path_object);
			var compcode03Path_easeInSpeedArray = [0,0,0,0];
			var compcode03Path_easeInInfluArray = [0.1,100,0.1,0.1];
			var compcode03Path_easeOutSpeedArray = [0,0,0,0];
			var compcode03Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode03Path, compcode03Path_keyTimesArray, [compcode03Path_easeInSpeedArray, compcode03Path_easeInInfluArray], [compcode03Path_easeOutSpeedArray, compcode03Path_easeOutInfluArray], [compcode03Path_keyInInterpolationType, compcode03Path_keyOutInterpolationType]);

		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode03.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		compcode03.property("ADBE Transform Group").property("ADBE Position").setValue([400,527,0]);
		compcode03.selected = false;
	// Add Shape Layer "Ø 04", varName "compcode04";
	var compcode04 = compcode_comp.layers.addShape();
		compcode04.name = File.decode("%C3%98%2004");
		compcode04.inPoint = 0.58333333333333;
		compcode04.outPoint = 30;
		compcode04.moveToEnd();
		compcode04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode04.property("ADBE Root Vectors Group").property(1).name = "Group 2";
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode04Path = compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode04Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode04Path_object = {};
				compcode04Path_object.closed = true;
				compcode04Path_object.vertices = [[[-69.5698394775391, 29.2445068359375], [-37.4722442626953, -8.60415649414062], [-7.37901306152344, -46.4528198242188], [23.7142944335938, -84.3057861328125], [23.7185668945312, -84.3057861328125], [54.8118591308594, -124.150146484375], [70.1959228515625, -141.174499511719], [-0.19207763671875, -165.416076660156], [-90.9626007080078, -124.145874023438], [-90.9841766357422, -124.145874023438], [-91.4589996337891, -123.627899169922], [-98.5553436279297, -115.806396484375], [-99.0862884521484, -115.193481445312], [-105.539505004883, -106.741760253906], [-106.515029907227, -105.373413085938], [-112.070419311523, -96.6454162597656], [-112.989822387695, -95.0396728515625], [-117.832962036133, -85.7591552734375], [-118.070388793945, -85.3016357421875], [-118.040176391602, -85.3016357421875], [-129.638656616211, -46.4486694335938], [-129.664566040039, -46.4486694335938], [-129.806991577148, -45.1321411132812], [-130.57536315918, -37.9710693359375], [-130.760971069336, -35.5106506347656], [-131.084701538086, -26.5279846191406], [-130.795486450195, -18.0244750976562], [-130.653060913086, -15.9439086914062], [-129.802688598633, -7.62167358398438], [-129.798385620117, -7.60009765625], [-118.480484008789, 31.24853515625], [-118.510696411133, 31.24853515625], [-118.199905395508, 31.8701171875], [-114.50065612793, 39.2556762695312], [-113.73664855957, 40.6196899414062], [-109.920852661133, 47.094482421875], [-109.25178527832, 48.1822509765625], [-104.602890014648, 54.9635009765625], [-103.50651550293, 56.4526977539062], [-98.3137359619141, 63.035400390625], [-69.5700531005859, 29.2442016601562]], [[-77.5698547363281, 31.2445068359375], [-42.4722595214844, -7.60415649414062], [-7.37899780273438, -46.4528198242188], [27.7142944335938, -85.3057861328125], [27.7185668945312, -85.3057861328125], [62.8118591308594, -124.150146484375], [78.1959228515625, -141.174499511719], [-0.19207763671875, -165.416076660156], [-98.9626159667969, -124.145874023438], [-98.9841918945312, -124.145874023438], [-99.4590148925781, -123.627899169922], [-106.555358886719, -115.806396484375], [-107.086303710938, -115.193481445312], [-113.539520263672, -106.741760253906], [-114.515045166016, -105.373413085938], [-120.070434570312, -96.6454162597656], [-120.989837646484, -95.0396728515625], [-125.832977294922, -85.7591552734375], [-126.070404052734, -85.3016357421875], [-126.040191650391, -85.3016357421875], [-137.638671875, -46.4486694335938], [-137.664581298828, -46.4486694335938], [-137.807006835938, -45.1321411132812], [-138.575378417969, -37.9710693359375], [-138.760986328125, -35.5106506347656], [-139.084716796875, -26.5279846191406], [-138.795501708984, -18.0244750976562], [-138.653076171875, -15.9439086914062], [-137.802703857422, -7.62167358398438], [-137.798400878906, -7.60009765625], [-126.480499267578, 31.24853515625], [-126.510711669922, 31.24853515625], [-126.199920654297, 31.8701171875], [-122.500671386719, 39.2556762695312], [-121.736663818359, 40.6196899414062], [-117.920867919922, 47.094482421875], [-117.251800537109, 48.1822509765625], [-112.602905273438, 54.9635009765625], [-111.506530761719, 56.4526977539062], [-106.313751220703, 63.035400390625], [-77.570068359375, 31.2442016601562]]];
				compcode04Path_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [29.0890502929688, 0], [25.1782531738281, -25.47607421875], [0, 0], [0, 0], [2.27047729492188, -2.69781494140625], [0, 0], [2.05465698242188, -2.8963623046875], [0.32373046875, -0.46185302734375], [1.75253295898438, -2.97842407226562], [0.29782104492188, -0.5352783203125], [1.49783325195312, -3.16400146484375], [0, 0], [0, 0], [1.97265625, -13.7049560546875], [0, 0], [0.0604248046875, -0.43597412109375], [0.19857788085938, -2.40863037109375], [0.0474853515625, -0.82012939453125], [0, -3.02157592773438], [-0.17266845703125, -2.81866455078125], [-0.05178833007812, -0.6949462890625], [-0.37985229492188, -2.74530029296875], [0, 0], [-5.55966186523438, -12.116455078125], [0, 0], [0, 0], [-1.3035888671875, -2.417236328125], [-0.25466918945312, -0.45318603515625], [-1.3294677734375, -2.119384765625], [0, 0], [-1.6143798828125, -2.21441650390625], [-0.36688232421875, -0.500732421875], [-1.79998779296875, -2.13671875], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [29.0890502929688, 0], [25.1782531738281, -25.47607421875], [0, 0], [0, 0], [2.27047729492188, -2.69781494140625], [0, 0], [2.05465698242188, -2.8963623046875], [0.32373046875, -0.46185302734375], [1.75253295898438, -2.97842407226562], [0.29782104492188, -0.5352783203125], [1.49783325195312, -3.16400146484375], [0, 0], [0, 0], [1.97265625, -13.7049560546875], [0, 0], [0.0604248046875, -0.43597412109375], [0.19857788085938, -2.40863037109375], [0.0474853515625, -0.82012939453125], [0, -3.02157592773438], [-0.17266845703125, -2.81866455078125], [-0.05178833007812, -0.6949462890625], [-0.37985229492188, -2.74530029296875], [0, 0], [-5.55966186523438, -12.116455078125], [0, 0], [0, 0], [-1.3035888671875, -2.417236328125], [-0.25466918945312, -0.45318603515625], [-1.3294677734375, -2.119384765625], [0, 0], [-1.6143798828125, -2.21441650390625], [-0.36688232421875, -0.500732421875], [-1.79998779296875, -2.13671875], [0, 0]]];
				compcode04Path_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-22.3077697753906, -15.2847900390625], [-38.645751953125, 0], [0, 0], [0, 0], [-2.45611572265625, 2.51651000976562], [0, 0], [-2.26187133789062, 2.72802734375], [-0.31942749023438, 0.4532470703125], [-1.95541381835938, 2.83163452148438], [-0.31509399414062, 0.53524780273438], [-1.7222900390625, 3.03018188476562], [0, 0], [0, 0], [-5.65896606445312, 12.1078491210938], [0, 0], [-0.0604248046875, 0.431640625], [-0.31512451171875, 2.3697509765625], [-0.06906127929688, 0.81582641601562], [-0.19424438476562, 2.96975708007812], [0, 2.85751342773438], [0.04315185546875, 0.6949462890625], [0.21151733398438, 2.797119140625], [0, 0], [1.86904907226562, 13.6919860839844], [0, 0], [0, 0], [1.1611328125, 2.50360107421875], [0.2503662109375, 0.45758056640625], [1.21295166015625, 2.19281005859375], [0, 0], [1.48056030273438, 2.309326171875], [0.3582763671875, 0.50067138671875], [1.67913818359375, 2.240234375], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-22.3077697753906, -15.2847900390625], [-38.645751953125, 0], [0, 0], [0, 0], [-2.45611572265625, 2.51651000976562], [0, 0], [-2.26187133789062, 2.72802734375], [-0.31942749023438, 0.4532470703125], [-1.95541381835938, 2.83163452148438], [-0.31509399414062, 0.53524780273438], [-1.7222900390625, 3.03018188476562], [0, 0], [0, 0], [-5.65896606445312, 12.1078491210938], [0, 0], [-0.0604248046875, 0.431640625], [-0.31512451171875, 2.3697509765625], [-0.06906127929688, 0.81582641601562], [-0.19424438476562, 2.96975708007812], [0, 2.85751342773438], [0.04315185546875, 0.6949462890625], [0.21151733398438, 2.797119140625], [0, 0], [1.86904907226562, 13.6919860839844], [0, 0], [0, 0], [1.1611328125, 2.50360107421875], [0.2503662109375, 0.45758056640625], [1.21295166015625, 2.19281005859375], [0, 0], [1.48056030273438, 2.309326171875], [0.3582763671875, 0.50067138671875], [1.67913818359375, 2.240234375], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode04Path, compcode04Path_keyTimesArray, compcode04Path_object);
			var compcode04Path_easeInSpeedArray = [0,0];
			var compcode04Path_easeInInfluArray = [0.1,100];
			var compcode04Path_easeOutSpeedArray = [0,0];
			var compcode04Path_easeOutInfluArray = [0.1,0.1];
			var compcode04Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode04Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode04Path, compcode04Path_keyTimesArray, [compcode04Path_easeInSpeedArray, compcode04Path_easeInInfluArray], [compcode04Path_easeOutSpeedArray, compcode04Path_easeOutInfluArray], [compcode04Path_keyInInterpolationType, compcode04Path_keyOutInterpolationType]);

		compcode04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode04.property("ADBE Root Vectors Group").property(2).name = "Group 4";
		compcode04.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode04.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode04Path3 = compcode04.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode04Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode04Path3_object = {};
				compcode04Path3_object.closed = true;
				compcode04Path3_object.vertices = [[[130.247375488281, -37.4571838378906], [129.315002441406, -46.0816040039062], [129.271850585938, -46.4528198242188], [129.254516601562, -46.4528198242188], [117.651733398438, -85.3057861328125], [117.664672851562, -85.3057861328125], [117.50927734375, -85.6079711914062], [113.844543457031, -92.8079223632812], [112.938049316406, -94.4395751953125], [109.10498046875, -100.866882324219], [108.686279296875, -101.540283203125], [104.1064453125, -108.183410644531], [102.966827392578, -109.720092773438], [97.929443359375, -116.099914550781], [70.100830078125, -85.3015747070312], [39.0032348632812, -46.4486083984375], [30.0291748046875, -36.5163269042969], [7.90560913085938, -7.5999755859375], [-22.1962738037109, 28.2486572265625], [-54.2938995361328, 68.0973510742188], [-54.2895965576172, 68.0973510742188], [-70.5671844482422, 88.1101684570312], [-0.1749267578125, 112.356018066406], [91.53662109375, 70.093017578125], [91.5840759277344, 70.093017578125], [92.2617492675781, 69.3333129882812], [99.2544860839844, 61.472900390625], [99.7810974121094, 60.8125], [106.035705566406, 52.46435546875], [106.648620605469, 51.6010131835938], [112.1953125, 42.7133178710938], [113.093139648438, 41.1507568359375], [117.780883789062, 31.9781494140625], [118.156372070312, 31.2486572265625], [118.10888671875, 31.2486572265625], [129.387939453125, -7.60003662109375], [129.426818847656, -7.60003662109375], [129.582153320312, -9.13671875], [130.225341796875, -15.4302062988281], [130.415283203125, -17.9294738769531], [130.704467773438, -26.5322875976562], [130.385009765625, -35.5149841308594], [130.246826171875, -37.4574279785156]], [[138.247375488281, -37.4571838378906], [137.315002441406, -46.0816040039062], [137.271850585938, -46.4528198242188], [137.254516601562, -46.4528198242188], [125.651733398438, -85.3057861328125], [125.664672851562, -85.3057861328125], [125.50927734375, -85.6079711914062], [121.844543457031, -92.8079223632812], [120.938049316406, -94.4395751953125], [117.10498046875, -100.866882324219], [116.686279296875, -101.540283203125], [112.1064453125, -108.183410644531], [110.966827392578, -109.720092773438], [105.929443359375, -116.099914550781], [78.100830078125, -85.3015747070312], [43.0032348632812, -46.4486083984375], [34.0291748046875, -36.5163269042969], [7.90560913085938, -7.5999755859375], [-27.1962890625, 31.2486572265625], [-62.2939147949219, 70.0973510742188], [-62.2896118164062, 70.0973510742188], [-78.5671997070312, 88.1101684570312], [-0.1749267578125, 112.356018066406], [99.53662109375, 70.093017578125], [99.5840759277344, 70.093017578125], [100.261749267578, 69.3333129882812], [107.254486083984, 61.472900390625], [107.781097412109, 60.8125], [114.035705566406, 52.46435546875], [114.648620605469, 51.6010131835938], [120.1953125, 42.7133178710938], [121.093139648438, 41.1507568359375], [125.780883789062, 31.9781494140625], [126.156372070312, 31.2486572265625], [126.10888671875, 31.2486572265625], [137.387939453125, -7.60003662109375], [137.426818847656, -7.60003662109375], [137.582153320312, -9.13671875], [138.225341796875, -15.4302062988281], [138.415283203125, -17.9294738769531], [138.704467773438, -26.5322875976562], [138.385009765625, -35.5149841308594], [138.246826171875, -37.4574279785156]]];
				compcode04Path3_object.inTangents = [[[0, 0], [0.40142822265625, 2.84890747070312], [0, 0], [0, 0], [5.66326904296875, 12.103515625], [0, 0], [0, 0], [1.28631591796875, 2.36544799804688], [0.30218505859375, 0.54388427734375], [1.33380126953125, 2.09783935546875], [0, 0], [1.5841064453125, 2.17120361328125], [0.38418579101562, 0.50933837890625], [1.74386596679688, 2.06759643554688], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-29.0933227539062, 0], [-25.247314453125, 26.0458984375], [0, 0], [0, 0], [-2.22732543945312, 2.71942138671875], [0, 0], [-1.98992919921875, 2.86181640625], [0, 0], [-1.7481689453125, 3.03448486328125], [-0.29345703125, 0.526611328125], [-1.4503173828125, 3.1251220703125], [0, 0], [0, 0], [-1.8690185546875, 13.683349609375], [0, 0], [-0.064697265625, 0.50933837890625], [-0.17266845703125, 2.11077880859375], [-0.05181884765625, 0.83740234375], [0, 2.89202880859375], [0.18994140625, 2.96975708007812], [0.0474853515625, 0.64315795898438]], [[0, 0], [0.40142822265625, 2.84890747070312], [0, 0], [0, 0], [5.66326904296875, 12.103515625], [0, 0], [0, 0], [1.28631591796875, 2.36544799804688], [0.30218505859375, 0.54388427734375], [1.33380126953125, 2.09783935546875], [0, 0], [1.5841064453125, 2.17120361328125], [0.38418579101562, 0.50933837890625], [1.74386596679688, 2.06759643554688], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-29.0933227539062, 0], [-25.247314453125, 26.0458984375], [0, 0], [0, 0], [-2.22732543945312, 2.71942138671875], [0, 0], [-1.98992919921875, 2.86181640625], [0, 0], [-1.7481689453125, 3.03448486328125], [-0.29345703125, 0.526611328125], [-1.4503173828125, 3.1251220703125], [0, 0], [0, 0], [-1.8690185546875, 13.683349609375], [0, 0], [-0.064697265625, 0.50933837890625], [-0.17266845703125, 2.11077880859375], [-0.05181884765625, 0.83740234375], [0, 2.89202880859375], [0.18994140625, 2.96975708007812], [0.0474853515625, 0.64315795898438]]];
				compcode04Path3_object.outTangents = [[[-0.23309326171875, -2.89639282226562], [0, 0], [0, 0], [-1.97265625, -13.7049560546875], [0, 0], [0, 0], [-1.148193359375, -2.44317626953125], [-0.2978515625, -0.54388427734375], [-1.230224609375, -2.17984008789062], [0, 0], [-1.4547119140625, -2.26617431640625], [-0.37127685546875, -0.513671875], [-1.62301635742188, -2.17123413085938], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [22.3120727539062, 15.2847900390625], [39.1378631591797, 0], [0, 0], [0, 0], [2.42153930664062, -2.53814697265625], [0, 0], [2.18414306640625, -2.7021484375], [0, 0], [1.9639892578125, -2.8834228515625], [0.30218505859375, -0.52227783203125], [1.6748046875, -2.9913330078125], [0, 0], [0, 0], [5.555419921875, -12.116455078125], [0, 0], [0.06903076171875, -0.50933837890625], [0.2633056640625, -2.08489990234375], [0.064697265625, -0.83309936523438], [0.172607421875, -2.85324096679688], [0, -3.0216064453125], [-0.05615234375, -0.65182495117188], [0, 0]], [[-0.23309326171875, -2.89639282226562], [0, 0], [0, 0], [-1.97265625, -13.7049560546875], [0, 0], [0, 0], [-1.148193359375, -2.44317626953125], [-0.2978515625, -0.54388427734375], [-1.230224609375, -2.17984008789062], [0, 0], [-1.4547119140625, -2.26617431640625], [-0.37127685546875, -0.513671875], [-1.62301635742188, -2.17123413085938], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [22.3120727539062, 15.2847900390625], [39.1378479003906, 0], [0, 0], [0, 0], [2.42153930664062, -2.53814697265625], [0, 0], [2.18414306640625, -2.7021484375], [0, 0], [1.9639892578125, -2.8834228515625], [0.30218505859375, -0.52227783203125], [1.6748046875, -2.9913330078125], [0, 0], [0, 0], [5.555419921875, -12.116455078125], [0, 0], [0.06903076171875, -0.50933837890625], [0.2633056640625, -2.08489990234375], [0.064697265625, -0.83309936523438], [0.172607421875, -2.85324096679688], [0, -3.0216064453125], [-0.05615234375, -0.65182495117188], [0, 0]]];
			addShapeKeyframes(compcode04Path3, compcode04Path3_keyTimesArray, compcode04Path3_object);
			var compcode04Path3_easeInSpeedArray = [0,0];
			var compcode04Path3_easeInInfluArray = [0.1,100];
			var compcode04Path3_easeOutSpeedArray = [0,0];
			var compcode04Path3_easeOutInfluArray = [0.1,0.1];
			var compcode04Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode04Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode04Path3, compcode04Path3_keyTimesArray, [compcode04Path3_easeInSpeedArray, compcode04Path3_easeInInfluArray], [compcode04Path3_easeOutSpeedArray, compcode04Path3_easeOutInfluArray], [compcode04Path3_keyInInterpolationType, compcode04Path3_keyOutInterpolationType]);

		compcode04.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode04.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode04.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode04.property("ADBE Root Vectors Group").property(3).name = "Group 1";
		compcode04.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		compcode04.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var compcode04Path5 = compcode04.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var compcode04Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode04Path5_object = {};
				compcode04Path5_object.closed = true;
				compcode04Path5_object.vertices = [[[160.441436767578, -85.3057861328125], [160.471710205078, -85.3057861328125], [160.363739013672, -85.6122436523438], [159.962310791016, -86.7518310546875], [159.888885498047, -86.8252410888672], [124.717864990234, -145.762969970703], [155.235626220703, -179.535430908203], [127.501983642578, -204.597137451172], [96.9884948730469, -170.820404052734], [-0.17919921875, -205.106536865234], [-170.749176025391, -26.5408325195312], [-125.084732055664, 92.6856689453125], [-155.593887329102, 126.458129882812], [-127.860275268555, 151.515502929688], [-97.3468170166016, 117.73876953125], [-0.17489624023438, 152.024841308594], [160.454254150391, 32.20263671875], [160.527618408203, 32.1249542236328], [160.834014892578, 31.2357177734375], [160.773590087891, 31.2357177734375], [170.386505126953, -26.545166015625], [160.441192626953, -85.3059387207031]], [[168.441421508789, -85.3057861328125], [168.471694946289, -85.3057861328125], [168.363723754883, -85.6122436523438], [167.962295532227, -86.7518310546875], [167.888870239258, -86.8252410888672], [132.717849731445, -145.762969970703], [163.235610961914, -179.535430908203], [135.501968383789, -204.597137451172], [104.988479614258, -170.820404052734], [-0.17919921875, -205.106536865234], [-178.74919128418, -26.5408325195312], [-133.084747314453, 92.6856689453125], [-163.593902587891, 126.458129882812], [-135.860290527344, 151.515502929688], [-105.346832275391, 117.73876953125], [-0.17489624023438, 152.024841308594], [168.454238891602, 32.20263671875], [168.527603149414, 32.1249542236328], [168.833999633789, 31.2357177734375], [168.773574829102, 31.2357177734375], [178.386489868164, -26.545166015625], [168.441177368164, -85.3059387207031]]];
				compcode04Path5_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [15.2718505859375, 17.0113830566406], [0, 0], [0, 0], [0, 0], [39.3278350830078, 0], [0, -98.6194763183594], [-28.3768005371094, -31.6141357421875], [0, 0], [0, 0], [0, 0], [-39.3320922851562, 0], [-24.302001953125, 69.7506103515625], [0, 0], [0, 0], [0, 0], [0, 20.2315063476562], [6.418701171875, 18.4056396484375]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [15.2718505859375, 17.0113830566406], [0, 0], [0, 0], [0, 0], [39.3278198242188, 0], [0, -98.6194763183594], [-28.3768005371094, -31.6141357421875], [0, 0], [0, 0], [0, 0], [-39.3320922851562, 0], [-24.302001953125, 69.7506103515625], [0, 0], [0, 0], [0, 0], [0, 20.2315063476562], [6.418701171875, 18.4056396484375]]];
				compcode04Path5_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [-7.87762451171875, -21.9495239257812], [0, 0], [0, 0], [0, 0], [-29.5034332275391, -21.5437622070312], [-98.623779296875, 0], [0, 45.8284454345703], [0, 0], [0, 0], [0, 0], [29.5033874511719, 21.543701171875], [78.0297088623047, 0], [0, 0], [0, 0], [0, 0], [6.20281982421875, -18.1294097900391], [-0.0086669921875, -20.5854797363281], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [-7.87762451171875, -21.9495239257812], [0, 0], [0, 0], [0, 0], [-29.50341796875, -21.5437622070312], [-98.623779296875, 0], [0, 45.8284454345703], [0, 0], [0, 0], [0, 0], [29.5033874511719, 21.543701171875], [78.0297088623047, 0], [0, 0], [0, 0], [0, 0], [6.20281982421875, -18.1294097900391], [-0.0086669921875, -20.5854797363281], [0, 0]]];
			addShapeKeyframes(compcode04Path5, compcode04Path5_keyTimesArray, compcode04Path5_object);
			var compcode04Path5_easeInSpeedArray = [0,0];
			var compcode04Path5_easeInInfluArray = [0.1,100];
			var compcode04Path5_easeOutSpeedArray = [0,0];
			var compcode04Path5_easeOutInfluArray = [0.1,0.1];
			var compcode04Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode04Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode04Path5, compcode04Path5_keyTimesArray, [compcode04Path5_easeInSpeedArray, compcode04Path5_easeInInfluArray], [compcode04Path5_easeOutSpeedArray, compcode04Path5_easeOutInfluArray], [compcode04Path5_keyInInterpolationType, compcode04Path5_keyOutInterpolationType]);

		compcode04.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode04.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		compcode04.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode04.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode04.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode04.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode04.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode_comp.openInViewer();

return {
	compItem : compcode_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

