// Created using compCode v2.0
// 201801030 from composition "0" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode0();
function utopian_201801030_094309() {

// app.beginUndoGroup("0");

try {

// ANIMATION PRESETS START
	// 0 -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var numbers_folder_properties = {"name":"03 Numbers","typeName":"Folder","label":9,"comment":""};
	var numbers_folder = findProjectItem(utopian_folder, false, numbers_folder_properties);
	if (numbers_folder === null) {
		numbers_folder = app.project.items.addFolder(numbers_folder_properties.name);
		numbers_folder.label = numbers_folder_properties.label;
		numbers_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode0_comp_properties = {"name":"0","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":6,"frameRate":24};
	var compcode0_comp = app.project.items.addComp(compcode0_comp_properties.name, compcode0_comp_properties.width, compcode0_comp_properties.height, 1, 30, 24);
		compcode0_comp.time = 0.875;
		compcode0_comp.bgColor = compcode0_comp_properties.bgColor;
		compcode0_comp.label = compcode0_comp_properties.label;
		compcode0_comp.resolutionFactor = [1, 1];
		compcode0_comp.parentFolder = numbers_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode0_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "0", varName "compcode0_comp";
	compcode0_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode0_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([200.302001953125,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([599.697998046875,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode0_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "0 01", varName "compcode001";
	var compcode001 = compcode0_comp.layers.addShape();
		compcode001.name = "0 01";
		compcode001.startTime = 0.04166666666667;
		compcode001.inPoint = 0;
		compcode001.outPoint = 0.58333333333333;
		compcode001.moveToEnd();
		compcode001.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode001.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode001.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode001.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode001.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode001Path = compcode001.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode001Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode001Path_object = {};
				compcode001Path_object.closed = true;
				compcode001Path_object.vertices = [[[46.7890625, 64.5703125], [46.7890625, 128.9296875], [-48, 128.9296875], [-48, 64.5703125]], [[47.89453125, 2.5703125], [46.7890625, 156.9296875], [-48, 156.9296875], [-46.89453125, 2.5703125]], [[47.89453125, 2.5703125], [46.7890625, 156.9296875], [-48, 156.9296875], [-46.89453125, 2.5703125]], [[52.89453125, 2.5703125], [40.7890625, 156.9296875], [-62, 156.9296875], [-49.89453125, 2.5703125]]];
			addShapeKeyframes(compcode001Path, compcode001Path_keyTimesArray, compcode001Path_object);
			var compcode001Path_easeInSpeedArray = [0,0,0,0];
			var compcode001Path_easeInInfluArray = [0.1,100,100,0.1];
			var compcode001Path_easeOutSpeedArray = [0,0,0,0];
			var compcode001Path_easeOutInfluArray = [0.1,0.1,0.1,16.666666667];
			var compcode001Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode001Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode001Path, compcode001Path_keyTimesArray, [compcode001Path_easeInSpeedArray, compcode001Path_easeInInfluArray], [compcode001Path_easeOutSpeedArray, compcode001Path_easeOutInfluArray], [compcode001Path_keyInInterpolationType, compcode001Path_keyOutInterpolationType]);

		compcode001.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode001.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode001.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode001.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode001.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode001.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode001.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode001.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		compcode001.property("ADBE Transform Group").property("ADBE Position").setValue([400,527,0]);
		compcode001.selected = false;
	// Add Shape Layer "0 02", varName "compcode002";
	var compcode002 = compcode0_comp.layers.addShape();
		compcode002.name = "0 02";
		compcode002.startTime = 0.04166666666667;
		compcode002.inPoint = 0;
		compcode002.outPoint = 0.58333333333333;
		compcode002.moveToEnd();
		compcode002.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode002.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode002.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode002.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode002.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode002Path = compcode002.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode002Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode002Path_object = {};
				compcode002Path_object.closed = true;
				compcode002Path_object.vertices = [[[47.89453125, -125.1796875], [47.578125, -60.8203125], [-47.2109375, -60.8203125], [-46.89453125, -125.1796875]], [[47.89453125, -153.1796875], [46.7890625, 1.1796875], [-48, 1.1796875], [-46.89453125, -153.1796875]], [[47.89453125, -153.1796875], [46.7890625, 1.1796875], [-48, 1.1796875], [-46.89453125, -153.1796875]], [[64.89453125, -153.1796875], [52.7890625, 1.1796875], [-50, 1.1796875], [-37.89453125, -153.1796875]]];
			addShapeKeyframes(compcode002Path, compcode002Path_keyTimesArray, compcode002Path_object);
			var compcode002Path_easeInSpeedArray = [0,0,0,0];
			var compcode002Path_easeInInfluArray = [0.1,100,100,0.1];
			var compcode002Path_easeOutSpeedArray = [0,0,0,0];
			var compcode002Path_easeOutInfluArray = [0.1,0.1,0.1,16.666666667];
			var compcode002Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode002Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode002Path, compcode002Path_keyTimesArray, [compcode002Path_easeInSpeedArray, compcode002Path_easeInInfluArray], [compcode002Path_easeOutSpeedArray, compcode002Path_easeOutInfluArray], [compcode002Path_keyInInterpolationType, compcode002Path_keyOutInterpolationType]);

		compcode002.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode002.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode002.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode002.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode002.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode002.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode002.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode002.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		compcode002.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([6.052734375,-125.1796875,0]);
		compcode002.property("ADBE Transform Group").property("ADBE Position").setValue([406.052734375,401.8203125,0]);
		compcode002.selected = false;
	// Add Shape Layer "0 03", varName "compcode003";
	var compcode003 = compcode0_comp.layers.addShape();
		compcode003.name = "0 03";
		compcode003.startTime = 0.04166666666667;
		compcode003.inPoint = 0;
		compcode003.outPoint = 0.58333333333333;
		compcode003.moveToEnd();
		compcode003.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode003.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode003.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode003.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode003.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode003Path = compcode003.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode003Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode003Path_object = {};
				compcode003Path_object.closed = true;
				compcode003Path_object.vertices = [[[47.89453125, -125.1796875], [46.89453125, 129.1796875], [-47.89453125, 129.1796875], [-46.89453125, -125.1796875]], [[47.89453125, -153.1796875], [46.89453125, 157.1796875], [-47.89453125, 157.1796875], [-46.89453125, -153.1796875]], [[47.89453125, -153.1796875], [46.89453125, 157.1796875], [-47.89453125, 157.1796875], [-46.89453125, -153.1796875]], [[59.89453125, -153.1796875], [34.89453125, 157.1796875], [-59.89453125, 157.1796875], [-34.89453125, -153.1796875]]];
			addShapeKeyframes(compcode003Path, compcode003Path_keyTimesArray, compcode003Path_object);
			var compcode003Path_easeInSpeedArray = [0,0,0,0];
			var compcode003Path_easeInInfluArray = [0.1,100,0.1,0.1];
			var compcode003Path_easeOutSpeedArray = [0,0,0,0];
			var compcode003Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode003Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode003Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode003Path, compcode003Path_keyTimesArray, [compcode003Path_easeInSpeedArray, compcode003Path_easeInInfluArray], [compcode003Path_easeOutSpeedArray, compcode003Path_easeOutInfluArray], [compcode003Path_keyInInterpolationType, compcode003Path_keyOutInterpolationType]);

		compcode003.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode003.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode003.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode003.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode003.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode003.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode003.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode003.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		compcode003.property("ADBE Transform Group").property("ADBE Position").setValue([400,527,0]);
		compcode003.selected = false;
	// Add Shape Layer "0 05", varName "compcode005";
	var compcode005 = compcode0_comp.layers.addShape();
		compcode005.name = "0 05";
		compcode005.inPoint = 0.58333333333333;
		compcode005.outPoint = 30;
		compcode005.moveToEnd();
		compcode005.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode005.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode005.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode005.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode005Path = compcode005.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode005Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode005Path_object = {};
				compcode005Path_object.closed = false;
				compcode005Path_object.vertices = [[[-19.6537475585938, -7.8837890625], [-129.097564697266, -7.8837890625], [-116.3681640625, 33.3734741210938], [-88.8633117675781, 71.3674926757812], [-19.6537475585938, 109.564331054688], [-19.6537475585938, -7.8837890625]], [[-19.6537475585938, -7.8837890625], [-137.097564697266, -7.8837890625], [-124.3681640625, 33.3734741210938], [-96.8633117675781, 71.3674926757812], [-19.6537475585938, 109.564331054688], [-19.6537475585938, -7.8837890625]]];
				compcode005Path_object.inTangents = [[[0, 0], [0, 0], [-6.27188110351562, -12.7725830078125], [-11.18408203125, -10.9596557617188], [-29.8616943359375, -4.281982421875], [0, 0]], [[0, 0], [0, 0], [-6.27188110351562, -12.7725830078125], [-11.18408203125, -10.9596557617188], [-29.8616943359375, -4.281982421875], [0, 0]]];
				compcode005Path_object.outTangents = [[[0, 0], [2.093505859375, 14.6113891601562], [6.97982788085938, 14.2056884765625], [20.5552673339844, 20.1322021484375], [0, 0], [0, 0]], [[0, 0], [2.093505859375, 14.6113891601562], [6.97982788085938, 14.2056884765625], [20.5552673339844, 20.1322021484375], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode005Path, compcode005Path_keyTimesArray, compcode005Path_object);
			var compcode005Path_easeInSpeedArray = [0,0];
			var compcode005Path_easeInInfluArray = [0.1,100];
			var compcode005Path_easeOutSpeedArray = [0,0];
			var compcode005Path_easeOutInfluArray = [0.1,0.1];
			var compcode005Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode005Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode005Path, compcode005Path_keyTimesArray, [compcode005Path_easeInSpeedArray, compcode005Path_easeInInfluArray], [compcode005Path_easeOutSpeedArray, compcode005Path_easeOutInfluArray], [compcode005Path_keyInInterpolationType, compcode005Path_keyOutInterpolationType]);

		compcode005.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode005.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode005.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode005.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode005.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		compcode005.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode005.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode005Path3 = compcode005.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode005Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode005Path3_object = {};
				compcode005Path3_object.closed = false;
				compcode005Path3_object.vertices = [[[129.420043945312, -7.8837890625], [19.9718627929688, -7.8837890625], [19.9718627929688, 109.564331054688], [89.1857299804688, 71.367431640625], [116.690551757812, 33.3734741210938], [129.419982910156, -7.88381958007812]], [[137.420043945312, -7.8837890625], [19.9718627929688, -7.8837890625], [19.9718627929688, 109.564331054688], [97.1857299804688, 71.367431640625], [124.690551757812, 33.3734741210938], [137.419982910156, -7.88381958007812]]];
				compcode005Path3_object.inTangents = [[[0, 0], [0, 0], [0, 0], [-20.5595703125, 20.1365966796875], [-6.97979736328125, 14.2056884765625], [-2.093505859375, 14.6114196777344]], [[0, 0], [0, 0], [0, 0], [-20.5595703125, 20.1365966796875], [-6.97979736328125, 14.2056884765625], [-2.093505859375, 14.6114196777344]]];
				compcode005Path3_object.outTangents = [[[0, 0], [0, 0], [29.865966796875, -4.27764892578125], [11.1883850097656, -10.9595947265625], [6.2762451171875, -12.7725830078125], [0, 0]], [[0, 0], [0, 0], [29.865966796875, -4.27764892578125], [11.1883850097656, -10.9595947265625], [6.2762451171875, -12.7725830078125], [0, 0]]];
			addShapeKeyframes(compcode005Path3, compcode005Path3_keyTimesArray, compcode005Path3_object);
			var compcode005Path3_easeInSpeedArray = [0,0];
			var compcode005Path3_easeInInfluArray = [0.1,100];
			var compcode005Path3_easeOutSpeedArray = [0,0];
			var compcode005Path3_easeOutInfluArray = [0.1,0.1];
			var compcode005Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode005Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode005Path3, compcode005Path3_keyTimesArray, [compcode005Path3_easeInSpeedArray, compcode005Path3_easeInInfluArray], [compcode005Path3_easeOutSpeedArray, compcode005Path3_easeOutInfluArray], [compcode005Path3_keyInInterpolationType, compcode005Path3_keyOutInterpolationType]);

		compcode005.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode005.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode005.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode005.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode005.property("ADBE Root Vectors Group").property(3).name = "Group 3";
		compcode005.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		compcode005.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var compcode005Path5 = compcode005.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var compcode005Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode005Path5_object = {};
				compcode005Path5_object.closed = false;
				compcode005Path5_object.vertices = [[[0.1590576171875, -166.390625], [-90.0158081054688, -125.655670166016], [-117.162384033203, -87.1350708007812], [-129.270202636719, -46.14111328125], [129.592651367188, -46.14111328125], [117.484802246094, -87.1350708007812], [90.3381958007812, -125.655700683594], [0.15899658203125, -166.390686035156]], [[0.1590576171875, -166.390625], [-98.0158081054688, -125.655670166016], [-125.162384033203, -87.1350708007812], [-137.270202636719, -46.14111328125], [137.592651367188, -46.14111328125], [125.484802246094, -87.1350708007812], [98.3381958007812, -125.655700683594], [0.15899658203125, -166.390686035156]]];
				compcode005Path5_object.inTangents = [[[0, 0], [25.1048583984375, -25.165283203125], [6.8287353515625, -14.3696899414062], [1.9251708984375, -14.4905395507812], [0, 0], [6.04315185546875, 12.7164306640625], [11.1064147949219, 11.1365966796875], [38.3565673828125, 0]], [[0, 0], [25.1048583984375, -25.165283203125], [6.8287353515625, -14.3696899414062], [1.9251708984375, -14.4905395507812], [0, 0], [6.04315185546875, 12.7164306640625], [11.1064147949219, 11.1365966796875], [38.3565673828125, 0]]];
				compcode005Path5_object.outTangents = [[[-38.3565673828125, 0], [-11.1063842773438, 11.1322937011719], [-6.04312133789062, 12.7164306640625], [0, 0], [-1.9251708984375, -14.4905395507812], [-6.82441711425781, -14.3697204589844], [-25.1091918945312, -25.1653137207031], [0, 0]], [[-38.3565673828125, 0], [-11.1063842773438, 11.1322937011719], [-6.04312133789062, 12.7164306640625], [0, 0], [-1.9251708984375, -14.4905395507812], [-6.82440185546875, -14.3697204589844], [-25.1091918945312, -25.1653137207031], [0, 0]]];
			addShapeKeyframes(compcode005Path5, compcode005Path5_keyTimesArray, compcode005Path5_object);
			var compcode005Path5_easeInSpeedArray = [0,0];
			var compcode005Path5_easeInInfluArray = [0.1,100];
			var compcode005Path5_easeOutSpeedArray = [0,0];
			var compcode005Path5_easeOutInfluArray = [0.1,0.1];
			var compcode005Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode005Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode005Path5, compcode005Path5_keyTimesArray, [compcode005Path5_easeInSpeedArray, compcode005Path5_easeInInfluArray], [compcode005Path5_easeOutSpeedArray, compcode005Path5_easeOutInfluArray], [compcode005Path5_keyInInterpolationType, compcode005Path5_keyOutInterpolationType]);

		compcode005.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode005.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		compcode005.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode005.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode005.property("ADBE Root Vectors Group").property(4).name = "Group 4";
		compcode005.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		compcode005.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var compcode005Path7 = compcode005.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var compcode005Path7_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode005Path7_object = {};
				compcode005Path7_object.closed = false;
				compcode005Path7_object.vertices = [[[0.15902709960938, -206.016265869141], [-170.156265258789, -27.700927734375], [0.15902709960938, 150.618713378906], [170.474349975586, -27.700927734375], [0.15902709960938, -206.016296386719]], [[0.1590576171875, -206.016265869141], [-178.156265258789, -27.700927734375], [0.1590576171875, 150.618713378906], [178.474349975586, -27.700927734375], [0.15902709960938, -206.016296386719]]];
				compcode005Path7_object.inTangents = [[[0, 0], [0, -98.4770202636719], [-98.4812927246094, 0], [0, 98.4813232421875], [98.4813385009766, 0]], [[0, 0], [0, -98.4770202636719], [-98.4813232421875, 0], [0, 98.4813232421875], [98.4813385009766, 0]]];
				compcode005Path7_object.outTangents = [[[-98.4812927246094, 0], [0, 98.47705078125], [98.4813995361328, 0], [0, -98.4813842773438], [0, 0]], [[-98.4813232421875, 0], [0, 98.47705078125], [98.4813690185547, 0], [0, -98.4813842773438], [0, 0]]];
			addShapeKeyframes(compcode005Path7, compcode005Path7_keyTimesArray, compcode005Path7_object);
			var compcode005Path7_easeInSpeedArray = [0,0];
			var compcode005Path7_easeInInfluArray = [0.1,100];
			var compcode005Path7_easeOutSpeedArray = [0,0];
			var compcode005Path7_easeOutInfluArray = [0.1,0.1];
			var compcode005Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode005Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode005Path7, compcode005Path7_keyTimesArray, [compcode005Path7_easeInSpeedArray, compcode005Path7_easeInInfluArray], [compcode005Path7_easeOutSpeedArray, compcode005Path7_easeOutInfluArray], [compcode005Path7_keyInInterpolationType, compcode005Path7_keyOutInterpolationType]);

		compcode005.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode005.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		compcode005.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode005.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode005.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode001.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode001.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode002.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode002.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode003.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode003.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode005.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode005.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode005.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode005.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode0_comp.openInViewer();

return {
	compItem : compcode0_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

