// Created using compCode v2.0
// 201801030 from composition "4" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode4();
function utopian_201801030_094309() {

// app.beginUndoGroup("4");

try {

// ANIMATION PRESETS START
	// 4 -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var numbers_folder_properties = {"name":"03 Numbers","typeName":"Folder","label":9,"comment":""};
	var numbers_folder = findProjectItem(utopian_folder, false, numbers_folder_properties);
	if (numbers_folder === null) {
		numbers_folder = app.project.items.addFolder(numbers_folder_properties.name);
		numbers_folder.label = numbers_folder_properties.label;
		numbers_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode4_comp_properties = {"name":"4","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":7,"frameRate":24};
	var compcode4_comp = app.project.items.addComp(compcode4_comp_properties.name, compcode4_comp_properties.width, compcode4_comp_properties.height, 1, 30, 24);
		compcode4_comp.time = 0.875;
		compcode4_comp.bgColor = compcode4_comp_properties.bgColor;
		compcode4_comp.label = compcode4_comp_properties.label;
		compcode4_comp.resolutionFactor = [1, 1];
		compcode4_comp.parentFolder = numbers_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode4_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "4", varName "compcode4_comp";
	compcode4_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode4_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([258.567993164062,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([541.432006835938,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode4_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	//Create new Null layer "compcode401" and replace its source with varName "null10_null";
	var compcode401 = compcode4_comp.layers.addNull();
	var compcode401_source = compcode401.source;
		compcode401.replaceSource(null10_null, true);
		compcode401_source.remove();
		compcode401.name = "4 01";
		compcode401.enabled = false;
		compcode401.outPoint = 0.58333333333333;
		compcode401.moveToEnd();
		var compcode401Position = compcode401.property("ADBE Transform Group").property("ADBE Position");
			var compcode401Position_keyTimesArray = [0,0.33333333333333,0.41666666666667,0.58333333333333];
			var compcode401Position_valuesArray = [[434.968770937008,496,0],[456,496,0],[456,496,0],[440,496,0]];
			compcode401Position.setValuesAtTimes(compcode401Position_keyTimesArray, compcode401Position_valuesArray);
			var compcode401Position_inSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			var compcode401Position_outSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			applySpatialTangents(compcode401Position, compcode401Position_keyTimesArray, compcode401Position_inSpatialTangents, compcode401Position_outSpatialTangents);
			var compcode401Position_easeInSpeedArray = [0,0,0,0];
			var compcode401Position_easeInInfluArray = [99.6000004016053,57.2001145530109,100,0.1];
			var compcode401Position_easeOutSpeedArray = [0,0,0,0];
			var compcode401Position_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode401Position_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode401Position_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode401Position, compcode401Position_keyTimesArray, [compcode401Position_easeInSpeedArray, compcode401Position_easeInInfluArray], [compcode401Position_easeOutSpeedArray, compcode401Position_easeOutInfluArray], [compcode401Position_keyInInterpolationType, compcode401Position_keyOutInterpolationType]);

		compcode401.selected = false;
	// Add Shape Layer "4 02", varName "compcode402";
	var compcode402 = compcode4_comp.layers.addShape();
		compcode402.name = "4 02";
		compcode402.outPoint = 0.58333333333333;
		compcode402.moveToEnd();
		compcode402.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode402.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode402.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode402.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode402.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode402Path = compcode402.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode402Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode402Path_object = {};
				compcode402Path_object.closed = true;
				compcode402Path_object.vertices = [[[87.4843902587891, 79.0000305175781], [87.7578125, 158], [-59.7578125, 158], [-60.0312347412109, 78.9999389648438]], [[87.515625, 78.0000305175781], [87.7578125, 158], [-3.7578125, 158], [-4, 77.9999389648438]], [[87.515625, 78.0000305175781], [87.7578125, 158], [-3.7578125, 158], [-4, 77.9999389648438]], [[101.515625, 78.0000305175781], [101.7578125, 158], [-40.7578125, 158], [-42, 77.7499084472656]]];
			addShapeKeyframes(compcode402Path, compcode402Path_keyTimesArray, compcode402Path_object);
			var compcode402Path_easeInSpeedArray = [0,0,0,0];
			var compcode402Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var compcode402Path_easeOutSpeedArray = [0,0,0,0];
			var compcode402Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var compcode402Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode402Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode402Path, compcode402Path_keyTimesArray, [compcode402Path_easeInSpeedArray, compcode402Path_easeInInfluArray], [compcode402Path_easeOutSpeedArray, compcode402Path_easeOutInfluArray], [compcode402Path_keyInInterpolationType, compcode402Path_keyOutInterpolationType]);

		compcode402.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode402.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode402.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode402.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode402.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode402.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode402.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode402.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		compcode402.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode402.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		compcode402.selected = false;
	// Add Shape Layer "4 03", varName "compcode403";
	var compcode403 = compcode4_comp.layers.addShape();
		compcode403.name = "4 03";
		compcode403.inPoint = 0.41666666666667;
		compcode403.outPoint = 0.58333333333333;
		compcode403.moveToEnd();
		compcode403.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode403.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode403.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode403.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode403.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode403Path = compcode403.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode403Path_keyTimesArray = [0.41666666666667, 0.58333333333333];
			var compcode403Path_object = {};
				compcode403Path_object.closed = true;
				compcode403Path_object.vertices = [[[-3.2421875, -153], [-3.484375, 78], [-4, 78], [-3.7578125, -153]], [[14.7578125, -153], [-7.984375, 77], [-60.5, 78], [-37.7578125, -153]]];
			addShapeKeyframes(compcode403Path, compcode403Path_keyTimesArray, compcode403Path_object);
			var compcode403Path_easeInSpeedArray = [0,0];
			var compcode403Path_easeInInfluArray = [100,16.666666667];
			var compcode403Path_easeOutSpeedArray = [0,0];
			var compcode403Path_easeOutInfluArray = [100,16.666666667];
			var compcode403Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode403Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode403Path, compcode403Path_keyTimesArray, [compcode403Path_easeInSpeedArray, compcode403Path_easeInInfluArray], [compcode403Path_easeOutSpeedArray, compcode403Path_easeOutInfluArray], [compcode403Path_keyInInterpolationType, compcode403Path_keyOutInterpolationType]);

		compcode403.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode403.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode403.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode403.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode403.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		compcode403.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode403.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		compcode403.selected = false;
	// Add Shape Layer "4 04", varName "compcode404";
	var compcode404 = compcode4_comp.layers.addShape();
		compcode404.name = "4 04";
		compcode404.outPoint = 0.58333333333333;
		compcode404.moveToEnd();
		compcode404.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode404.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode404.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode404.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode404.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode404Path = compcode404.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode404Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode404Path_object = {};
				compcode404Path_object.closed = true;
				compcode404Path_object.vertices = [[[87.7578277587891, -153], [87.7578125, 0.00003051757812], [87.7578125, 158], [-59.7578125, 158], [-59.7578125, -1.75003051757812], [-59.7577972412109, -153]], [[87.7578125, -153], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -153]], [[87.7578125, -153], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -153]], [[101.7578125, -153], [101.515625, 68.0000152587891], [101.7578125, 158], [-40.7578125, 158], [-40, 66.2499542236328], [-36.7578125, -153]]];
			addShapeKeyframes(compcode404Path, compcode404Path_keyTimesArray, compcode404Path_object);
			var compcode404Path_easeInSpeedArray = [0,0,0,0];
			var compcode404Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var compcode404Path_easeOutSpeedArray = [0,0,0,0];
			var compcode404Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var compcode404Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode404Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode404Path, compcode404Path_keyTimesArray, [compcode404Path_easeInSpeedArray, compcode404Path_easeInInfluArray], [compcode404Path_easeOutSpeedArray, compcode404Path_easeOutInfluArray], [compcode404Path_keyInInterpolationType, compcode404Path_keyOutInterpolationType]);

		compcode404.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode404.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode404.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode404.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode404.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode404.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode404.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode404.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		compcode404.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode404.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		compcode404.selected = false;
	// Add Shape Layer "4 05", varName "compcode405";
	var compcode405 = compcode4_comp.layers.addShape();
		compcode405.name = "4 05";
		compcode405.inPoint = 0.58333333333333;
		compcode405.outPoint = 30;
		compcode405.moveToEnd();
		compcode405.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode405.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode405.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode405.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode405Path = compcode405.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode405Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode405Path_object = {};
				compcode405Path_object.closed = false;
				compcode405Path_object.vertices = [[[82.8592834472656, 69.8964233398438], [41.0149536132812, 69.8964233398438], [41.0149536132812, 108.7451171875], [82.8592529296875, 108.7451171875], [82.8592529296875, 69.8964233398438]], [[80.6092834472656, 69.8964233398438], [41.7649536132812, 69.8964233398438], [41.7649536132812, 108.7451171875], [80.6092529296875, 108.7451171875], [80.6092529296875, 69.8964233398438]]];
			addShapeKeyframes(compcode405Path, compcode405Path_keyTimesArray, compcode405Path_object);
			var compcode405Path_easeInSpeedArray = [0,0];
			var compcode405Path_easeInInfluArray = [0.1,100];
			var compcode405Path_easeOutSpeedArray = [0,0];
			var compcode405Path_easeOutInfluArray = [0.1,0.1];
			var compcode405Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode405Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode405Path, compcode405Path_keyTimesArray, [compcode405Path_easeInSpeedArray, compcode405Path_easeInInfluArray], [compcode405Path_easeOutSpeedArray, compcode405Path_easeOutInfluArray], [compcode405Path_keyInInterpolationType, compcode405Path_keyOutInterpolationType]);

		compcode405.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode405.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode405.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode405.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode405.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		compcode405.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode405.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode405Path3 = compcode405.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode405Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode405Path3_object = {};
				compcode405Path3_object.closed = false;
				compcode405Path3_object.vertices = [[[82.8592834472656, -66.8033447265625], [82.0003051757812, -65.3746032714844], [45.7649536132812, 31.0175170898438], [82.8592529296875, 31.0477294921875], [82.8592529296875, -65.3746337890625], [82.8592529296875, -66.8034057617188]], [[80.6092834472656, -66.8033447265625], [79.7503051757812, -65.3746032714844], [41.7649536132812, 31.0175170898438], [80.6092529296875, 31.0477294921875], [80.6092529296875, -65.3746337890625], [80.6092529296875, -66.8034057617188]]];
			addShapeKeyframes(compcode405Path3, compcode405Path3_keyTimesArray, compcode405Path3_object);
			var compcode405Path3_easeInSpeedArray = [0,0];
			var compcode405Path3_easeInInfluArray = [0.1,100];
			var compcode405Path3_easeOutSpeedArray = [0,0];
			var compcode405Path3_easeOutInfluArray = [0.1,0.1];
			var compcode405Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode405Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode405Path3, compcode405Path3_keyTimesArray, [compcode405Path3_easeInSpeedArray, compcode405Path3_easeInInfluArray], [compcode405Path3_easeOutSpeedArray, compcode405Path3_easeOutInfluArray], [compcode405Path3_keyInInterpolationType, compcode405Path3_keyOutInterpolationType]);

		compcode405.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode405.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode405.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode405.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode405.property("ADBE Root Vectors Group").property(3).name = "Group 3";
		compcode405.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		compcode405.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var compcode405Path5 = compcode405.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var compcode405Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode405Path5_object = {};
				compcode405Path5_object.closed = false;
				compcode405Path5_object.vertices = [[[77.3592834472656, -163.221435546875], [6.85324096679688, -163.221435546875], [-66.0310363769531, 31.0175170898438], [-65.9835510253906, 31.0477294921875], [-0.925048828125, 31.0477294921875], [-0.86029052734375, 31.0175170898438], [77.3592529296875, -162.125091552734], [77.3592529296875, -163.221496582031]], [[80.6092834472656, -163.221435546875], [10.103271484375, -163.221435546875], [-74.7810363769531, 31.0175170898438], [-74.7335510253906, 31.0477294921875], [-3.675048828125, 31.0477294921875], [-3.61029052734375, 31.0175170898438], [80.6092529296875, -162.125091552734], [80.6092529296875, -163.221496582031]]];
			addShapeKeyframes(compcode405Path5, compcode405Path5_keyTimesArray, compcode405Path5_object);
			var compcode405Path5_easeInSpeedArray = [0,0];
			var compcode405Path5_easeInInfluArray = [0.1,100];
			var compcode405Path5_easeOutSpeedArray = [0,0];
			var compcode405Path5_easeOutInfluArray = [0.1,0.1];
			var compcode405Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode405Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode405Path5, compcode405Path5_keyTimesArray, [compcode405Path5_easeInSpeedArray, compcode405Path5_easeInInfluArray], [compcode405Path5_easeOutSpeedArray, compcode405Path5_easeOutInfluArray], [compcode405Path5_keyInInterpolationType, compcode405Path5_keyOutInterpolationType]);

		compcode405.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode405.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		compcode405.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode405.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode405.property("ADBE Root Vectors Group").property(4).name = "Group 4";
		compcode405.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		compcode405.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var compcode405Path7 = compcode405.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var compcode405Path7_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode405Path7_object = {};
				compcode405Path7_object.closed = true;
				compcode405Path7_object.vertices = [[[-15.09619140625, -202.044189453125], [-15.0789489746094, -201.988098144531], [-15.1264343261719, -201.988098144531], [-111.401977539062, 31.0175018310547], [-111.371765136719, 31.0477294921875], [-111.401977539062, 31.0477294921875], [-111.401977539062, 69.8963623046875], [2.17059326171875, 69.8963623046875], [2.35188293457031, 147.593688964844], [121.716552734375, 147.593688964844], [121.716552734375, 147.567810058594], [121.716552734375, -201.988159179688], [121.716552734375, -202.044281005859]], [[-11.84619140625, -202.044189453125], [-11.8289489746094, -201.988098144531], [-11.8764343261719, -201.988098144531], [-120.151977539062, 31.0175018310547], [-120.121765136719, 31.0477294921875], [-120.151977539062, 31.0477294921875], [-120.151977539062, 69.8963623046875], [2.92059326171875, 69.8963623046875], [3.10186767578125, 147.593688964844], [119.466552734375, 147.593688964844], [119.466552734375, 147.567810058594], [119.466552734375, -201.988159179688], [119.466552734375, -202.044281005859]]];
			addShapeKeyframes(compcode405Path7, compcode405Path7_keyTimesArray, compcode405Path7_object);
			var compcode405Path7_easeInSpeedArray = [0,0];
			var compcode405Path7_easeInInfluArray = [0.1,100];
			var compcode405Path7_easeOutSpeedArray = [0,0];
			var compcode405Path7_easeOutInfluArray = [0.1,0.1];
			var compcode405Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode405Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode405Path7, compcode405Path7_keyTimesArray, [compcode405Path7_easeInSpeedArray, compcode405Path7_easeInInfluArray], [compcode405Path7_easeOutSpeedArray, compcode405Path7_easeOutInfluArray], [compcode405Path7_keyInInterpolationType, compcode405Path7_keyOutInterpolationType]);

		compcode405.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode405.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		compcode405.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode405.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode405.selected = false;
	// Apply parents
		compcode402.setParentWithJump(compcode401);
		compcode403.setParentWithJump(compcode401);
		compcode404.setParentWithJump(compcode401);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode402.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode402.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode403.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode404.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode404.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode405.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode405.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode405.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode405.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode4_comp.openInViewer();

return {
	compItem : compcode4_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function applySpatialTangents(property, keyTimesArray, inSpatialTangentsArray, outSpatialTangentsArray) {
	for (var sp = 0, spl = keyTimesArray.length; sp < spl; sp ++) {
		property.setSpatialTangentsAtKey(sp+1, inSpatialTangentsArray[sp], outSpatialTangentsArray[sp]);
	}
}
function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

