// Created using compCode v2.0
// 201801030 from composition "5" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode5();
function utopian_201801030_094309() {

// app.beginUndoGroup("5");

try {

// ANIMATION PRESETS START
	// 5 -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var numbers_folder_properties = {"name":"03 Numbers","typeName":"Folder","label":9,"comment":""};
	var numbers_folder = findProjectItem(utopian_folder, false, numbers_folder_properties);
	if (numbers_folder === null) {
		numbers_folder = app.project.items.addFolder(numbers_folder_properties.name);
		numbers_folder.label = numbers_folder_properties.label;
		numbers_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode5_comp_properties = {"name":"5","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var compcode5_comp = app.project.items.addComp(compcode5_comp_properties.name, compcode5_comp_properties.width, compcode5_comp_properties.height, 1, 30, 24);
		compcode5_comp.time = 0.83333333333333;
		compcode5_comp.bgColor = compcode5_comp_properties.bgColor;
		compcode5_comp.label = compcode5_comp_properties.label;
		compcode5_comp.resolutionFactor = [1, 1];
		compcode5_comp.parentFolder = numbers_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode5_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "5", varName "compcode5_comp";
	compcode5_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode5_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([241.138000488281,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([558.861999511719,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode5_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "5 01", varName "compcode501";
	var compcode501 = compcode5_comp.layers.addShape();
		compcode501.name = "5 01";
		compcode501.outPoint = 0.625;
		compcode501.moveToEnd();
		compcode501.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode501.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode501.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode501.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode501.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode501Path = compcode501.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode501Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode501Path_object = {};
				compcode501Path_object.closed = true;
				compcode501Path_object.vertices = [[[127.757843017578, -153], [127.757827758789, 0.00003051757812], [127.757827758789, 158], [-19.7577972412109, 158], [-19.7577972412109, -1.75003051757812], [-19.7577819824219, -153]], [[-8.24215698242188, -153], [-8.24217224121094, 0.00003051757812], [-8.24217224121094, 158], [-95.7578125, 158], [-95.7578125, -1.75003051757812], [-95.7577972412109, -153]], [[-8.24215698242188, -153], [-8.24217224121094, 0.00003051757812], [-8.24217224121094, 158], [-95.7578125, 158], [-95.7578125, -1.75003051757812], [-95.7577972412109, -153]], [[38.7578430175781, -153], [38.7578277587891, 0.00003051757812], [38.7578277587891, 158], [-68.7578125, 158], [-68.7578125, -1.75003051757812], [-68.7577972412109, -153]]];
			addShapeKeyframes(compcode501Path, compcode501Path_keyTimesArray, compcode501Path_object);
			var compcode501Path_easeInSpeedArray = [0,0,0,0];
			var compcode501Path_easeInInfluArray = [16.666666667,100,16.666666667,0.1];
			var compcode501Path_easeOutSpeedArray = [0,0,0,0];
			var compcode501Path_easeOutInfluArray = [0.1,16.666666667,100,16.666666667];
			var compcode501Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode501Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode501Path, compcode501Path_keyTimesArray, [compcode501Path_easeInSpeedArray, compcode501Path_easeInInfluArray], [compcode501Path_easeOutSpeedArray, compcode501Path_easeOutInfluArray], [compcode501Path_keyInInterpolationType, compcode501Path_keyOutInterpolationType]);

		compcode501.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode501.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode501.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode501.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode501.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode501.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode501.property("ADBE Root Vectors Group").property(1).property(2).property(3).enabled = false;
		compcode501.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode501.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-166.2421875,-29]);
		compcode501.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode501.property("ADBE Transform Group").property("ADBE Position").setValue([479.7578125,503,0]);
		compcode501.property("ADBE Transform Group").property("ADBE Scale").setValue([-100,100,100]);
		compcode501.property("ADBE Transform Group").property("ADBE Rotate Z").setValue(-180);
		compcode501.selected = false;
	// Add Shape Layer "5 02", varName "compcode502";
	var compcode502 = compcode5_comp.layers.addShape();
		compcode502.name = "5 02";
		compcode502.enabled = false;
		compcode502.outPoint = 0.625;
		compcode502.moveToEnd();
		compcode502.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode502.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode502.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode502.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode502.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode502Path = compcode502.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode502Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode502Path_object = {};
				compcode502Path_object.closed = true;
				compcode502Path_object.vertices = [[[127.757843017578, -153], [127.757827758789, 0.00003051757812], [127.757827758789, 158], [-19.7577972412109, 158], [-19.7577972412109, -1.75003051757812], [-19.7577819824219, -153]], [[-8.24215698242188, -153], [-8.24217224121094, 0.00003051757812], [-8.24217224121094, 158], [-95.7578125, 158], [-95.7578125, -1.75003051757812], [-95.7577972412109, -153]], [[-8.24215698242188, -153], [-8.24217224121094, 0.00003051757812], [-8.24217224121094, 158], [-95.7578125, 158], [-95.7578125, -1.75003051757812], [-95.7577972412109, -153]], [[38.7578430175781, -153], [38.7578277587891, 0.00003051757812], [38.7578277587891, 158], [-68.7578125, 158], [-68.7578125, -1.75003051757812], [-68.7577972412109, -153]]];
			addShapeKeyframes(compcode502Path, compcode502Path_keyTimesArray, compcode502Path_object);
			var compcode502Path_easeInSpeedArray = [0,0,0,0];
			var compcode502Path_easeInInfluArray = [16.666666667,100,16.666666667,0.1];
			var compcode502Path_easeOutSpeedArray = [0,0,0,0];
			var compcode502Path_easeOutInfluArray = [0.1,16.666666667,100,16.666666667];
			var compcode502Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode502Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode502Path, compcode502Path_keyTimesArray, [compcode502Path_easeInSpeedArray, compcode502Path_easeInInfluArray], [compcode502Path_easeOutSpeedArray, compcode502Path_easeOutInfluArray], [compcode502Path_keyInInterpolationType, compcode502Path_keyOutInterpolationType]);

		compcode502.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode502.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode502.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode502.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-166.2421875,-29]);
		compcode502.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode502.property("ADBE Transform Group").property("ADBE Position").setValue([479.7578125,503,0]);
		compcode502.property("ADBE Transform Group").property("ADBE Scale").setValue([-100,100,100]);
		compcode502.property("ADBE Transform Group").property("ADBE Rotate Z").setValue(-180);
		compcode502.selected = false;
	// Add Shape Layer "5 03", varName "compcode503";
	var compcode503 = compcode5_comp.layers.addShape();
		compcode503.name = "5 03";
		compcode503.startTime = 0.04166666666667;
		compcode503.inPoint = 0.41666666666667;
		compcode503.outPoint = 0.625;
		compcode503.moveToEnd();
		compcode503.trackMatteType = TrackMatteType.ALPHA;
		compcode503.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode503.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode503.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode503.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode503Path = compcode503.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode503Path_keyTimesArray = [0.41666666666667, 0.45833333333333, 0.5, 0.54166666666667, 0.58333333333333];
			var compcode503Path_object = {};
				compcode503Path_object.closed = false;
				compcode503Path_object.vertices = [[[130.776062011719, -165.819946289062], [122.613525390625, -165.819946289062], [122.613525390625, -165.578247070312], [122.613525390625, -10.3044738769531], [130.776031494141, -10.3044738769531], [208.473358154297, -86.64208984375], [130.776031494141, -165.820007324219]], [[133.776062011719, -165.819946289062], [125.613525390625, -165.819946289062], [125.613525390625, -165.578247070312], [125.613525390625, -10.3044738769531], [133.776031494141, -10.3044738769531], [211.473358154297, -86.64208984375], [133.776031494141, -165.820007324219]], [[151.823699951172, -165.819946289062], [143.661163330078, -165.819946289062], [143.661163330078, -165.578247070312], [143.661163330078, -10.3044738769531], [151.823669433594, -10.3044738769531], [229.52099609375, -86.64208984375], [151.823669433594, -165.820007324219]], [[189.990447998047, -165.819946289062], [181.827911376953, -165.819946289062], [181.827911376953, -165.578247070312], [181.827911376953, -10.3044738769531], [189.990417480469, -10.3044738769531], [267.687744140625, -86.64208984375], [189.990417480469, -165.820007324219]], [[224.776062011719, -165.819946289062], [216.613525390625, -165.819946289062], [216.613525390625, -165.578247070312], [216.613525390625, -10.3044738769531], [224.776031494141, -10.3044738769531], [302.473358154297, -86.64208984375], [224.776031494141, -165.820007324219]]];
				compcode503Path_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]]];
				compcode503Path_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]]];
			addShapeKeyframes(compcode503Path, compcode503Path_keyTimesArray, compcode503Path_object);
			var compcode503Path_easeInSpeedArray = [0,0,1,1,0];
			var compcode503Path_easeInInfluArray = [16.666666667,16.666666667,16.666666667,16.666666667,0.1];
			var compcode503Path_easeOutSpeedArray = [0,0,1,1,0];
			var compcode503Path_easeOutInfluArray = [100,100,16.666666667,16.666666667,16.666666667];
			var compcode503Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode503Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode503Path, compcode503Path_keyTimesArray, [compcode503Path_easeInSpeedArray, compcode503Path_easeInInfluArray], [compcode503Path_easeOutSpeedArray, compcode503Path_easeOutInfluArray], [compcode503Path_keyInInterpolationType, compcode503Path_keyOutInterpolationType]);

		compcode503.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode503.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode503.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode503.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode503.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		compcode503.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode503.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode503Path3 = compcode503.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode503Path3_keyTimesArray = [0.41666666666667, 0.45833333333333, 0.5, 0.54166666666667, 0.58333333333333];
			var compcode503Path3_object = {};
				compcode503Path3_object.closed = false;
				compcode503Path3_object.vertices = [[[130.007720947266, -204.897369384766], [85.2851257324219, -204.897369384766], [85.3473968505859, 29.0929565429688], [122.613494873047, 28.5485229492188], [130.007690429688, 28.5485229492188], [247.321990966797, -87.4061126708984], [130.007675170898, -204.897430419922]], [[133.007720947266, -204.897369384766], [88.2851257324219, -204.897369384766], [88.3473968505859, 29.0929565429688], [125.613494873047, 28.5485229492188], [133.007690429688, 28.5485229492188], [250.321990966797, -87.4061126708984], [133.007675170898, -204.897430419922]], [[151.055358886719, -204.897369384766], [106.332763671875, -204.897369384766], [106.39501953125, 29.0929565429688], [143.6611328125, 28.5485229492188], [151.055328369141, 28.5485229492188], [268.36962890625, -87.4061126708984], [151.055297851562, -204.897430419922]], [[189.222106933594, -204.897369384766], [144.49951171875, -204.897369384766], [144.561767578125, 29.0929565429688], [181.827880859375, 28.5485229492188], [189.222076416016, 28.5485229492188], [306.536376953125, -87.4061126708984], [189.222061157227, -204.897430419922]], [[224.007720947266, -204.897369384766], [179.285125732422, -204.897369384766], [179.347381591797, 29.0929565429688], [216.613494873047, 28.5485229492188], [224.007690429688, 28.5485229492188], [341.321990966797, -87.4061126708984], [224.007690429688, -204.897430419922]]];
				compcode503Path3_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7866058349609], [64.7909393310547, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7866058349609], [64.7909393310547, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7866058349609], [64.7909545898438, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7866058349609], [64.7909393310547, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7866058349609], [64.7909240722656, 0]]];
				compcode503Path3_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909393310547], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909393310547], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909393310547], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909393310547], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909393310547], [0, 0]]];
			addShapeKeyframes(compcode503Path3, compcode503Path3_keyTimesArray, compcode503Path3_object);
			var compcode503Path3_easeInSpeedArray = [0,0,1,1,0];
			var compcode503Path3_easeInInfluArray = [16.666666667,16.666666667,16.666666667,16.666666667,0.1];
			var compcode503Path3_easeOutSpeedArray = [0,0,1,1,0];
			var compcode503Path3_easeOutInfluArray = [100,100,16.666666667,16.666666667,16.666666667];
			var compcode503Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode503Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode503Path3, compcode503Path3_keyTimesArray, [compcode503Path3_easeInSpeedArray, compcode503Path3_easeInInfluArray], [compcode503Path3_easeOutSpeedArray, compcode503Path3_easeOutInfluArray], [compcode503Path3_keyInInterpolationType, compcode503Path3_keyOutInterpolationType]);

		compcode503.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode503.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode503.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode503.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([51.5184326171875,-85.2260284423828,0]);
		compcode503.property("ADBE Transform Group").property("ADBE Position").setValue([626.518432617188,557.226028442383,0]);
		compcode503.property("ADBE Transform Group").property("ADBE Scale").setValue([100,-100,100]);
		compcode503.property("ADBE Transform Group").property("ADBE Rotate Z").setValue(-180);
		compcode503.selected = false;
	// Add Shape Layer "5 04", varName "compcode504";
	var compcode504 = compcode5_comp.layers.addShape();
		compcode504.name = "5 04";
		compcode504.outPoint = 0.625;
		compcode504.moveToEnd();
		compcode504.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode504.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode504.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode504.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode504.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode504Path = compcode504.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode504Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode504Path_object = {};
				compcode504Path_object.closed = true;
				compcode504Path_object.vertices = [[[127.484405517578, 79.0000305175781], [127.757827758789, 158], [-19.7577972412109, 158], [-20.0312194824219, 78.9999389648438]], [[-8.51559448242188, 79.0000305175781], [-8.24217224121094, 158], [-95.7578125, 158], [-96.0312347412109, 78.9999389648438]], [[-8.51559448242188, 79.0000305175781], [-8.24217224121094, 158], [-95.7578125, 158], [-96.0312347412109, 78.9999389648438]], [[39.4844055175781, 79.0000305175781], [39.7578277587891, 158], [-67.7578125, 158], [-68.0312347412109, 78.9999389648438]]];
			addShapeKeyframes(compcode504Path, compcode504Path_keyTimesArray, compcode504Path_object);
			var compcode504Path_easeInSpeedArray = [0,0,0,0];
			var compcode504Path_easeInInfluArray = [16.666666667,100,16.666666667,0.1];
			var compcode504Path_easeOutSpeedArray = [0,0,0,0];
			var compcode504Path_easeOutInfluArray = [0.1,16.666666667,100,16.666666667];
			var compcode504Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode504Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode504Path, compcode504Path_keyTimesArray, [compcode504Path_easeInSpeedArray, compcode504Path_easeInInfluArray], [compcode504Path_easeOutSpeedArray, compcode504Path_easeOutInfluArray], [compcode504Path_keyInInterpolationType, compcode504Path_keyOutInterpolationType]);

		compcode504.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode504.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode504.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode504.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode504.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode504.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode504.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode504.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-166.2421875,-29]);
		compcode504.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode504.property("ADBE Transform Group").property("ADBE Position").setValue([479.7578125,503,0]);
		compcode504.property("ADBE Transform Group").property("ADBE Scale").setValue([-100,100,100]);
		compcode504.property("ADBE Transform Group").property("ADBE Rotate Z").setValue(-180);
		compcode504.selected = false;
	// Add Shape Layer "5 05", varName "compcode505";
	var compcode505 = compcode5_comp.layers.addShape();
		compcode505.name = "5 05";
		compcode505.outPoint = 0.625;
		compcode505.moveToEnd();
		compcode505.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode505.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode505.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode505.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode505.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode505Path = compcode505.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode505Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode505Path_object = {};
				compcode505Path_object.closed = true;
				compcode505Path_object.vertices = [[[127.757843017578, -153], [127.757827758789, 0.00003051757812], [127.757827758789, 158], [-19.7577972412109, 158], [-19.7577972412109, -1.75003051757812], [-19.7577819824219, -153]], [[-8.24215698242188, -153], [-8.24217224121094, 0.00003051757812], [-8.24217224121094, 158], [-95.7578125, 158], [-95.7578125, -1.75003051757812], [-95.7577972412109, -153]], [[-8.24215698242188, -153], [-8.24217224121094, 0.00003051757812], [-8.24217224121094, 158], [-95.7578125, 158], [-95.7578125, -1.75003051757812], [-95.7577972412109, -153]], [[38.7578430175781, -153], [38.7578277587891, 0.00003051757812], [38.7578277587891, 158], [-68.7578125, 158], [-68.7578125, -1.75003051757812], [-68.7577972412109, -153]]];
			addShapeKeyframes(compcode505Path, compcode505Path_keyTimesArray, compcode505Path_object);
			var compcode505Path_easeInSpeedArray = [0,0,0,0];
			var compcode505Path_easeInInfluArray = [16.666666667,100,16.666666667,0.1];
			var compcode505Path_easeOutSpeedArray = [0,0,0,0];
			var compcode505Path_easeOutInfluArray = [0.1,16.666666667,100,16.666666667];
			var compcode505Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode505Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode505Path, compcode505Path_keyTimesArray, [compcode505Path_easeInSpeedArray, compcode505Path_easeInInfluArray], [compcode505Path_easeOutSpeedArray, compcode505Path_easeOutInfluArray], [compcode505Path_keyInInterpolationType, compcode505Path_keyOutInterpolationType]);

		compcode505.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode505.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode505.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode505.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode505.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode505.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode505.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode505.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-166.2421875,-29]);
		compcode505.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode505.property("ADBE Transform Group").property("ADBE Position").setValue([479.7578125,503,0]);
		compcode505.property("ADBE Transform Group").property("ADBE Scale").setValue([-100,100,100]);
		compcode505.property("ADBE Transform Group").property("ADBE Rotate Z").setValue(-180);
		compcode505.selected = false;
	// Add Shape Layer "5 07", varName "compcode507";
	var compcode507 = compcode5_comp.layers.addShape();
		compcode507.name = "5 07";
		compcode507.inPoint = 0.625;
		compcode507.outPoint = 30;
		compcode507.moveToEnd();
		compcode507.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode507.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode507.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode507.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode507Path = compcode507.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode507Path_keyTimesArray = [0.625, 0.91666666666667];
			var compcode507Path_object = {};
				compcode507Path_object.closed = false;
				compcode507Path_object.vertices = [[[65.4599609375, -58.0371704101562], [-31.0821533203125, 107.752380371094], [0.20394897460938, 111.90771484375], [75.8120422363281, 72.5626220703125], [93.414794921875, 33.3815765380859], [95.3874206542969, 13.7371215820312], [93.4147644042969, -5.9073486328125], [78.81201171875, -45.08837890625], [65.4598999023438, -58.0372314453125]], [[67.7099609375, -57.5371704101562], [-34.0821533203125, 105.752380371094], [0.20394897460938, 111.90771484375], [78.8120422363281, 72.5626220703125], [96.414794921875, 33.381591796875], [98.3874206542969, 13.7371215820312], [96.4147644042969, -5.9073486328125], [78.81201171875, -45.08837890625], [67.7098999023438, -57.5372314453125]]];
				compcode507Path_object.inTangents = [[[0, 0], [0, 0], [-12.0603332519531, 0], [-17.9092407226562, 23.8876342773438], [-2.93954467773438, 14.4690093994141], [0, 6.72515869140625], [1.29061889648438, 6.34527587890625], [8.5423583984375, 11.3955993652344], [4.03594970703125, 3.82012939453125]], [[0, 0], [0, 0], [-12.0603332519531, 0], [-17.9092407226562, 23.8876342773438], [-2.93954467773438, 14.468994140625], [0, 6.72515869140625], [1.29061889648438, 6.34527587890625], [8.5423583984375, 11.3955993652344], [4.03594970703125, 3.82012939453125]]];
				compcode507Path_object.outTangents = [[[0, 0], [10.6747436523438, 3.97979736328125], [32.1580505371094, 0], [8.54240417480469, -11.3955688476562], [1.29061889648438, -6.34959411621094], [0, -6.72943115234375], [-2.93954467773438, -14.4732971191406], [-3.34963989257812, -4.46759033203125], [0, 0]], [[0, 0], [10.6747436523438, 3.97979736328125], [32.1580505371094, 0], [8.54240417480469, -11.3955688476562], [1.29061889648438, -6.349609375], [0, -6.72943115234375], [-2.93954467773438, -14.4732971191406], [-3.34963989257812, -4.46759033203125], [0, 0]]];
			addShapeKeyframes(compcode507Path, compcode507Path_keyTimesArray, compcode507Path_object);
			var compcode507Path_easeInSpeedArray = [0,0];
			var compcode507Path_easeInInfluArray = [16.666666667,100];
			var compcode507Path_easeOutSpeedArray = [0,0];
			var compcode507Path_easeOutInfluArray = [0.1,0.1];
			var compcode507Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode507Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode507Path, compcode507Path_keyTimesArray, [compcode507Path_easeInSpeedArray, compcode507Path_easeInInfluArray], [compcode507Path_easeOutSpeedArray, compcode507Path_easeOutInfluArray], [compcode507Path_keyInInterpolationType, compcode507Path_keyOutInterpolationType]);

		compcode507.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode507.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode507.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode507.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode507.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		compcode507.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode507.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode507Path3 = compcode507.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode507Path3_keyTimesArray = [0.625, 0.91666666666667];
			var compcode507Path3_object = {};
				compcode507Path3_object.closed = false;
				compcode507Path3_object.vertices = [[[75.9904174804688, -162.864532470703], [-3.17587280273438, -162.864532470703], [-28.2980346679688, -123.627410888672], [75.9904174804688, -123.627410888672], [75.9904174804688, -162.864562988281]], [[85.9904174804688, -162.864532470703], [-3.17587280273438, -162.864532470703], [-28.2980346679688, -123.627410888672], [85.9904174804688, -123.627410888672], [85.9904174804688, -162.864562988281]]];
			addShapeKeyframes(compcode507Path3, compcode507Path3_keyTimesArray, compcode507Path3_object);
			var compcode507Path3_easeInSpeedArray = [0,0];
			var compcode507Path3_easeInInfluArray = [16.666666667,100];
			var compcode507Path3_easeOutSpeedArray = [0,0];
			var compcode507Path3_easeOutInfluArray = [0.1,0.1];
			var compcode507Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode507Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode507Path3, compcode507Path3_keyTimesArray, [compcode507Path3_easeInSpeedArray, compcode507Path3_easeInInfluArray], [compcode507Path3_easeOutSpeedArray, compcode507Path3_easeOutInfluArray], [compcode507Path3_keyInInterpolationType, compcode507Path3_keyOutInterpolationType]);

		compcode507.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode507.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode507.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode507.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode507.property("ADBE Root Vectors Group").property(3).name = "Group 3";
		compcode507.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		compcode507.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var compcode507Path5 = compcode507.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var compcode507Path5_keyTimesArray = [0.625, 0.91666666666667];
			var compcode507Path5_object = {};
				compcode507Path5_object.closed = false;
				compcode507Path5_object.vertices = [[[0.2039794921875, -84.4420166015625], [-50.3769836425781, -84.4420166015625], [-50.4114990234375, -84.3859252929688], [-81.8228149414062, -35.320068359375], [-81.8616638183594, -35.2596435546875], [-93.0025939941406, -5.91168212890625], [-94.9709167480469, 13.7327880859375], [-93.0025939941406, 33.3772583007812], [-75.3955078125, 72.5582885742188], [-61.3538818359375, 86.955322265625], [32.1450805664062, -78.7694702148438], [2.40536499023438, -84.385986328125], [0.16940307617188, -84.385986328125], [0.20391845703125, -84.4421081542969]], [[0.2039794921875, -84.4420166015625], [-53.3769836425781, -84.4420166015625], [-53.4114990234375, -84.3859252929688], [-84.8228149414062, -35.320068359375], [-84.8616638183594, -35.2596435546875], [-96.0025939941406, -5.91168212890625], [-97.9709167480469, 13.7327880859375], [-96.0025939941406, 33.3772583007812], [-78.3955078125, 72.5582885742188], [-67.3538818359375, 84.955322265625], [34.3950805664062, -78.2694702148438], [2.40536499023438, -84.385986328125], [0.16940307617188, -84.385986328125], [0.20391845703125, -84.4421081542969]]];
				compcode507Path5_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [2.1280517578125, -10.4934387207031], [0, -6.72512817382812], [-1.28631591796875, -6.34527587890625], [-8.54672241210938, -11.3955688476562], [-4.0186767578125, -3.8157958984375], [0, 0], [11.2358703613281, 0.24172973632812], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [2.1280517578125, -10.4934387207031], [0, -6.72512817382812], [-1.28631591796875, -6.34527587890625], [-8.54672241210938, -11.3955688476562], [-4.0186767578125, -3.8157958984375], [0, 0], [11.2358703613281, 0.24172973632812], [0, 0], [0, 0]]];
				compcode507Path5_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [-5.18414306640625, 8.98696899414062], [-1.28631591796875, 6.349609375], [0, 6.7294921875], [2.93954467773438, 14.4733276367188], [3.3280029296875, 4.4373779296875], [0, 0], [-9.9970703125, -3.71221923828125], [0, 0], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [-5.18414306640625, 8.98696899414062], [-1.28631591796875, 6.349609375], [0, 6.7294921875], [2.93954467773438, 14.4733276367188], [3.3280029296875, 4.4373779296875], [0, 0], [-9.9970703125, -3.71221923828125], [0, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode507Path5, compcode507Path5_keyTimesArray, compcode507Path5_object);
			var compcode507Path5_easeInSpeedArray = [0,0];
			var compcode507Path5_easeInInfluArray = [16.666666667,100];
			var compcode507Path5_easeOutSpeedArray = [0,0];
			var compcode507Path5_easeOutInfluArray = [0.1,0.1];
			var compcode507Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode507Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode507Path5, compcode507Path5_keyTimesArray, [compcode507Path5_easeInSpeedArray, compcode507Path5_easeInInfluArray], [compcode507Path5_easeOutSpeedArray, compcode507Path5_easeOutInfluArray], [compcode507Path5_keyInInterpolationType, compcode507Path5_keyOutInterpolationType]);

		compcode507.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode507.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		compcode507.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode507.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode507.property("ADBE Root Vectors Group").property(4).name = "Group 4";
		compcode507.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		compcode507.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var compcode507Path7 = compcode507.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var compcode507Path7_keyTimesArray = [0.625, 0.91666666666667];
			var compcode507Path7_object = {};
				compcode507Path7_object.closed = false;
				compcode507Path7_object.vertices = [[[115.546997070312, -84.3859252929688], [115.546997070312, -202.101715087891], [-26.9339904785156, -202.101715087891], [-114.632659912109, -56.6048583984375], [-115.003875732422, -56.0048522949219], [-114.982299804688, -55.9919128417969], [-134.156280517578, 13.7328033447266], [0.19961547851562, 151.088684082031], [134.559814453125, 13.7328033447266], [96.2895812988281, -84.385986328125], [115.546936035156, -84.385986328125]], [[125.546997070312, -84.3859252929688], [125.546997070312, -202.101715087891], [-26.9339904785156, -202.101715087891], [-117.632659912109, -56.6048583984375], [-118.003875732422, -56.0048522949219], [-117.982299804688, -55.9919128417969], [-137.156280517578, 13.7328033447266], [0.19961547851562, 151.088684082031], [137.559814453125, 13.7328033447266], [96.2895812988281, -84.385986328125], [125.546936035156, -84.385986328125]]];
				compcode507Path7_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0.28921508789062, -0.48345947265625], [0, 0], [0, 0], [0, -25.4933624267578], [-75.8584594726562, 0], [0, 75.8584442138672], [25.4544982910156, 24.9321899414062], [0, 0]], [[0, 0], [0, 0], [0, 0], [0.28921508789062, -0.48345947265625], [0, 0], [0, 0], [0, -25.4933624267578], [-75.8584594726562, 0], [0, 75.8584442138672], [25.4544982910156, 24.9321899414062], [0, 0]]];
				compcode507Path7_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-12.103515625, 20.4516296386719], [0, 75.8584442138672], [75.8627471923828, 0], [0, -38.4516296386719], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-12.103515625, 20.4516296386719], [0, 75.8584442138672], [75.8627471923828, 0], [0, -38.4516296386719], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode507Path7, compcode507Path7_keyTimesArray, compcode507Path7_object);
			var compcode507Path7_easeInSpeedArray = [0,0];
			var compcode507Path7_easeInInfluArray = [16.666666667,100];
			var compcode507Path7_easeOutSpeedArray = [0,0];
			var compcode507Path7_easeOutInfluArray = [0.1,0.1];
			var compcode507Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode507Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode507Path7, compcode507Path7_keyTimesArray, [compcode507Path7_easeInSpeedArray, compcode507Path7_easeInInfluArray], [compcode507Path7_easeOutSpeedArray, compcode507Path7_easeOutInfluArray], [compcode507Path7_keyInInterpolationType, compcode507Path7_keyOutInterpolationType]);

		compcode507.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode507.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		compcode507.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode507.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode507.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode501.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode501.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode503.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode503.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode504.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode504.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode505.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode505.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode507.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode507.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode507.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode507.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode5_comp.openInViewer();

return {
	compItem : compcode5_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

