// Created using compCode v2.0
// 201801030 from composition "6" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode6();
function utopian_201801030_094309() {

// app.beginUndoGroup("6");

try {

// ANIMATION PRESETS START
	// 6 -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var numbers_folder_properties = {"name":"03 Numbers","typeName":"Folder","label":9,"comment":""};
	var numbers_folder = findProjectItem(utopian_folder, false, numbers_folder_properties);
	if (numbers_folder === null) {
		numbers_folder = app.project.items.addFolder(numbers_folder_properties.name);
		numbers_folder.label = numbers_folder_properties.label;
		numbers_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode6_comp_properties = {"name":"6","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":9,"frameRate":24};
	var compcode6_comp = app.project.items.addComp(compcode6_comp_properties.name, compcode6_comp_properties.width, compcode6_comp_properties.height, 1, 30, 24);
		compcode6_comp.time = 0.91666666666667;
		compcode6_comp.bgColor = compcode6_comp_properties.bgColor;
		compcode6_comp.label = compcode6_comp_properties.label;
		compcode6_comp.resolutionFactor = [1, 1];
		compcode6_comp.parentFolder = numbers_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode6_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "6", varName "compcode6_comp";
	compcode6_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode6_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([241.138000488281,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([558.364013671875,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode6_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	//Create new Null layer "compcode601" and replace its source with varName "null10_null";
	var compcode601 = compcode6_comp.layers.addNull();
	var compcode601_source = compcode601.source;
		compcode601.replaceSource(null10_null, true);
		compcode601_source.remove();
		compcode601.name = "6 01";
		compcode601.enabled = false;
		compcode601.outPoint = 0.58333333333333;
		compcode601.moveToEnd();
		compcode601.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([32,0,0]);
		var compcode601Position = compcode601.property("ADBE Transform Group").property("ADBE Position");
			var compcode601Position_keyTimesArray = [0,0.33333333333333,0.41666666666667,0.54166666666667];
			var compcode601Position_valuesArray = [[434.968770937008,496,0],[456,496,0],[456,496,0],[440,496,0]];
			compcode601Position.setValuesAtTimes(compcode601Position_keyTimesArray, compcode601Position_valuesArray);
			var compcode601Position_inSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			var compcode601Position_outSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			applySpatialTangents(compcode601Position, compcode601Position_keyTimesArray, compcode601Position_inSpatialTangents, compcode601Position_outSpatialTangents);
			var compcode601Position_easeInSpeedArray = [0,0,0,0];
			var compcode601Position_easeInInfluArray = [99.6000004016053,57.2001145530109,100,0.1];
			var compcode601Position_easeOutSpeedArray = [0,0,0,0];
			var compcode601Position_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode601Position_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode601Position_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode601Position, compcode601Position_keyTimesArray, [compcode601Position_easeInSpeedArray, compcode601Position_easeInInfluArray], [compcode601Position_easeOutSpeedArray, compcode601Position_easeOutInfluArray], [compcode601Position_keyInInterpolationType, compcode601Position_keyOutInterpolationType]);

		compcode601.selected = false;
	// Add Shape Layer "6 02", varName "compcode602";
	var compcode602 = compcode6_comp.layers.addShape();
		compcode602.name = "6 02";
		compcode602.outPoint = 0.58333333333333;
		compcode602.moveToEnd();
		compcode602.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode602.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode602.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode602.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode602.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode602Path = compcode602.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode602Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode602Path_object = {};
				compcode602Path_object.closed = true;
				compcode602Path_object.vertices = [[[87.7578277587891, -153], [87.7578125, -68.2642211914062], [87.7578125, 0.00003051757812], [87.7578125, 158], [-59.7578125, 158], [-59.7578125, -1.75003051757812], [-59.7578125, -72.3157958984375], [-59.7577972412109, -153]], [[87.7578125, -153], [87.7578125, -68.2642211914062], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -72.3157958984375], [-3.7578125, -153]], [[87.7578125, -153], [87.7578125, -71], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -73.9999694824219], [-3.7578125, -153]], [[97.7578125, -153], [93.6236877441406, -67.6038970947266], [93.515625, 68.0000152587891], [93.7578125, 158], [-40.7578125, 158], [-40, 66.2499542236328], [-38.4873504638672, -73.041259765625], [-32.7578125, -153]]];
			addShapeKeyframes(compcode602Path, compcode602Path_keyTimesArray, compcode602Path_object);
			var compcode602Path_easeInSpeedArray = [0,0,0,0];
			var compcode602Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var compcode602Path_easeOutSpeedArray = [0,0,0,0];
			var compcode602Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var compcode602Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode602Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode602Path, compcode602Path_keyTimesArray, [compcode602Path_easeInSpeedArray, compcode602Path_easeInInfluArray], [compcode602Path_easeOutSpeedArray, compcode602Path_easeOutInfluArray], [compcode602Path_keyInInterpolationType, compcode602Path_keyOutInterpolationType]);

		compcode602.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode602.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode602.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode602.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode602.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode602.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode602.property("ADBE Root Vectors Group").property(1).property(2).property(3).enabled = false;
		compcode602.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode602.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		compcode602.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode602.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		compcode602.selected = false;
	// Add Shape Layer "6 03", varName "compcode603";
	var compcode603 = compcode6_comp.layers.addShape();
		compcode603.name = "6 03";
		compcode603.enabled = false;
		compcode603.outPoint = 0.58333333333333;
		compcode603.moveToEnd();
		compcode603.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode603.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode603.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode603.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode603.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode603Path = compcode603.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode603Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode603Path_object = {};
				compcode603Path_object.closed = true;
				compcode603Path_object.vertices = [[[87.7578277587891, -153], [87.7578125, -68.2642211914062], [87.7578125, 0.00003051757812], [87.7578125, 158], [-59.7578125, 158], [-59.7578125, -1.75003051757812], [-59.7578125, -72.3157958984375], [-59.7577972412109, -153]], [[87.7578125, -153], [87.7578125, -68.2642211914062], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -72.3157958984375], [-3.7578125, -153]], [[87.7578125, -153], [87.7578125, -71], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -73.9999694824219], [-3.7578125, -153]], [[97.7578125, -153], [93.6236877441406, -67.6038970947266], [93.515625, 68.0000152587891], [93.7578125, 158], [-40.7578125, 158], [-40, 66.2499542236328], [-38.4873504638672, -73.041259765625], [-32.7578125, -153]]];
			addShapeKeyframes(compcode603Path, compcode603Path_keyTimesArray, compcode603Path_object);
			var compcode603Path_easeInSpeedArray = [0,0,0,0];
			var compcode603Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var compcode603Path_easeOutSpeedArray = [0,0,0,0];
			var compcode603Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var compcode603Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode603Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode603Path, compcode603Path_keyTimesArray, [compcode603Path_easeInSpeedArray, compcode603Path_easeInInfluArray], [compcode603Path_easeOutSpeedArray, compcode603Path_easeOutInfluArray], [compcode603Path_keyInInterpolationType, compcode603Path_keyOutInterpolationType]);

		compcode603.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode603.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode603.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode603.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		compcode603.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode603.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		compcode603.selected = false;
	// Add Shape Layer "6 04", varName "compcode604";
	var compcode604 = compcode6_comp.layers.addShape();
		compcode604.name = "6 04";
		compcode604.inPoint = 0.41666666666667;
		compcode604.outPoint = 0.58333333333333;
		compcode604.moveToEnd();
		compcode604.trackMatteType = TrackMatteType.ALPHA;
		compcode604.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode604.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode604.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode604.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode604Path = compcode604.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode604Path_keyTimesArray = [0.41666666666667, 0.54166666666667];
			var compcode604Path_object = {};
				compcode604Path_object.closed = false;
				compcode604Path_object.vertices = [[[226.776062011719, -257.819946289062], [218.613525390625, -257.819946289062], [218.613525390625, -257.578247070312], [218.613525390625, -102.304473876953], [226.776031494141, -102.304473876953], [304.473358154297, -178.64208984375], [226.776031494141, -257.820007324219]], [[266.776062011719, -257.819946289062], [258.613525390625, -257.819946289062], [258.613525390625, -257.578247070312], [258.613525390625, -102.304473876953], [266.776031494141, -102.304473876953], [344.473358154297, -178.64208984375], [266.776031494141, -257.820007324219]]];
				compcode604Path_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]]];
				compcode604Path_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]]];
			addShapeKeyframes(compcode604Path, compcode604Path_keyTimesArray, compcode604Path_object);
			var compcode604Path_easeInSpeedArray = [0,0];
			var compcode604Path_easeInInfluArray = [16.666666667,16.666666667];
			var compcode604Path_easeOutSpeedArray = [0,0];
			var compcode604Path_easeOutInfluArray = [100,16.666666667];
			var compcode604Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode604Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode604Path, compcode604Path_keyTimesArray, [compcode604Path_easeInSpeedArray, compcode604Path_easeInInfluArray], [compcode604Path_easeOutSpeedArray, compcode604Path_easeOutInfluArray], [compcode604Path_keyInInterpolationType, compcode604Path_keyOutInterpolationType]);

		compcode604.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode604.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode604.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode604.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode604.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		compcode604.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode604.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode604Path3 = compcode604.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode604Path3_keyTimesArray = [0.41666666666667, 0.54166666666667];
			var compcode604Path3_object = {};
				compcode604Path3_object.closed = false;
				compcode604Path3_object.vertices = [[[226.007720947266, -296.897369384766], [181.285125732422, -296.897369384766], [181.347381591797, -62.9070434570312], [218.613494873047, -63.4514770507812], [226.007690429688, -63.4514770507812], [343.321990966797, -179.406097412109], [226.007675170898, -296.897430419922]], [[266.007720947266, -296.897369384766], [221.285125732422, -296.897369384766], [221.347381591797, -62.9070434570312], [258.613494873047, -63.4514770507812], [266.007690429688, -63.4514770507812], [383.321990966797, -179.406097412109], [266.007690429688, -296.897430419922]]];
				compcode604Path3_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7865905761719], [64.7909393310547, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7865905761719], [64.7909240722656, 0]]];
				compcode604Path3_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909545898438], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909545898438], [0, 0]]];
			addShapeKeyframes(compcode604Path3, compcode604Path3_keyTimesArray, compcode604Path3_object);
			var compcode604Path3_easeInSpeedArray = [0,0];
			var compcode604Path3_easeInInfluArray = [16.666666667,16.666666667];
			var compcode604Path3_easeOutSpeedArray = [0,0];
			var compcode604Path3_easeOutInfluArray = [100,16.666666667];
			var compcode604Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode604Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode604Path3, compcode604Path3_keyTimesArray, [compcode604Path3_easeInSpeedArray, compcode604Path3_easeInInfluArray], [compcode604Path3_easeOutSpeedArray, compcode604Path3_easeOutInfluArray], [compcode604Path3_keyInInterpolationType, compcode604Path3_keyOutInterpolationType]);

		compcode604.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode604.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode604.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode604.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([51.5184326171875,-85.2260284423828,0]);
		compcode604.property("ADBE Transform Group").property("ADBE Position").setValue([119.518432617188,442.773971557617,0]);
		compcode604.property("ADBE Transform Group").property("ADBE Scale").setValue([100,-100,100]);
		compcode604.selected = false;
	// Add Shape Layer "6 05", varName "compcode605";
	var compcode605 = compcode6_comp.layers.addShape();
		compcode605.name = "6 05";
		compcode605.outPoint = 0.58333333333333;
		compcode605.moveToEnd();
		compcode605.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode605.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode605.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode605.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode605.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode605Path = compcode605.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode605Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode605Path_object = {};
				compcode605Path_object.closed = true;
				compcode605Path_object.vertices = [[[87.4843902587891, 79.0000305175781], [87.7578125, 158], [-59.7578125, 158], [-60.0312347412109, 78.9999389648438]], [[87.515625, 78.0000305175781], [87.7578125, 158], [-3.7578125, 158], [-4, 77.9999389648438]], [[87.515625, 78.0000305175781], [87.7578125, 158], [-3.7578125, 158], [-4, 77.9999389648438]], [[97.515625, 78.0000305175781], [89.7578125, 158], [-36.7578125, 158], [-30, 77.7499084472656]]];
			addShapeKeyframes(compcode605Path, compcode605Path_keyTimesArray, compcode605Path_object);
			var compcode605Path_easeInSpeedArray = [0,0,0,0];
			var compcode605Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var compcode605Path_easeOutSpeedArray = [0,0,0,0];
			var compcode605Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var compcode605Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode605Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode605Path, compcode605Path_keyTimesArray, [compcode605Path_easeInSpeedArray, compcode605Path_easeInInfluArray], [compcode605Path_easeOutSpeedArray, compcode605Path_easeOutInfluArray], [compcode605Path_keyInInterpolationType, compcode605Path_keyOutInterpolationType]);

		compcode605.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode605.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode605.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode605.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode605.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode605.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode605.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode605.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		compcode605.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,201,0]);
		compcode605.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		compcode605.selected = false;
	// Add Shape Layer "6 06", varName "compcode606";
	var compcode606 = compcode6_comp.layers.addShape();
		compcode606.name = "6 06";
		compcode606.outPoint = 0.58333333333333;
		compcode606.moveToEnd();
		compcode606.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode606.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode606.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode606.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode606.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode606Path = compcode606.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode606Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode606Path_object = {};
				compcode606Path_object.closed = true;
				compcode606Path_object.vertices = [[[87.7578277587891, -153], [87.7578125, -68.2642211914062], [87.7578125, 0.00003051757812], [87.7578125, 158], [-59.7578125, 158], [-59.7578125, -1.75003051757812], [-59.7578125, -72.3157958984375], [-59.7577972412109, -153]], [[87.7578125, -153], [87.7578125, -68.2642211914062], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -72.3157958984375], [-3.7578125, -153]], [[87.7578125, -153], [87.7578125, -71], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -73.9999694824219], [-3.7578125, -153]], [[97.7578125, -153], [93.6236877441406, -67.6038970947266], [93.515625, 68.0000152587891], [93.7578125, 158], [-40.7578125, 158], [-40, 66.2499542236328], [-38.4873504638672, -73.041259765625], [-32.7578125, -153]]];
			addShapeKeyframes(compcode606Path, compcode606Path_keyTimesArray, compcode606Path_object);
			var compcode606Path_easeInSpeedArray = [0,0,0,0];
			var compcode606Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var compcode606Path_easeOutSpeedArray = [0,0,0,0];
			var compcode606Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var compcode606Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode606Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode606Path, compcode606Path_keyTimesArray, [compcode606Path_easeInSpeedArray, compcode606Path_easeInInfluArray], [compcode606Path_easeOutSpeedArray, compcode606Path_easeOutInfluArray], [compcode606Path_keyInInterpolationType, compcode606Path_keyOutInterpolationType]);

		compcode606.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode606.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode606.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode606.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		compcode606.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode606.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		compcode606.selected = false;
	// Add Shape Layer "6 07", varName "compcode607";
	var compcode607 = compcode6_comp.layers.addShape();
		compcode607.name = "6 07";
		compcode607.inPoint = 0.58333333333333;
		compcode607.outPoint = 30;
		compcode607.moveToEnd();
		compcode607.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode607.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode607.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode607.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode607Path = compcode607.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode607Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode607Path_object = {};
				compcode607Path_object.closed = false;
				compcode607Path_object.vertices = [[[29.7188110351562, -163.676055908203], [-12.9326782226562, -163.676055908203], [-29.9296569824219, -123.579925537109], [13.3865966796875, -123.579925537109], [29.7187805175781, -163.676086425781]], [[37.7188110351562, -163.676055908203], [-4.93267822265625, -163.676055908203], [-29.9296569824219, -123.579925537109], [13.3865966796875, -123.579925537109], [37.7187805175781, -163.676086425781]]];
			addShapeKeyframes(compcode607Path, compcode607Path_keyTimesArray, compcode607Path_object);
			var compcode607Path_easeInSpeedArray = [0,0];
			var compcode607Path_easeInInfluArray = [0.1,100];
			var compcode607Path_easeOutSpeedArray = [0,0];
			var compcode607Path_easeOutInfluArray = [0.1,0.1];
			var compcode607Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode607Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode607Path, compcode607Path_keyTimesArray, [compcode607Path_easeInSpeedArray, compcode607Path_easeInInfluArray], [compcode607Path_easeOutSpeedArray, compcode607Path_easeOutInfluArray], [compcode607Path_keyInInterpolationType, compcode607Path_keyOutInterpolationType]);

		compcode607.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode607.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode607.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode607.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode607.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		compcode607.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode607.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode607Path3 = compcode607.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode607Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode607Path3_object = {};
				compcode607Path3_object.closed = false;
				compcode607Path3_object.vertices = [[[19.796630859375, -82.3139953613281], [19.796630859375, 109.844421386719], [74.6566772460938, 72.610107421875], [76.4825439453125, 70.05908203125], [92.3112182617188, 33.3729858398438], [94.2752075195312, 13.75439453125], [92.3111877441406, -5.85986328125], [74.6609497070312, -45.0970153808594], [31.8785095214844, -79.0680236816406], [19.7965698242188, -82.3140563964844]], [[19.796630859375, -82.3139953613281], [19.796630859375, 109.844421386719], [78.6566772460938, 72.610107421875], [80.4825439453125, 70.05908203125], [96.3112182617188, 33.3729858398438], [98.2752075195312, 13.75439453125], [96.3111877441406, -5.85986328125], [78.6609497070312, -45.0970153808594], [31.8785095214844, -79.0680236816406], [19.7965698242188, -82.3140563964844]]];
				compcode607Path3_object.inTangents = [[[0, 0], [0, 0], [-14.1495361328125, 18.8330078125], [-0.60430908203125, 0.8546142578125], [-2.73236083984375, 13.4329833984375], [0, 6.7208251953125], [1.281982421875, 6.33663940429688], [8.56826782226562, 11.4042053222656], [18.8200073242188, 6.4229736328125], [4.11795043945312, 0.83743286132812]], [[0, 0], [0, 0], [-14.1495361328125, 18.8330078125], [-0.60430908203125, 0.8546142578125], [-2.73236083984375, 13.4329833984375], [0, 6.7208251953125], [1.281982421875, 6.33663940429688], [8.56826782226562, 11.4042053222656], [18.8200073242188, 6.4229736328125], [4.11795043945312, 0.83743286132812]]];
				compcode607Path3_object.outTangents = [[[0, 0], [23.9307861328125, -4.86041259765625], [0.63018798828125, -0.83740234375], [7.605712890625, -10.8302001953125], [1.281982421875, -6.34098815917969], [0, -6.71649169921875], [-2.94818115234375, -14.4992065429688], [-11.7107543945312, -15.5869445800781], [-3.92373657226562, -1.34243774414062], [0, 0]], [[0, 0], [23.9307861328125, -4.86041259765625], [0.63018798828125, -0.83740234375], [7.605712890625, -10.8302001953125], [1.281982421875, -6.34098815917969], [0, -6.71649169921875], [-2.94818115234375, -14.4992065429688], [-11.7107543945312, -15.5869445800781], [-3.92373657226562, -1.34243774414062], [0, 0]]];
			addShapeKeyframes(compcode607Path3, compcode607Path3_keyTimesArray, compcode607Path3_object);
			var compcode607Path3_easeInSpeedArray = [0,0];
			var compcode607Path3_easeInInfluArray = [0.1,100];
			var compcode607Path3_easeOutSpeedArray = [0,0];
			var compcode607Path3_easeOutInfluArray = [0.1,0.1];
			var compcode607Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode607Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode607Path3, compcode607Path3_keyTimesArray, [compcode607Path3_easeInSpeedArray, compcode607Path3_easeInInfluArray], [compcode607Path3_easeOutSpeedArray, compcode607Path3_easeOutInfluArray], [compcode607Path3_keyInInterpolationType, compcode607Path3_keyOutInterpolationType]);

		compcode607.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode607.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode607.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode607.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode607.property("ADBE Root Vectors Group").property(3).name = "Group 3";
		compcode607.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		compcode607.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var compcode607Path5 = compcode607.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var compcode607Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode607Path5_object = {};
				compcode607Path5_object.closed = false;
				compcode607Path5_object.vertices = [[[-19.4404907226562, -84.3384399414062], [-48.391357421875, -84.3384399414062], [-74.4098815917969, -39.1920166015625], [-83.7896728515625, -20.4194946289062], [-87.9508056640625, -5.86419677734375], [-89.9148254394531, 13.7500610351562], [-87.9508056640625, 33.36865234375], [-70.3005676269531, 72.6057739257812], [-19.4405517578125, 109.805541992188], [-19.4405517578125, -84.3385009765625]], [[-19.4404907226562, -84.3384399414062], [-54.391357421875, -84.3384399414062], [-82.4098815917969, -39.1920166015625], [-91.7896728515625, -20.4194946289062], [-95.9508056640625, -5.86419677734375], [-97.9148254394531, 13.7500610351562], [-95.9508056640625, 33.36865234375], [-78.3005676269531, 72.6057739257812], [-19.4405517578125, 109.805541992188], [-19.4405517578125, -84.3385009765625]]];
				compcode607Path5_object.inTangents = [[[0, 0], [0, 0], [1.29928588867188, -2.0244140625], [2.46041870117188, -6.62152099609375], [1.014404296875, -4.99853515625], [0, -6.71649169921875], [-1.28631591796875, -6.3409423828125], [-8.56826782226562, -11.4085693359375], [-23.9307556152344, -4.86041259765625], [0, 0]], [[0, 0], [0, 0], [1.29928588867188, -2.0244140625], [2.46041870117188, -6.62152099609375], [1.014404296875, -4.99853515625], [0, -6.71649169921875], [-1.28631591796875, -6.3409423828125], [-8.56826782226562, -11.4085693359375], [-23.9307556152344, -4.86041259765625], [0, 0]]];
				compcode607Path5_object.outTangents = [[[0, 0], [0, 0], [-3.76400756835938, 5.86181640625], [-1.743896484375, 4.69207763671875], [-1.28631591796875, 6.336669921875], [0, 6.7208251953125], [2.94384765625, 14.4991455078125], [14.1452331542969, 18.8243408203125], [0, 0], [0, 0]], [[0, 0], [0, 0], [-3.76400756835938, 5.86181640625], [-1.743896484375, 4.69207763671875], [-1.28631591796875, 6.336669921875], [0, 6.7208251953125], [2.94384765625, 14.4991455078125], [14.1452331542969, 18.8243408203125], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode607Path5, compcode607Path5_keyTimesArray, compcode607Path5_object);
			var compcode607Path5_easeInSpeedArray = [0,0];
			var compcode607Path5_easeInInfluArray = [0.1,100];
			var compcode607Path5_easeOutSpeedArray = [0,0];
			var compcode607Path5_easeOutInfluArray = [0.1,0.1];
			var compcode607Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode607Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode607Path5, compcode607Path5_keyTimesArray, [compcode607Path5_easeInSpeedArray, compcode607Path5_easeInInfluArray], [compcode607Path5_easeOutSpeedArray, compcode607Path5_easeOutInfluArray], [compcode607Path5_keyInInterpolationType, compcode607Path5_keyOutInterpolationType]);

		compcode607.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode607.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		compcode607.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode607.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode607.property("ADBE Root Vectors Group").property(4).name = "Group 4";
		compcode607.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		compcode607.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var compcode607Path7 = compcode607.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var compcode607Path7_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode607Path7_object = {};
				compcode607Path7_object.closed = false;
				compcode607Path7_object.vertices = [[[52.567626953125, -113.203002929688], [98.437744140625, -202.049896240234], [-34.9124450683594, -202.049896240234], [-35.2448120117188, -202.049896240234], [-110.146362304688, -55.9271240234375], [-110.344940185547, -55.5904541015625], [-129.156311035156, 13.75439453125], [0.17367553710938, 151.088684082031], [133.503662109375, 13.75439453125], [52.5675354003906, -113.203063964844]], [[52.567626953125, -113.203002929688], [106.437744140625, -202.049896240234], [-26.9124450683594, -202.049896240234], [-27.2448120117188, -202.049896240234], [-118.146362304688, -55.9271240234375], [-118.344940185547, -55.5904541015625], [-137.156311035156, 13.75439453125], [0.17367553710938, 151.088684082031], [137.503662109375, 13.75439453125], [52.5675354003906, -113.203063964844]]];
				compcode607Path7_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, -25.2991333007812], [-75.8455200195312, 0], [0, 75.849853515625], [49.8514404296875, 20.5897979736328]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, -25.2991333007812], [-75.8455200195312, 0], [0, 75.849853515625], [49.8514404296875, 20.5897979736328]]];
				compcode607Path7_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-11.9351806640625, 20.356689453125], [0, 75.849853515625], [75.8498229980469, 0], [0.0042724609375, -57.2888488769531], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-11.9351806640625, 20.356689453125], [0, 75.849853515625], [75.8498229980469, 0], [0.0042724609375, -57.2888488769531], [0, 0]]];
			addShapeKeyframes(compcode607Path7, compcode607Path7_keyTimesArray, compcode607Path7_object);
			var compcode607Path7_easeInSpeedArray = [0,0];
			var compcode607Path7_easeInInfluArray = [0.1,100];
			var compcode607Path7_easeOutSpeedArray = [0,0];
			var compcode607Path7_easeOutInfluArray = [0.1,0.1];
			var compcode607Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode607Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode607Path7, compcode607Path7_keyTimesArray, [compcode607Path7_easeInSpeedArray, compcode607Path7_easeInInfluArray], [compcode607Path7_easeOutSpeedArray, compcode607Path7_easeOutInfluArray], [compcode607Path7_keyInInterpolationType, compcode607Path7_keyOutInterpolationType]);

		compcode607.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode607.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		compcode607.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode607.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode607.selected = false;
	// Apply parents
		compcode602.setParentWithJump(compcode601);
		compcode603.setParentWithJump(compcode601);
		compcode605.setParentWithJump(compcode601);
		compcode606.setParentWithJump(compcode601);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode602.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode602.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode604.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode604.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode605.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode605.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode606.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode607.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode607.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode607.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode607.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode6_comp.openInViewer();

return {
	compItem : compcode6_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function applySpatialTangents(property, keyTimesArray, inSpatialTangentsArray, outSpatialTangentsArray) {
	for (var sp = 0, spl = keyTimesArray.length; sp < spl; sp ++) {
		property.setSpatialTangentsAtKey(sp+1, inSpatialTangentsArray[sp], outSpatialTangentsArray[sp]);
	}
}
function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

