// Created using compCode v2.0
// 201801030 from composition "7" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode7();
function utopian_201801030_094309() {

// app.beginUndoGroup("7");

try {

// ANIMATION PRESETS START
	// 7 -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var numbers_folder_properties = {"name":"03 Numbers","typeName":"Folder","label":9,"comment":""};
	var numbers_folder = findProjectItem(utopian_folder, false, numbers_folder_properties);
	if (numbers_folder === null) {
		numbers_folder = app.project.items.addFolder(numbers_folder_properties.name);
		numbers_folder.label = numbers_folder_properties.label;
		numbers_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode7_comp_properties = {"name":"7","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":5,"frameRate":24};
	var compcode7_comp = app.project.items.addComp(compcode7_comp_properties.name, compcode7_comp_properties.width, compcode7_comp_properties.height, 1, 30, 24);
		compcode7_comp.time = 0.875;
		compcode7_comp.bgColor = compcode7_comp_properties.bgColor;
		compcode7_comp.label = compcode7_comp_properties.label;
		compcode7_comp.resolutionFactor = [1, 1];
		compcode7_comp.parentFolder = numbers_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode7_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "7", varName "compcode7_comp";
	compcode7_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode7_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([252.093994140625,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([547.408020019531,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode7_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "7 01", varName "compcode701";
	var compcode701 = compcode7_comp.layers.addShape();
		compcode701.name = "7 01";
		compcode701.outPoint = 0.58333333333333;
		compcode701.moveToEnd();
		compcode701.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode701.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode701.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode701.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode701.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode701Path = compcode701.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode701Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode701Path_object = {};
				compcode701Path_object.closed = true;
				compcode701Path_object.vertices = [[[104.89453125, 24.1640625], [104.7890625, 187.5859375], [-107.10546875, 187.5859375], [-107, 24.1640625]], [[104.697265625, -58.3359375], [104.697265625, 45.0859375], [-107.197265625, 45.0859375], [-107.197265625, -58.3359375]], [[104.697265625, -58.3359375], [104.697265625, 45.0859375], [-107.197265625, 45.0859375], [-107.197265625, -58.3359375]], [[104.697265625, -54.3359375], [104.697265625, 53.0859375], [-107.197265625, 57.0859375], [-107.197265625, -54.3359375]]];
			addShapeKeyframes(compcode701Path, compcode701Path_keyTimesArray, compcode701Path_object);
			var compcode701Path_easeInSpeedArray = [0,0,0,0];
			var compcode701Path_easeInInfluArray = [0.1,100,0.1,0.1];
			var compcode701Path_easeOutSpeedArray = [0,0,0,0];
			var compcode701Path_easeOutInfluArray = [0.1,0.1,100,0.1];
			var compcode701Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode701Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode701Path, compcode701Path_keyTimesArray, [compcode701Path_easeInSpeedArray, compcode701Path_easeInInfluArray], [compcode701Path_easeOutSpeedArray, compcode701Path_easeOutInfluArray], [compcode701Path_keyInInterpolationType, compcode701Path_keyOutInterpolationType]);

		compcode701.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode701.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode701.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode701.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode701.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode701.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode701.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode701.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([1.447265625,-124.1640625]);
		compcode701.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode701.selected = false;
	// Add Shape Layer "7 02", varName "compcode702";
	var compcode702 = compcode7_comp.layers.addShape();
		compcode702.name = "7 02";
		compcode702.inPoint = 0.41666666666667;
		compcode702.outPoint = 0.58333333333333;
		compcode702.moveToEnd();
		compcode702.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode702.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode702.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode702.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode702.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode702Path = compcode702.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode702Path_keyTimesArray = [0.41666666666667, 0.54166666666667];
			var compcode702Path_object = {};
				compcode702Path_object.closed = true;
				compcode702Path_object.vertices = [[[104.697265625, -58.3359375], [104.697265625, 45.0859375], [-107.197265625, 45.0859375], [-107.197265625, -58.3359375]], [[104.697265625, -50.3359375], [104.697265625, 57.0859375], [-107.197265625, 71.0859375], [-107.197265625, -40.3359375]]];
			addShapeKeyframes(compcode702Path, compcode702Path_keyTimesArray, compcode702Path_object);
			var compcode702Path_easeInSpeedArray = [0,0];
			var compcode702Path_easeInInfluArray = [0.1,0.1];
			var compcode702Path_easeOutSpeedArray = [0,0];
			var compcode702Path_easeOutInfluArray = [100,0.1];
			var compcode702Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode702Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode702Path, compcode702Path_keyTimesArray, [compcode702Path_easeInSpeedArray, compcode702Path_easeInInfluArray], [compcode702Path_easeOutSpeedArray, compcode702Path_easeOutInfluArray], [compcode702Path_keyInInterpolationType, compcode702Path_keyOutInterpolationType]);

		compcode702.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode702.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode702.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode702.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode702.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([1.447265625,-124.1640625]);
		compcode702.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode702.selected = false;
	// Add Shape Layer "7 03", varName "compcode703";
	var compcode703 = compcode7_comp.layers.addShape();
		compcode703.name = "7 03";
		compcode703.inPoint = 0.58333333333333;
		compcode703.outPoint = 30;
		compcode703.moveToEnd();
		compcode703.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode703.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode703.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode703.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode703Path = compcode703.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode703Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode703Path_object = {};
				compcode703Path_object.closed = false;
				compcode703Path_object.vertices = [[[9.81402587890625, 65.581298828125], [-13.2706909179688, 65.581298828125], [-67.7969665527344, 65.581298828125], [-67.8876037597656, 65.581298828125], [-67.8876037597656, 102.7451171875], [-67.7969665527344, 102.7451171875], [-36.907958984375, 102.7451171875], [8.46725463867188, 102.7451171875], [9.81399536132812, 102.7451171875], [9.81399536132812, 100.517761230469], [9.81399536132812, 65.581298828125]], [[9.81402587890625, 69.581298828125], [-13.2706909179688, 69.581298828125], [-67.7969665527344, 69.581298828125], [-67.8876037597656, 69.581298828125], [-67.8876037597656, 108.7451171875], [-67.7969665527344, 108.7451171875], [-36.907958984375, 108.7451171875], [8.46725463867188, 108.7451171875], [9.81399536132812, 108.7451171875], [9.81399536132812, 106.517761230469], [9.81399536132812, 69.581298828125]]];
			addShapeKeyframes(compcode703Path, compcode703Path_keyTimesArray, compcode703Path_object);
			var compcode703Path_easeInSpeedArray = [0,0];
			var compcode703Path_easeInInfluArray = [0.1,100];
			var compcode703Path_easeOutSpeedArray = [0,0];
			var compcode703Path_easeOutInfluArray = [0.1,0.1];
			var compcode703Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode703Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode703Path, compcode703Path_keyTimesArray, [compcode703Path_easeInSpeedArray, compcode703Path_easeInInfluArray], [compcode703Path_easeOutSpeedArray, compcode703Path_easeOutInfluArray], [compcode703Path_keyInInterpolationType, compcode703Path_keyOutInterpolationType]);

		compcode703.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode703.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode703.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode703.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode703.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		compcode703.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode703.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode703Path3 = compcode703.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode703Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode703Path3_object = {};
				compcode703Path3_object.closed = false;
				compcode703Path3_object.vertices = [[[85.6897888183594, -159.195526123047], [55.6727294921875, -159.195526123047], [55.6942749023438, -159.117858886719], [-61.5379943847656, 27.3628540039062], [9.7838134765625, 27.3628540039062], [9.81402587890625, 27.3628540039062], [9.81402587890625, 27.3197021484375], [85.6897583007812, -96.4204711914062], [85.6897583007812, -159.195587158203]], [[85.6897888183594, -163.195526123047], [55.6727294921875, -163.195526123047], [55.6942749023438, -163.117858886719], [-61.5379943847656, 31.3628540039062], [9.7838134765625, 31.3628540039062], [9.81402587890625, 31.3628540039062], [9.81402587890625, 31.3197021484375], [85.6897583007812, -94.4204711914062], [85.6897583007812, -163.195587158203]]];
			addShapeKeyframes(compcode703Path3, compcode703Path3_keyTimesArray, compcode703Path3_object);
			var compcode703Path3_easeInSpeedArray = [0,0];
			var compcode703Path3_easeInInfluArray = [0.1,100];
			var compcode703Path3_easeOutSpeedArray = [0,0];
			var compcode703Path3_easeOutInfluArray = [0.1,0.1];
			var compcode703Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode703Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode703Path3, compcode703Path3_keyTimesArray, [compcode703Path3_easeInSpeedArray, compcode703Path3_easeInInfluArray], [compcode703Path3_easeOutSpeedArray, compcode703Path3_easeOutInfluArray], [compcode703Path3_keyInInterpolationType, compcode703Path3_keyOutInterpolationType]);

		compcode703.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode703.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode703.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode703.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode703.property("ADBE Root Vectors Group").property(3).name = "Group 3";
		compcode703.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		compcode703.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var compcode703Path5 = compcode703.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var compcode703Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode703Path5_object = {};
				compcode703Path5_object.closed = false;
				compcode703Path5_object.vertices = [[[10.3665771484375, -159.195526123047], [-87.3076171875, -159.195526123047], [-87.3076171875, -124.031768798828], [-87.3076171875, -87.817626953125], [-36.3252258300781, -87.8133544921875], [-13.9958801269531, -123.823181152344], [9.831298828125, -158.302062988281], [10.3665466308594, -159.195587158203]], [[10.3665771484375, -163.195526123047], [-87.3076171875, -163.195526123047], [-87.3076171875, -124.031768798828], [-87.3076171875, -85.817626953125], [-36.3252258300781, -85.8133544921875], [-13.9958801269531, -122.823181152344], [9.831298828125, -162.302062988281], [10.3665466308594, -163.195587158203]]];
			addShapeKeyframes(compcode703Path5, compcode703Path5_keyTimesArray, compcode703Path5_object);
			var compcode703Path5_easeInSpeedArray = [0,0];
			var compcode703Path5_easeInInfluArray = [0.1,100];
			var compcode703Path5_easeOutSpeedArray = [0,0];
			var compcode703Path5_easeOutInfluArray = [0.1,0.1];
			var compcode703Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode703Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode703Path5, compcode703Path5_keyTimesArray, [compcode703Path5_easeInSpeedArray, compcode703Path5_easeInInfluArray], [compcode703Path5_easeOutSpeedArray, compcode703Path5_easeOutInfluArray], [compcode703Path5_keyInInterpolationType, compcode703Path5_keyOutInterpolationType]);

		compcode703.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode703.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		compcode703.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode703.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode703.property("ADBE Root Vectors Group").property(4).name = "Group 4";
		compcode703.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		compcode703.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var compcode703Path7 = compcode703.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var compcode703Path7_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode703Path7_object = {};
				compcode703Path7_object.closed = false;
				compcode703Path7_object.vertices = [[[-126.15625, -198.048522949219], [-126.15625, -48.9905700683594], [-55.6891174316406, -48.8956298828125], [-106.723297119141, 27.0476989746094], [-106.73193359375, 27.0476989746094], [-106.73193359375, 27.0649871826172], [-106.73193359375, 141.593688964844], [48.6626586914062, 141.593688964844], [48.6626586914062, 38.1324920654297], [126.355651855469, -88.6292266845703], [126.355651855469, -198.048614501953], [-126.156311035156, -198.048614501953]], [[-126.15625, -202.048522949219], [-126.15625, -46.9905700683594], [-55.6891174316406, -46.8956298828125], [-106.723297119141, 31.0477142333984], [-106.73193359375, 31.0477142333984], [-106.73193359375, 31.0650024414062], [-106.73193359375, 147.593688964844], [48.6626586914062, 147.593688964844], [48.6626586914062, 42.1325073242188], [126.355651855469, -86.6292114257812], [126.355651855469, -202.048614501953], [-126.156311035156, -202.048614501953]]];
			addShapeKeyframes(compcode703Path7, compcode703Path7_keyTimesArray, compcode703Path7_object);
			var compcode703Path7_easeInSpeedArray = [0,0];
			var compcode703Path7_easeInInfluArray = [0.1,100];
			var compcode703Path7_easeOutSpeedArray = [0,0];
			var compcode703Path7_easeOutInfluArray = [0.1,0.1];
			var compcode703Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode703Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode703Path7, compcode703Path7_keyTimesArray, [compcode703Path7_easeInSpeedArray, compcode703Path7_easeInInfluArray], [compcode703Path7_easeOutSpeedArray, compcode703Path7_easeOutInfluArray], [compcode703Path7_keyInInterpolationType, compcode703Path7_keyOutInterpolationType]);

		compcode703.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode703.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		compcode703.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode703.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode703.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode701.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode701.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode702.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode703.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode703.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode703.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode703.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode7_comp.openInViewer();

return {
	compItem : compcode7_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

