// Created using compCode v2.0
// 201801030 from composition "9" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode9();
function utopian_201801030_094309() {

// app.beginUndoGroup("9");

try {

// ANIMATION PRESETS START
	// 9 -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var numbers_folder_properties = {"name":"03 Numbers","typeName":"Folder","label":9,"comment":""};
	var numbers_folder = findProjectItem(utopian_folder, false, numbers_folder_properties);
	if (numbers_folder === null) {
		numbers_folder = app.project.items.addFolder(numbers_folder_properties.name);
		numbers_folder.label = numbers_folder_properties.label;
		numbers_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode9_comp_properties = {"name":"9","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":9,"frameRate":24};
	var compcode9_comp = app.project.items.addComp(compcode9_comp_properties.name, compcode9_comp_properties.width, compcode9_comp_properties.height, 1, 30, 24);
		compcode9_comp.time = 0.875;
		compcode9_comp.bgColor = compcode9_comp_properties.bgColor;
		compcode9_comp.label = compcode9_comp_properties.label;
		compcode9_comp.resolutionFactor = [1, 1];
		compcode9_comp.parentFolder = numbers_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode9_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "9", varName "compcode9_comp";
	compcode9_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode9_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([241.138000488281,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([558.364013671875,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode9_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	//Create new Null layer "compcode901" and replace its source with varName "null10_null";
	var compcode901 = compcode9_comp.layers.addNull();
	var compcode901_source = compcode901.source;
		compcode901.replaceSource(null10_null, true);
		compcode901_source.remove();
		compcode901.name = "9 01";
		compcode901.enabled = false;
		compcode901.outPoint = 0.58333333333333;
		compcode901.moveToEnd();
		compcode901.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([32,0,0]);
		var compcode901Position = compcode901.property("ADBE Transform Group").property("ADBE Position");
			var compcode901Position_keyTimesArray = [0,0.33333333333333,0.41666666666667,0.54166666666667];
			var compcode901Position_valuesArray = [[434.968770937008,502,0],[456,502,0],[456,502,0],[440,502,0]];
			compcode901Position.setValuesAtTimes(compcode901Position_keyTimesArray, compcode901Position_valuesArray);
			var compcode901Position_inSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			var compcode901Position_outSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			applySpatialTangents(compcode901Position, compcode901Position_keyTimesArray, compcode901Position_inSpatialTangents, compcode901Position_outSpatialTangents);
			var compcode901Position_easeInSpeedArray = [0,0,0,0];
			var compcode901Position_easeInInfluArray = [99.6000004016053,57.2001145530109,100,0.1];
			var compcode901Position_easeOutSpeedArray = [0,0,0,0];
			var compcode901Position_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode901Position_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode901Position_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode901Position, compcode901Position_keyTimesArray, [compcode901Position_easeInSpeedArray, compcode901Position_easeInInfluArray], [compcode901Position_easeOutSpeedArray, compcode901Position_easeOutInfluArray], [compcode901Position_keyInInterpolationType, compcode901Position_keyOutInterpolationType]);

		compcode901.property("ADBE Transform Group").property("ADBE Scale").setValue([100,-100,100]);
		compcode901.selected = false;
	// Add Shape Layer "9 02", varName "compcode902";
	var compcode902 = compcode9_comp.layers.addShape();
		compcode902.name = "9 02";
		compcode902.outPoint = 0.58333333333333;
		compcode902.moveToEnd();
		compcode902.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode902.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode902.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode902.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode902.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode902Path = compcode902.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode902Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode902Path_object = {};
				compcode902Path_object.closed = true;
				compcode902Path_object.vertices = [[[87.7578277587891, -153], [87.7578125, -68.2642211914062], [87.7578125, 0.00003051757812], [87.7578125, 158], [-59.7578125, 158], [-59.7578125, -1.75003051757812], [-59.7578125, -72.3157958984375], [-59.7577972412109, -153]], [[87.7578125, -153], [87.7578125, -68.2642211914062], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -72.3157958984375], [-3.7578125, -153]], [[87.7578125, -153], [87.7578125, -71], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -73.9999694824219], [-3.7578125, -153]], [[97.7578125, -153], [93.6236877441406, -67.6038970947266], [93.515625, 68.0000152587891], [93.7578125, 158], [-40.7578125, 158], [-40, 66.2499542236328], [-38.4873504638672, -73.041259765625], [-32.7578125, -153]]];
			addShapeKeyframes(compcode902Path, compcode902Path_keyTimesArray, compcode902Path_object);
			var compcode902Path_easeInSpeedArray = [0,0,0,0];
			var compcode902Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var compcode902Path_easeOutSpeedArray = [0,0,0,0];
			var compcode902Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var compcode902Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode902Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode902Path, compcode902Path_keyTimesArray, [compcode902Path_easeInSpeedArray, compcode902Path_easeInInfluArray], [compcode902Path_easeOutSpeedArray, compcode902Path_easeOutInfluArray], [compcode902Path_keyInInterpolationType, compcode902Path_keyOutInterpolationType]);

		compcode902.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode902.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode902.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode902.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode902.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode902.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode902.property("ADBE Root Vectors Group").property(1).property(2).property(3).enabled = false;
		compcode902.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode902.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		compcode902.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode902.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		compcode902.selected = false;
	// Add Shape Layer "9 03", varName "compcode903";
	var compcode903 = compcode9_comp.layers.addShape();
		compcode903.name = "9 03";
		compcode903.enabled = false;
		compcode903.outPoint = 0.58333333333333;
		compcode903.moveToEnd();
		compcode903.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode903.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode903.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode903.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode903.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode903Path = compcode903.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode903Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode903Path_object = {};
				compcode903Path_object.closed = true;
				compcode903Path_object.vertices = [[[87.7578277587891, -153], [87.7578125, -68.2642211914062], [87.7578125, 0.00003051757812], [87.7578125, 158], [-59.7578125, 158], [-59.7578125, -1.75003051757812], [-59.7578125, -72.3157958984375], [-59.7577972412109, -153]], [[87.7578125, -153], [87.7578125, -68.2642211914062], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -72.3157958984375], [-3.7578125, -153]], [[87.7578125, -153], [87.7578125, -71], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -73.9999694824219], [-3.7578125, -153]], [[97.7578125, -153], [93.6236877441406, -67.6038970947266], [93.515625, 68.0000152587891], [93.7578125, 158], [-40.7578125, 158], [-40, 66.2499542236328], [-38.4873504638672, -73.041259765625], [-32.7578125, -153]]];
			addShapeKeyframes(compcode903Path, compcode903Path_keyTimesArray, compcode903Path_object);
			var compcode903Path_easeInSpeedArray = [0,0,0,0];
			var compcode903Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var compcode903Path_easeOutSpeedArray = [0,0,0,0];
			var compcode903Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var compcode903Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode903Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode903Path, compcode903Path_keyTimesArray, [compcode903Path_easeInSpeedArray, compcode903Path_easeInInfluArray], [compcode903Path_easeOutSpeedArray, compcode903Path_easeOutInfluArray], [compcode903Path_keyInInterpolationType, compcode903Path_keyOutInterpolationType]);

		compcode903.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode903.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode903.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode903.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		compcode903.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode903.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		compcode903.selected = false;
	// Add Shape Layer "9 04", varName "compcode904";
	var compcode904 = compcode9_comp.layers.addShape();
		compcode904.name = "9 04";
		compcode904.inPoint = 0.41666666666667;
		compcode904.outPoint = 0.58333333333333;
		compcode904.moveToEnd();
		compcode904.trackMatteType = TrackMatteType.ALPHA;
		compcode904.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode904.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode904.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode904.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode904Path = compcode904.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode904Path_keyTimesArray = [0.41666666666667, 0.54166666666667];
			var compcode904Path_object = {};
				compcode904Path_object.closed = false;
				compcode904Path_object.vertices = [[[229.776062011719, -257.819946289062], [221.613525390625, -257.819946289062], [221.613525390625, -257.578247070312], [221.613525390625, -102.304473876953], [229.776031494141, -102.304473876953], [307.473358154297, -178.64208984375], [229.776031494141, -257.820007324219]], [[268.776062011719, -257.819946289062], [260.613525390625, -257.819946289062], [260.613525390625, -257.578247070312], [260.613525390625, -102.304473876953], [268.776031494141, -102.304473876953], [346.473358154297, -178.64208984375], [268.776031494141, -257.820007324219]]];
				compcode904Path_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]]];
				compcode904Path_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]]];
			addShapeKeyframes(compcode904Path, compcode904Path_keyTimesArray, compcode904Path_object);
			var compcode904Path_easeInSpeedArray = [0,0];
			var compcode904Path_easeInInfluArray = [16.666666667,0.1];
			var compcode904Path_easeOutSpeedArray = [0,0];
			var compcode904Path_easeOutInfluArray = [100,16.666666667];
			var compcode904Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode904Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode904Path, compcode904Path_keyTimesArray, [compcode904Path_easeInSpeedArray, compcode904Path_easeInInfluArray], [compcode904Path_easeOutSpeedArray, compcode904Path_easeOutInfluArray], [compcode904Path_keyInInterpolationType, compcode904Path_keyOutInterpolationType]);

		compcode904.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode904.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode904.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode904.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode904.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		compcode904.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode904.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode904Path3 = compcode904.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode904Path3_keyTimesArray = [0.41666666666667, 0.54166666666667];
			var compcode904Path3_object = {};
				compcode904Path3_object.closed = false;
				compcode904Path3_object.vertices = [[[229.007720947266, -296.897369384766], [184.285125732422, -296.897369384766], [184.347381591797, -62.9070434570312], [221.613494873047, -63.4514770507812], [229.007690429688, -63.4514770507812], [346.321990966797, -179.406097412109], [229.007675170898, -296.897430419922]], [[268.007720947266, -296.897369384766], [223.285125732422, -296.897369384766], [223.347381591797, -62.9070434570312], [260.613494873047, -63.4514770507812], [268.007690429688, -63.4514770507812], [385.321990966797, -179.406097412109], [268.007690429688, -296.897430419922]]];
				compcode904Path3_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7865905761719], [64.7909393310547, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7865905761719], [64.7909240722656, 0]]];
				compcode904Path3_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909545898438], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909545898438], [0, 0]]];
			addShapeKeyframes(compcode904Path3, compcode904Path3_keyTimesArray, compcode904Path3_object);
			var compcode904Path3_easeInSpeedArray = [0,0];
			var compcode904Path3_easeInInfluArray = [16.666666667,0.1];
			var compcode904Path3_easeOutSpeedArray = [0,0];
			var compcode904Path3_easeOutInfluArray = [100,16.666666667];
			var compcode904Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode904Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode904Path3, compcode904Path3_keyTimesArray, [compcode904Path3_easeInSpeedArray, compcode904Path3_easeInInfluArray], [compcode904Path3_easeOutSpeedArray, compcode904Path3_easeOutInfluArray], [compcode904Path3_keyInInterpolationType, compcode904Path3_keyOutInterpolationType]);

		compcode904.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode904.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode904.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode904.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([51.5184326171875,-170.226028442383,0]);
		compcode904.property("ADBE Transform Group").property("ADBE Position").setValue([119.518432617188,442.773971557617,0]);
		compcode904.property("ADBE Transform Group").property("ADBE Scale").setValue([100,-100,100]);
		compcode904.selected = false;
	// Add Shape Layer "9 05", varName "compcode905";
	var compcode905 = compcode9_comp.layers.addShape();
		compcode905.name = "9 05";
		compcode905.outPoint = 0.58333333333333;
		compcode905.moveToEnd();
		compcode905.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode905.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode905.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode905.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode905.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode905Path = compcode905.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode905Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode905Path_object = {};
				compcode905Path_object.closed = true;
				compcode905Path_object.vertices = [[[87.4843902587891, 79.0000305175781], [87.7578125, 158], [-59.7578125, 158], [-60.0312347412109, 78.9999389648438]], [[87.515625, 78.0000305175781], [87.7578125, 158], [-3.7578125, 158], [-4, 77.9999389648438]], [[87.515625, 78.0000305175781], [87.7578125, 158], [-3.7578125, 158], [-4, 77.9999389648438]], [[97.515625, 78.0000305175781], [89.7578125, 158], [-36.7578125, 158], [-30, 77.7499084472656]]];
			addShapeKeyframes(compcode905Path, compcode905Path_keyTimesArray, compcode905Path_object);
			var compcode905Path_easeInSpeedArray = [0,0,0,0];
			var compcode905Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var compcode905Path_easeOutSpeedArray = [0,0,0,0];
			var compcode905Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var compcode905Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode905Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode905Path, compcode905Path_keyTimesArray, [compcode905Path_easeInSpeedArray, compcode905Path_easeInInfluArray], [compcode905Path_easeOutSpeedArray, compcode905Path_easeOutInfluArray], [compcode905Path_keyInInterpolationType, compcode905Path_keyOutInterpolationType]);

		compcode905.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode905.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode905.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode905.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode905.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode905.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode905.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode905.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		compcode905.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,201,0]);
		compcode905.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		compcode905.selected = false;
	// Add Shape Layer "9 06", varName "compcode906";
	var compcode906 = compcode9_comp.layers.addShape();
		compcode906.name = "9 06";
		compcode906.outPoint = 0.58333333333333;
		compcode906.moveToEnd();
		compcode906.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode906.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode906.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode906.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode906.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode906Path = compcode906.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode906Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode906Path_object = {};
				compcode906Path_object.closed = true;
				compcode906Path_object.vertices = [[[87.7578277587891, -153], [87.7578125, -68.2642211914062], [87.7578125, 0.00003051757812], [87.7578125, 158], [-59.7578125, 158], [-59.7578125, -1.75003051757812], [-59.7578125, -72.3157958984375], [-59.7577972412109, -153]], [[87.7578125, -153], [87.7578125, -68.2642211914062], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -72.3157958984375], [-3.7578125, -153]], [[87.7578125, -153], [87.7578125, -71], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -73.9999694824219], [-3.7578125, -153]], [[97.7578125, -153], [93.6236877441406, -67.6038970947266], [93.515625, 68.0000152587891], [93.7578125, 158], [-40.7578125, 158], [-40, 66.2499542236328], [-38.4873504638672, -73.041259765625], [-32.7578125, -153]]];
			addShapeKeyframes(compcode906Path, compcode906Path_keyTimesArray, compcode906Path_object);
			var compcode906Path_easeInSpeedArray = [0,0,0,0];
			var compcode906Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var compcode906Path_easeOutSpeedArray = [0,0,0,0];
			var compcode906Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var compcode906Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode906Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode906Path, compcode906Path_keyTimesArray, [compcode906Path_easeInSpeedArray, compcode906Path_easeInInfluArray], [compcode906Path_easeOutSpeedArray, compcode906Path_easeOutInfluArray], [compcode906Path_keyInInterpolationType, compcode906Path_keyOutInterpolationType]);

		compcode906.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode906.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode906.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode906.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		compcode906.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode906.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		compcode906.selected = false;
	// Add Shape Layer "9 07", varName "compcode907";
	var compcode907 = compcode9_comp.layers.addShape();
		compcode907.name = "9 07";
		compcode907.inPoint = 0.58333333333333;
		compcode907.outPoint = 30;
		compcode907.moveToEnd();
		compcode907.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode907.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode907.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode907.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode907Path = compcode907.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode907Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode907Path_object = {};
				compcode907Path_object.closed = false;
				compcode907Path_object.vertices = [[[32.2756958007812, 68.6544799804688], [-13.0391235351562, 68.6544799804688], [-29.3670043945312, 108.750610351562], [16.0772705078125, 108.750610351562], [32.2756652832031, 68.6544189453125]], [[32.2756958007812, 68.6544799804688], [-13.0391235351562, 68.6544799804688], [-37.3670043945312, 108.750610351562], [8.0772705078125, 108.750610351562], [32.2756652832031, 68.6544189453125]]];
			addShapeKeyframes(compcode907Path, compcode907Path_keyTimesArray, compcode907Path_object);
			var compcode907Path_easeInSpeedArray = [0,0];
			var compcode907Path_easeInInfluArray = [0.1,100];
			var compcode907Path_easeOutSpeedArray = [0,0];
			var compcode907Path_easeOutInfluArray = [0.1,0.1];
			var compcode907Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode907Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode907Path, compcode907Path_keyTimesArray, [compcode907Path_easeInSpeedArray, compcode907Path_easeInInfluArray], [compcode907Path_easeOutSpeedArray, compcode907Path_easeOutInfluArray], [compcode907Path_keyInInterpolationType, compcode907Path_keyOutInterpolationType]);

		compcode907.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode907.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode907.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode907.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode907.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		compcode907.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode907.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode907Path3 = compcode907.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode907Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode907Path3_object = {};
				compcode907Path3_object.closed = false;
				compcode907Path3_object.vertices = [[[19.7923278808594, -164.7353515625], [19.7923278808594, 29.4129638671875], [47.4553833007812, 29.4129638671875], [48.6423950195312, 27.40576171875], [70.6523132324219, -9.82418823242188], [84.1414184570312, -34.5060424804688], [88.3025512695312, -49.0613403320312], [90.2665405273438, -68.6755981445312], [88.3025207519531, -88.294189453125], [70.6522827148438, -127.531341552734], [19.792236328125, -164.735412597656]], [[19.7923278808594, -164.7353515625], [19.7923278808594, 29.4129638671875], [55.4553833007812, 29.4129638671875], [56.6423950195312, 27.40576171875], [78.6523132324219, -9.82418823242188], [92.1414184570312, -34.5060424804688], [96.3025512695312, -49.0613403320312], [98.2665405273438, -68.6755981445312], [96.3025207519531, -88.294189453125], [78.6522827148438, -127.531341552734], [19.792236328125, -164.735412597656]]];
				compcode907Path3_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-3.3150634765625, 8.9093017578125], [-1.014404296875, 4.99853515625], [0, 6.71649169921875], [1.281982421875, 6.3409423828125], [8.56826782226562, 11.4085388183594], [23.9307556152344, 4.86038208007812]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-3.3150634765625, 8.9093017578125], [-1.014404296875, 4.99853515625], [0, 6.71649169921875], [1.281982421875, 6.3409423828125], [8.56826782226562, 11.4085388183594], [23.9307556152344, 4.86038208007812]]];
				compcode907Path3_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [5.61148071289062, -7.47189331054688], [1.74386596679688, -4.69638061523438], [1.281982421875, -6.336669921875], [0, -6.7208251953125], [-2.94818115234375, -14.4992065429688], [-14.1495666503906, -18.8286743164062], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [5.61148071289062, -7.47189331054688], [1.74386596679688, -4.69638061523438], [1.281982421875, -6.336669921875], [0, -6.7208251953125], [-2.94818115234375, -14.4992065429688], [-14.1495666503906, -18.8286743164062], [0, 0]]];
			addShapeKeyframes(compcode907Path3, compcode907Path3_keyTimesArray, compcode907Path3_object);
			var compcode907Path3_easeInSpeedArray = [0,0];
			var compcode907Path3_easeInInfluArray = [0.1,100];
			var compcode907Path3_easeOutSpeedArray = [0,0];
			var compcode907Path3_easeOutInfluArray = [0.1,0.1];
			var compcode907Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode907Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode907Path3, compcode907Path3_keyTimesArray, [compcode907Path3_easeInSpeedArray, compcode907Path3_easeInInfluArray], [compcode907Path3_easeOutSpeedArray, compcode907Path3_easeOutInfluArray], [compcode907Path3_keyInInterpolationType, compcode907Path3_keyOutInterpolationType]);

		compcode907.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode907.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode907.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode907.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode907.property("ADBE Root Vectors Group").property(3).name = "Group 3";
		compcode907.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		compcode907.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var compcode907Path5 = compcode907.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var compcode907Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode907Path5_object = {};
				compcode907Path5_object.closed = false;
				compcode907Path5_object.vertices = [[[-18.1585083007812, -165.037506103516], [-70.300537109375, -127.531311035156], [-72.1264343261719, -124.980255126953], [-87.9551086425781, -88.294189453125], [-89.9234313964844, -68.6755981445312], [-87.9551086425781, -49.0613403320312], [-70.3048706054688, -9.82421875], [-31.5224609375, 24.146728515625], [-18.162841796875, 27.6776733398438], [-18.162841796875, -165.03759765625]], [[-18.1585083007812, -165.037506103516], [-78.300537109375, -127.531311035156], [-80.1264343261719, -124.980255126953], [-95.9551086425781, -88.294189453125], [-97.9234313964844, -68.6755981445312], [-95.9551086425781, -49.0613403320312], [-78.3048706054688, -9.82421875], [-31.5224609375, 24.146728515625], [-18.162841796875, 27.6776733398438], [-18.162841796875, -165.03759765625]]];
				compcode907Path5_object.inTangents = [[[0, 0], [14.39990234375, -19.1696472167969], [0.60430908203125, -0.85467529296875], [2.72802734375, -13.4329833984375], [0, -6.7208251953125], [-1.28631591796875, -6.336669921875], [-8.56829833984375, -11.4085693359375], [-18.8200073242188, -6.4229736328125], [-4.57119750976562, -0.8719482421875], [0, 0]], [[0, 0], [14.39990234375, -19.1696472167969], [0.60430908203125, -0.85467529296875], [2.72802734375, -13.4329833984375], [0, -6.7208251953125], [-1.28631591796875, -6.336669921875], [-8.56829833984375, -11.4085693359375], [-18.8200073242188, -6.4229736328125], [-4.57119750976562, -0.8719482421875], [0, 0]]];
				compcode907Path5_object.outTangents = [[[-24.4789733886719, 4.62728881835938], [-0.63021850585938, 0.83740234375], [-7.61001586914062, 10.8301391601562], [-1.28631591796875, 6.34097290039062], [0, 6.71649169921875], [2.94384765625, 14.4991455078125], [11.710693359375, 15.5869140625], [4.32513427734375, 1.4805908203125], [0, 0], [0, 0]], [[-24.4789733886719, 4.62728881835938], [-0.63021850585938, 0.83740234375], [-7.61001586914062, 10.8301391601562], [-1.28631591796875, 6.34097290039062], [0, 6.71649169921875], [2.94384765625, 14.4991455078125], [11.710693359375, 15.5869140625], [4.32513427734375, 1.4805908203125], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode907Path5, compcode907Path5_keyTimesArray, compcode907Path5_object);
			var compcode907Path5_easeInSpeedArray = [0,0];
			var compcode907Path5_easeInInfluArray = [0.1,100];
			var compcode907Path5_easeOutSpeedArray = [0,0];
			var compcode907Path5_easeOutInfluArray = [0.1,0.1];
			var compcode907Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode907Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode907Path5, compcode907Path5_keyTimesArray, [compcode907Path5_easeInSpeedArray, compcode907Path5_easeInInfluArray], [compcode907Path5_easeOutSpeedArray, compcode907Path5_easeOutInfluArray], [compcode907Path5_keyInInterpolationType, compcode907Path5_keyOutInterpolationType]);

		compcode907.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode907.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		compcode907.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode907.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode907.property("ADBE Root Vectors Group").property(4).name = "Group 4";
		compcode907.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		compcode907.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var compcode907Path7 = compcode907.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var compcode907Path7_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode907Path7_object = {};
				compcode907Path7_object.closed = false;
				compcode907Path7_object.vertices = [[[0.17376708984375, -206.009887695312], [-129.156280517578, -68.675537109375], [-52.2115173339844, 58.2818603515625], [-98.0859680175781, 147.128723144531], [38.7476196289062, 147.128723144531], [110.791625976562, 0.863525390625], [110.692260742188, 0.66925048828125], [129.503662109375, -68.6755981445312], [0.17364501953125, -206.009979248047]], [[0.17376708984375, -206.009887695312], [-137.156280517578, -68.675537109375], [-52.2115173339844, 58.2818603515625], [-106.085968017578, 147.128723144531], [30.7476196289062, 147.128723144531], [118.791625976562, 0.863525390625], [118.692260742188, 0.66925048828125], [137.503662109375, -68.6755981445312], [0.17364501953125, -206.009979248047]]];
				compcode907Path7_object.inTangents = [[[0, 0], [0, -75.8498840332031], [-49.8557739257812, -20.5941162109375], [0, 0], [0, 0], [0, 0], [0, 0], [0, 25.299072265625], [75.8455200195312, 0]], [[0, 0], [0, -75.8498840332031], [-49.8557739257812, -20.5941162109375], [0, 0], [0, 0], [0, 0], [0, 0], [0, 25.299072265625], [75.8455200195312, 0]]];
				compcode907Path7_object.outTangents = [[[-75.8455505371094, 0], [0, 57.2844848632812], [0, 0], [0, 0], [0, 0], [0, 0], [11.9395141601562, -20.356689453125], [0, -75.8498840332031], [0, 0]], [[-75.8455505371094, 0], [0, 57.2844848632812], [0, 0], [0, 0], [0, 0], [0, 0], [11.9395141601562, -20.356689453125], [0, -75.8498840332031], [0, 0]]];
			addShapeKeyframes(compcode907Path7, compcode907Path7_keyTimesArray, compcode907Path7_object);
			var compcode907Path7_easeInSpeedArray = [0,0];
			var compcode907Path7_easeInInfluArray = [0.1,100];
			var compcode907Path7_easeOutSpeedArray = [0,0];
			var compcode907Path7_easeOutInfluArray = [0.1,0.1];
			var compcode907Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode907Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode907Path7, compcode907Path7_keyTimesArray, [compcode907Path7_easeInSpeedArray, compcode907Path7_easeInInfluArray], [compcode907Path7_easeOutSpeedArray, compcode907Path7_easeOutInfluArray], [compcode907Path7_keyInInterpolationType, compcode907Path7_keyOutInterpolationType]);

		compcode907.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode907.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		compcode907.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode907.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode907.selected = false;
	// Apply parents
		compcode902.setParentWithJump(compcode901);
		compcode903.setParentWithJump(compcode901);
		compcode905.setParentWithJump(compcode901);
		compcode906.setParentWithJump(compcode901);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode902.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode902.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode904.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode904.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode905.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode905.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode906.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode907.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode907.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode907.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode907.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode9_comp.openInViewer();

return {
	compItem : compcode9_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function applySpatialTangents(property, keyTimesArray, inSpatialTangentsArray, outSpatialTangentsArray) {
	for (var sp = 0, spl = keyTimesArray.length; sp < spl; sp ++) {
		property.setSpatialTangentsAtKey(sp+1, inSpatialTangentsArray[sp], outSpatialTangentsArray[sp]);
	}
}
function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

