// Created using compCode v2.0
// 201801030 from composition "$" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode();
function utopian_201801030_094309() {

// app.beginUndoGroup("$");

try {

// ANIMATION PRESETS START
	// $ -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var specialCharacters_folder_properties = {"name":"05 Special Characters","typeName":"Folder","label":9,"comment":""};
	var specialCharacters_folder = findProjectItem(utopian_folder, false, specialCharacters_folder_properties);
	if (specialCharacters_folder === null) {
		specialCharacters_folder = app.project.items.addFolder(specialCharacters_folder_properties.name);
		specialCharacters_folder.label = specialCharacters_folder_properties.label;
		specialCharacters_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode_comp_properties = {"name":"$","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":7,"frameRate":24};
	var compcode_comp = app.project.items.addComp(compcode_comp_properties.name, compcode_comp_properties.width, compcode_comp_properties.height, 1, 30, 24);
		compcode_comp.time = 3.08333333333333;
		compcode_comp.bgColor = compcode_comp_properties.bgColor;
		compcode_comp.label = compcode_comp_properties.label;
		compcode_comp.resolutionFactor = [1, 1];
		compcode_comp.parentFolder = specialCharacters_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "$", varName "compcode_comp";
	compcode_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([262.053985595703,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([538.443969726562,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	//Create new Null layer "compcode01" and replace its source with varName "null10_null";
	var compcode01 = compcode_comp.layers.addNull();
	var compcode01_source = compcode01.source;
		compcode01.replaceSource(null10_null, true);
		compcode01_source.remove();
		compcode01.name = "$ 01";
		compcode01.enabled = false;
		compcode01.startTime = -0.45833333333333;
		compcode01.inPoint = -0.08333333333333;
		compcode01.outPoint = 0.58333333333333;
		compcode01.moveToEnd();
		compcode01.property("ADBE Transform Group").property("ADBE Position").setValue([400,480,0]);
		compcode01.selected = false;
	// Add Shape Layer "$ 02", varName "compcode02";
	var compcode02 = compcode_comp.layers.addShape();
		compcode02.name = "$ 02";
		compcode02.startTime = -0.95833333333333;
		compcode02.inPoint = -0.08333333333333;
		compcode02.outPoint = 0.58333333333333;
		compcode02.moveToEnd();
		compcode02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode02.property("ADBE Root Vectors Group").property(1).name = "Ellipse 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode02Path = compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var compcode02Path_newShape = new Shape();
			compcode02Path_newShape.vertices = [[0.00001525878906, -78.18359375], [78.18359375, 0.00003051757812], [0.00001525878906, 78.18359375], [-17.8904113769531, 78.0309143066406], [-17.5902252197266, -78.1152496337891]];
			compcode02Path_newShape.inTangents = [[-4.32063293457031, -0.33651733398438], [0, -43.1796264648438], [43.1796112060547, 0], [0, 0], [-0.00001525878906, 0.00001525878906]];
			compcode02Path_newShape.outTangents = [[43.1796112060547, 0], [0, 43.1795654296875], [-3.45692443847656, -0.08184814453125], [0.00001525878906, 0], [0, 0]];
			compcode02Path_newShape.closed = true;
		compcode02Path.setValue(compcode02Path_newShape);
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([19,53]);
		compcode02.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([0.25,53,0]);
		var compcode02Position1 = compcode02.property("ADBE Transform Group").property("ADBE Position");
			var compcode02Position1_keyTimesArray = [-0.125,-0.08333333333333,0.29166666666667,0.375,0.58333333333333];
			var compcode02Position1_valuesArray = [[18.25,0,0],[-1.13036417691049,13.389077846619,0],[2.25,97,0],[2.25,97,0],[2.25,92,0]];
			compcode02Position1.setValuesAtTimes(compcode02Position1_keyTimesArray, compcode02Position1_valuesArray);
			var compcode02Position1_inSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			var compcode02Position1_outSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			applySpatialTangents(compcode02Position1, compcode02Position1_keyTimesArray, compcode02Position1_inSpatialTangents, compcode02Position1_outSpatialTangents);
			var compcode02Position1_easeInSpeedArray = [0,493.340711896204,0,0,0];
			var compcode02Position1_easeInInfluArray = [100,62.9178066248662,100,100,0.1];
			var compcode02Position1_easeOutSpeedArray = [0,0,0,0,0];
			var compcode02Position1_easeOutInfluArray = [0.79896486063303,0.1,16.666666667,100,16.666666667];
			var compcode02Position1_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode02Position1_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode02Position1, compcode02Position1_keyTimesArray, [compcode02Position1_easeInSpeedArray, compcode02Position1_easeInInfluArray], [compcode02Position1_easeOutSpeedArray, compcode02Position1_easeOutInfluArray], [compcode02Position1_keyInInterpolationType, compcode02Position1_keyOutInterpolationType]);

		compcode02.property("ADBE Transform Group").property("ADBE Rotate Z").setValue(180);
		compcode02.selected = false;
	// Add Shape Layer "$ 03", varName "compcode03";
	var compcode03 = compcode_comp.layers.addShape();
		compcode03.name = "$ 03";
		compcode03.startTime = -0.95833333333333;
		compcode03.inPoint = -0.08333333333333;
		compcode03.outPoint = 0.58333333333333;
		compcode03.moveToEnd();
		compcode03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode03.property("ADBE Root Vectors Group").property(1).name = "Ellipse 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode03Path = compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var compcode03Path_newShape = new Shape();
			compcode03Path_newShape.vertices = [[0.00001525878906, -78.18359375], [78.18359375, 0.00003051757812], [0.00001525878906, 78.18359375], [-17.8904113769531, 78.0309143066406], [-19.5902252197266, -78.1152496337891]];
			compcode03Path_newShape.inTangents = [[-4.32063293457031, -0.33651733398438], [0, -43.1796264648438], [43.1795959472656, 0], [0, 0], [-0.00001525878906, 0.00001525878906]];
			compcode03Path_newShape.outTangents = [[43.1795959472656, 0], [0, 43.1795654296875], [-3.45692443847656, -0.08184814453125], [0.00001525878906, 0], [0, 0]];
			compcode03Path_newShape.closed = true;
		compcode03Path.setValue(compcode03Path_newShape);
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode03.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([19,53]);
		compcode03.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([0.25,53,0]);
		var compcode03Position1 = compcode03.property("ADBE Transform Group").property("ADBE Position");
			var compcode03Position1_keyTimesArray = [-0.125,-0.08333333333333,0.29166666666667,0.375,0.58333333333333];
			var compcode03Position1_valuesArray = [[-19.8,0,0],[2.07496718268674,-11.4416580130305,0],[1.25,-58,0],[1.25,-58,0],[1.25,-52,0]];
			compcode03Position1.setValuesAtTimes(compcode03Position1_keyTimesArray, compcode03Position1_valuesArray);
			var compcode03Position1_inSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			var compcode03Position1_outSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			applySpatialTangents(compcode03Position1, compcode03Position1_keyTimesArray, compcode03Position1_inSpatialTangents, compcode03Position1_outSpatialTangents);
			var compcode03Position1_easeInSpeedArray = [0,334.710284658808,0,0,0];
			var compcode03Position1_easeInInfluArray = [100,62.9178066248662,100,100,0.1];
			var compcode03Position1_easeOutSpeedArray = [0,0,0,0,0];
			var compcode03Position1_easeOutInfluArray = [0.79896486063303,0.1,16.666666667,100,16.666666667];
			var compcode03Position1_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode03Position1_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode03Position1, compcode03Position1_keyTimesArray, [compcode03Position1_easeInSpeedArray, compcode03Position1_easeInInfluArray], [compcode03Position1_easeOutSpeedArray, compcode03Position1_easeOutInfluArray], [compcode03Position1_keyInInterpolationType, compcode03Position1_keyOutInterpolationType]);

		compcode03.selected = false;
	// Add Shape Layer "$ 04", varName "compcode04";
	var compcode04 = compcode_comp.layers.addShape();
		compcode04.name = "$ 04";
		compcode04.startTime = -0.04166666666667;
		compcode04.outPoint = 0.58333333333333;
		compcode04.moveToEnd();
		compcode04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode04.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode04Path = compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode04Path_keyTimesArray = [-0.04166666666667, 0.29166666666667, 0.375, 0.58333333333333];
			var compcode04Path_object = {};
				compcode04Path_object.closed = true;
				compcode04Path_object.vertices = [[[98.0604553222656, -157.776992797852], [98.4241333007812, 109.712326049805], [-95.5758666992188, 109.712326049805], [-95.9395446777344, -157.776992797852]], [[97, -169], [97, 142], [-97, 142], [-97, -169]], [[97, -169], [97, 142], [-97, 142], [-97, -169]], [[97, -164], [97, 138], [-97, 138], [-97, -164]]];
			addShapeKeyframes(compcode04Path, compcode04Path_keyTimesArray, compcode04Path_object);
			var compcode04Path_easeInSpeedArray = [0,0,0,0];
			var compcode04Path_easeInInfluArray = [0.1,100,100,0.1];
			var compcode04Path_easeOutSpeedArray = [0,0,0,0];
			var compcode04Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode04Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode04Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode04Path, compcode04Path_keyTimesArray, [compcode04Path_easeInSpeedArray, compcode04Path_easeInInfluArray], [compcode04Path_easeOutSpeedArray, compcode04Path_easeOutInfluArray], [compcode04Path_keyInInterpolationType, compcode04Path_keyOutInterpolationType]);

		compcode04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode04.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([1,-13]);
		compcode04.property("ADBE Transform Group").property("ADBE Position").setValue([0,46,0]);
		compcode04.selected = false;
	// Add Shape Layer "$ 05", varName "compcode05";
	var compcode05 = compcode_comp.layers.addShape();
		compcode05.name = "$ 05";
		compcode05.inPoint = 0.58333333333333;
		compcode05.outPoint = 30;
		compcode05.moveToEnd();
		compcode05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode05.property("ADBE Root Vectors Group").property(1).name = "Group 2";
		compcode05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode05Path = compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode05Path_keyTimesArray = [0.58333333333333, 0.875];
			var compcode05Path_object = {};
				compcode05Path_object.closed = false;
				compcode05Path_object.vertices = [[[-19.6273803710938, 41.59814453125], [-75.8888854980469, 41.59814453125], [-75.8888854980469, 98.2954711914062], [-19.6273803710938, 98.2954711914062], [-19.6273803710938, 41.59814453125]], [[-19.6273803710938, 31.59814453125], [-75.8888854980469, 31.59814453125], [-75.8888854980469, 109.295471191406], [-19.6273803710938, 109.295471191406], [-19.6273803710938, 31.59814453125]]];
			addShapeKeyframes(compcode05Path, compcode05Path_keyTimesArray, compcode05Path_object);
			var compcode05Path_easeInSpeedArray = [0,0];
			var compcode05Path_easeInInfluArray = [0.1,100];
			var compcode05Path_easeOutSpeedArray = [0,0];
			var compcode05Path_easeOutInfluArray = [0.1,0.1];
			var compcode05Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode05Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode05Path, compcode05Path_keyTimesArray, [compcode05Path_easeInSpeedArray, compcode05Path_easeInInfluArray], [compcode05Path_easeOutSpeedArray, compcode05Path_easeOutInfluArray], [compcode05Path_keyInInterpolationType, compcode05Path_keyOutInterpolationType]);

		compcode05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode05.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		compcode05.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode05.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode05Path3 = compcode05.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode05Path3_keyTimesArray = [0.58333333333333, 0.875];
			var compcode05Path3_object = {};
				compcode05Path3_object.closed = false;
				compcode05Path3_object.vertices = [[[65.6972045898438, -152.645141601562], [19.2212524414062, -152.645141601562], [19.2212524414062, -94.9478149414062], [65.6972045898438, -94.9478149414062], [65.6972045898438, -152.645172119141]], [[65.6972045898438, -162.645141601562], [19.2212524414062, -162.645141601562], [19.2212524414062, -84.9478149414062], [65.6972045898438, -84.9478149414062], [65.6972045898438, -162.645172119141]]];
			addShapeKeyframes(compcode05Path3, compcode05Path3_keyTimesArray, compcode05Path3_object);
			var compcode05Path3_easeInSpeedArray = [0,0];
			var compcode05Path3_easeInInfluArray = [0.1,100];
			var compcode05Path3_easeOutSpeedArray = [0,0];
			var compcode05Path3_easeOutInfluArray = [0.1,0.1];
			var compcode05Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode05Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode05Path3, compcode05Path3_keyTimesArray, [compcode05Path3_easeInSpeedArray, compcode05Path3_easeInInfluArray], [compcode05Path3_easeOutSpeedArray, compcode05Path3_easeOutInfluArray], [compcode05Path3_keyInInterpolationType, compcode05Path3_keyOutInterpolationType]);

		compcode05.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode05.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode05.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode05.property("ADBE Root Vectors Group").property(3).name = "Group 4";
		compcode05.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		compcode05.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var compcode05Path5 = compcode05.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var compcode05Path5_keyTimesArray = [0.58333333333333, 0.875];
			var compcode05Path5_object = {};
				compcode05Path5_object.closed = false;
				compcode05Path5_object.vertices = [[[-19.6273803710938, -152.148742675781], [-77.9046936035156, -94.1217956542969], [-19.6273803710938, -36.0991821289062], [-19.6273803710938, -152.148773193359]], [[-19.6273803710938, -162.148742675781], [-77.9046936035156, -104.121795654297], [-19.6273803710938, -46.0991821289062], [-19.6273803710938, -162.148773193359]]];
				compcode05Path5_object.inTangents = [[[0, 0], [0.13381958007812, -32.0674133300781], [-32.1062622070312, 0], [0, 0]], [[0, 0], [0.13381958007812, -32.0674133300781], [-32.1062622070312, 0], [0, 0]]];
				compcode05Path5_object.outTangents = [[[-32.1019592285156, 0], [0.13381958007812, 32.0717163085938], [0, 0], [0, 0]], [[-32.1019592285156, 0], [0.13381958007812, 32.0717163085938], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode05Path5, compcode05Path5_keyTimesArray, compcode05Path5_object);
			var compcode05Path5_easeInSpeedArray = [0,0];
			var compcode05Path5_easeInInfluArray = [0.1,100];
			var compcode05Path5_easeOutSpeedArray = [0,0];
			var compcode05Path5_easeOutInfluArray = [0.1,0.1];
			var compcode05Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode05Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode05Path5, compcode05Path5_keyTimesArray, [compcode05Path5_easeInSpeedArray, compcode05Path5_easeInInfluArray], [compcode05Path5_easeOutSpeedArray, compcode05Path5_easeOutInfluArray], [compcode05Path5_keyInInterpolationType, compcode05Path5_keyOutInterpolationType]);

		compcode05.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode05.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		compcode05.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode05.property("ADBE Root Vectors Group").property(4).name = "Group 5";
		compcode05.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		compcode05.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var compcode05Path7 = compcode05.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var compcode05Path7_keyTimesArray = [0.58333333333333, 0.875];
			var compcode05Path7_object = {};
				compcode05Path7_object.closed = false;
				compcode05Path7_object.vertices = [[[19.2212524414062, -17.25048828125], [19.2212524414062, 99.2954711914062], [22.2212524414062, 99.2177734375], [77.4942321777344, 41.0224609375], [77.4942321777344, 41.0224609375], [19.2212524414062, -17.2505187988281]], [[19.2212524414062, -7.25048828125], [19.2212524414062, 109.295471191406], [22.2212524414062, 109.2177734375], [77.4942321777344, 51.0224609375], [77.4942321777344, 51.0224609375], [19.2212524414062, -7.25051879882812]]];
				compcode05Path7_object.inTangents = [[[0, 0], [0, 0], [-0.9927978515625, 0.05181884765625], [0, 31.1738891601562], [0, 0], [32.1839599609375, 0]], [[0, 0], [0, 0], [-0.9927978515625, 0.05181884765625], [0, 31.1738891601562], [0, 0], [32.1839599609375, 0]]];
				compcode05Path7_object.outTangents = [[[0, 0], [1.0057373046875, 0], [30.7897033691406, -1.55828857421875], [0, 0], [0, -32.1839599609375], [0, 0]], [[0, 0], [1.0057373046875, 0], [30.7897033691406, -1.55828857421875], [0, 0], [0, -32.1839599609375], [0, 0]]];
			addShapeKeyframes(compcode05Path7, compcode05Path7_keyTimesArray, compcode05Path7_object);
			var compcode05Path7_easeInSpeedArray = [0,0];
			var compcode05Path7_easeInInfluArray = [0.1,100];
			var compcode05Path7_easeOutSpeedArray = [0,0];
			var compcode05Path7_easeOutInfluArray = [0.1,0.1];
			var compcode05Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode05Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode05Path7, compcode05Path7_keyTimesArray, [compcode05Path7_easeInSpeedArray, compcode05Path7_easeInInfluArray], [compcode05Path7_easeOutSpeedArray, compcode05Path7_easeOutInfluArray], [compcode05Path7_keyInInterpolationType, compcode05Path7_keyOutInterpolationType]);

		compcode05.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode05.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		compcode05.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode05.property("ADBE Root Vectors Group").property(5).name = "Group 1";
		compcode05.property("ADBE Root Vectors Group").property(5).property(2).addProperty("ADBE Vector Shape - Group");
		compcode05.property("ADBE Root Vectors Group").property(5).property(2).property(1).name = "Path 1";
		var compcode05Path9 = compcode05.property("ADBE Root Vectors Group").property(5).property(2).property(1).property("ADBE Vector Shape");
			var compcode05Path9_keyTimesArray = [0.58333333333333, 0.875];
			var compcode05Path9_object = {};
				compcode05Path9_object.closed = true;
				compcode05Path9_object.vertices = [[[116.342895507812, 41.0225219726562], [19.2212524414062, -56.0991516113281], [19.2212524414062, -56.0991516113281], [65.6972045898438, -56.0991516113281], [77.4942321777344, -56.0991516113281], [104.545837402344, -56.0991516113281], [104.545837402344, -191.493804931641], [77.4942016601562, -191.493804931641], [65.6971435546875, -191.493804931641], [19.2212219238281, -191.493804931641], [19.2212219238281, -233.735260009766], [-19.62744140625, -233.735260009766], [-19.62744140625, -191.493835449219], [-116.749084472656, -94.3721923828125], [-19.62744140625, 2.74943542480469], [-19.62744140625, 2.74943542480469], [-75.8846435546875, 2.74943542480469], [-77.9004516601562, 2.74943542480469], [-114.733306884766, 2.74943542480469], [-114.733306884766, 137.14404296875], [-77.9004516601562, 137.14404296875], [-75.8846435546875, 137.14404296875], [-19.6274719238281, 137.14404296875], [-19.6274719238281, 179.599914550781], [19.22119140625, 179.599914550781], [19.22119140625, 138.14404296875], [116.342834472656, 41.0223999023438]], [[116.342895507812, 51.0225219726562], [19.2212524414062, -46.0991516113281], [19.2212524414062, -46.0991516113281], [65.6972045898438, -46.0991516113281], [77.4942321777344, -46.0991516113281], [104.545837402344, -46.0991516113281], [104.545837402344, -201.493804931641], [77.4942016601562, -201.493804931641], [65.6971435546875, -201.493804931641], [19.2212219238281, -201.493804931641], [19.2212219238281, -240.735260009766], [-19.62744140625, -240.735260009766], [-19.62744140625, -201.493835449219], [-116.749084472656, -104.372192382812], [-19.62744140625, -7.25054931640625], [-19.62744140625, -7.25054931640625], [-75.8846435546875, -7.25054931640625], [-77.9004516601562, -7.25054931640625], [-114.733306884766, -7.25054931640625], [-114.733306884766, 148.14404296875], [-77.9004516601562, 148.14404296875], [-75.8846435546875, 148.14404296875], [-19.6274719238281, 148.14404296875], [-19.6274719238281, 186.599914550781], [19.22119140625, 186.599914550781], [19.22119140625, 148.14404296875], [116.342834472656, 51.0223999023438]]];
				compcode05Path9_object.inTangents = [[[0, 0], [53.6370239257812, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, -53.6370544433594], [-53.6413879394531, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 53.6370239257812]], [[0, 0], [53.6370239257812, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, -53.6370544433594], [-53.6413879394531, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 53.6370239257812]]];
				compcode05Path9_object.outTangents = [[[0, -53.6370544433594], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-53.641357421875, 0], [0, 53.6370544433594], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [53.6370239257812, 0], [0, 0]], [[0, -53.6370849609375], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-53.641357421875, 0], [0, 53.6370544433594], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [53.6370239257812, 0], [0, 0]]];
			addShapeKeyframes(compcode05Path9, compcode05Path9_keyTimesArray, compcode05Path9_object);
			var compcode05Path9_easeInSpeedArray = [0,0];
			var compcode05Path9_easeInInfluArray = [0.1,100];
			var compcode05Path9_easeOutSpeedArray = [0,0];
			var compcode05Path9_easeOutInfluArray = [0.1,0.1];
			var compcode05Path9_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode05Path9_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode05Path9, compcode05Path9_keyTimesArray, [compcode05Path9_easeInSpeedArray, compcode05Path9_easeInInfluArray], [compcode05Path9_easeOutSpeedArray, compcode05Path9_easeOutInfluArray], [compcode05Path9_keyInInterpolationType, compcode05Path9_keyOutInterpolationType]);

		compcode05.property("ADBE Root Vectors Group").property(5).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode05.property("ADBE Root Vectors Group").property(5).property(2).property(2).name = "Fill 1";
		compcode05.property("ADBE Root Vectors Group").property(5).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode05.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode05.selected = false;
	// Apply parents
		compcode02.setParentWithJump(compcode01);
		compcode03.setParentWithJump(compcode01);
		compcode04.setParentWithJump(compcode01);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode05.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode05.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode05.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode05.property("ADBE Root Vectors Group").property(5).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode_comp.openInViewer();

return {
	compItem : compcode_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function applySpatialTangents(property, keyTimesArray, inSpatialTangentsArray, outSpatialTangentsArray) {
	for (var sp = 0, spl = keyTimesArray.length; sp < spl; sp ++) {
		property.setSpatialTangentsAtKey(sp+1, inSpatialTangentsArray[sp], outSpatialTangentsArray[sp]);
	}
}
function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

