// Created using compCode v2.0
// 201801030 from composition "&" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode();
function utopian_201801030_094309() {

// app.beginUndoGroup("&");

try {

// ANIMATION PRESETS START
	// & -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var specialCharacters_folder_properties = {"name":"05 Special Characters","typeName":"Folder","label":9,"comment":""};
	var specialCharacters_folder = findProjectItem(utopian_folder, false, specialCharacters_folder_properties);
	if (specialCharacters_folder === null) {
		specialCharacters_folder = app.project.items.addFolder(specialCharacters_folder_properties.name);
		specialCharacters_folder.label = specialCharacters_folder_properties.label;
		specialCharacters_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode_comp_properties = {"name":"&","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":5,"frameRate":24};
	var compcode_comp = app.project.items.addComp(compcode_comp_properties.name, compcode_comp_properties.width, compcode_comp_properties.height, 1, 30, 24);
		compcode_comp.time = 3.08333333333333;
		compcode_comp.bgColor = compcode_comp_properties.bgColor;
		compcode_comp.label = compcode_comp_properties.label;
		compcode_comp.resolutionFactor = [1, 1];
		compcode_comp.parentFolder = specialCharacters_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "&", varName "compcode_comp";
	compcode_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([217.731994628906,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([582.765991210938,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "& 01", varName "compcode01";
	var compcode01 = compcode_comp.layers.addShape();
		compcode01.name = "& 01";
		compcode01.outPoint = 0.58333333333333;
		compcode01.moveToEnd();
		compcode01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode01.property("ADBE Root Vectors Group").property(1).name = "Ellipse 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Ellipse");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Ellipse Path 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Ellipse Size").setValue([115.78125,115.78125]);
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode01.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([73.51953125,-125.5234375]);
		var compcode01Position1 = compcode01.property("ADBE Transform Group").property("ADBE Position");
			var compcode01Position1_keyTimesArray = [0,0.33333333333333,0.41666666666667,0.54166666666667,1.20833333333333];
			var compcode01Position1_valuesArray = [[399,500,0],[419,500,0],[419,500,0],[413,500,0],[413,526,0]];
			compcode01Position1.setValuesAtTimes(compcode01Position1_keyTimesArray, compcode01Position1_valuesArray);
			var compcode01Position1_inSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			var compcode01Position1_outSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			applySpatialTangents(compcode01Position1, compcode01Position1_keyTimesArray, compcode01Position1_inSpatialTangents, compcode01Position1_outSpatialTangents);
			var compcode01Position1_easeInSpeedArray = [0,0,0,0,0];
			var compcode01Position1_easeInInfluArray = [0.1,100,0.1,0.1,0.1];
			var compcode01Position1_easeOutSpeedArray = [0,0,0,0,0];
			var compcode01Position1_easeOutInfluArray = [0.1,0.1,100,0.1,0.1];
			var compcode01Position1_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode01Position1_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode01Position1, compcode01Position1_keyTimesArray, [compcode01Position1_easeInSpeedArray, compcode01Position1_easeInInfluArray], [compcode01Position1_easeOutSpeedArray, compcode01Position1_easeOutInfluArray], [compcode01Position1_keyInInterpolationType, compcode01Position1_keyOutInterpolationType]);

		compcode01.selected = false;
	// Add Shape Layer "& 02", varName "compcode02";
	var compcode02 = compcode_comp.layers.addShape();
		compcode02.name = "& 02";
		compcode02.outPoint = 0.58333333333333;
		compcode02.moveToEnd();
		compcode02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode02Path = compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode02Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode02Path_object = {};
				compcode02Path_object.closed = true;
				compcode02Path_object.vertices = [[[-123.548828125, -96.45703125], [-123.548828125, 100], [-221.451171875, 100], [-221.451171875, -96.45703125]], [[-153.548828125, -96.45703125], [-153.548828125, 100], [-231.451171875, 100], [-231.451171875, -96.45703125]], [[-153.548828125, -96.45703125], [-153.548828125, 100], [-231.451171875, 100], [-231.451171875, -96.45703125]], [[-143.548828125, -96.45703125], [-137.548828125, 100], [-215.451171875, 100], [-221.451171875, -96.45703125]]];
			addShapeKeyframes(compcode02Path, compcode02Path_keyTimesArray, compcode02Path_object);
			var compcode02Path_easeInSpeedArray = [0,0,0,0];
			var compcode02Path_easeInInfluArray = [0.1,100,0.1,0.1];
			var compcode02Path_easeOutSpeedArray = [0,0,0,0];
			var compcode02Path_easeOutInfluArray = [0.1,0.1,100,0.1];
			var compcode02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode02Path, compcode02Path_keyTimesArray, [compcode02Path_easeInSpeedArray, compcode02Path_easeInInfluArray], [compcode02Path_easeOutSpeedArray, compcode02Path_easeOutInfluArray], [compcode02Path_keyInInterpolationType, compcode02Path_keyOutInterpolationType]);

		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([90.548828125,31.271484375]);
		compcode02.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([90.548828125,31.271484375,0]);
		compcode02.property("ADBE Transform Group").property("ADBE Position").setValue([490.548828125,557.271484375,0]);
		compcode02.selected = false;
	// Add Shape Layer "& 03", varName "compcode03";
	var compcode03 = compcode_comp.layers.addShape();
		compcode03.name = "& 03";
		compcode03.inPoint = 0.58333333333333;
		compcode03.outPoint = 30;
		compcode03.moveToEnd();
		compcode03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode03.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode03Path = compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode03Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode03Path_object = {};
				compcode03Path_object.closed = false;
				compcode03Path_object.vertices = [[[-82.5814514160156, -37.6338500976562], [-125.617126464844, 32.8074340820312], [-51.3658752441406, 112.058654785156], [-49.4752502441406, 111.963684082031], [-10.2294921875, 100.447265625], [-26.6322631835938, 71.1682891845703], [-82.5814819335938, -37.6338500976562]], [[-78.5814514160156, -37.6338500976562], [-121.617126464844, 32.8074340820312], [-42.3658752441406, 112.058654785156], [-40.4752502441406, 111.963684082031], [-1.2294921875, 100.447265625], [-17.6322631835938, 71.1682891845703], [-78.5814819335938, -37.6338500976562]]];
				compcode03Path_object.inTangents = [[[0, 0], [0, -30.7120361328125], [-43.7695007324219, 0], [-0.634521484375, 0.01300048828125], [-11.4992065429688, 7.010009765625], [0, 0], [0, 0]], [[0, 0], [0, -30.7120361328125], [-43.7695007324219, 0], [-0.634521484375, 0.01300048828125], [-11.4992065429688, 7.010009765625], [0, 0], [0, 0]]];
				compcode03Path_object.outTangents = [[[-25.5365295410156, 13.15673828125], [0, 43.7694702148438], [0.63882446289062, 0], [14.3653564453125, -0.34100341796875], [0, 0], [0, 0], [0, 0]], [[-25.5365295410156, 13.15673828125], [0, 43.7694702148438], [0.63882446289062, 0], [14.3653564453125, -0.34100341796875], [0, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode03Path, compcode03Path_keyTimesArray, compcode03Path_object);
			var compcode03Path_easeInSpeedArray = [0,0];
			var compcode03Path_easeInInfluArray = [16.666666667,100];
			var compcode03Path_easeOutSpeedArray = [0,0];
			var compcode03Path_easeOutInfluArray = [0.1,0.1];
			var compcode03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode03Path, compcode03Path_keyTimesArray, [compcode03Path_easeInSpeedArray, compcode03Path_easeInInfluArray], [compcode03Path_easeOutSpeedArray, compcode03Path_easeOutInfluArray], [compcode03Path_keyInInterpolationType, compcode03Path_keyOutInterpolationType]);

		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode03.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		compcode03.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode03Path3 = compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode03Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode03Path3_object = {};
				compcode03Path3_object.closed = false;
				compcode03Path3_object.vertices = [[[-35.2421569824219, -165.325073242188], [-74.8677978515625, -125.699462890625], [-70.6894226074219, -108.07080078125], [-68.9973449707031, -105.027679443359], [-35.2421875, -86.0738525390625], [4.3834228515625, -125.699493408203], [-35.2421875, -165.325134277344]], [[-37.2421569824219, -165.325073242188], [-76.8677978515625, -125.699462890625], [-72.6894226074219, -108.07080078125], [-70.9973449707031, -105.027679443359], [-37.2421875, -86.0738525390625], [2.3834228515625, -125.699493408203], [-37.2421875, -165.325134277344]]];
				compcode03Path3_object.inTangents = [[[0, 0], [0, -21.8890380859375], [-2.65032958984375, -5.31796264648438], [0, 0], [-14.2962951660156, 0], [0, 21.8847351074219], [21.8847351074219, 0]], [[0, 0], [0, -21.8890380859375], [-2.65032958984375, -5.31796264648438], [0, 0], [-14.2962951660156, 0], [0, 21.8847351074219], [21.8847351074219, 0]]];
				compcode03Path3_object.outTangents = [[[-21.8804321289062, 0], [0, 6.3409423828125], [0, 0], [6.97116088867188, 11.3524475097656], [21.8847351074219, 0], [0, -21.884765625], [0, 0]], [[-21.8804321289062, 0], [0, 6.3409423828125], [0, 0], [6.97116088867188, 11.3524475097656], [21.8847351074219, 0], [0, -21.884765625], [0, 0]]];
			addShapeKeyframes(compcode03Path3, compcode03Path3_keyTimesArray, compcode03Path3_object);
			var compcode03Path3_easeInSpeedArray = [0,0];
			var compcode03Path3_easeInInfluArray = [16.666666667,100];
			var compcode03Path3_easeOutSpeedArray = [0,0];
			var compcode03Path3_easeOutInfluArray = [16.666666667,0.1];
			var compcode03Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode03Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode03Path3, compcode03Path3_keyTimesArray, [compcode03Path3_easeInSpeedArray, compcode03Path3_easeInInfluArray], [compcode03Path3_easeOutSpeedArray, compcode03Path3_easeOutInfluArray], [compcode03Path3_keyInInterpolationType, compcode03Path3_keyOutInterpolationType]);

		compcode03.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode03.property("ADBE Root Vectors Group").property(3).name = "Group 3";
		compcode03.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		compcode03.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var compcode03Path5 = compcode03.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var compcode03Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode03Path5_object = {};
				compcode03Path5_object.closed = false;
				compcode03Path5_object.vertices = [[[1.14605712890625, -46.4481506347656], [-42.4594116210938, -46.4481506347656], [-42.3471984863281, -46.2453002929688], [38.7975463867188, 108.933532714844], [83.0634155273438, 108.933532714844], [1.14599609375, -46.4481811523438]], [[5.14605712890625, -46.4481506347656], [-38.4594116210938, -46.4481506347656], [-38.3471984863281, -46.2453002929688], [47.7975463867188, 108.933532714844], [92.0634155273438, 108.933532714844], [5.14599609375, -46.4481811523438]]];
				compcode03Path5_object.inTangents = [[[0, 0], [0, 0], [0, 0], [-0.44891357421875, -0.798583984375], [0, 0], [6.18988037109375, 11.0545959472656]], [[0, 0], [0, 0], [0, 0], [-0.44891357421875, -0.798583984375], [0, 0], [6.18988037109375, 11.0545959472656]]];
				compcode03Path5_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [-6.48342895507812, -11.5812377929688], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [-6.48342895507812, -11.5812377929688], [0, 0]]];
			addShapeKeyframes(compcode03Path5, compcode03Path5_keyTimesArray, compcode03Path5_object);
			var compcode03Path5_easeInSpeedArray = [0,0];
			var compcode03Path5_easeInInfluArray = [16.666666667,100];
			var compcode03Path5_easeOutSpeedArray = [0,0];
			var compcode03Path5_easeOutInfluArray = [0.1,0.1];
			var compcode03Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode03Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode03Path5, compcode03Path5_keyTimesArray, [compcode03Path5_easeInSpeedArray, compcode03Path5_easeInInfluArray], [compcode03Path5_easeOutSpeedArray, compcode03Path5_easeOutInfluArray], [compcode03Path5_keyInInterpolationType, compcode03Path5_keyOutInterpolationType]);

		compcode03.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode03.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		compcode03.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode03.property("ADBE Root Vectors Group").property(4).name = "Group 4";
		compcode03.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		compcode03.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var compcode03Path7 = compcode03.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var compcode03Path7_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode03Path7_object = {};
				compcode03Path7_object.closed = false;
				compcode03Path7_object.vertices = [[[82.4763488769531, -48.321533203125], [45.7140502929688, -48.321533203125], [45.6363525390625, -48.1834106445312], [67.7886962890625, -8.17794799804688], [82.476318359375, -48.3215637207031]], [[94.4763488769531, -48.321533203125], [49.7140502929688, -48.321533203125], [49.6363525390625, -48.1834106445312], [71.7886962890625, -8.17794799804688], [94.476318359375, -48.3215637207031]]];
				compcode03Path7_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [-6.686279296875, 11.8315734863281]], [[0, 0], [0, 0], [0, 0], [0, 0], [-6.686279296875, 11.8315734863281]]];
				compcode03Path7_object.outTangents = [[[0, 0], [0, 0], [0, 0], [8.24887084960938, -14.5984802246094], [0, 0]], [[0, 0], [0, 0], [0, 0], [8.24887084960938, -14.5984802246094], [0, 0]]];
			addShapeKeyframes(compcode03Path7, compcode03Path7_keyTimesArray, compcode03Path7_object);
			var compcode03Path7_easeInSpeedArray = [0,0];
			var compcode03Path7_easeInInfluArray = [16.666666667,100];
			var compcode03Path7_easeOutSpeedArray = [0,0];
			var compcode03Path7_easeOutInfluArray = [0.1,0.1];
			var compcode03Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode03Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode03Path7, compcode03Path7_keyTimesArray, [compcode03Path7_easeInSpeedArray, compcode03Path7_easeInInfluArray], [compcode03Path7_easeOutSpeedArray, compcode03Path7_easeOutInfluArray], [compcode03Path7_keyInInterpolationType, compcode03Path7_keyOutInterpolationType]);

		compcode03.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode03.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		compcode03.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode03.property("ADBE Root Vectors Group").property(5).name = "Group 5";
		compcode03.property("ADBE Root Vectors Group").property(5).property(2).addProperty("ADBE Vector Shape - Group");
		compcode03.property("ADBE Root Vectors Group").property(5).property(2).property(1).name = "Path 1";
		var compcode03Path9 = compcode03.property("ADBE Root Vectors Group").property(5).property(2).property(1).property("ADBE Vector Shape");
			var compcode03Path9_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode03Path9_object = {};
				compcode03Path9_object.closed = false;
				compcode03Path9_object.vertices = [[[140.881729125977, -86.0737915039062], [33.3300170898438, -86.1083374023438], [44.0090789794922, -125.703765869141], [-35.2421722412109, -204.950744628906], [-114.493469238281, -125.699493408203], [-106.1884765625, -90.5889282226562], [-106.235961914062, -90.5673828125], [-95.9540100097656, -72.2135620117188], [-165.247116088867, 32.802978515625], [-46.3659210205078, 151.679870605469], [-21.9689636230469, 149.163330078125], [-21.03662109375, 148.947509765625], [9.18182373046875, 135.100158691406], [16.5846557617188, 148.554748535156], [149.391006469727, 148.554748535156], [90.4115295410156, 32.6907348632812], [140.881607055664, -86.0739135742188]], [[160.881729125977, -86.0737915039062], [31.3300170898438, -86.1083374023438], [42.0090942382812, -125.703765869141], [-37.2421875, -204.950744628906], [-116.493469238281, -125.699493408203], [-108.1884765625, -90.5889282226562], [-108.235961914062, -90.5673828125], [-97.9540100097656, -72.2135620117188], [-161.247116088867, 32.802978515625], [-42.3659057617188, 151.679870605469], [-17.9689636230469, 149.163330078125], [-17.03662109375, 148.947509765625], [18.1818389892578, 135.100158691406], [25.5846557617188, 148.554748535156], [158.391006469727, 148.554748535156], [94.4115295410156, 32.6907348632812], [160.881607055664, -86.0739135742188]]];
				compcode03Path9_object.inTangents = [[[0, 0], [0, 0], [0, 14.4473876953125], [43.7694702148438, 0], [0, -43.7695007324219], [-5.27911376953125, -10.5798034667969], [0, 0], [0, 0], [0, -45.5608215332031], [-65.6585540771484, 0], [-7.87332153320312, 1.64892578125], [0, 0], [-10.7610473632812, 6.38409423828125], [0, 0], [0, 0], [0, 0], [-6.7596435546875, 12.0819091796875]], [[0, 0], [0, 0], [0, 14.4473876953125], [43.7695007324219, 0], [0, -43.7695007324219], [-5.27911376953125, -10.5798034667969], [0, 0], [0, 0], [0, -45.5608215332031], [-65.6585693359375, 0], [-7.87332153320312, 1.64892578125], [0, 0], [-10.7610626220703, 6.38409423828125], [0, 0], [0, 0], [0, 0], [-6.7596435546875, 12.0819091796875]]];
				compcode03Path9_object.outTangents = [[[0, 0], [6.75106811523438, -11.6546020507812], [0, -43.7651977539062], [-43.7652282714844, 0], [0, 12.630126953125], [0, 0], [0, 0], [-42.0459899902344, 15.2135620117188], [0, 65.6542358398438], [8.36541748046875, 0], [0, 0], [12.5999145507812, -2.73663330078125], [0, 0], [0, 0], [0, 0], [21.5884857177734, -55.6907348632812], [0, 0]], [[0, 0], [6.75105285644531, -11.6546020507812], [0, -43.7651977539062], [-43.7651977539062, 0], [0, 12.630126953125], [0, 0], [0, 0], [-37.6227722167969, 19.9595947265625], [0, 65.6542358398438], [8.36538696289062, 0], [0, 0], [12.5999145507812, -2.73663330078125], [0, 0], [0, 0], [0, 0], [27.8458709716797, -49.752197265625], [0, 0]]];
			addShapeKeyframes(compcode03Path9, compcode03Path9_keyTimesArray, compcode03Path9_object);
			var compcode03Path9_easeInSpeedArray = [0,0];
			var compcode03Path9_easeInInfluArray = [16.666666667,100];
			var compcode03Path9_easeOutSpeedArray = [0,0];
			var compcode03Path9_easeOutInfluArray = [0.1,0.1];
			var compcode03Path9_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode03Path9_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode03Path9, compcode03Path9_keyTimesArray, [compcode03Path9_easeInSpeedArray, compcode03Path9_easeInInfluArray], [compcode03Path9_easeOutSpeedArray, compcode03Path9_easeOutInfluArray], [compcode03Path9_keyInInterpolationType, compcode03Path9_keyOutInterpolationType]);

		compcode03.property("ADBE Root Vectors Group").property(5).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode03.property("ADBE Root Vectors Group").property(5).property(2).property(2).name = "Fill 1";
		compcode03.property("ADBE Root Vectors Group").property(5).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode03.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode03.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(5).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode_comp.openInViewer();

return {
	compItem : compcode_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function applySpatialTangents(property, keyTimesArray, inSpatialTangentsArray, outSpatialTangentsArray) {
	for (var sp = 0, spl = keyTimesArray.length; sp < spl; sp ++) {
		property.setSpatialTangentsAtKey(sp+1, inSpatialTangentsArray[sp], outSpatialTangentsArray[sp]);
	}
}
function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

