// Created using compCode v2.0
// 201801030 from composition "C" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// c();
function utopian_201801030_094309() {

// app.beginUndoGroup("C");

try {

// ANIMATION PRESETS START
	// C -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var c_comp_properties = {"name":"C","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":6,"frameRate":24};
	var c_comp = app.project.items.addComp(c_comp_properties.name, c_comp_properties.width, c_comp_properties.height, 1, 30, 24);
		c_comp.time = 0.375;
		c_comp.bgColor = c_comp_properties.bgColor;
		c_comp.label = c_comp_properties.label;
		c_comp.resolutionFactor = [2, 2];
		c_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = c_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "C", varName "c_comp";
	c_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = c_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([239.893005371094,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([559.609008789062,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = c_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	//Create new Null layer "c01" and replace its source with varName "null10_null";
	var c01 = c_comp.layers.addNull();
	var c01_source = c01.source;
		c01.replaceSource(null10_null, true);
		c01_source.remove();
		c01.name = "C 01";
		c01.enabled = false;
		c01.outPoint = 0.58333333333333;
		c01.moveToEnd();
		var c01Position = c01.property("ADBE Transform Group").property("ADBE Position");
			var c01Position_keyTimesArray = [0,0.33333333333333,0.41666666666667,0.58333333333333];
			var c01Position_valuesArray = [[434.968770937008,498,0],[456,498,0],[456,498,0],[440,498,0]];
			c01Position.setValuesAtTimes(c01Position_keyTimesArray, c01Position_valuesArray);
			var c01Position_inSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			var c01Position_outSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			applySpatialTangents(c01Position, c01Position_keyTimesArray, c01Position_inSpatialTangents, c01Position_outSpatialTangents);
			var c01Position_easeInSpeedArray = [0,0,0,0];
			var c01Position_easeInInfluArray = [99.6000004016053,57.2001145530109,100,0.1];
			var c01Position_easeOutSpeedArray = [0,0,0,0];
			var c01Position_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var c01Position_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var c01Position_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(c01Position, c01Position_keyTimesArray, [c01Position_easeInSpeedArray, c01Position_easeInInfluArray], [c01Position_easeOutSpeedArray, c01Position_easeOutInfluArray], [c01Position_keyInInterpolationType, c01Position_keyOutInterpolationType]);

		c01.selected = false;
	// Add Shape Layer "C 02", varName "c02";
	var c02 = c_comp.layers.addShape();
		c02.name = "C 02";
		c02.outPoint = 0.58333333333333;
		c02.moveToEnd();
		c02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		c02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		c02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		c02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		c02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var c02Path = c02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var c02Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var c02Path_object = {};
				c02Path_object.closed = true;
				c02Path_object.vertices = [[[87.7578125, 0.00003051757812], [87.7578125, 158], [-59.7578125, 158], [-59.7578125, -0.00006103515625]], [[87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -0.00006103515625]], [[87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -0.00006103515625]], [[88.7578125, 0.00003051757812], [101.7578125, 150], [-40.7578125, 150], [-48.7578125, -0.25009155273438]]];
			addShapeKeyframes(c02Path, c02Path_keyTimesArray, c02Path_object);
			var c02Path_easeInSpeedArray = [0,0,0,0];
			var c02Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var c02Path_easeOutSpeedArray = [0,0,0,0];
			var c02Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var c02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var c02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(c02Path, c02Path_keyTimesArray, [c02Path_easeInSpeedArray, c02Path_easeInInfluArray], [c02Path_easeOutSpeedArray, c02Path_easeOutInfluArray], [c02Path_keyInInterpolationType, c02Path_keyOutInterpolationType]);

		c02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		c02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		c02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		c02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		c02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		c02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		c02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		c02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		c02.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		c02.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		c02.selected = false;
	// Add Shape Layer "C 03", varName "c03";
	var c03 = c_comp.layers.addShape();
		c03.name = "C 03";
		c03.outPoint = 0.58333333333333;
		c03.moveToEnd();
		c03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		c03.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		c03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		c03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		c03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var c03Path = c03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var c03Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var c03Path_object = {};
				c03Path_object.closed = true;
				c03Path_object.vertices = [[[87.7578125, -157], [87.7578125, 0.00003051757812], [87.7578125, 158], [-59.7578125, 158], [-59.7578125, -1.75003051757812], [-59.7578125, -157]], [[87.7578125, -157], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -157]], [[87.7578125, -157], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -157]], [[101.7578125, -149], [88.7578125, 0.00003051757812], [101.7578125, 150], [-40.7578125, 150], [-50.7578125, -1.75003051757812], [-40.7578125, -149]]];
			addShapeKeyframes(c03Path, c03Path_keyTimesArray, c03Path_object);
			var c03Path_easeInSpeedArray = [0,0,0,0];
			var c03Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var c03Path_easeOutSpeedArray = [0,0,0,0];
			var c03Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var c03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var c03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(c03Path, c03Path_keyTimesArray, [c03Path_easeInSpeedArray, c03Path_easeInInfluArray], [c03Path_easeOutSpeedArray, c03Path_easeOutInfluArray], [c03Path_keyInInterpolationType, c03Path_keyOutInterpolationType]);

		c03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		c03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		c03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		c03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		c03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		c03.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		c03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		c03.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		c03.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		c03.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		c03.selected = false;
	// Add Shape Layer "C 04", varName "c04";
	var c04 = c_comp.layers.addShape();
		c04.name = "C 04";
		c04.startTime = -0.08333333333333;
		c04.inPoint = 0.58333333333333;
		c04.outPoint = 30;
		c04.moveToEnd();
		c04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		c04.property("ADBE Root Vectors Group").property(1).name = "Group 2";
		c04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		c04.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var c04Path = c04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var c04Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var c04Path_object = {};
				c04Path_object.closed = false;
				c04Path_object.vertices = [[[22.8974151611328, -7.51016235351562], [-89.0025634765625, -7.51016235351562], [39.9863891601562, 110.201293945312], [82.2451171875, 103.536560058594], [22.8974151611328, -7.51019287109375]], [[10.8973999023438, -7.51016235351562], [-97.0025634765625, -7.51016235351562], [39.9863891601562, 110.201293945312], [82.2451171875, 103.536560058594], [10.8973999023438, -7.51019287109375]]];
				c04Path_object.inTangents = [[[0, 0], [0, 0], [-69.4354858398438, 0], [-13.3251037597656, 4.27764892578125], [0, 0]], [[0, 0], [0, 0], [-69.4354858398438, 0], [-13.3251037597656, 4.27764892578125], [0, 0]]];
				c04Path_object.outTangents = [[[0, 0], [10.0574645996094, 66.6297912597656], [14.7538452148438, 0], [0, 0], [0, 0]], [[0, 0], [10.0574645996094, 66.6297912597656], [14.7538452148438, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(c04Path, c04Path_keyTimesArray, c04Path_object);
			var c04Path_easeInSpeedArray = [0,0];
			var c04Path_easeInInfluArray = [16.666666667,100];
			var c04Path_easeOutSpeedArray = [0,0];
			var c04Path_easeOutInfluArray = [0.1,16.666666667];
			var c04Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var c04Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(c04Path, c04Path_keyTimesArray, [c04Path_easeInSpeedArray, c04Path_easeInInfluArray], [c04Path_easeOutSpeedArray, c04Path_easeOutInfluArray], [c04Path_keyInInterpolationType, c04Path_keyOutInterpolationType]);

		c04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		c04.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		c04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		c04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		c04.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		c04.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		c04.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var c04Path3 = c04.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var c04Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var c04Path3_object = {};
				c04Path3_object.closed = false;
				c04Path3_object.vertices = [[[39.9863891601562, -166.906219482422], [-89.1364135742188, -48.1501770019531], [21.0067749023438, -48.1501770019531], [80.6738891601562, -160.763824462891], [39.9863891601562, -166.90625]], [[39.9863891601562, -166.906219482422], [-97.1364135742188, -48.1501770019531], [9.00677490234375, -48.1501770019531], [80.6738891601562, -160.763824462891], [39.9863891601562, -166.90625]]];
				c04Path3_object.inTangents = [[[0, 0], [9.60858154296875, -67.1391296386719], [0, 0], [0, 0], [14.171142578125, 0]], [[0, 0], [9.60858154296875, -67.1391296386719], [0, 0], [0, 0], [14.171142578125, 0]]];
				c04Path3_object.outTangents = [[[-69.7937622070312, 0], [0, 0], [0, 0], [-12.8718566894531, -3.94961547851562], [0, 0]], [[-69.7937622070312, 0], [0, 0], [0, 0], [-12.8718566894531, -3.94961547851562], [0, 0]]];
			addShapeKeyframes(c04Path3, c04Path3_keyTimesArray, c04Path3_object);
			var c04Path3_easeInSpeedArray = [0,0];
			var c04Path3_easeInInfluArray = [16.666666667,100];
			var c04Path3_easeOutSpeedArray = [0,0];
			var c04Path3_easeOutInfluArray = [0.1,16.666666667];
			var c04Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var c04Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(c04Path3, c04Path3_keyTimesArray, [c04Path3_easeInSpeedArray, c04Path3_easeInInfluArray], [c04Path3_easeOutSpeedArray, c04Path3_easeOutInfluArray], [c04Path3_keyInInterpolationType, c04Path3_keyOutInterpolationType]);

		c04.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		c04.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		c04.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		c04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		c04.property("ADBE Root Vectors Group").property(3).name = "Group 1";
		c04.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		c04.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var c04Path5 = c04.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var c04Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var c04Path5_object = {};
				c04Path5_object.closed = true;
				c04Path5_object.vertices = [[[56.1950073242188, -29.2092895507812], [138.808776855469, -180.471649169922], [133.6591796875, -183.868774414062], [102.537048339844, -195.131988525391], [39.9820404052734, -206.497406005859], [-130.156311035156, -28.354736328125], [39.9820404052734, 149.783630371094], [104.220474243164, 137.740539550781], [135.092163085938, 126.235595703125], [138.929565429688, 123.658630371094]], [[44.1950073242188, -29.2092895507812], [138.808776855469, -176.471649169922], [133.6591796875, -179.868774414062], [102.537048339844, -195.131988525391], [39.9820404052734, -206.497406005859], [-138.156311035156, -28.354736328125], [39.9820404052734, 149.783630371094], [104.220458984375, 137.740539550781], [135.092163085938, 122.235595703125], [138.929565429688, 119.658630371094]]];
				c04Path5_object.inTangents = [[[0, 0], [0, 0], [1.7481689453125, 1.08346557617188], [10.9164428710938, 4.10501098632812], [22.0272064208984, 0], [0, -98.3863830566406], [-98.3820648193359, 0], [-19.9337158203125, 7.7352294921875], [-9.6905517578125, 6.1337890625], [-1.2777099609375, 0.86334228515625]], [[0, 0], [0, 0], [1.7481689453125, 1.08346557617188], [10.9164428710938, 4.10501098632812], [22.0272064208984, 0], [0, -98.3863830566406], [-98.3820648193359, 0], [-19.9336853027344, 7.7352294921875], [-9.6905517578125, 6.1337890625], [-1.2777099609375, 0.86334228515625]]];
				c04Path5_object.outTangents = [[[0, 0], [-1.7093505859375, -1.14389038085938], [-9.78125, -6.06039428710938], [-19.4674987792969, -7.3165283203125], [-98.3820648193359, 0], [0, 98.382080078125], [22.6660308837891, 0], [10.8301239013672, -4.199951171875], [1.3035888671875, -0.824462890625], [0, 0]], [[0, 0], [-1.7093505859375, -1.14389038085938], [-9.78125, -6.06039428710938], [-19.4674987792969, -7.3165283203125], [-98.3820648193359, 0], [0, 98.382080078125], [22.6660308837891, 0], [10.8301391601562, -4.199951171875], [1.3035888671875, -0.824462890625], [0, 0]]];
			addShapeKeyframes(c04Path5, c04Path5_keyTimesArray, c04Path5_object);
			var c04Path5_easeInSpeedArray = [0,0];
			var c04Path5_easeInInfluArray = [16.666666667,100];
			var c04Path5_easeOutSpeedArray = [0,0];
			var c04Path5_easeOutInfluArray = [0.1,16.666666667];
			var c04Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var c04Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(c04Path5, c04Path5_keyTimesArray, [c04Path5_easeInSpeedArray, c04Path5_easeInInfluArray], [c04Path5_easeOutSpeedArray, c04Path5_easeOutInfluArray], [c04Path5_keyInInterpolationType, c04Path5_keyOutInterpolationType]);

		c04.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		c04.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		c04.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		c04.property("ADBE Transform Group").property("ADBE Position").setValue([400,528,0]);
		c04.selected = false;
	// Apply parents
		c02.setParentWithJump(c01);
		c03.setParentWithJump(c01);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			c02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			c02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			c03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			c03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			c04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			c04.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			c04.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

c_comp.openInViewer();

return {
	compItem : c_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function applySpatialTangents(property, keyTimesArray, inSpatialTangentsArray, outSpatialTangentsArray) {
	for (var sp = 0, spl = keyTimesArray.length; sp < spl; sp ++) {
		property.setSpatialTangentsAtKey(sp+1, inSpatialTangentsArray[sp], outSpatialTangentsArray[sp]);
	}
}
function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

