// Created using compCode v2.0
// 201801030 from composition "E" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// e();
function utopian_201801030_094309() {

// app.beginUndoGroup("E");

try {

// ANIMATION PRESETS START
	// E -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var e_comp_properties = {"name":"E","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":4,"frameRate":24};
	var e_comp = app.project.items.addComp(e_comp_properties.name, e_comp_properties.width, e_comp_properties.height, 1, 30, 24);
		e_comp.time = 0.375;
		e_comp.bgColor = e_comp_properties.bgColor;
		e_comp.label = e_comp_properties.label;
		e_comp.resolutionFactor = [1, 1];
		e_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = e_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "E", varName "e_comp";
	e_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = e_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([242.63200378418,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([557.367980957031,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = e_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "E 01", varName "e01";
	var e01 = e_comp.layers.addShape();
		e01.name = "E 01";
		e01.outPoint = 0.58333333333333;
		e01.moveToEnd();
		e01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		e01.property("ADBE Root Vectors Group").property(1).name = "Group 4";
		e01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		e01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var e01Path = e01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var e01Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var e01Path_object = {};
				e01Path_object.closed = false;
				e01Path_object.vertices = [[[96.9356689453125, -147.195526123047], [-97.3076171875, -147.195526123047], [-97.3076171875, -62.44775390625], [96.9356689453125, -62.44775390625], [96.9356689453125, -147.195556640625]], [[96.9356689453125, -163.195526123047], [-97.3076171875, -163.195526123047], [-97.3076171875, -98.44775390625], [96.9356689453125, -98.44775390625], [96.9356689453125, -163.195556640625]], [[96.9356689453125, -163.195526123047], [-97.3076171875, -163.195526123047], [-97.3076171875, -98.44775390625], [96.9356689453125, -98.44775390625], [96.9356689453125, -163.195556640625]], [[96.9356689453125, -155.195526123047], [-97.3076171875, -155.195526123047], [-97.3076171875, -58.44775390625], [96.9356689453125, -58.44775390625], [96.9356689453125, -155.195556640625]]];
			addShapeKeyframes(e01Path, e01Path_keyTimesArray, e01Path_object);
			var e01Path_easeInSpeedArray = [0,0,0,0];
			var e01Path_easeInInfluArray = [0.1,100,16.666666667,16.666666667];
			var e01Path_easeOutSpeedArray = [0,0,0,0];
			var e01Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var e01Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var e01Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(e01Path, e01Path_keyTimesArray, [e01Path_easeInSpeedArray, e01Path_easeInInfluArray], [e01Path_easeOutSpeedArray, e01Path_easeOutInfluArray], [e01Path_keyInInterpolationType, e01Path_keyOutInterpolationType]);

		e01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		e01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		e01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		e01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		e01.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		e01.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		e01.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var e01Path3 = e01.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var e01Path3_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var e01Path3_object = {};
				e01Path3_object.closed = false;
				e01Path3_object.vertices = [[[96.871337890625, -18.002685546875], [-97.3719482421875, -18.002685546875], [-97.3076171875, 192.745056152344], [96.9356689453125, 192.745056152344], [96.871337890625, -18.002685546875]], [[96.871337890625, -54.002685546875], [-97.3719482421875, -54.002685546875], [-97.3076171875, 108.745056152344], [96.9356689453125, 108.745056152344], [96.871337890625, -54.002685546875]], [[96.871337890625, -54.002685546875], [-97.3719482421875, -54.002685546875], [-97.3076171875, 108.745056152344], [96.9356689453125, 108.745056152344], [96.871337890625, -54.002685546875]], [[96.871337890625, -14.002685546875], [-97.3719482421875, -14.002685546875], [-97.3076171875, 108.745056152344], [96.9356689453125, 108.745056152344], [96.871337890625, -14.002685546875]]];
			addShapeKeyframes(e01Path3, e01Path3_keyTimesArray, e01Path3_object);
			var e01Path3_easeInSpeedArray = [0,0,0,0];
			var e01Path3_easeInInfluArray = [0.1,100,16.666666667,16.666666667];
			var e01Path3_easeOutSpeedArray = [0,0,0,0];
			var e01Path3_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var e01Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var e01Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(e01Path3, e01Path3_keyTimesArray, [e01Path3_easeInSpeedArray, e01Path3_easeInInfluArray], [e01Path3_easeOutSpeedArray, e01Path3_easeOutInfluArray], [e01Path3_keyInInterpolationType, e01Path3_keyOutInterpolationType]);

		e01.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		e01.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		e01.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		e01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		e01.property("ADBE Root Vectors Group").property(3).name = "Group 1";
		e01.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		e01.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var e01Path5 = e01.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var e01Path5_keyTimesArray = [0, 0.33333333333333, 0.41666666666667];
			var e01Path5_object = {};
				e01Path5_object.closed = true;
				e01Path5_object.vertices = [[[-136.15625, -186.044189453125], [-136.15625, -186.044189453125], [-136.15625, 231.59375], [135.784301757812, 231.59375], [135.784301757812, -186.044219970703]], [[-136.15625, -202.044189453125], [-136.15625, -202.044189453125], [-136.15625, 147.59375], [135.784301757812, 147.59375], [135.784301757812, -202.044219970703]], [[-136.15625, -202.044189453125], [-136.15625, -202.044189453125], [-136.15625, 147.59375], [135.784301757812, 147.59375], [135.784301757812, -202.044219970703]]];
			addShapeKeyframes(e01Path5, e01Path5_keyTimesArray, e01Path5_object);
			var e01Path5_easeInSpeedArray = [0,0,0];
			var e01Path5_easeInInfluArray = [0.1,100,16.666666667];
			var e01Path5_easeOutSpeedArray = [0,0,0];
			var e01Path5_easeOutInfluArray = [0.1,0.1,100];
			var e01Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var e01Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(e01Path5, e01Path5_keyTimesArray, [e01Path5_easeInSpeedArray, e01Path5_easeInInfluArray], [e01Path5_easeOutSpeedArray, e01Path5_easeOutInfluArray], [e01Path5_keyInInterpolationType, e01Path5_keyOutInterpolationType]);

		e01.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		e01.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		e01.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		e01.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		e01.selected = false;
	// Add Shape Layer "E 02", varName "e02";
	var e02 = e_comp.layers.addShape();
		e02.name = "E 02";
		e02.inPoint = 0.58333333333333;
		e02.outPoint = 30;
		e02.moveToEnd();
		e02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		e02.property("ADBE Root Vectors Group").property(1).name = "Group 2";
		e02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		e02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var e02Path = e02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var e02Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var e02Path_object = {};
				e02Path_object.closed = false;
				e02Path_object.vertices = [[[96.9356689453125, -75.5990905761719], [-97.3076171875, -75.5990905761719], [-97.3076171875, -10.8513488769531], [96.9356689453125, -10.8513488769531], [96.9356689453125, -75.59912109375]], [[96.9356689453125, -59.5990905761719], [-97.3076171875, -59.5990905761719], [-97.3076171875, 5.14865112304688], [96.9356689453125, 5.14865112304688], [96.9356689453125, -59.59912109375]]];
			addShapeKeyframes(e02Path, e02Path_keyTimesArray, e02Path_object);
			var e02Path_easeInSpeedArray = [0,0];
			var e02Path_easeInInfluArray = [0.1,100];
			var e02Path_easeOutSpeedArray = [0,0];
			var e02Path_easeOutInfluArray = [0.1,0.1];
			var e02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var e02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(e02Path, e02Path_keyTimesArray, [e02Path_easeInSpeedArray, e02Path_easeInInfluArray], [e02Path_easeOutSpeedArray, e02Path_easeOutInfluArray], [e02Path_keyInInterpolationType, e02Path_keyOutInterpolationType]);

		e02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		e02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		e02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		e02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		e02.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		e02.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		e02.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var e02Path3 = e02.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var e02Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var e02Path3_object = {};
				e02Path3_object.closed = false;
				e02Path3_object.vertices = [[[96.9356689453125, 27.997314453125], [-97.3076171875, 27.997314453125], [-97.3076171875, 100.745056152344], [96.9356689453125, 100.745056152344], [96.9356689453125, 27.997314453125]], [[96.9356689453125, 43.997314453125], [-97.3076171875, 43.997314453125], [-97.3076171875, 108.745056152344], [96.9356689453125, 108.745056152344], [96.9356689453125, 43.997314453125]]];
			addShapeKeyframes(e02Path3, e02Path3_keyTimesArray, e02Path3_object);
			var e02Path3_easeInSpeedArray = [0,0];
			var e02Path3_easeInInfluArray = [0.1,100];
			var e02Path3_easeOutSpeedArray = [0,0];
			var e02Path3_easeOutInfluArray = [0.1,0.1];
			var e02Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var e02Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(e02Path3, e02Path3_keyTimesArray, [e02Path3_easeInSpeedArray, e02Path3_easeInInfluArray], [e02Path3_easeOutSpeedArray, e02Path3_easeOutInfluArray], [e02Path3_keyInInterpolationType, e02Path3_keyOutInterpolationType]);

		e02.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		e02.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		e02.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		e02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		e02.property("ADBE Root Vectors Group").property(3).name = "Group 4";
		e02.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		e02.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var e02Path5 = e02.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var e02Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var e02Path5_object = {};
				e02Path5_object.closed = false;
				e02Path5_object.vertices = [[[96.9356689453125, -163.195526123047], [-97.3076171875, -163.195526123047], [-97.3076171875, -114.44775390625], [96.9356689453125, -114.44775390625], [96.9356689453125, -163.195556640625]], [[96.9356689453125, -163.195526123047], [-97.3076171875, -163.195526123047], [-97.3076171875, -98.44775390625], [96.9356689453125, -98.44775390625], [96.9356689453125, -163.195556640625]]];
			addShapeKeyframes(e02Path5, e02Path5_keyTimesArray, e02Path5_object);
			var e02Path5_easeInSpeedArray = [0,0];
			var e02Path5_easeInInfluArray = [0.1,100];
			var e02Path5_easeOutSpeedArray = [0,0];
			var e02Path5_easeOutInfluArray = [0.1,0.1];
			var e02Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var e02Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(e02Path5, e02Path5_keyTimesArray, [e02Path5_easeInSpeedArray, e02Path5_easeInInfluArray], [e02Path5_easeOutSpeedArray, e02Path5_easeOutInfluArray], [e02Path5_keyInInterpolationType, e02Path5_keyOutInterpolationType]);

		e02.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		e02.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		e02.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		e02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		e02.property("ADBE Root Vectors Group").property(4).name = "Group 1";
		e02.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		e02.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var e02Path7 = e02.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var e02Path7_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var e02Path7_object = {};
				e02Path7_object.closed = true;
				e02Path7_object.vertices = [[[-136.15625, -202.044189453125], [-136.15625, -202.044189453125], [-136.15625, 147.59375], [135.784301757812, 147.59375], [135.784301757812, -202.044219970703]], [[-136.15625, -202.044189453125], [-136.15625, -202.044189453125], [-136.15625, 147.59375], [135.784301757812, 147.59375], [135.784301757812, -202.044219970703]]];
			addShapeKeyframes(e02Path7, e02Path7_keyTimesArray, e02Path7_object);
			var e02Path7_easeInSpeedArray = [0,0];
			var e02Path7_easeInInfluArray = [0.1,100];
			var e02Path7_easeOutSpeedArray = [0,0];
			var e02Path7_easeOutInfluArray = [0.1,0.1];
			var e02Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var e02Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(e02Path7, e02Path7_keyTimesArray, [e02Path7_easeInSpeedArray, e02Path7_easeInInfluArray], [e02Path7_easeOutSpeedArray, e02Path7_easeOutInfluArray], [e02Path7_keyInInterpolationType, e02Path7_keyOutInterpolationType]);

		e02.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		e02.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		e02.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		e02.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		e02.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			e01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			e01.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			e01.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			e02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			e02.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			e02.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			e02.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

e_comp.openInViewer();

return {
	compItem : e_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

