// Created using compCode v2.0
// 201801030 from composition "G" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// g();
function utopian_201801030_094309() {

// app.beginUndoGroup("G");

try {

// ANIMATION PRESETS START
	// G -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var g_comp_properties = {"name":"G","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":7,"frameRate":24};
	var g_comp = app.project.items.addComp(g_comp_properties.name, g_comp_properties.width, g_comp_properties.height, 1, 30, 24);
		g_comp.time = 0.54166666666667;
		g_comp.bgColor = g_comp_properties.bgColor;
		g_comp.label = g_comp_properties.label;
		g_comp.resolutionFactor = [1, 1];
		g_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = g_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "G", varName "g_comp";
	g_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = g_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([196.815994262695,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([603.682006835938,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = g_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	//Create new Null layer "g01" and replace its source with varName "null10_null";
	var g01 = g_comp.layers.addNull();
	var g01_source = g01.source;
		g01.replaceSource(null10_null, true);
		g01_source.remove();
		g01.name = "G 01";
		g01.enabled = false;
		g01.outPoint = 0.58333333333333;
		g01.moveToEnd();
		var g01Position = g01.property("ADBE Transform Group").property("ADBE Position");
			var g01Position_keyTimesArray = [0,0.33333333333333,0.41666666666667,0.54166666666667];
			var g01Position_valuesArray = [[34.9687709370079,-30,0],[56,-30,0],[56,-30,0],[40,-30,0]];
			g01Position.setValuesAtTimes(g01Position_keyTimesArray, g01Position_valuesArray);
			var g01Position_inSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			var g01Position_outSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			applySpatialTangents(g01Position, g01Position_keyTimesArray, g01Position_inSpatialTangents, g01Position_outSpatialTangents);
			var g01Position_easeInSpeedArray = [0,0,0,0];
			var g01Position_easeInInfluArray = [99.6000004016053,57.2001145530109,100,0.1];
			var g01Position_easeOutSpeedArray = [0,0,0,0];
			var g01Position_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var g01Position_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var g01Position_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(g01Position, g01Position_keyTimesArray, [g01Position_easeInSpeedArray, g01Position_easeInInfluArray], [g01Position_easeOutSpeedArray, g01Position_easeOutInfluArray], [g01Position_keyInInterpolationType, g01Position_keyOutInterpolationType]);

		g01.selected = false;
	// Add Shape Layer "G 02", varName "g02";
	var g02 = g_comp.layers.addShape();
		g02.name = "G 02";
		g02.inPoint = 0.41666666666667;
		g02.outPoint = 0.58333333333333;
		g02.moveToEnd();
		g02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		g02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		g02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		g02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		g02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var g02Path = g02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var g02Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var g02Path_object = {};
				g02Path_object.closed = true;
				g02Path_object.vertices = [[[87.7578125, 3.00003051757812], [87.7578125, 158], [-59.7578125, 158], [-59.7578125, 2.99993896484375]], [[87.515625, 2.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-4, 1.99993896484375]], [[-4.484375, 2.00003051757812], [-4.2421875, 158], [-3.7578125, 158], [-4, 1.99993896484375]], [[15.515625, 3.00003051757812], [31.7578125, 157], [-40.7578125, 157], [-39, 2.74990844726562]]];
			addShapeKeyframes(g02Path, g02Path_keyTimesArray, g02Path_object);
			var g02Path_easeInSpeedArray = [0,0,0,0];
			var g02Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var g02Path_easeOutSpeedArray = [0,0,0,0];
			var g02Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var g02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var g02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(g02Path, g02Path_keyTimesArray, [g02Path_easeInSpeedArray, g02Path_easeInInfluArray], [g02Path_easeOutSpeedArray, g02Path_easeOutInfluArray], [g02Path_keyInInterpolationType, g02Path_keyOutInterpolationType]);

		g02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		g02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		g02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		g02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		g02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		g02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		g02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		g02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		g02.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		g02.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		g02.selected = false;
	// Add Shape Layer "G 03", varName "g03";
	var g03 = g_comp.layers.addShape();
		g03.name = "G 03";
		g03.outPoint = 0.58333333333333;
		g03.moveToEnd();
		g03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		g03.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		g03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		g03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		g03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var g03Path = g03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var g03Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var g03Path_object = {};
				g03Path_object.closed = true;
				g03Path_object.vertices = [[[87.7578125, 3.00003051757812], [87.7578125, 158], [-59.7578125, 158], [-59.7578125, 2.99993896484375]], [[87.515625, 2.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-4, 1.99993896484375]], [[87.515625, 2.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-4, 1.99993896484375]], [[101.515625, 3.00003051757812], [101.7578125, 157], [-40.7578125, 157], [-39, 2.74990844726562]]];
			addShapeKeyframes(g03Path, g03Path_keyTimesArray, g03Path_object);
			var g03Path_easeInSpeedArray = [0,0,0,0];
			var g03Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var g03Path_easeOutSpeedArray = [0,0,0,0];
			var g03Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var g03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var g03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(g03Path, g03Path_keyTimesArray, [g03Path_easeInSpeedArray, g03Path_easeInInfluArray], [g03Path_easeOutSpeedArray, g03Path_easeOutInfluArray], [g03Path_keyInInterpolationType, g03Path_keyOutInterpolationType]);

		g03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		g03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		g03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		g03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		g03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		g03.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		g03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		g03.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		g03.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		g03.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		g03.selected = false;
	// Add Shape Layer "G 04", varName "g04";
	var g04 = g_comp.layers.addShape();
		g04.name = "G 04";
		g04.outPoint = 0.58333333333333;
		g04.moveToEnd();
		g04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		g04.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		g04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		g04.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		g04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var g04Path = g04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var g04Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var g04Path_object = {};
				g04Path_object.closed = true;
				g04Path_object.vertices = [[[87.7578125, -155], [87.7578125, 0.00003051757812], [87.7578125, 158], [-59.7578125, 158], [-59.7578125, -1.75003051757812], [-59.7578125, -155]], [[87.7578125, -155], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -155]], [[87.7578125, -155], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -155]], [[101.7578125, -155], [102.515625, 25.0000305175781], [101.7578125, 157], [-40.7578125, 157], [-41, 23.25], [-40.7578125, -155]]];
			addShapeKeyframes(g04Path, g04Path_keyTimesArray, g04Path_object);
			var g04Path_easeInSpeedArray = [0,0,0,0];
			var g04Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var g04Path_easeOutSpeedArray = [0,0,0,0];
			var g04Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var g04Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var g04Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(g04Path, g04Path_keyTimesArray, [g04Path_easeInSpeedArray, g04Path_easeInInfluArray], [g04Path_easeOutSpeedArray, g04Path_easeOutInfluArray], [g04Path_keyInInterpolationType, g04Path_keyOutInterpolationType]);

		g04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		g04.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		g04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		g04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		g04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		g04.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		g04.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		g04.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		g04.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		g04.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		g04.selected = false;
	// Add Shape Layer "G 05", varName "g05";
	var g05 = g_comp.layers.addShape();
		g05.name = "G 05";
		g05.inPoint = 0.58333333333333;
		g05.outPoint = 30;
		g05.moveToEnd();
		g05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		g05.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		g05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		g05.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var g05Path = g05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var g05Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var g05Path_object = {};
				g05Path_object.closed = true;
				g05Path_object.vertices = [[[138.122131347656, 109.248718261719], [137.807006835938, 109.248718261719], [110.519409179688, 109.248718261719], [34.5357666015625, -7.07278442382812], [137.806945800781, -7.2972412109375]], [[142.122131347656, 109.248718261719], [141.807006835938, 109.248718261719], [112.519409179688, 109.248718261719], [33.5357666015625, -7.07278442382812], [141.806945800781, -7.2972412109375]]];
			addShapeKeyframes(g05Path, g05Path_keyTimesArray, g05Path_object);
			var g05Path_easeInSpeedArray = [0,0];
			var g05Path_easeInInfluArray = [0.1,100];
			var g05Path_easeOutSpeedArray = [0,0];
			var g05Path_easeOutInfluArray = [0.1,0.1];
			var g05Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var g05Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(g05Path, g05Path_keyTimesArray, [g05Path_easeInSpeedArray, g05Path_easeInInfluArray], [g05Path_easeOutSpeedArray, g05Path_easeOutInfluArray], [g05Path_keyInInterpolationType, g05Path_keyOutInterpolationType]);

		g05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		g05.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		g05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		g05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		g05.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		g05.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		g05.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var g05Path3 = g05.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var g05Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var g05Path3_object = {};
				g05Path3_object.closed = false;
				g05Path3_object.vertices = [[[-10.8739776611328, -7.07278442382812], [-22.9990692138672, -7.07278442382812], [-136.188186645508, -7.07278442382812], [-24.1558837890625, 109.969604492188], [-1.67547607421875, 111.506286621094], [54.8536071777344, 97.3264770507812], [-10.8739929199219, -7.07281494140625]], [[-11.8739624023438, -7.07278442382812], [-23.9990539550781, -7.07278442382812], [-141.188201904297, -7.07278442382812], [-25.1558837890625, 109.969604492188], [-2.67547607421875, 111.506286621094], [56.8536071777344, 97.3264770507812], [-11.8739929199219, -7.07281494140625]]];
				g05Path3_object.inTangents = [[[0, 0], [0, 0], [0, 0], [-60.06005859375, -9.10784912109375], [-7.46330261230469, -0.17266845703125], [-17.9869384765625, 8.86181640625], [0, 0]], [[0, 0], [0, 0], [0, 0], [-60.06005859375, -9.10784912109375], [-7.46328735351562, -0.17266845703125], [-17.9869384765625, 8.86181640625], [0, 0]]];
				g05Path3_object.outTangents = [[[0, 0], [0, 0], [8.61575317382812, 60.2154235839844], [7.52366638183594, 0.850341796875], [21.3537902832031, -0.23309326171875], [0, 0], [0, 0]], [[0, 0], [0, 0], [8.61575317382812, 60.2154235839844], [7.52366638183594, 0.850341796875], [21.3537902832031, -0.23309326171875], [0, 0], [0, 0]]];
			addShapeKeyframes(g05Path3, g05Path3_keyTimesArray, g05Path3_object);
			var g05Path3_easeInSpeedArray = [0,0];
			var g05Path3_easeInInfluArray = [0.1,100];
			var g05Path3_easeOutSpeedArray = [0,0];
			var g05Path3_easeOutInfluArray = [0.1,0.1];
			var g05Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var g05Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(g05Path3, g05Path3_keyTimesArray, [g05Path3_easeInSpeedArray, g05Path3_easeInInfluArray], [g05Path3_easeOutSpeedArray, g05Path3_easeOutInfluArray], [g05Path3_keyInInterpolationType, g05Path3_keyOutInterpolationType]);

		g05.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		g05.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		g05.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		g05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		g05.property("ADBE Root Vectors Group").property(3).name = "Group 4";
		g05.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		g05.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var g05Path5 = g05.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var g05Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var g05Path5_object = {};
				g05Path5_object.closed = false;
				g05Path5_object.vertices = [[[-22.9990539550781, -163.796905517578], [-136.188186645508, -46.6077575683594], [-22.9990844726562, -46.6077575683594], [-22.9990844726562, -163.796936035156]], [[-23.9990539550781, -163.796905517578], [-141.188201904297, -46.6077575683594], [-23.9990844726562, -46.6077575683594], [-23.9990844726562, -163.796936035156]]];
				g05Path5_object.inTangents = [[[0, 0], [8.67190551757812, -60.6039123535156], [0, 0], [0, 0]], [[0, 0], [8.67190551757812, -60.6039123535156], [0, 0], [0, 0]]];
				g05Path5_object.outTangents = [[[-60.599609375, 8.66754150390625], [0, 0], [0, 0], [0, 0]], [[-60.599609375, 8.66754150390625], [0, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(g05Path5, g05Path5_keyTimesArray, g05Path5_object);
			var g05Path5_easeInSpeedArray = [0,0];
			var g05Path5_easeInInfluArray = [0.1,100];
			var g05Path5_easeOutSpeedArray = [0,0];
			var g05Path5_easeOutInfluArray = [0.1,0.1];
			var g05Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var g05Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(g05Path5, g05Path5_keyTimesArray, [g05Path5_easeInSpeedArray, g05Path5_easeInInfluArray], [g05Path5_easeOutSpeedArray, g05Path5_easeOutInfluArray], [g05Path5_keyInInterpolationType, g05Path5_keyOutInterpolationType]);

		g05.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		g05.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		g05.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		g05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		g05.property("ADBE Root Vectors Group").property(4).name = "Group 2";
		g05.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		g05.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var g05Path7 = g05.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var g05Path7_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var g05Path7_object = {};
				g05Path7_object.closed = true;
				g05Path7_object.vertices = [[[176.543487548828, -46.6077575683594], [16.5402069091797, -46.6077575683594], [16.5402069091797, -204.764984130859], [-2.94453430175781, -204.764984130859], [-2.94453430175781, -204.760681152344], [-3.22943115234375, -204.765014648438], [-177.156280517578, -26.8381652832031], [-3.22944641113281, 151.088684082031], [77.5843811035156, 131.310424804688], [88.8720397949219, 148.231140136719], [177.661346435547, 148.200927734375], [177.661346435547, -46.6078186035156]], [[180.543472290039, -46.6077575683594], [15.5402221679688, -46.6077575683594], [15.5402221679688, -204.764984130859], [-3.94454956054688, -204.764984130859], [-3.94454956054688, -204.760681152344], [-4.22943115234375, -204.765014648438], [-182.156295776367, -26.8381652832031], [-4.22946166992188, 151.088684082031], [79.5843658447266, 131.310424804688], [90.8720245361328, 148.231140136719], [181.661331176758, 148.200927734375], [181.661331176758, -46.6078186035156]]];
				g05Path7_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, -98.2655334472656], [-98.2655181884766, 0], [-25.7091979980469, 15.5523681640625], [0, 0], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, -98.2655334472656], [-98.2655029296875, 0], [-25.7091827392578, 15.5523681640625], [0, 0], [0, 0], [0, 0]]];
				g05Path7_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-98.2655334472656, 0], [0, 98.2655334472656], [39.8457641601562, 0], [0, 0], [0, 0], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-98.2655334472656, 0], [0, 98.2655334472656], [39.8457946777344, 0], [0, 0], [0, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(g05Path7, g05Path7_keyTimesArray, g05Path7_object);
			var g05Path7_easeInSpeedArray = [0,0];
			var g05Path7_easeInInfluArray = [0.1,100];
			var g05Path7_easeOutSpeedArray = [0,0];
			var g05Path7_easeOutInfluArray = [0.1,0.1];
			var g05Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var g05Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(g05Path7, g05Path7_keyTimesArray, [g05Path7_easeInSpeedArray, g05Path7_easeInInfluArray], [g05Path7_easeOutSpeedArray, g05Path7_easeOutInfluArray], [g05Path7_keyInInterpolationType, g05Path7_keyOutInterpolationType]);

		g05.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		g05.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		g05.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		g05.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		g05.selected = false;
	// Apply parents
		g01.setParentWithJump(g05);
		g02.setParentWithJump(g01);
		g03.setParentWithJump(g01);
		g04.setParentWithJump(g01);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			g02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			g02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			g03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			g03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			g04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			g04.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			g05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			g05.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			g05.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			g05.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

g_comp.openInViewer();

return {
	compItem : g_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function applySpatialTangents(property, keyTimesArray, inSpatialTangentsArray, outSpatialTangentsArray) {
	for (var sp = 0, spl = keyTimesArray.length; sp < spl; sp ++) {
		property.setSpatialTangentsAtKey(sp+1, inSpatialTangentsArray[sp], outSpatialTangentsArray[sp]);
	}
}
function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

