// Created using compCode v2.0
// 201801030 from composition "J" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// j();
function utopian_201801030_094309() {

// app.beginUndoGroup("J");

try {

// ANIMATION PRESETS START
	// J -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var j_comp_properties = {"name":"J","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":5,"frameRate":24};
	var j_comp = app.project.items.addComp(j_comp_properties.name, j_comp_properties.width, j_comp_properties.height, 1, 30, 24);
		j_comp.time = 0.29166666666667;
		j_comp.bgColor = j_comp_properties.bgColor;
		j_comp.label = j_comp_properties.label;
		j_comp.resolutionFactor = [1, 1];
		j_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = j_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "J", varName "j_comp";
	j_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = j_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([261.804992675781,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([537.697021484375,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = j_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "J 01", varName "j01";
	var j01 = j_comp.layers.addShape();
		j01.name = "J 01";
		j01.outPoint = 0.625;
		j01.moveToEnd();
		j01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		j01.property("ADBE Root Vectors Group").property(1).name = "Group 5";
		j01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		j01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var j01Path = j01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var j01Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.625];
			var j01Path_object = {};
				j01Path_object.closed = true;
				j01Path_object.vertices = [[[-38.4589691162109, 77.9652709960938], [-77.3076324462891, 77.9652709960938], [0.38969421386719, 155.66259765625], [0.38969421386719, 155.66259765625], [78.0869598388672, 77.9652709960938], [78.0869598388672, 77.9652709960938], [0.38966369628906, 77.9652709960938]], [[-38.4589538574219, 33.5277709960938], [-77.3076171875, 33.5277709960938], [0.38970947265625, 111.22509765625], [0.38970947265625, 111.22509765625], [78.0869750976562, 33.5277709960938], [78.0869750976562, 33.5277709960938], [0.38967895507812, 33.5277709960938]], [[-38.4589538574219, 33.5277709960938], [-77.3076171875, 33.5277709960938], [0.38970947265625, 111.22509765625], [0.38970947265625, 111.22509765625], [78.0869750976562, 33.5277709960938], [78.0869750976562, 33.5277709960938], [0.38967895507812, 33.5277709960938]], [[-38.4589691162109, 40.0277709960938], [-77.3076324462891, 40.0277709960938], [0.38969421386719, 112.72509765625], [0.38969421386719, 112.72509765625], [78.0869598388672, 40.0277709960938], [78.0869598388672, 40.0277709960938], [0.38966369628906, 40.0277709960938]]];
				j01Path_object.inTangents = [[[0, 0], [0, 0], [-42.9104919433594, 0], [0, 0], [0, 42.9104614257812], [0, 0], [0, 0]], [[0, 0], [0, 0], [-42.9104919433594, 0], [0, 0], [0, 42.9104614257812], [0, 0], [0, 0]], [[0, 0], [0, 0], [-42.9104919433594, 0], [0, 0], [0, 42.9104614257812], [0, 0], [0, 0]], [[0, 0], [0, 0], [-42.9104919433594, 0], [0, 0], [0, 42.9104614257812], [0, 0], [0, 0]]];
				j01Path_object.outTangents = [[[0, 0], [0, 42.9104614257812], [0, 0], [42.9104614257812, 0], [0, 0], [0, 0], [0, 0]], [[0, 0], [0, 42.9104614257812], [0, 0], [42.9104614257812, 0], [0, 0], [0, 0], [0, 0]], [[0, 0], [0, 42.9104614257812], [0, 0], [42.9104614257812, 0], [0, 0], [0, 0], [0, 0]], [[0, 0], [0, 42.9104614257812], [0, 0], [42.9104614257812, 0], [0, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(j01Path, j01Path_keyTimesArray, j01Path_object);
			var j01Path_easeInSpeedArray = [0,0,0,0];
			var j01Path_easeInInfluArray = [0.1,100,0.1,0.1];
			var j01Path_easeOutSpeedArray = [0,0,0,0];
			var j01Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var j01Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var j01Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(j01Path, j01Path_keyTimesArray, [j01Path_easeInSpeedArray, j01Path_easeInInfluArray], [j01Path_easeOutSpeedArray, j01Path_easeOutInfluArray], [j01Path_keyInInterpolationType, j01Path_keyOutInterpolationType]);

		j01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		j01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		j01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		j01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		j01.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		j01.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		j01.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var j01Path3 = j01.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var j01Path3_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.625];
			var j01Path3_object = {};
				j01Path3_object.closed = true;
				j01Path3_object.vertices = [[[-38.4589691162109, 29.1166076660156], [-116.156265258789, 29.1166076660156], [-116.156265258789, 77.9652709960938], [0.38969421386719, 194.51123046875], [0.38969421386719, 194.51123046875], [116.935653686523, 77.9652709960938], [117.048461914062, 28.3059692382812]], [[-38.4589538574219, -5.32089233398438], [-116.15625, -5.32089233398438], [-116.15625, 33.5277709960938], [0.38970947265625, 150.07373046875], [0.38970947265625, 150.07373046875], [116.935668945312, 33.5277709960938], [117.048477172852, -6.13153076171875]], [[-38.4589538574219, -5.32089233398438], [-116.15625, -5.32089233398438], [-116.15625, 33.5277709960938], [0.38970947265625, 150.07373046875], [0.38970947265625, 150.07373046875], [116.935668945312, 33.5277709960938], [117.048477172852, -6.13153076171875]], [[-38.4589691162109, 1.17910766601562], [-116.156265258789, 1.17910766601562], [-116.156265258789, 40.0277709960938], [0.38969421386719, 151.57373046875], [0.38969421386719, 151.57373046875], [116.935653686523, 40.0277709960938], [117.048461914062, 0.36846923828125]]];
				j01Path3_object.inTangents = [[[0, 0], [0, 0], [0, 0], [-64.367919921875, 0], [0, 0], [0, 64.367919921875], [0, 0]], [[0, 0], [0, 0], [0, 0], [-64.367919921875, 0], [0, 0], [0, 64.367919921875], [0, 0]], [[0, 0], [0, 0], [0, 0], [-64.367919921875, 0], [0, 0], [0, 64.367919921875], [0, 0]], [[0, 0], [0, 0], [0, 0], [-64.367919921875, 0], [0, 0], [0, 64.3679046630859], [0, 0]]];
				j01Path3_object.outTangents = [[[0, 0], [0, 0], [0, 64.367919921875], [0, 0], [64.3678894042969, 0], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 64.367919921875], [0, 0], [64.3678894042969, 0], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 64.367919921875], [0, 0], [64.3678894042969, 0], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 64.3679046630859], [0, 0], [64.3678894042969, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(j01Path3, j01Path3_keyTimesArray, j01Path3_object);
			var j01Path3_easeInSpeedArray = [0,0,0,0];
			var j01Path3_easeInInfluArray = [0.1,100,0.1,0.1];
			var j01Path3_easeOutSpeedArray = [0,0,0,0];
			var j01Path3_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var j01Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var j01Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(j01Path3, j01Path3_keyTimesArray, [j01Path3_easeInSpeedArray, j01Path3_easeInInfluArray], [j01Path3_easeOutSpeedArray, j01Path3_easeOutInfluArray], [j01Path3_keyInInterpolationType, j01Path3_keyOutInterpolationType]);

		j01.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		j01.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		j01.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		j01.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([0.44611358642578,71.9710998535156,0]);
		j01.property("ADBE Transform Group").property("ADBE Position").setValue([0.44611358642578,71.9710998535156,0]);
		j01.property("ADBE Transform Group").property("ADBE Rotate Z").setValue(180);
		j01.selected = false;
	// Add Shape Layer "J 02", varName "j02";
	var j02 = j_comp.layers.addShape();
		j02.name = "J 02";
		j02.outPoint = 0.625;
		j02.moveToEnd();
		j02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		j02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		j02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		j02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		j02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var j02Path = j02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var j02Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.625];
			var j02Path_object = {};
				j02Path_object.closed = true;
				j02Path_object.vertices = [[[93.591796875, -211.81640625], [93.591796875, 24.81640625], [-99.591796875, 24.81640625], [-99.591796875, -211.81640625]], [[93.591796875, -91.81640625], [93.591796875, 100.81640625], [-99.591796875, 100.81640625], [-99.591796875, -91.81640625]], [[93.591796875, -91.81640625], [93.591796875, 100.81640625], [-99.591796875, 100.81640625], [-99.591796875, -91.81640625]], [[93.591796875, -79.7524719238281], [93.591796875, 92.8110961914062], [-99.591796875, 92.8110961914062], [-99.591796875, -79.7524719238281]]];
			addShapeKeyframes(j02Path, j02Path_keyTimesArray, j02Path_object);
			var j02Path_easeInSpeedArray = [0,0,0,0];
			var j02Path_easeInInfluArray = [0.1,100,0.1,0.1];
			var j02Path_easeOutSpeedArray = [0,0,0,0];
			var j02Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var j02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var j02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(j02Path, j02Path_keyTimesArray, [j02Path_easeInSpeedArray, j02Path_easeInInfluArray], [j02Path_easeOutSpeedArray, j02Path_easeOutInfluArray], [j02Path_keyInInterpolationType, j02Path_keyOutInterpolationType]);

		j02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		j02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		j02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		j02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		j02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		j02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		j02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		j02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([3.591796875,30.18359375]);
		j02.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		j02.selected = false;
	// Add Shape Layer "J 03", varName "j03";
	var j03 = j_comp.layers.addShape();
		j03.name = "J 03";
		j03.inPoint = 0.625;
		j03.outPoint = 30;
		j03.moveToEnd();
		j03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		j03.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		j03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		j03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var j03Path = j03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var j03Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var j03Path_object = {};
				j03Path_object.closed = true;
				j03Path_object.vertices = [[[78.0870361328125, -17.3208923339844], [0.38970947265625, -17.3208923339844], [0.38970947265625, -151.573089599609], [78.0870056152344, -151.573089599609]], [[78.0870361328125, -5.32089233398438], [0.38970947265625, -5.32089233398438], [0.38970947265625, -163.573089599609], [78.0870056152344, -163.573089599609]]];
			addShapeKeyframes(j03Path, j03Path_keyTimesArray, j03Path_object);
			var j03Path_easeInSpeedArray = [0,0];
			var j03Path_easeInInfluArray = [0.1,100];
			var j03Path_easeOutSpeedArray = [0,0];
			var j03Path_easeOutInfluArray = [0.1,0.1];
			var j03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var j03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(j03Path, j03Path_keyTimesArray, [j03Path_easeInSpeedArray, j03Path_easeInInfluArray], [j03Path_easeOutSpeedArray, j03Path_easeOutInfluArray], [j03Path_keyInInterpolationType, j03Path_keyOutInterpolationType]);

		j03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		j03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		j03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		j03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		j03.property("ADBE Root Vectors Group").property(2).name = "Group 5";
		j03.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		j03.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var j03Path3 = j03.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var j03Path3_keyTimesArray = [0.58333333333333, 0.91666666666667, 1];
			var j03Path3_object = {};
				j03Path3_object.closed = true;
				j03Path3_object.vertices = [[[-77.3076171875, 21.5277709960938], [0.38970947265625, 99.22509765625], [0.38970947265625, 99.22509765625], [78.0869750976562, 21.5277709960938], [78.0869750976562, 21.5277709960938]], [[-77.3076171875, 33.5277709960938], [0.38970947265625, 111.22509765625], [0.38970947265625, 111.22509765625], [78.0869750976562, 33.5277709960938], [78.0869750976562, 33.5277709960938]], [[-77.3076171875, 33.5277709960938], [0.38970947265625, 111.22509765625], [0.38970947265625, 111.22509765625], [78.0869750976562, 33.5277709960938], [78.0869750976562, 33.5277709960938]]];
				j03Path3_object.inTangents = [[[0, 0], [-42.9104919433594, 0], [0, 0], [0, 42.9104614257812], [0, 0]], [[0, 0], [-42.9104919433594, 0], [0, 0], [0, 42.9104614257812], [0, 0]], [[0, 0], [-42.9104919433594, 0], [0, 0], [0, 42.9104614257812], [0, 0]]];
				j03Path3_object.outTangents = [[[0, 42.9104614257812], [0, 0], [42.9104614257812, 0], [0, 0], [0, 0]], [[0, 42.9104614257812], [0, 0], [42.9104614257812, 0], [0, 0], [0, 0]], [[0, 42.9104614257812], [0, 0], [42.9104614257812, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(j03Path3, j03Path3_keyTimesArray, j03Path3_object);
			var j03Path3_easeInSpeedArray = [0,0,0];
			var j03Path3_easeInInfluArray = [0.1,100,16.666666667];
			var j03Path3_easeOutSpeedArray = [0,0,0];
			var j03Path3_easeOutInfluArray = [0.1,0.1,16.666666667];
			var j03Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var j03Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(j03Path3, j03Path3_keyTimesArray, [j03Path3_easeInSpeedArray, j03Path3_easeInInfluArray], [j03Path3_easeOutSpeedArray, j03Path3_easeOutInfluArray], [j03Path3_keyInInterpolationType, j03Path3_keyOutInterpolationType]);

		j03.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		j03.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		j03.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		j03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		j03.property("ADBE Root Vectors Group").property(3).name = "Group 2";
		j03.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		j03.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var j03Path5 = j03.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var j03Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var j03Path5_object = {};
				j03Path5_object.closed = true;
				j03Path5_object.vertices = [[[-38.4589538574219, -190.421722412109], [-38.4589538574219, -17.3209075927734], [-116.15625, -17.3209075927734], [-116.15625, 21.5277709960938], [0.38970947265625, 138.07373046875], [0.38970947265625, 138.07373046875], [116.935668945312, 21.5277709960938], [116.935668945312, -190.421752929688]], [[-38.4589538574219, -202.421722412109], [-38.4589538574219, -5.32089233398438], [-116.15625, -5.32089233398438], [-116.15625, 33.5277709960938], [0.38970947265625, 150.07373046875], [0.38970947265625, 150.07373046875], [116.935668945312, 33.5277709960938], [116.935668945312, -202.421752929688]]];
				j03Path5_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [-64.367919921875, 0], [0, 0], [0, 64.367919921875], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [-64.367919921875, 0], [0, 0], [0, 64.367919921875], [0, 0]]];
				j03Path5_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 64.367919921875], [0, 0], [64.3678894042969, 0], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 64.367919921875], [0, 0], [64.3678894042969, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(j03Path5, j03Path5_keyTimesArray, j03Path5_object);
			var j03Path5_easeInSpeedArray = [0,0];
			var j03Path5_easeInInfluArray = [0.1,100];
			var j03Path5_easeOutSpeedArray = [0,0];
			var j03Path5_easeOutInfluArray = [0.1,0.1];
			var j03Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var j03Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(j03Path5, j03Path5_keyTimesArray, [j03Path5_easeInSpeedArray, j03Path5_easeInInfluArray], [j03Path5_easeOutSpeedArray, j03Path5_easeOutInfluArray], [j03Path5_keyInInterpolationType, j03Path5_keyOutInterpolationType]);

		j03.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		j03.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		j03.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		j03.property("ADBE Transform Group").property("ADBE Position").setValue([400,528,0]);
		j03.selected = false;
	// Apply parents
		j01.setParentWithJump(j03);
		j02.setParentWithJump(j03);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			j01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			j01.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			j02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			j02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			j03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			j03.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			j03.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

j_comp.openInViewer();

return {
	compItem : j_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

