// Created using compCode v2.0
// 201801030 from composition "Q" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// q();
function utopian_201801030_094309() {

// app.beginUndoGroup("Q");

try {

// ANIMATION PRESETS START
	// Q -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var q_comp_properties = {"name":"Q","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":6,"frameRate":24};
	var q_comp = app.project.items.addComp(q_comp_properties.name, q_comp_properties.width, q_comp_properties.height, 1, 30, 24);
		q_comp.time = 0.83333333333333;
		q_comp.bgColor = q_comp_properties.bgColor;
		q_comp.label = q_comp_properties.label;
		q_comp.resolutionFactor = [1, 1];
		q_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = q_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "Q", varName "q_comp";
	q_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = q_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([202.294006347656,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([597.705993652344,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = q_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	//Create new Null layer "q01" and replace its source with varName "null10_null";
	var q01 = q_comp.layers.addNull();
	var q01_source = q01.source;
		q01.replaceSource(null10_null, true);
		q01_source.remove();
		q01.name = "Q 01";
		q01.enabled = false;
		q01.outPoint = 0.58333333333333;
		q01.moveToEnd();
		var q01Position = q01.property("ADBE Transform Group").property("ADBE Position");
			var q01Position_keyTimesArray = [0,0.33333333333333,0.41666666666667,0.54166666666667];
			var q01Position_valuesArray = [[34.9687709370079,-30,0],[56,-30,0],[56,-30,0],[40,-30,0]];
			q01Position.setValuesAtTimes(q01Position_keyTimesArray, q01Position_valuesArray);
			var q01Position_inSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			var q01Position_outSpatialTangents = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			applySpatialTangents(q01Position, q01Position_keyTimesArray, q01Position_inSpatialTangents, q01Position_outSpatialTangents);
			var q01Position_easeInSpeedArray = [0,0,0,0];
			var q01Position_easeInInfluArray = [99.6000004016053,57.2001145530109,100,0.1];
			var q01Position_easeOutSpeedArray = [0,0,0,0];
			var q01Position_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var q01Position_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var q01Position_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(q01Position, q01Position_keyTimesArray, [q01Position_easeInSpeedArray, q01Position_easeInInfluArray], [q01Position_easeOutSpeedArray, q01Position_easeOutInfluArray], [q01Position_keyInInterpolationType, q01Position_keyOutInterpolationType]);

		q01.selected = false;
	// Add Shape Layer "Q 02", varName "q02";
	var q02 = q_comp.layers.addShape();
		q02.name = "Q 02";
		q02.outPoint = 0.58333333333333;
		q02.moveToEnd();
		q02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		q02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		q02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		q02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		q02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var q02Path = q02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var q02Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var q02Path_object = {};
				q02Path_object.closed = true;
				q02Path_object.vertices = [[[87.7578125, 41.0000305175781], [87.7578125, 158], [-59.7578125, 158], [-59.7578125, 40.9999389648438]], [[87.515625, 41.0000305175781], [87.7578125, 158], [-3.7578125, 158], [-4, 40.9999389648438]], [[87.7578125, 41.0000305175781], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, 40.9999389648438]], [[101.515625, 41.0000305175781], [101.7578125, 157], [-40.7578125, 157], [-39, 40.7499084472656]]];
			addShapeKeyframes(q02Path, q02Path_keyTimesArray, q02Path_object);
			var q02Path_easeInSpeedArray = [0,0,0,0];
			var q02Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var q02Path_easeOutSpeedArray = [0,0,0,0];
			var q02Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var q02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var q02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(q02Path, q02Path_keyTimesArray, [q02Path_easeInSpeedArray, q02Path_easeInInfluArray], [q02Path_easeOutSpeedArray, q02Path_easeOutInfluArray], [q02Path_keyInInterpolationType, q02Path_keyOutInterpolationType]);

		q02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		q02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		q02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		q02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		q02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		q02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		q02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		q02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		q02.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		q02.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		q02.selected = false;
	// Add Shape Layer "Q 03", varName "q03";
	var q03 = q_comp.layers.addShape();
		q03.name = "Q 03";
		q03.outPoint = 0.58333333333333;
		q03.moveToEnd();
		q03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		q03.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		q03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		q03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		q03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var q03Path = q03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var q03Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var q03Path_object = {};
				q03Path_object.closed = true;
				q03Path_object.vertices = [[[87.7578125, -155], [87.7578125, 0.00003051757812], [87.7578125, 158], [-59.7578125, 158], [-59.7578125, -1.75003051757812], [-59.7578125, -155]], [[87.7578125, -155], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -155]], [[87.7578125, -155], [87.7578125, 0.00003051757812], [87.7578125, 158], [-3.7578125, 158], [-3.7578125, -1.75003051757812], [-3.7578125, -155]], [[101.7578125, -155], [102.515625, 25.0000305175781], [101.7578125, 157], [-40.7578125, 157], [-41, 23.25], [-40.7578125, -155]]];
			addShapeKeyframes(q03Path, q03Path_keyTimesArray, q03Path_object);
			var q03Path_easeInSpeedArray = [0,0,0,0];
			var q03Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var q03Path_easeOutSpeedArray = [0,0,0,0];
			var q03Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var q03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var q03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(q03Path, q03Path_keyTimesArray, [q03Path_easeInSpeedArray, q03Path_easeInInfluArray], [q03Path_easeOutSpeedArray, q03Path_easeOutInfluArray], [q03Path_keyInInterpolationType, q03Path_keyOutInterpolationType]);

		q03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		q03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		q03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		q03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		q03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		q03.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		q03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		q03.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		q03.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		q03.property("ADBE Transform Group").property("ADBE Position").setValue([-28.2421875,1,0]);
		q03.selected = false;
	// Add Shape Layer "Q 04", varName "q04";
	var q04 = q_comp.layers.addShape();
		q04.name = "Q 04";
		q04.inPoint = 0.58333333333333;
		q04.outPoint = 30;
		q04.moveToEnd();
		q04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		q04.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		q04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		q04.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var q04Path = q04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var q04Path_keyTimesArray = [0.54166666666667, 0.83333333333333];
			var q04Path_object = {};
				q04Path_object.closed = false;
				q04Path_object.vertices = [[[31.9345092773438, -162.761535644531], [31.9345092773438, -7.30645751953125], [132.165344238281, -7.30645751953125], [133.58544921875, -7.30645751953125], [133.58544921875, -26.9164428710938], [31.9344482421875, -162.761566162109]], [[19.9345092773438, -162.761535644531], [19.9345092773438, -7.30645751953125], [136.165344238281, -7.30645751953125], [137.58544921875, -7.30645751953125], [137.58544921875, -26.9164428710938], [19.9344482421875, -162.761566162109]]];
				q04Path_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 6.660400390625], [66.51318359375, 9.52224731445312]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 6.660400390625], [66.51318359375, 9.52224731445312]]];
				q04Path_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, -9.15106201171875], [0, -69.1419677734375], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, -9.15106201171875], [0, -69.1419677734375], [0, 0]]];
			addShapeKeyframes(q04Path, q04Path_keyTimesArray, q04Path_object);
			var q04Path_easeInSpeedArray = [0,0];
			var q04Path_easeInInfluArray = [16.666666667,100];
			var q04Path_easeOutSpeedArray = [0,0];
			var q04Path_easeOutInfluArray = [0.1,16.666666667];
			var q04Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var q04Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(q04Path, q04Path_keyTimesArray, [q04Path_easeInSpeedArray, q04Path_easeInInfluArray], [q04Path_easeOutSpeedArray, q04Path_easeOutInfluArray], [q04Path_keyInInterpolationType, q04Path_keyOutInterpolationType]);

		q04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		q04.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		q04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		q04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		q04.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		q04.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		q04.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var q04Path3 = q04.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var q04Path3_keyTimesArray = [0.54166666666667, 0.83333333333333];
			var q04Path3_object = {};
				q04Path3_object.closed = false;
				q04Path3_object.vertices = [[[133.585510253906, 31.9134521484375], [31.9345092773438, 31.9134521484375], [31.9345092773438, 110.344543457031], [133.58544921875, 110.344543457031], [133.58544921875, 31.9134521484375]], [[137.585510253906, 31.9134521484375], [19.9345092773438, 31.9134521484375], [19.9345092773438, 110.344543457031], [137.58544921875, 110.344543457031], [137.58544921875, 31.9134521484375]]];
			addShapeKeyframes(q04Path3, q04Path3_keyTimesArray, q04Path3_object);
			var q04Path3_easeInSpeedArray = [0,0];
			var q04Path3_easeInInfluArray = [16.666666667,100];
			var q04Path3_easeOutSpeedArray = [0,0];
			var q04Path3_easeOutInfluArray = [0.1,16.666666667];
			var q04Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var q04Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(q04Path3, q04Path3_keyTimesArray, [q04Path3_easeInSpeedArray, q04Path3_easeInInfluArray], [q04Path3_easeOutSpeedArray, q04Path3_easeOutInfluArray], [q04Path3_keyInInterpolationType, q04Path3_keyOutInterpolationType]);

		q04.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		q04.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		q04.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		q04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		q04.property("ADBE Root Vectors Group").property(3).name = "Group 4";
		q04.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		q04.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var q04Path5 = q04.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var q04Path5_keyTimesArray = [0.54166666666667, 0.83333333333333, 1.04166666666667];
			var q04Path5_object = {};
				q04Path5_object.closed = false;
				q04Path5_object.vertices = [[[-7.28536987304688, -162.761535644531], [-120.940689086914, -26.9164123535156], [-7.285400390625, 108.9287109375], [-7.285400390625, -162.761566162109]], [[-19.2853698730469, -162.761535644531], [-136.940704345703, -26.9164123535156], [-19.285400390625, 108.9287109375], [-19.285400390625, -162.761566162109]], [[-19.2853698730469, -162.761535644531], [-136.940704345703, -26.9164123535156], [-19.285400390625, 108.9287109375], [-19.285400390625, -162.761566162109]]];
				q04Path5_object.inTangents = [[[0, 0], [0, -69.1463012695312], [-66.5175170898438, -9.522216796875], [0, 0]], [[0, 0], [0, -69.1463012695312], [-66.5175170898438, -9.522216796875], [0, 0]], [[0, 0], [0, -69.1463012695312], [-66.5175170898438, -9.522216796875], [0, 0]]];
				q04Path5_object.outTangents = [[[-66.5175476074219, 9.51791381835938], [0, 69.1462707519531], [0, 0], [0, 0]], [[-66.5175476074219, 9.51791381835938], [0, 69.1462707519531], [0, 0], [0, 0]], [[-66.5175476074219, 9.51791381835938], [0, 69.1462707519531], [0, 0], [0, 0]]];
			addShapeKeyframes(q04Path5, q04Path5_keyTimesArray, q04Path5_object);
			var q04Path5_easeInSpeedArray = [0,0,0];
			var q04Path5_easeInInfluArray = [16.666666667,100,16.666666667];
			var q04Path5_easeOutSpeedArray = [0,0,0];
			var q04Path5_easeOutInfluArray = [0.1,16.666666667,16.666666667];
			var q04Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var q04Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(q04Path5, q04Path5_keyTimesArray, [q04Path5_easeInSpeedArray, q04Path5_easeInInfluArray], [q04Path5_easeOutSpeedArray, q04Path5_easeOutInfluArray], [q04Path5_keyInInterpolationType, q04Path5_keyOutInterpolationType]);

		q04.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		q04.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		q04.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		q04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		q04.property("ADBE Root Vectors Group").property(4).name = "Group 2";
		q04.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		q04.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var q04Path7 = q04.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var q04Path7_keyTimesArray = [0.54166666666667, 0.83333333333333];
			var q04Path7_object = {};
				q04Path7_object.closed = false;
				q04Path7_object.vertices = [[[12.3245544433594, -203.392913818359], [-160.15625, -26.912109375], [12.3245086669922, 149.568725585938], [172.805358886719, 149.568725585938], [172.805358886719, -26.912109375], [12.3245086669922, -203.392944335938]], [[0.32455444335938, -203.392913818359], [-176.156265258789, -26.912109375], [0.32452392578125, 149.568725585938], [176.80534362793, 149.568725585938], [176.80534362793, -26.912109375], [0.32452392578125, -203.392944335938]]];
				q04Path7_object.inTangents = [[[0, 0], [0, -97.4669494628906], [-97.4669342041016, 0], [0, 0], [0, 6.63018798828125], [97.4669952392578, 0]], [[0, 0], [0, -97.4669494628906], [-97.4669494628906, 0], [0, 0], [0, 6.63018798828125], [97.4669647216797, 0]]];
				q04Path7_object.outTangents = [[[-97.4669799804688, 0], [0, 97.4669799804688], [0.56983947753906, 0], [0, 0], [-0.00433349609375, -97.4712829589844], [0, 0]], [[-97.4669799804688, 0], [0, 97.4669799804688], [0.56979370117188, 0], [0, 0], [-0.00433349609375, -97.4712829589844], [0, 0]]];
			addShapeKeyframes(q04Path7, q04Path7_keyTimesArray, q04Path7_object);
			var q04Path7_easeInSpeedArray = [0,0];
			var q04Path7_easeInInfluArray = [16.666666667,100];
			var q04Path7_easeOutSpeedArray = [0,0];
			var q04Path7_easeOutInfluArray = [0.1,16.666666667];
			var q04Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var q04Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(q04Path7, q04Path7_keyTimesArray, [q04Path7_easeInSpeedArray, q04Path7_easeInInfluArray], [q04Path7_easeOutSpeedArray, q04Path7_easeOutInfluArray], [q04Path7_keyInInterpolationType, q04Path7_keyOutInterpolationType]);

		q04.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		q04.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		q04.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		q04.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		q04.selected = false;
	// Apply parents
		q01.setParentWithJump(q04);
		q02.setParentWithJump(q01);
		q03.setParentWithJump(q01);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			q02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			q02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			q03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			q03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			q04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			q04.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			q04.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			q04.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

q_comp.openInViewer();

return {
	compItem : q_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function applySpatialTangents(property, keyTimesArray, inSpatialTangentsArray, outSpatialTangentsArray) {
	for (var sp = 0, spl = keyTimesArray.length; sp < spl; sp ++) {
		property.setSpatialTangentsAtKey(sp+1, inSpatialTangentsArray[sp], outSpatialTangentsArray[sp]);
	}
}
function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

