// Created using compCode v2.0
// 201801030 from composition "R" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// r();
function utopian_201801030_094309() {

// app.beginUndoGroup("R");

try {

// ANIMATION PRESETS START
	// R -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var r_comp_properties = {"name":"R","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":6,"frameRate":24};
	var r_comp = app.project.items.addComp(r_comp_properties.name, r_comp_properties.width, r_comp_properties.height, 1, 30, 24);
		r_comp.time = 1.875;
		r_comp.bgColor = r_comp_properties.bgColor;
		r_comp.label = r_comp_properties.label;
		r_comp.resolutionFactor = [1, 1];
		r_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = r_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "R", varName "r_comp";
	r_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = r_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([241.884994506836,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([558.114990234375,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = r_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "R 01", varName "r01";
	var r01 = r_comp.layers.addShape();
		r01.name = "R 01";
		r01.outPoint = 0.58333333333333;
		r01.moveToEnd();
		r01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		r01.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		r01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		r01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		r01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var r01Path = r01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var r01Path_keyTimesArray = [0, 0.41666666666667, 0.54166666666667];
			var r01Path_object = {};
				r01Path_object.closed = true;
				r01Path_object.vertices = [[[72.537109375, -156.1328125], [72.537109375, 156.234375], [-38.537109375, 156.05078125], [-38.537109375, -156.31640625]], [[112.537109375, -156.1328125], [112.537109375, 156.234375], [9.462890625, 156.05078125], [9.462890625, -156.31640625]], [[104.537109375, -156.1328125], [104.537109375, 156.234375], [-6.537109375, 156.05078125], [-6.537109375, -156.31640625]]];
			addShapeKeyframes(r01Path, r01Path_keyTimesArray, r01Path_object);
			var r01Path_easeInSpeedArray = [0,0,0];
			var r01Path_easeInInfluArray = [16.666666667,100,0.1];
			var r01Path_easeOutSpeedArray = [0,0,0];
			var r01Path_easeOutInfluArray = [0.1,100,16.666666667];
			var r01Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var r01Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(r01Path, r01Path_keyTimesArray, [r01Path_easeInSpeedArray, r01Path_easeInInfluArray], [r01Path_easeOutSpeedArray, r01Path_easeOutInfluArray], [r01Path_keyInInterpolationType, r01Path_keyOutInterpolationType]);

		r01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		r01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		r01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		r01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		r01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		r01.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		r01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		r01.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1.462890625,-26.81640625]);
		r01.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		r01.selected = false;
	// Add Shape Layer "R 02", varName "r02";
	var r02 = r_comp.layers.addShape();
		r02.name = "R 02";
		r02.outPoint = 0.58333333333333;
		r02.moveToEnd();
		r02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		r02.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		r02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		r02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var r02Path = r02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var r02Path_keyTimesArray = [0, 0.41666666666667, 0.54166666666667];
			var r02Path_object = {};
				r02Path_object.closed = false;
				r02Path_object.vertices = [[[104.776031494141, -165.819946289062], [96.6134948730469, -165.819946289062], [96.6134948730469, -165.578247070312], [96.6134948730469, -10.3044738769531], [104.776000976562, -10.3044738769531], [182.473327636719, -86.64208984375], [104.776000976562, -165.820007324219]], [[120.77604675293, -165.819946289062], [112.613510131836, -165.819946289062], [112.613510131836, -165.578247070312], [112.613510131836, -10.3044738769531], [120.776016235352, -10.3044738769531], [198.473342895508, -86.64208984375], [120.776016235352, -165.820007324219]], [[112.776031494141, -165.819946289062], [104.613494873047, -165.819946289062], [104.613494873047, -165.578247070312], [104.613494873047, -10.3044738769531], [112.776000976562, -10.3044738769531], [190.473327636719, -86.64208984375], [112.776000976562, -165.820007324219]]];
				r02Path_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]]];
				r02Path_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]]];
			addShapeKeyframes(r02Path, r02Path_keyTimesArray, r02Path_object);
			var r02Path_easeInSpeedArray = [0,0,0];
			var r02Path_easeInInfluArray = [16.666666667,100,16.666666667];
			var r02Path_easeOutSpeedArray = [0,0,0];
			var r02Path_easeOutInfluArray = [0.1,100,16.666666667];
			var r02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var r02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(r02Path, r02Path_keyTimesArray, [r02Path_easeInSpeedArray, r02Path_easeInInfluArray], [r02Path_easeOutSpeedArray, r02Path_easeOutInfluArray], [r02Path_keyInInterpolationType, r02Path_keyOutInterpolationType]);

		r02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		r02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		r02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		r02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		r02.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		r02.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		r02.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var r02Path3 = r02.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var r02Path3_keyTimesArray = [0, 0.41666666666667, 0.54166666666667];
			var r02Path3_object = {};
				r02Path3_object.closed = false;
				r02Path3_object.vertices = [[[104.007705688477, -204.897369384766], [59.2850952148438, -204.897369384766], [59.3473663330078, 29.0929565429688], [96.6134643554688, 28.5485229492188], [104.007659912109, 28.5485229492188], [221.321960449219, -87.4061126708984], [104.00764465332, -204.897430419922]], [[120.007720947266, -204.897369384766], [75.2851104736328, -204.897369384766], [75.3473815917969, 29.0929565429688], [112.613479614258, 28.5485229492188], [120.007675170898, 28.5485229492188], [237.321975708008, -87.4061126708984], [120.007659912109, -204.897430419922]], [[112.007705688477, -204.897369384766], [67.2850952148438, -204.897369384766], [67.3473663330078, 29.0929565429688], [104.613464355469, 28.5485229492188], [112.007659912109, 28.5485229492188], [229.321960449219, -87.4061126708984], [112.00764465332, -204.897430419922]]];
				r02Path3_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7866058349609], [64.7909393310547, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7866058349609], [64.7909545898438, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7866058349609], [64.7909393310547, 0]]];
				r02Path3_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909393310547], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909393310547, 0], [0, -64.7909393310547], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909393310547], [0, 0]]];
			addShapeKeyframes(r02Path3, r02Path3_keyTimesArray, r02Path3_object);
			var r02Path3_easeInSpeedArray = [0,0,0];
			var r02Path3_easeInInfluArray = [16.666666667,100,16.666666667];
			var r02Path3_easeOutSpeedArray = [0,0,0];
			var r02Path3_easeOutInfluArray = [0.1,100,16.666666667];
			var r02Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var r02Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(r02Path3, r02Path3_keyTimesArray, [r02Path3_easeInSpeedArray, r02Path3_easeInInfluArray], [r02Path3_easeOutSpeedArray, r02Path3_easeOutInfluArray], [r02Path3_keyInInterpolationType, r02Path3_keyOutInterpolationType]);

		r02.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		r02.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		r02.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		r02.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([51.5184326171875,-85.2260284423828,0]);
		r02.property("ADBE Transform Group").property("ADBE Position").setValue([51.5184326171875,-83.2260284423828,0]);
		r02.property("ADBE Transform Group").property("ADBE Scale").setValue([-100,-100,100]);
		r02.selected = false;
	// Add Shape Layer "R 03", varName "r03";
	var r03 = r_comp.layers.addShape();
		r03.name = "R 03";
		r03.outPoint = 0.58333333333333;
		r03.moveToEnd();
		r03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		r03.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		r03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		r03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		r03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var r03Path = r03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var r03Path_keyTimesArray = [0, 0.41666666666667, 0.54166666666667];
			var r03Path_object = {};
				r03Path_object.closed = true;
				r03Path_object.vertices = [[[72.537109375, -156.18359375], [72.537109375, 156.18359375], [-96.537109375, 156.18359375], [-96.537109375, -156.18359375]], [[112.537109375, -156.18359375], [112.537109375, 156.18359375], [-112.537109375, 156.18359375], [-112.537109375, -156.18359375]], [[104.537109375, -156.18359375], [104.537109375, 156.18359375], [-104.537109375, 156.18359375], [-104.537109375, -156.18359375]]];
			addShapeKeyframes(r03Path, r03Path_keyTimesArray, r03Path_object);
			var r03Path_easeInSpeedArray = [0,0,0];
			var r03Path_easeInInfluArray = [16.666666667,100,0.1];
			var r03Path_easeOutSpeedArray = [0,0,0];
			var r03Path_easeOutInfluArray = [0.1,100,16.666666667];
			var r03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var r03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(r03Path, r03Path_keyTimesArray, [r03Path_easeInSpeedArray, r03Path_easeInInfluArray], [r03Path_easeOutSpeedArray, r03Path_easeOutInfluArray], [r03Path_keyInInterpolationType, r03Path_keyOutInterpolationType]);

		r03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		r03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		r03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		r03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		r03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		r03.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		r03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		r03.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1.462890625,-26.81640625]);
		r03.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		r03.selected = false;
	// Add Shape Layer "R 05", varName "r05";
	var r05 = r_comp.layers.addShape();
		r05.name = "R 05";
		r05.inPoint = 0.58333333333333;
		r05.outPoint = 30;
		r05.moveToEnd();
		r05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		r05.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		r05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		r05.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var r05Path = r05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var r05Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var r05Path_object = {};
				r05Path_object.closed = false;
				r05Path_object.vertices = [[[27.737548828125, 30.075439453125], [18.8556518554688, 31.2754516601562], [11.4528198242188, 31.2754516601562], [11.4528198242188, 108.325256347656], [64.0350952148438, 108.325256347656], [27.7374877929688, 30.075439453125]], [[35.737548828125, 30.075439453125], [18.8556518554688, 31.2754516601562], [11.4528198242188, 31.2754516601562], [11.4528198242188, 108.325256347656], [72.0350952148438, 108.325256347656], [35.7374877929688, 30.075439453125]]];
				r05Path_object.inTangents = [[[0, 0], [5.73233032226562, 0], [0, 0], [0, 0], [0, 0], [0, 0]], [[0, 0], [5.73233032226562, 0], [0, 0], [0, 0], [0, 0], [0, 0]]];
				r05Path_object.outTangents = [[[-5.51651000976562, 0.7769775390625], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]], [[-5.51651000976562, 0.7769775390625], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(r05Path, r05Path_keyTimesArray, r05Path_object);
			var r05Path_easeInSpeedArray = [0,0];
			var r05Path_easeInInfluArray = [0.1,100];
			var r05Path_easeOutSpeedArray = [0,0];
			var r05Path_easeOutInfluArray = [0.1,0.1];
			var r05Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var r05Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(r05Path, r05Path_keyTimesArray, [r05Path_easeInSpeedArray, r05Path_easeInInfluArray], [r05Path_easeOutSpeedArray, r05Path_easeOutInfluArray], [r05Path_keyInInterpolationType, r05Path_keyOutInterpolationType]);

		r05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		r05.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		r05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		r05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		r05.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		r05.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		r05.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var r05Path3 = r05.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var r05Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var r05Path3_object = {};
				r05Path3_object.closed = false;
				r05Path3_object.vertices = [[[19.6239624023438, -163.093048095703], [11.4571228027344, -163.093048095703], [11.4571228027344, -162.851348876953], [11.4571228027344, -7.57757568359375], [19.6239624023438, -7.57757568359375], [89.3212585449219, -83.9151916503906], [19.6239624023438, -163.093109130859]], [[19.6239624023438, -163.093048095703], [11.4571228027344, -163.093048095703], [11.4571228027344, -162.851348876953], [11.4571228027344, -7.57757568359375], [19.6239624023438, -7.57757568359375], [97.3212585449219, -83.9151916503906], [19.6239624023438, -163.093109130859]]];
				r05Path3_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061584472656], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061584472656], [42.9104614257812, 0]]];
				r05Path3_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [42.9104614257812, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104614257812, 0], [0, -42.9062194824219], [0, 0]]];
			addShapeKeyframes(r05Path3, r05Path3_keyTimesArray, r05Path3_object);
			var r05Path3_easeInSpeedArray = [0,0];
			var r05Path3_easeInInfluArray = [0.1,100];
			var r05Path3_easeOutSpeedArray = [0,0];
			var r05Path3_easeOutInfluArray = [0.1,0.1];
			var r05Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var r05Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(r05Path3, r05Path3_keyTimesArray, [r05Path3_easeInSpeedArray, r05Path3_easeInInfluArray], [r05Path3_easeOutSpeedArray, r05Path3_easeOutInfluArray], [r05Path3_keyInInterpolationType, r05Path3_keyOutInterpolationType]);

		r05.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		r05.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		r05.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		r05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		r05.property("ADBE Root Vectors Group").property(3).name = "Group 3";
		r05.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		r05.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var r05Path5 = r05.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var r05Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var r05Path5_object = {};
				r05Path5_object.closed = true;
				r05Path5_object.vertices = [[[-89.0601196289062, 108.325256347656], [-89.0601196289062, -162.851348876953], [-27.3915405273438, -162.851348876953], [-27.3915405273438, 108.325256347656]], [[-97.0601196289062, 108.325256347656], [-97.0601196289062, -162.851348876953], [-27.3915405273438, -162.851348876953], [-27.3915405273438, 108.325256347656]]];
			addShapeKeyframes(r05Path5, r05Path5_keyTimesArray, r05Path5_object);
			var r05Path5_easeInSpeedArray = [0,0];
			var r05Path5_easeInInfluArray = [0.1,100];
			var r05Path5_easeOutSpeedArray = [0,0];
			var r05Path5_easeOutInfluArray = [0.1,0.1];
			var r05Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var r05Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(r05Path5, r05Path5_keyTimesArray, [r05Path5_easeInSpeedArray, r05Path5_easeInInfluArray], [r05Path5_easeOutSpeedArray, r05Path5_easeOutInfluArray], [r05Path5_keyInInterpolationType, r05Path5_keyOutInterpolationType]);

		r05.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		r05.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		r05.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		r05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		r05.property("ADBE Root Vectors Group").property(4).name = "Group 4";
		r05.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		r05.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var r05Path7 = r05.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var r05Path7_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var r05Path7_object = {};
				r05Path7_object.closed = false;
				r05Path7_object.vertices = [[[128.165649414062, -84.6792144775391], [18.8599243164062, -202.170501708984], [-129.156311035156, -202.170501708984], [-129.156311035156, -201.989227294922], [-129.156311035156, 147.648681640625], [125.001586914062, 147.545104980469], [65.0623931884766, 18.2869262695312], [128.16552734375, -84.6792602539062]], [[136.165649414062, -84.6792144775391], [18.8599243164062, -202.170501708984], [-137.156311035156, -202.170501708984], [-137.156311035156, -201.989227294922], [-137.156311035156, 147.648681640625], [133.001586914062, 147.545104980469], [73.0623779296875, 18.2869262695312], [136.16552734375, -84.6792602539062]]];
				r05Path7_object.inTangents = [[[0, 0], [64.78662109375, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 45.2284545898438]], [[0, 0], [64.78662109375, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 45.2284545898438]]];
				r05Path7_object.outTangents = [[[0, -64.7909088134766], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [37.4932403564453, -19.1739501953125], [0, 0]], [[0, -64.7909088134766], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [37.4932556152344, -19.1739501953125], [0, 0]]];
			addShapeKeyframes(r05Path7, r05Path7_keyTimesArray, r05Path7_object);
			var r05Path7_easeInSpeedArray = [0,0];
			var r05Path7_easeInInfluArray = [0.1,100];
			var r05Path7_easeOutSpeedArray = [0,0];
			var r05Path7_easeOutInfluArray = [0.1,0.1];
			var r05Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var r05Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(r05Path7, r05Path7_keyTimesArray, [r05Path7_easeInSpeedArray, r05Path7_easeInInfluArray], [r05Path7_easeOutSpeedArray, r05Path7_easeOutInfluArray], [r05Path7_keyInInterpolationType, r05Path7_keyOutInterpolationType]);

		r05.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		r05.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		r05.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		r05.property("ADBE Transform Group").property("ADBE Position").setValue([400,527,0]);
		r05.selected = false;
	// Apply parents
		r01.setParentWithJump(r05);
		r02.setParentWithJump(r05);
		r03.setParentWithJump(r05);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			r01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			r01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			r02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			r02.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			r03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			r03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			r05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			r05.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			r05.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			r05.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

r_comp.openInViewer();

return {
	compItem : r_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

