// Created using compCode v2.0
// 201801030 from composition "S" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// s();
function utopian_201801030_094309() {

// app.beginUndoGroup("S");

try {

// ANIMATION PRESETS START
	// S -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var s_comp_properties = {"name":"S","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var s_comp = app.project.items.addComp(s_comp_properties.name, s_comp_properties.width, s_comp_properties.height, 1, 30, 24);
		s_comp.time = 0.29166666666667;
		s_comp.bgColor = s_comp_properties.bgColor;
		s_comp.label = s_comp_properties.label;
		s_comp.resolutionFactor = [1, 1];
		s_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = s_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "S", varName "s_comp";
	s_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = s_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([261.804992675781,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([537.697021484375,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = s_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "S 01", varName "s01";
	var s01 = s_comp.layers.addShape();
		s01.name = "S 01";
		s01.startTime = 0.04166666666667;
		s01.inPoint = 0;
		s01.outPoint = 0.625;
		s01.moveToEnd();
		s01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		s01.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		s01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		s01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		s01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var s01Path = s01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var s01Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var s01Path_object = {};
				s01Path_object.closed = true;
				s01Path_object.vertices = [[[91.7890625, 64.5703125], [91.7890625, 128.9296875], [-102, 128.9296875], [-102, 64.5703125]], [[90.89453125, 2.5703125], [89.7890625, 156.9296875], [-103, 156.9296875], [-101.89453125, 2.5703125]], [[90.89453125, 2.5703125], [89.7890625, 156.9296875], [-103, 156.9296875], [-101.89453125, 2.5703125]], [[90.89453125, -7.4296875], [89.7890625, 146.9296875], [-103, 156.9296875], [-101.89453125, 12.5703125]]];
			addShapeKeyframes(s01Path, s01Path_keyTimesArray, s01Path_object);
			var s01Path_easeInSpeedArray = [0,0,0,0];
			var s01Path_easeInInfluArray = [0.1,100,16.666666667,0.1];
			var s01Path_easeOutSpeedArray = [0,0,0,0];
			var s01Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var s01Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var s01Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(s01Path, s01Path_keyTimesArray, [s01Path_easeInSpeedArray, s01Path_easeInInfluArray], [s01Path_easeOutSpeedArray, s01Path_easeOutInfluArray], [s01Path_keyInInterpolationType, s01Path_keyOutInterpolationType]);

		s01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		s01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		s01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		s01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		s01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		s01.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		s01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		s01.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		s01.property("ADBE Transform Group").property("ADBE Position").setValue([0,1,0]);
		s01.selected = false;
	// Add Shape Layer "S 02", varName "s02";
	var s02 = s_comp.layers.addShape();
		s02.name = "S 02";
		s02.startTime = 0.04166666666667;
		s02.inPoint = 0;
		s02.outPoint = 0.625;
		s02.moveToEnd();
		s02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		s02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		s02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		s02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		s02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var s02Path = s02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var s02Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var s02Path_object = {};
				s02Path_object.closed = true;
				s02Path_object.vertices = [[[92.89453125, -125.1796875], [92.578125, -60.8203125], [-101.2109375, -60.8203125], [-100.89453125, -125.1796875]], [[92.89453125, -153.1796875], [91.7890625, 1.1796875], [-102, 1.1796875], [-100.89453125, -153.1796875]], [[92.89453125, -153.1796875], [91.7890625, 1.1796875], [-102, 1.1796875], [-100.89453125, -153.1796875]], [[92.89453125, -153.1796875], [91.7890625, -8.8203125], [-102, 11.1796875], [-100.89453125, -143.1796875]]];
			addShapeKeyframes(s02Path, s02Path_keyTimesArray, s02Path_object);
			var s02Path_easeInSpeedArray = [0,0,0,0];
			var s02Path_easeInInfluArray = [0.1,100,16.666666667,0.1];
			var s02Path_easeOutSpeedArray = [0,0,0,0];
			var s02Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var s02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var s02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(s02Path, s02Path_keyTimesArray, [s02Path_easeInSpeedArray, s02Path_easeInInfluArray], [s02Path_easeOutSpeedArray, s02Path_easeOutInfluArray], [s02Path_keyInInterpolationType, s02Path_keyOutInterpolationType]);

		s02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		s02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		s02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		s02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		s02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		s02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		s02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		s02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		s02.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([6.052734375,-125.1796875,0]);
		s02.property("ADBE Transform Group").property("ADBE Position").setValue([6.052734375,-124.1796875,0]);
		s02.selected = false;
	// Add Shape Layer "S 03", varName "s03";
	var s03 = s_comp.layers.addShape();
		s03.name = "S 03";
		s03.startTime = 0.04166666666667;
		s03.inPoint = 0;
		s03.outPoint = 0.625;
		s03.moveToEnd();
		s03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		s03.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		s03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		s03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		s03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var s03Path = s03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var s03Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var s03Path_object = {};
				s03Path_object.closed = true;
				s03Path_object.vertices = [[[92.89453125, -125.1796875], [91.89453125, 129.1796875], [-102.89453125, 129.1796875], [-101.89453125, -125.1796875]], [[91.89453125, -153.1796875], [90.89453125, 157.1796875], [-102.89453125, 157.1796875], [-101.89453125, -153.1796875]], [[91.89453125, -153.1796875], [90.89453125, 157.1796875], [-102.89453125, 157.1796875], [-101.89453125, -153.1796875]], [[91.89453125, -153.1796875], [90.89453125, 147.1796875], [-102.89453125, 157.1796875], [-101.89453125, -143.1796875]]];
			addShapeKeyframes(s03Path, s03Path_keyTimesArray, s03Path_object);
			var s03Path_easeInSpeedArray = [0,0,0,0];
			var s03Path_easeInInfluArray = [16.666666667,100,16.666666667,0.1];
			var s03Path_easeOutSpeedArray = [0,0,0,0];
			var s03Path_easeOutInfluArray = [16.666666667,0.1,100,16.666666667];
			var s03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var s03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(s03Path, s03Path_keyTimesArray, [s03Path_easeInSpeedArray, s03Path_easeInInfluArray], [s03Path_easeOutSpeedArray, s03Path_easeOutInfluArray], [s03Path_keyInInterpolationType, s03Path_keyOutInterpolationType]);

		s03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		s03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		s03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		s03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		s03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		s03.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		s03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		s03.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		s03.property("ADBE Transform Group").property("ADBE Position").setValue([0,1,0]);
		s03.selected = false;
	// Add Shape Layer "S 04", varName "s04";
	var s04 = s_comp.layers.addShape();
		s04.name = "S 04";
		s04.inPoint = 0.625;
		s04.outPoint = 30;
		s04.moveToEnd();
		s04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		s04.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		s04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		s04.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var s04Path = s04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var s04Path_keyTimesArray = [0.625, 0.91666666666667];
			var s04Path_object = {};
				s04Path_object.closed = true;
				s04Path_object.vertices = [[[-2.8531494140625, 107.79963684082], [-72.0851135253906, 56.580810546875], [23.041748046875, -25.6818542480469], [43.6548614501953, -13.6986389160156], [43.6589965820312, -13.6945037841797], [68.1590576171875, 38.7874298095703]], [[-2.8531494140625, 109.79963684082], [-70.0851135253906, 61.580810546875], [22.041748046875, -27.6818542480469], [42.6548461914062, -15.6986389160156], [42.6589965820312, -15.6945037841797], [68.1590576171875, 38.7874298095703]]];
				s04Path_object.inTangents = [[[39.1578521728516, 0], [9.59982299804688, 28.4471740722656], [0, 0], [-6.1221923828125, -5.12322998046875], [0, 0], [0, -21.0690612792969]], [[39.1578521728516, 0], [9.59982299804688, 28.4471588134766], [0, 0], [-6.12217712402344, -5.12322998046875], [0, 0], [0, -21.0690612792969]]];
				s04Path_object.outTangents = [[[-30.7517852783203, 0], [0, 0], [7.48588562011719, 2.80201721191406], [0, 0], [16.2069702148438, 13.5541687011719], [0, 39.1578521728516]], [[-30.7517852783203, 0], [0, 0], [7.48588562011719, 2.80201721191406], [0, 0], [16.2069702148438, 13.5541687011719], [0, 39.1578521728516]]];
			addShapeKeyframes(s04Path, s04Path_keyTimesArray, s04Path_object);
			var s04Path_easeInSpeedArray = [0,0];
			var s04Path_easeInInfluArray = [0.1,100];
			var s04Path_easeOutSpeedArray = [0,0];
			var s04Path_easeOutInfluArray = [0.1,0.1];
			var s04Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var s04Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(s04Path, s04Path_keyTimesArray, [s04Path_easeInSpeedArray, s04Path_easeInInfluArray], [s04Path_easeOutSpeedArray, s04Path_easeOutInfluArray], [s04Path_keyInInterpolationType, s04Path_keyOutInterpolationType]);

		s04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		s04.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		s04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		s04.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		s04.selected = false;
	// Add Shape Layer "S 05", varName "s05";
	var s05 = s_comp.layers.addShape();
		s05.name = "S 05";
		s05.inPoint = 0.625;
		s05.outPoint = 30;
		s05.moveToEnd();
		s05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		s05.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		s05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		s05.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var s05Path = s05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var s05Path_keyTimesArray = [0.625, 0.91666666666667];
			var s05Path_object = {};
				s05Path_object.closed = true;
				s05Path_object.vertices = [[[-47.9549407958984, -46.6473541259766], [-71.0177459716797, -93.6350555419922], [-2.8531494140625, -161.79963684082], [62.2451934814453, -114.859512329102], [-28.0216064453125, -34.3657073974609], [-28.0226440429688, -34.3657073974609]], [[-47.9549407958984, -44.6473541259766], [-71.0177459716797, -95.6350555419922], [-2.8531494140625, -163.79963684082], [61.2451934814453, -118.859512329102], [-28.0216064453125, -32.3657073974609], [-28.0226440429688, -32.3657073974609]]];
				s05Path_object.inTangents = [[[5.89834594726562, 5.22270202636719], [0, 19.4234924316406], [-37.5868988037109, 0], [-9.61639404296875, -26.5446014404297], [0, 0], [0.00103759765625, 0]], [[5.89834594726562, 5.22270202636719], [0, 19.4234924316406], [-37.5868988037109, 0], [-9.61640930175781, -26.5446014404297], [0, 0], [0.00103759765625, 0]]];
				s05Path_object.outTangents = [[[-14.65673828125, -12.9780120849609], [0, -37.5868988037109], [28.936279296875, 0], [0, 0], [0, 0], [-7.26515197753906, -2.90254211425781]], [[-14.65673828125, -12.9780120849609], [0, -37.5868988037109], [28.936279296875, 0], [0, 0], [0, 0], [-7.26515197753906, -2.90254211425781]]];
			addShapeKeyframes(s05Path, s05Path_keyTimesArray, s05Path_object);
			var s05Path_easeInSpeedArray = [0,0];
			var s05Path_easeInInfluArray = [0.1,100];
			var s05Path_easeOutSpeedArray = [0,0];
			var s05Path_easeOutInfluArray = [0.1,0.1];
			var s05Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var s05Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(s05Path, s05Path_keyTimesArray, [s05Path_easeInSpeedArray, s05Path_easeInInfluArray], [s05Path_easeOutSpeedArray, s05Path_easeOutInfluArray], [s05Path_keyInInterpolationType, s05Path_keyOutInterpolationType]);

		s05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		s05.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		s05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		s05.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		s05.selected = false;
	// Add Shape Layer "S 06", varName "s06";
	var s06 = s_comp.layers.addShape();
		s06.name = "S 06";
		s06.inPoint = 0.625;
		s06.outPoint = 30;
		s06.moveToEnd();
		s06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		s06.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		s06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		s06.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 3";
		var s06Path = s06.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var s06Path_keyTimesArray = [0.625, 0.91666666666667];
			var s06Path_object = {};
				s06Path_object.closed = true;
				s06Path_object.vertices = [[[66.1642608642578, -42.9996795654297], [50.2868194580078, -54.0202026367188], [104.457916259766, -100.569580078125], [102.389556884766, -110.803588867188], [-2.8531494140625, -199], [-109.21809387207, -89.6350250244141], [-74.2809143066406, -20.0468597412109], [-58.0573883056641, -8.23359680175781], [-115.024261474609, 42.0255737304688], [-113.117568969727, 52.131103515625], [-2.8531494140625, 146], [106.359420776367, 36.7874298095703]], [[67.1642608642578, -44.9996795654297], [51.2868194580078, -56.0202026367188], [103.457916259766, -106.569564819336], [101.389556884766, -116.803588867188], [-2.8531494140625, -202], [-109.21809387207, -95.6350555419922], [-73.2809143066406, -16.0468292236328], [-57.057373046875, -4.23356628417969], [-112.024261474609, 49.0255889892578], [-110.117568969727, 59.131103515625], [-2.8531494140625, 148], [106.359420776367, 38.7874298095703]]];
				s06Path_object.inTangents = [[[24.9114685058594, 20.8369140625], [5.60508728027344, 3.19528198242188], [0, 0], [0, 0], [50.4239807128906, 0], [0, -58.6518402099609], [-22.8389739990234, -20.2275848388672], [-5.75117492675781, -3.41342163085938], [0, 0], [0, 0], [-52.4301605224609, 0], [0, 60.2186126708984]], [[24.9114685058594, 20.8369293212891], [5.60508728027344, 3.19528198242188], [0, 0], [0, 0], [50.4239807128906, 0], [0, -58.6518096923828], [-22.8389739990234, -20.2276153564453], [-5.75119018554688, -3.41342163085938], [0, 0], [0, 0], [-52.4301605224609, 0], [0, 60.2186126708984]]];
				s06Path_object.outTangents = [[[-4.94914245605469, -4.13981628417969], [0, 0], [0, 0], [-9.98117065429688, -49.3670043945312], [-58.6518096923828, 0], [0, 30.3496856689453], [5.02789306640625, 4.45175170898438], [0, 0], [0, 0], [9.72418212890625, 51.493408203125], [60.2186126708984, 0], [0, -32.4139556884766]], [[-4.94914245605469, -4.13981628417969], [0, 0], [0, 0], [-9.98117065429688, -49.3670043945312], [-58.6518096923828, 0], [0, 30.3497161865234], [5.02789306640625, 4.45173645019531], [0, 0], [0, 0], [9.72418212890625, 51.493408203125], [60.2186126708984, 0], [0, -32.4139251708984]]];
			addShapeKeyframes(s06Path, s06Path_keyTimesArray, s06Path_object);
			var s06Path_easeInSpeedArray = [0,0];
			var s06Path_easeInInfluArray = [0.1,100];
			var s06Path_easeOutSpeedArray = [0,0];
			var s06Path_easeOutInfluArray = [0.1,0.1];
			var s06Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var s06Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(s06Path, s06Path_keyTimesArray, [s06Path_easeInSpeedArray, s06Path_easeInInfluArray], [s06Path_easeOutSpeedArray, s06Path_easeOutInfluArray], [s06Path_keyInInterpolationType, s06Path_keyOutInterpolationType]);

		s06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		s06.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		s06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		s06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(2.14663314819336);
		s06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Miter Limit").setValue(10);
		s06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		s06.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		s06.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		s06.property("ADBE Transform Group").property("ADBE Position").setValue([400,526.5,0]);
		s06.selected = false;
	// Apply parents
		s01.setParentWithJump(s06);
		s02.setParentWithJump(s06);
		s03.setParentWithJump(s06);
		s04.setParentWithJump(s06);
		s05.setParentWithJump(s06);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			s01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			s01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			s02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			s02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			s03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			s03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			s04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			s05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			s06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			s06.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

s_comp.openInViewer();

return {
	compItem : s_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

