// Created using compCode v2.0
// 201801030 from composition "V" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// v();
function utopian_201801030_094309() {

// app.beginUndoGroup("V");

try {

// ANIMATION PRESETS START
	// V -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercase_folder_properties = {"name":"01 Uppercase","typeName":"Folder","label":9,"comment":""};
	var uppercase_folder = findProjectItem(utopian_folder, false, uppercase_folder_properties);
	if (uppercase_folder === null) {
		uppercase_folder = app.project.items.addFolder(uppercase_folder_properties.name);
		uppercase_folder.label = uppercase_folder_properties.label;
		uppercase_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var v_comp_properties = {"name":"V","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":9,"frameRate":24};
	var v_comp = app.project.items.addComp(v_comp_properties.name, v_comp_properties.width, v_comp_properties.height, 1, 30, 24);
		v_comp.time = 0.83333333333333;
		v_comp.bgColor = v_comp_properties.bgColor;
		v_comp.label = v_comp_properties.label;
		v_comp.resolutionFactor = [1, 1];
		v_comp.parentFolder = uppercase_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = v_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "V", varName "v_comp";
	v_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = v_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([222.960998535156,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([577.039001464844,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = v_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	//Create new Null layer "v01" and replace its source with varName "null10_null";
	var v01 = v_comp.layers.addNull();
	var v01_source = v01.source;
		v01.replaceSource(null10_null, true);
		v01_source.remove();
		v01.name = "V 01";
		v01.enabled = false;
		v01.moveToEnd();
		v01.property("ADBE Transform Group").property("ADBE Position").setValue([400,476,0]);
		v01.property("ADBE Transform Group").property("ADBE Scale").setValue([100,-100,100]);
		v01.selected = false;
	// Add Shape Layer "V 02", varName "v02";
	var v02 = v_comp.layers.addShape();
		v02.name = "V 02";
		v02.enabled = false;
		v02.outPoint = 0.58333333333333;
		v02.moveToEnd();
		v02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		v02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		v02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		v02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		v02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var v02Path = v02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var v02Path_keyTimesArray = [0, 0.375, 0.54166666666667];
			var v02Path_object = {};
				v02Path_object.closed = true;
				v02Path_object.vertices = [[[136, -240.75], [136, 140.75], [-135, 140.75], [-135, -240.75]], [[136, -156.75], [136, 152.75], [-135, 152.75], [-135, -156.75]], [[136, -124.75], [136, 152.75], [-135, 152.75], [-135, -124.75]]];
			addShapeKeyframes(v02Path, v02Path_keyTimesArray, v02Path_object);
			var v02Path_easeInSpeedArray = [0,0,0];
			var v02Path_easeInInfluArray = [16.666666667,100,0.1];
			var v02Path_easeOutSpeedArray = [0,0,0];
			var v02Path_easeOutInfluArray = [16.666666667,100,16.666666667];
			var v02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var v02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(v02Path, v02Path_keyTimesArray, [v02Path_easeInSpeedArray, v02Path_easeInInfluArray], [v02Path_easeOutSpeedArray, v02Path_easeOutInfluArray], [v02Path_keyInInterpolationType, v02Path_keyOutInterpolationType]);

		v02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		v02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		v02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		v02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1,-25.25]);
		v02.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		v02.selected = false;
	// Add Shape Layer "V 03", varName "v03";
	var v03 = v_comp.layers.addShape();
		v03.name = "V 03";
		v03.outPoint = 0.58333333333333;
		v03.moveToEnd();
		v03.trackMatteType = TrackMatteType.ALPHA;
		v03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		v03.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		v03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		v03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		v03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var v03Path = v03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var v03Path_keyTimesArray = [0.375, 0.54166666666667];
			var v03Path_object = {};
				v03Path_object.closed = true;
				v03Path_object.vertices = [[[136, -101.75], [-1.00001525878906, -101.25], [-135, -101.75]], [[136, -101.75], [2.24993896484375, 36], [-135, -101.75]]];
			addShapeKeyframes(v03Path, v03Path_keyTimesArray, v03Path_object);
			var v03Path_easeInSpeedArray = [0,0];
			var v03Path_easeInInfluArray = [100,16.666666667];
			var v03Path_easeOutSpeedArray = [0,0];
			var v03Path_easeOutInfluArray = [100,16.666666667];
			var v03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var v03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(v03Path, v03Path_keyTimesArray, [v03Path_easeInSpeedArray, v03Path_easeInInfluArray], [v03Path_easeOutSpeedArray, v03Path_easeOutInfluArray], [v03Path_keyInInterpolationType, v03Path_keyOutInterpolationType]);

		v03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		v03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		v03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		v03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		v03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		v03.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		v03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		v03.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1,-25.25]);
		v03.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		v03.property("ADBE Transform Group").property("ADBE Rotate Z").setValue(180);
		v03.selected = false;
	// Add Shape Layer "V 04", varName "v04";
	var v04 = v_comp.layers.addShape();
		v04.name = "V 04";
		v04.enabled = false;
		v04.outPoint = 0.58333333333333;
		v04.moveToEnd();
		v04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		v04.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		v04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		v04.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		v04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var v04Path = v04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var v04Path_keyTimesArray = [0, 0.375, 0.54166666666667];
			var v04Path_object = {};
				v04Path_object.closed = true;
				v04Path_object.vertices = [[[136, -240.75], [136, 140.75], [-135, 140.75], [-135, -240.75]], [[136, -156.75], [136, 152.75], [-135, 152.75], [-135, -156.75]], [[136, -124.75], [136, 152.75], [-135, 152.75], [-135, -124.75]]];
			addShapeKeyframes(v04Path, v04Path_keyTimesArray, v04Path_object);
			var v04Path_easeInSpeedArray = [0,0,0];
			var v04Path_easeInInfluArray = [16.666666667,100,0.1];
			var v04Path_easeOutSpeedArray = [0,0,0];
			var v04Path_easeOutInfluArray = [16.666666667,100,16.666666667];
			var v04Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var v04Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(v04Path, v04Path_keyTimesArray, [v04Path_easeInSpeedArray, v04Path_easeInInfluArray], [v04Path_easeOutSpeedArray, v04Path_easeOutInfluArray], [v04Path_keyInInterpolationType, v04Path_keyOutInterpolationType]);

		v04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		v04.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		v04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		v04.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1,-25.25]);
		v04.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		v04.selected = false;
	// Add Shape Layer "V 05", varName "v05";
	var v05 = v_comp.layers.addShape();
		v05.name = "V 05";
		v05.outPoint = 0.58333333333333;
		v05.moveToEnd();
		v05.trackMatteType = TrackMatteType.ALPHA;
		v05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		v05.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		v05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		v05.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		v05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var v05Path = v05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var v05Path_keyTimesArray = [0, 0.375, 0.54166666666667];
			var v05Path_object = {};
				v05Path_object.closed = true;
				v05Path_object.vertices = [[[136, -240.75], [-2.00001525878906, 152.75], [-135, -240.75]], [[136, -156.75], [-2.00001525878906, 152.75], [-135, -156.75]], [[136, -124.75], [-0.50001525878906, 14.75], [-135, -124.75]]];
			addShapeKeyframes(v05Path, v05Path_keyTimesArray, v05Path_object);
			var v05Path_easeInSpeedArray = [0,0,0];
			var v05Path_easeInInfluArray = [16.666666667,100,16.666666667];
			var v05Path_easeOutSpeedArray = [0,0,0];
			var v05Path_easeOutInfluArray = [16.666666667,100,16.666666667];
			var v05Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var v05Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(v05Path, v05Path_keyTimesArray, [v05Path_easeInSpeedArray, v05Path_easeInInfluArray], [v05Path_easeOutSpeedArray, v05Path_easeOutInfluArray], [v05Path_keyInInterpolationType, v05Path_keyOutInterpolationType]);

		v05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		v05.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		v05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		v05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		v05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		v05.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		v05.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		v05.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1,-25.25]);
		v05.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		v05.selected = false;
	// Add Shape Layer "V 06", varName "v06";
	var v06 = v_comp.layers.addShape();
		v06.name = "V 06";
		v06.outPoint = 0.58333333333333;
		v06.moveToEnd();
		v06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		v06.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		v06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		v06.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		v06.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var v06Path = v06.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var v06Path_keyTimesArray = [0, 0.375, 0.54166666666667];
			var v06Path_object = {};
				v06Path_object.closed = true;
				v06Path_object.vertices = [[[136, -240.75], [136, 140.75], [-135, 140.75], [-135, -240.75]], [[136, -156.75], [136, 152.75], [-135, 152.75], [-135, -156.75]], [[136, -124.75], [136, 152.75], [-135, 152.75], [-135, -124.75]]];
			addShapeKeyframes(v06Path, v06Path_keyTimesArray, v06Path_object);
			var v06Path_easeInSpeedArray = [0,0,0];
			var v06Path_easeInInfluArray = [16.666666667,100,0.1];
			var v06Path_easeOutSpeedArray = [0,0,0];
			var v06Path_easeOutInfluArray = [16.666666667,100,16.666666667];
			var v06Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var v06Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(v06Path, v06Path_keyTimesArray, [v06Path_easeInSpeedArray, v06Path_easeInInfluArray], [v06Path_easeOutSpeedArray, v06Path_easeOutInfluArray], [v06Path_keyInInterpolationType, v06Path_keyOutInterpolationType]);

		v06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		v06.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		v06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		v06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		v06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		v06.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		v06.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		v06.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1,-25.25]);
		v06.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		v06.selected = false;
	// Add Shape Layer "V 07", varName "v07";
	var v07 = v_comp.layers.addShape();
		v07.name = "V 07";
		v07.inPoint = 0.58333333333333;
		v07.outPoint = 30;
		v07.moveToEnd();
		v07.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		v07.property("ADBE Root Vectors Group").property(1).name = "Group 2";
		v07.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		v07.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var v07Path = v07.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var v07Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var v07Path_object = {};
				v07Path_object.closed = true;
				v07Path_object.vertices = [[[-40.4332885742188, -11.5308837890625], [39.1344604492188, -11.5308837890625], [-0.6494140625, -92.2222900390625]], [[-45.4332885742188, -4.5308837890625], [44.1344604492188, -4.5308837890625], [-0.6494140625, -108.222290039062]]];
			addShapeKeyframes(v07Path, v07Path_keyTimesArray, v07Path_object);
			var v07Path_easeInSpeedArray = [0,0];
			var v07Path_easeInInfluArray = [0.1,100];
			var v07Path_easeOutSpeedArray = [0,0];
			var v07Path_easeOutInfluArray = [0.1,0.1];
			var v07Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var v07Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(v07Path, v07Path_keyTimesArray, [v07Path_easeInSpeedArray, v07Path_easeInInfluArray], [v07Path_easeOutSpeedArray, v07Path_easeOutInfluArray], [v07Path_keyInInterpolationType, v07Path_keyOutInterpolationType]);

		v07.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		v07.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		v07.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		v07.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		v07.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		v07.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		v07.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var v07Path3 = v07.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var v07Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var v07Path3_object = {};
				v07Path3_object.closed = false;
				v07Path3_object.vertices = [[[56.4091796875, 27.3220825195312], [-57.7122802734375, 27.3220825195312], [-97.2703247070312, 109.015075683594], [95.9671936035156, 109.015075683594], [56.4091186523438, 27.3220825195312]], [[61.4091796875, 34.3220825195312], [-62.7122802734375, 34.3220825195312], [-97.2703247070312, 112.015075683594], [95.9671936035156, 112.015075683594], [61.4091186523438, 34.3220825195312]]];
			addShapeKeyframes(v07Path3, v07Path3_keyTimesArray, v07Path3_object);
			var v07Path3_easeInSpeedArray = [0,0];
			var v07Path3_easeInInfluArray = [0.1,100];
			var v07Path3_easeOutSpeedArray = [0,0];
			var v07Path3_easeOutInfluArray = [0.1,0.1];
			var v07Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var v07Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(v07Path3, v07Path3_keyTimesArray, [v07Path3_easeInSpeedArray, v07Path3_easeInInfluArray], [v07Path3_easeOutSpeedArray, v07Path3_easeOutInfluArray], [v07Path3_keyInInterpolationType, v07Path3_keyOutInterpolationType]);

		v07.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		v07.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		v07.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		v07.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		v07.property("ADBE Root Vectors Group").property(3).name = "Group 1";
		v07.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		v07.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var v07Path5 = v07.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var v07Path5_keyTimesArray = [0.58333333333333, 0.83333333333333, 0.91666666666667];
			var v07Path5_object = {};
				v07Path5_object.closed = true;
				v07Path5_object.vertices = [[[20.1518859863281, -138.99609375], [20.1518859863281, -138.99609375], [-0.6494140625, -185.774200439453], [-156.156265258789, 147.863708496094], [154.853134155273, 147.863708496094]], [[-0.6494140625, -203.411163330078], [-156.156265258789, 150.793029785156], [154.853134155273, 150.793029785156]], [[20.1518859863281, -157.05859375], [20.1518859863281, -157.05859375], [-0.6494140625, -203.836700439453], [-156.156265258789, 150.863708496094], [154.853134155273, 150.863708496094]]];
			addShapeKeyframes(v07Path5, v07Path5_keyTimesArray, v07Path5_object);
			var v07Path5_easeInSpeedArray = [0,1,0];
			var v07Path5_easeInInfluArray = [0.1,16.666666667,100];
			var v07Path5_easeOutSpeedArray = [0,1,0];
			var v07Path5_easeOutInfluArray = [0.1,16.666666667,0.1];
			var v07Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var v07Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(v07Path5, v07Path5_keyTimesArray, [v07Path5_easeInSpeedArray, v07Path5_easeInInfluArray], [v07Path5_easeOutSpeedArray, v07Path5_easeOutInfluArray], [v07Path5_keyInInterpolationType, v07Path5_keyOutInterpolationType]);

		v07.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		v07.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		v07.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		v07.property("ADBE Transform Group").property("ADBE Position").setValue([0,0,0]);
		v07.selected = false;
	// Apply parents
		v02.setParentWithJump(v01);
		v03.setParentWithJump(v06);
		v04.setParentWithJump(v01);
		v05.setParentWithJump(v06);
		v06.setParentWithJump(v01);
		v07.setParentWithJump(v01);

// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			v03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			v03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			v05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			v05.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			v06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			v06.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			v07.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			v07.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			v07.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

v_comp.openInViewer();

return {
	compItem : v_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

