// Created using compCode v2.0
// 201801030 from composition "Ì" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode();
function utopian_201801030_094309() {

// app.beginUndoGroup(File.decode("%C3%8C"));

try {

// ANIMATION PRESETS START
	// Ì -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercaseAccents_folder_properties = {"name":"02 Uppercase Accents","typeName":"Folder","label":9,"comment":""};
	var uppercaseAccents_folder = findProjectItem(utopian_folder, false, uppercaseAccents_folder_properties);
	if (uppercaseAccents_folder === null) {
		uppercaseAccents_folder = app.project.items.addFolder(uppercaseAccents_folder_properties.name);
		uppercaseAccents_folder.label = uppercaseAccents_folder_properties.label;
		uppercaseAccents_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode_comp_properties = {"name":"Ì","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":5,"frameRate":24};
	var compcode_comp = app.project.items.addComp(compcode_comp_properties.name, compcode_comp_properties.width, compcode_comp_properties.height, 1, 30, 24);
		compcode_comp.time = 1.375;
		compcode_comp.bgColor = compcode_comp_properties.bgColor;
		compcode_comp.label = compcode_comp_properties.label;
		compcode_comp.resolutionFactor = [1, 1];
		compcode_comp.parentFolder = uppercaseAccents_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "Ì", varName "compcode_comp";
	compcode_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([319.821990966797,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([480.178009033203,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "Ì 01", varName "compcode01";
	var compcode01 = compcode_comp.layers.addShape();
		compcode01.name = File.decode("%C3%8C%2001");
		compcode01.outPoint = 0.58333333333333;
		compcode01.moveToEnd();
		compcode01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode01.property("ADBE Root Vectors Group").property(1).name = "Group 4";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode01Path = compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode01Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode01Path_object = {};
				compcode01Path_object.closed = false;
				compcode01Path_object.vertices = [[[19.70751953125, -138.195526123047], [-19.8359375, -138.195526123047], [-19.90380859375, 38.3504638671875], [19.6396484375, 38.3504638671875], [19.70751953125, -138.195556640625]], [[20.48583984375, -163.195526123047], [-19.3076171875, -163.195526123047], [-20.07177734375, -91.6495361328125], [19.7216796875, -91.6495361328125], [20.48583984375, -163.195556640625]], [[20.48583984375, -163.195526123047], [-19.3076171875, -163.195526123047], [-20.07177734375, -91.6495361328125], [19.7216796875, -91.6495361328125], [20.48583984375, -163.195556640625]], [[19.23583984375, -163.195526123047], [-20.3076171875, -163.195526123047], [-20.60009765625, -62.6495361328125], [18.943359375, -62.6495361328125], [19.23583984375, -163.195556640625]]];
			addShapeKeyframes(compcode01Path, compcode01Path_keyTimesArray, compcode01Path_object);
			var compcode01Path_easeInSpeedArray = [0,0,0,0];
			var compcode01Path_easeInInfluArray = [0.1,100,100,0.1];
			var compcode01Path_easeOutSpeedArray = [0,0,0,0];
			var compcode01Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode01Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode01Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode01Path, compcode01Path_keyTimesArray, [compcode01Path_easeInSpeedArray, compcode01Path_easeInInfluArray], [compcode01Path_easeOutSpeedArray, compcode01Path_easeOutInfluArray], [compcode01Path_keyInInterpolationType, compcode01Path_keyOutInterpolationType]);

		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode01.property("ADBE Root Vectors Group").property(2).name = "Group 1";
		compcode01.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode01.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode01Path3 = compcode01.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode01Path3_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode01Path3_object = {};
				compcode01Path3_object.closed = true;
				compcode01Path3_object.vertices = [[[58.55615234375, -177.044189453125], [-58.6846008300781, -177.044189453125], [-59.6679992675781, 77.1875], [57.57275390625, 77.1875], [58.55615234375, -177.044311523438]], [[59.33447265625, -202.044189453125], [-58.1562805175781, -202.044189453125], [-58.8359680175781, -52.8125], [57.65478515625, -52.8125], [59.33447265625, -202.044311523438]], [[59.33447265625, -202.044189453125], [-58.1562805175781, -202.044189453125], [-58.8359680175781, -52.8125], [57.65478515625, -52.8125], [59.33447265625, -202.044311523438]], [[58.08447265625, -202.044189453125], [-58.1562805175781, -202.044189453125], [-58.3642883300781, -23.8125], [56.87646484375, -23.8125], [58.08447265625, -202.044311523438]]];
			addShapeKeyframes(compcode01Path3, compcode01Path3_keyTimesArray, compcode01Path3_object);
			var compcode01Path3_easeInSpeedArray = [0,0,0,0];
			var compcode01Path3_easeInInfluArray = [0.1,100,100,0.1];
			var compcode01Path3_easeOutSpeedArray = [0,0,0,0];
			var compcode01Path3_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode01Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode01Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode01Path3, compcode01Path3_keyTimesArray, [compcode01Path3_easeInSpeedArray, compcode01Path3_easeInInfluArray], [compcode01Path3_easeOutSpeedArray, compcode01Path3_easeOutInfluArray], [compcode01Path3_keyInInterpolationType, compcode01Path3_keyOutInterpolationType]);

		compcode01.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode01.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode01.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode01.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode01.selected = false;
	// Add Shape Layer "Ì 02", varName "compcode02";
	var compcode02 = compcode_comp.layers.addShape();
		compcode02.name = File.decode("%C3%8C%2002");
		compcode02.inPoint = 0.58333333333333;
		compcode02.outPoint = 30;
		compcode02.moveToEnd();
		compcode02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode02.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode02Path = compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode02Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode02Path_object = {};
				compcode02Path_object.closed = true;
				compcode02Path_object.vertices = [[[21.6372680664062, -220.025939941406], [-17.2113952636719, -271.300354003906], [-56.06005859375, -271.300354003906], [-17.21142578125, -220.025970458984]], [[21.6372680664062, -220.025939941406], [-17.2113952636719, -279.300354003906], [-56.06005859375, -279.300354003906], [-17.21142578125, -220.025970458984]]];
			addShapeKeyframes(compcode02Path, compcode02Path_keyTimesArray, compcode02Path_object);
			var compcode02Path_easeInSpeedArray = [0,0];
			var compcode02Path_easeInInfluArray = [0.1,100];
			var compcode02Path_easeOutSpeedArray = [0,0];
			var compcode02Path_easeOutInfluArray = [0.1,0.1];
			var compcode02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode02Path, compcode02Path_keyTimesArray, [compcode02Path_easeInSpeedArray, compcode02Path_easeInInfluArray], [compcode02Path_easeOutSpeedArray, compcode02Path_easeOutInfluArray], [compcode02Path_keyInInterpolationType, compcode02Path_keyOutInterpolationType]);

		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode02.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode02.selected = false;
	// Add Shape Layer "Ì 03", varName "compcode03";
	var compcode03 = compcode_comp.layers.addShape();
		compcode03.name = File.decode("%C3%8C%2003");
		compcode03.inPoint = 0.58333333333333;
		compcode03.outPoint = 30;
		compcode03.moveToEnd();
		compcode03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode03.property("ADBE Root Vectors Group").property(1).name = "Group 3";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode03Path = compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode03Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode03Path_object = {};
				compcode03Path_object.closed = false;
				compcode03Path_object.vertices = [[[19.23583984375, -27.8009033203125], [-19.3076171875, -27.8009033203125], [-19.3076171875, 96.7451171875], [19.23583984375, 96.7451171875], [19.23583984375, -27.8009033203125]], [[19.73583984375, -7.8009033203125], [-19.3076171875, -7.8009033203125], [-19.3076171875, 108.7451171875], [19.73583984375, 108.7451171875], [19.73583984375, -7.8009033203125]]];
			addShapeKeyframes(compcode03Path, compcode03Path_keyTimesArray, compcode03Path_object);
			var compcode03Path_easeInSpeedArray = [0,0];
			var compcode03Path_easeInInfluArray = [0.1,100];
			var compcode03Path_easeOutSpeedArray = [0,0];
			var compcode03Path_easeOutInfluArray = [0.1,0.1];
			var compcode03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode03Path, compcode03Path_keyTimesArray, [compcode03Path_easeInSpeedArray, compcode03Path_easeInInfluArray], [compcode03Path_easeOutSpeedArray, compcode03Path_easeOutInfluArray], [compcode03Path_keyInInterpolationType, compcode03Path_keyOutInterpolationType]);

		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode03.property("ADBE Root Vectors Group").property(2).name = "Group 4";
		compcode03.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode03Path3 = compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode03Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode03Path3_object = {};
				compcode03Path3_object.closed = false;
				compcode03Path3_object.vertices = [[[19.23583984375, -163.195526123047], [-19.3076171875, -163.195526123047], [-19.3076171875, -66.6495361328125], [19.23583984375, -66.6495361328125], [19.23583984375, -163.195556640625]], [[19.73583984375, -163.195526123047], [-19.3076171875, -163.195526123047], [-19.3076171875, -46.6495361328125], [19.73583984375, -46.6495361328125], [19.73583984375, -163.195556640625]]];
			addShapeKeyframes(compcode03Path3, compcode03Path3_keyTimesArray, compcode03Path3_object);
			var compcode03Path3_easeInSpeedArray = [0,0];
			var compcode03Path3_easeInInfluArray = [0.1,100];
			var compcode03Path3_easeOutSpeedArray = [0,0];
			var compcode03Path3_easeOutInfluArray = [0.1,0.1];
			var compcode03Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode03Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode03Path3, compcode03Path3_keyTimesArray, [compcode03Path3_easeInSpeedArray, compcode03Path3_easeInInfluArray], [compcode03Path3_easeOutSpeedArray, compcode03Path3_easeOutInfluArray], [compcode03Path3_keyInInterpolationType, compcode03Path3_keyOutInterpolationType]);

		compcode03.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode03.property("ADBE Root Vectors Group").property(3).name = "Group 1";
		compcode03.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		compcode03.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var compcode03Path5 = compcode03.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var compcode03Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode03Path5_object = {};
				compcode03Path5_object.closed = true;
				compcode03Path5_object.vertices = [[[58.08447265625, -202.044189453125], [19.2358093261719, -202.044189453125], [-19.3076171875, -202.044189453125], [-58.1562805175781, -202.044189453125], [-58.1562805175781, -66.6495361328125], [-58.1562805175781, -27.8008575439453], [-58.1562805175781, 135.59375], [-19.3076171875, 135.59375], [19.2358093261719, 135.59375], [58.08447265625, 135.59375], [58.08447265625, 96.7450561523438], [58.08447265625, -27.8009490966797], [58.08447265625, -66.6495971679688], [58.08447265625, -163.195617675781], [58.08447265625, -202.044311523438]], [[58.58447265625, -202.044189453125], [19.7358093261719, -202.044189453125], [-19.3076171875, -202.044189453125], [-58.1562805175781, -202.044189453125], [-58.1562805175781, -46.6495361328125], [-58.1562805175781, -7.80088806152344], [-58.1562805175781, 147.59375], [-19.3076171875, 147.59375], [19.7358093261719, 147.59375], [58.58447265625, 147.59375], [58.58447265625, 108.745056152344], [58.58447265625, -7.80093383789062], [58.58447265625, -46.6495971679688], [58.58447265625, -163.195617675781], [58.58447265625, -202.044311523438]]];
			addShapeKeyframes(compcode03Path5, compcode03Path5_keyTimesArray, compcode03Path5_object);
			var compcode03Path5_easeInSpeedArray = [0,0];
			var compcode03Path5_easeInInfluArray = [0.1,100];
			var compcode03Path5_easeOutSpeedArray = [0,0];
			var compcode03Path5_easeOutInfluArray = [0.1,0.1];
			var compcode03Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode03Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode03Path5, compcode03Path5_keyTimesArray, [compcode03Path5_easeInSpeedArray, compcode03Path5_easeInInfluArray], [compcode03Path5_easeOutSpeedArray, compcode03Path5_easeOutInfluArray], [compcode03Path5_keyInInterpolationType, compcode03Path5_keyOutInterpolationType]);

		compcode03.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode03.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		compcode03.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode03.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode03.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode01.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode_comp.openInViewer();

return {
	compItem : compcode_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

