// Created using compCode v2.0
// 201801030 from composition "Ù" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode();
function utopian_201801030_094309() {

// app.beginUndoGroup(File.decode("%C3%99"));

try {

// ANIMATION PRESETS START
	// Ù -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var uppercaseAccents_folder_properties = {"name":"02 Uppercase Accents","typeName":"Folder","label":9,"comment":""};
	var uppercaseAccents_folder = findProjectItem(utopian_folder, false, uppercaseAccents_folder_properties);
	if (uppercaseAccents_folder === null) {
		uppercaseAccents_folder = app.project.items.addFolder(uppercaseAccents_folder_properties.name);
		uppercaseAccents_folder.label = uppercaseAccents_folder_properties.label;
		uppercaseAccents_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode_comp_properties = {"name":"Ù","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":9,"frameRate":24};
	var compcode_comp = app.project.items.addComp(compcode_comp_properties.name, compcode_comp_properties.width, compcode_comp_properties.height, 1, 30, 24);
		compcode_comp.time = 1.375;
		compcode_comp.bgColor = compcode_comp_properties.bgColor;
		compcode_comp.label = compcode_comp_properties.label;
		compcode_comp.resolutionFactor = [1, 1];
		compcode_comp.parentFolder = uppercaseAccents_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "Ù", varName "compcode_comp";
	compcode_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([261.804992675781,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([538.195007324219,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "Ù 01", varName "compcode01";
	var compcode01 = compcode_comp.layers.addShape();
		compcode01.name = File.decode("%C3%99%2001");
		compcode01.outPoint = 0.58333333333333;
		compcode01.moveToEnd();
		compcode01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode01.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode01Path = compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode01Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode01Path_object = {};
				compcode01Path_object.closed = true;
				compcode01Path_object.vertices = [[[99.298828125, -143.162109375], [99.298828125, 239.162109375], [-95.298828125, 239.162109375], [-95.298828125, -143.162109375]], [[101.298828125, -155.162109375], [101.298828125, 155.162109375], [-95.298828125, 155.162109375], [-95.298828125, -155.162109375]], [[101.298828125, -155.162109375], [101.298828125, 155.162109375], [-95.298828125, 155.162109375], [-95.298828125, -155.162109375]], [[100.298828125, -143.162109375], [100.298828125, 119.162109375], [-95.298828125, 119.162109375], [-95.298828125, -143.162109375]]];
			addShapeKeyframes(compcode01Path, compcode01Path_keyTimesArray, compcode01Path_object);
			var compcode01Path_easeInSpeedArray = [0,0,0,0];
			var compcode01Path_easeInInfluArray = [0.1,100,100,0.1];
			var compcode01Path_easeOutSpeedArray = [0,0,0,0];
			var compcode01Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode01Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode01Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode01Path, compcode01Path_keyTimesArray, [compcode01Path_easeInSpeedArray, compcode01Path_easeInInfluArray], [compcode01Path_easeOutSpeedArray, compcode01Path_easeOutInfluArray], [compcode01Path_keyInInterpolationType, compcode01Path_keyOutInterpolationType]);

		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode01.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-2.701171875,-26.837890625]);
		compcode01.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode01.selected = false;
	// Add Shape Layer "Ù 02", varName "compcode02";
	var compcode02 = compcode_comp.layers.addShape();
		compcode02.name = File.decode("%C3%99%2002");
		compcode02.enabled = false;
		compcode02.outPoint = 0.58333333333333;
		compcode02.moveToEnd();
		compcode02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode02Path = compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode02Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode02Path_object = {};
				compcode02Path_object.closed = true;
				compcode02Path_object.vertices = [[[99.298828125, -143.162109375], [99.298828125, 239.162109375], [-95.298828125, 239.162109375], [-95.298828125, -143.162109375]], [[101.298828125, -155.162109375], [101.298828125, 155.162109375], [-95.298828125, 155.162109375], [-95.298828125, -155.162109375]], [[101.298828125, -155.162109375], [101.298828125, 155.162109375], [-95.298828125, 155.162109375], [-95.298828125, -155.162109375]], [[100.298828125, -143.162109375], [100.298828125, 119.162109375], [-95.298828125, 119.162109375], [-95.298828125, -143.162109375]]];
			addShapeKeyframes(compcode02Path, compcode02Path_keyTimesArray, compcode02Path_object);
			var compcode02Path_easeInSpeedArray = [0,0,0,0];
			var compcode02Path_easeInInfluArray = [0.1,100,100,0.1];
			var compcode02Path_easeOutSpeedArray = [0,0,0,0];
			var compcode02Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode02Path, compcode02Path_keyTimesArray, [compcode02Path_easeInSpeedArray, compcode02Path_easeInInfluArray], [compcode02Path_easeOutSpeedArray, compcode02Path_easeOutInfluArray], [compcode02Path_keyInInterpolationType, compcode02Path_keyOutInterpolationType]);

		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-2.701171875,-26.837890625]);
		compcode02.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode02.selected = false;
	// Add Shape Layer "Ù 03", varName "compcode03";
	var compcode03 = compcode_comp.layers.addShape();
		compcode03.name = File.decode("%C3%99%2003");
		compcode03.outPoint = 0.58333333333333;
		compcode03.moveToEnd();
		compcode03.trackMatteType = TrackMatteType.ALPHA;
		compcode03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode03.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode03Path = compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode03Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode03Path_object = {};
				compcode03Path_object.closed = true;
				compcode03Path_object.vertices = [[[-137.15625, -258.728332519531], [-137.15625, -41.9226531982422], [-0.54278564453125, 94.6908264160156], [-0.54278564453125, 94.6908264160156], [136.074951171875, -41.9226531982422], [136.074951171875, -258.728363037109]], [[-137.15625, -201.585479736328], [-137.15625, 15.2201995849609], [-0.54278564453125, 151.833679199219], [-0.54278564453125, 151.833679199219], [136.074951171875, 15.2201995849609], [136.074951171875, -201.585510253906]], [[-137.15625, -201.585479736328], [-137.15625, 15.2201995849609], [-0.54278564453125, 151.833679199219], [-0.54278564453125, 151.833679199219], [136.074951171875, 15.2201995849609], [136.074951171875, -201.585510253906]], [[-137.15625, -201.585479736328], [-137.15625, -32.3988647460938], [-0.54278564453125, 94.6907958984375], [-0.54278564453125, 94.6907958984375], [136.074951171875, -32.3988647460938], [136.074951171875, -201.585510253906]]];
				compcode03Path_object.inTangents = [[[0, 0], [0, 0], [-75.4484252929688, 0], [0, 0], [0, 75.4484405517578], [0, 0]], [[0, 0], [0, 0], [-75.4484252929688, 0], [0, 0], [0, 75.4484405517578], [0, 0]], [[0, 0], [0, 0], [-75.4484252929688, 0], [0, 0], [0, 75.4484405517578], [0, 0]], [[0, 0], [0, 0], [-75.4484252929688, 0], [0, 0], [0, 75.4484558105469], [0, 0]]];
				compcode03Path_object.outTangents = [[[0, 0], [0, 75.4484405517578], [0, 0], [75.4526977539062, 0], [0, 0], [0, 0]], [[0, 0], [0, 75.4484405517578], [0, 0], [75.4526977539062, 0], [0, 0], [0, 0]], [[0, 0], [0, 75.4484405517578], [0, 0], [75.4526977539062, 0], [0, 0], [0, 0]], [[0, 0], [0, 75.4484558105469], [0, 0], [75.4526977539062, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode03Path, compcode03Path_keyTimesArray, compcode03Path_object);
			var compcode03Path_easeInSpeedArray = [0,0,0,0];
			var compcode03Path_easeInInfluArray = [0.1,100,16.666666667,0.1];
			var compcode03Path_easeOutSpeedArray = [0,0,0,0];
			var compcode03Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode03Path, compcode03Path_keyTimesArray, [compcode03Path_easeInSpeedArray, compcode03Path_easeInInfluArray], [compcode03Path_easeOutSpeedArray, compcode03Path_easeOutInfluArray], [compcode03Path_keyInInterpolationType, compcode03Path_keyOutInterpolationType]);

		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode03.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-0.5406494140625,-24.8759155273438,0]);
		compcode03.property("ADBE Transform Group").property("ADBE Position").setValue([399.459350585938,577.124084472656,0]);
		compcode03.property("ADBE Transform Group").property("ADBE Scale").setValue([84,84,100]);
		compcode03.property("ADBE Transform Group").property("ADBE Rotate Z").setValue(180);
		compcode03.selected = false;
	// Add Shape Layer "Ù 04", varName "compcode04";
	var compcode04 = compcode_comp.layers.addShape();
		compcode04.name = File.decode("%C3%99%2004");
		compcode04.outPoint = 0.58333333333333;
		compcode04.moveToEnd();
		compcode04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode04.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode04Path = compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode04Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode04Path_object = {};
				compcode04Path_object.closed = true;
				compcode04Path_object.vertices = [[[99.298828125, -143.162109375], [99.298828125, 239.162109375], [1.701171875, 239.162109375], [1.701171875, -143.162109375]], [[101.298828125, -155.162109375], [101.298828125, 155.162109375], [1.701171875, 155.162109375], [1.701171875, -155.162109375]], [[101.298828125, -155.162109375], [101.298828125, 155.162109375], [1.701171875, 155.162109375], [1.701171875, -155.162109375]], [[100.298828125, -143.162109375], [100.298828125, 119.162109375], [1.701171875, 119.162109375], [1.701171875, -143.162109375]]];
			addShapeKeyframes(compcode04Path, compcode04Path_keyTimesArray, compcode04Path_object);
			var compcode04Path_easeInSpeedArray = [0,0,0,0];
			var compcode04Path_easeInInfluArray = [0.1,100,0.1,0.1];
			var compcode04Path_easeOutSpeedArray = [0,0,0,0];
			var compcode04Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode04Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode04Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode04Path, compcode04Path_keyTimesArray, [compcode04Path_easeInSpeedArray, compcode04Path_easeInInfluArray], [compcode04Path_easeOutSpeedArray, compcode04Path_easeOutInfluArray], [compcode04Path_keyInInterpolationType, compcode04Path_keyOutInterpolationType]);

		compcode04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode04.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-2.701171875,-26.837890625]);
		compcode04.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode04.selected = false;
	// Add Shape Layer "Ù 05", varName "compcode05";
	var compcode05 = compcode_comp.layers.addShape();
		compcode05.name = File.decode("%C3%99%2005");
		compcode05.outPoint = 0.58333333333333;
		compcode05.moveToEnd();
		compcode05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode05.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode05Path = compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode05Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode05Path_object = {};
				compcode05Path_object.closed = true;
				compcode05Path_object.vertices = [[[99.298828125, -143.162109375], [99.298828125, 239.162109375], [-95.298828125, 239.162109375], [-95.298828125, -143.162109375]], [[101.298828125, -155.162109375], [101.298828125, 155.162109375], [-95.298828125, 155.162109375], [-95.298828125, -155.162109375]], [[101.298828125, -155.162109375], [101.298828125, 155.162109375], [-95.298828125, 155.162109375], [-95.298828125, -155.162109375]], [[100.298828125, -143.162109375], [100.298828125, 119.162109375], [-95.298828125, 119.162109375], [-95.298828125, -143.162109375]]];
			addShapeKeyframes(compcode05Path, compcode05Path_keyTimesArray, compcode05Path_object);
			var compcode05Path_easeInSpeedArray = [0,0,0,0];
			var compcode05Path_easeInInfluArray = [0.1,100,100,0.1];
			var compcode05Path_easeOutSpeedArray = [0,0,0,0];
			var compcode05Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode05Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode05Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode05Path, compcode05Path_keyTimesArray, [compcode05Path_easeInSpeedArray, compcode05Path_easeInInfluArray], [compcode05Path_easeOutSpeedArray, compcode05Path_easeOutInfluArray], [compcode05Path_keyInInterpolationType, compcode05Path_keyOutInterpolationType]);

		compcode05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode05.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-2.701171875,-26.837890625]);
		compcode05.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode05.selected = false;
	// Add Shape Layer "Ù 06", varName "compcode06";
	var compcode06 = compcode_comp.layers.addShape();
		compcode06.name = File.decode("%C3%99%2006");
		compcode06.inPoint = 0.58333333333333;
		compcode06.outPoint = 30;
		compcode06.moveToEnd();
		compcode06.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode06.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode06.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode06Path = compcode06.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode06Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode06Path_object = {};
				compcode06Path_object.closed = true;
				compcode06Path_object.vertices = [[[21.6372680664062, -220.025939941406], [-17.2113952636719, -271.300354003906], [-56.06005859375, -271.300354003906], [-17.21142578125, -220.025970458984]], [[21.6372680664062, -220.025939941406], [-17.2113952636719, -279.300354003906], [-56.06005859375, -279.300354003906], [-17.21142578125, -220.025970458984]]];
			addShapeKeyframes(compcode06Path, compcode06Path_keyTimesArray, compcode06Path_object);
			var compcode06Path_easeInSpeedArray = [0,0];
			var compcode06Path_easeInInfluArray = [0.1,100];
			var compcode06Path_easeOutSpeedArray = [0,0];
			var compcode06Path_easeOutInfluArray = [0.1,0.1];
			var compcode06Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode06Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode06Path, compcode06Path_keyTimesArray, [compcode06Path_easeInSpeedArray, compcode06Path_easeInInfluArray], [compcode06Path_easeOutSpeedArray, compcode06Path_easeOutInfluArray], [compcode06Path_keyInInterpolationType, compcode06Path_keyOutInterpolationType]);

		compcode06.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode06.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode06.property("ADBE Transform Group").property("ADBE Position").setValue([400,531.5,0]);
		compcode06.selected = false;
	// Add Shape Layer "Ù 07", varName "compcode07";
	var compcode07 = compcode_comp.layers.addShape();
		compcode07.name = File.decode("%C3%99%2007");
		compcode07.inPoint = 0.58333333333333;
		compcode07.outPoint = 30;
		compcode07.moveToEnd();
		compcode07.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode07.property("ADBE Root Vectors Group").property(1).name = "Group 3";
		compcode07.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode07.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode07Path = compcode07.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode07Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode07Path_object = {};
				compcode07Path_object.closed = true;
				compcode07Path_object.vertices = [[[-19.6273803710938, 93.6295776367188], [-19.6273803710938, -155.764282226562], [-77.900390625, -155.764282226562], [-77.900390625, 18.47900390625]], [[-19.6273803710938, 110.629577636719], [-19.6273803710938, -158.764282226562], [-77.900390625, -158.764282226562], [-77.900390625, 35.47900390625]]];
				compcode07Path_object.inTangents = [[[-33.4918823242188, -8.63739013671875], [0, 0], [0, 0], [0, 0]], [[-33.4918823242188, -8.63739013671875], [0, 0], [0, 0], [0, 0]]];
				compcode07Path_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 36.1939697265625]], [[0, 0], [0, 0], [0, 0], [0, 36.1939697265625]]];
			addShapeKeyframes(compcode07Path, compcode07Path_keyTimesArray, compcode07Path_object);
			var compcode07Path_easeInSpeedArray = [0,0];
			var compcode07Path_easeInInfluArray = [0.1,100];
			var compcode07Path_easeOutSpeedArray = [0,0];
			var compcode07Path_easeOutInfluArray = [0.1,0.1];
			var compcode07Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode07Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode07Path, compcode07Path_keyTimesArray, [compcode07Path_easeInSpeedArray, compcode07Path_easeInInfluArray], [compcode07Path_easeOutSpeedArray, compcode07Path_easeOutInfluArray], [compcode07Path_keyInInterpolationType, compcode07Path_keyOutInterpolationType]);

		compcode07.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode07.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode07.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode07.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode07.property("ADBE Root Vectors Group").property(2).name = "Group 4";
		compcode07.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode07.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode07Path3 = compcode07.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode07Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode07Path3_object = {};
				compcode07Path3_object.closed = true;
				compcode07Path3_object.vertices = [[[77.4985656738281, 18.47900390625], [77.4985656738281, -155.764282226562], [19.2255859375, -155.764282226562], [19.2255859375, 93.6295776367188], [77.49853515625, 18.47900390625]], [[77.4985656738281, 35.47900390625], [77.4985656738281, -158.764282226562], [19.2255859375, -158.764282226562], [19.2255859375, 110.629577636719], [77.49853515625, 35.47900390625]]];
				compcode07Path3_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 36.1939697265625]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 36.1939697265625]]];
				compcode07Path3_object.outTangents = [[[0, 0], [0, 0], [0, 0], [33.4875183105469, -8.63739013671875], [0, 0]], [[0, 0], [0, 0], [0, 0], [33.4875183105469, -8.63739013671875], [0, 0]]];
			addShapeKeyframes(compcode07Path3, compcode07Path3_keyTimesArray, compcode07Path3_object);
			var compcode07Path3_easeInSpeedArray = [0,0];
			var compcode07Path3_easeInInfluArray = [0.1,100];
			var compcode07Path3_easeOutSpeedArray = [0,0];
			var compcode07Path3_easeOutInfluArray = [0.1,0.1];
			var compcode07Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode07Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode07Path3, compcode07Path3_keyTimesArray, [compcode07Path3_easeInSpeedArray, compcode07Path3_easeInInfluArray], [compcode07Path3_easeOutSpeedArray, compcode07Path3_easeOutInfluArray], [compcode07Path3_keyInInterpolationType, compcode07Path3_keyOutInterpolationType]);

		compcode07.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode07.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode07.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode07.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode07.property("ADBE Root Vectors Group").property(3).name = "Group 2";
		compcode07.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		compcode07.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var compcode07Path5 = compcode07.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var compcode07Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode07Path5_object = {};
				compcode07Path5_object.closed = true;
				compcode07Path5_object.vertices = [[[-116.7490234375, 18.47900390625], [-0.20306396484375, 135.024963378906], [116.342895507812, 18.47900390625], [116.342895507812, -194.612976074219], [-116.7490234375, -194.612976074219]], [[-116.7490234375, 35.47900390625], [-0.20306396484375, 152.024963378906], [116.342895507812, 35.47900390625], [116.342895507812, -197.612976074219], [-116.7490234375, -197.612976074219]]];
				compcode07Path5_object.inTangents = [[[0, 0], [-64.3635864257812, 0], [0, 64.3635864257812], [0, 0], [0, 0]], [[0, 0], [-64.3635864257812, 0], [0, 64.3635864257812], [0, 0], [0, 0]]];
				compcode07Path5_object.outTangents = [[[0, 64.367919921875], [64.3635864257812, 0], [0, 0], [0, 0], [0, 0]], [[0, 64.367919921875], [64.3635864257812, 0], [0, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode07Path5, compcode07Path5_keyTimesArray, compcode07Path5_object);
			var compcode07Path5_easeInSpeedArray = [0,0];
			var compcode07Path5_easeInInfluArray = [0.1,100];
			var compcode07Path5_easeOutSpeedArray = [0,0];
			var compcode07Path5_easeOutInfluArray = [0.1,0.1];
			var compcode07Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode07Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode07Path5, compcode07Path5_keyTimesArray, [compcode07Path5_easeInSpeedArray, compcode07Path5_easeInInfluArray], [compcode07Path5_easeOutSpeedArray, compcode07Path5_easeOutInfluArray], [compcode07Path5_keyInInterpolationType, compcode07Path5_keyOutInterpolationType]);

		compcode07.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode07.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		compcode07.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode07.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode07.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").expression = "try{" + "\n" + 
				"s = scale [0]/100;" + "\n" + 
				"L = thisLayer;" + "\n" + 
				"while (L.hasParent){" + "\n" + 
				"s *= L.parent.scale[0]/100" + "\n" + 
				"}" + "\n" + 
				"w = value;" + "\n" + 
				"w/s" + "\n" + 
				"}catch(e){" + "\n" + 
				"value;" + "\n" + 
				"};";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode06.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode07.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode07.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode07.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode_comp.openInViewer();

return {
	compItem : compcode_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

