// Created using compCode v2.0
// 201801030 from composition "2" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode2();
function utopian_201801030_094309() {

// app.beginUndoGroup("2");

try {

// ANIMATION PRESETS START
	// 2 -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var numbers_folder_properties = {"name":"03 Numbers","typeName":"Folder","label":9,"comment":""};
	var numbers_folder = findProjectItem(utopian_folder, false, numbers_folder_properties);
	if (numbers_folder === null) {
		numbers_folder = app.project.items.addFolder(numbers_folder_properties.name);
		numbers_folder.label = numbers_folder_properties.label;
		numbers_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode2_comp_properties = {"name":"2","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var compcode2_comp = app.project.items.addComp(compcode2_comp_properties.name, compcode2_comp_properties.width, compcode2_comp_properties.height, 1, 30, 24);
		compcode2_comp.time = 0.91666666666667;
		compcode2_comp.bgColor = compcode2_comp_properties.bgColor;
		compcode2_comp.label = compcode2_comp_properties.label;
		compcode2_comp.resolutionFactor = [1, 1];
		compcode2_comp.parentFolder = numbers_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode2_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "2", varName "compcode2_comp";
	compcode2_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode2_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([233.169998168945,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([566.830017089844,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode2_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "2 01", varName "compcode201";
	var compcode201 = compcode2_comp.layers.addShape();
		compcode201.name = "2 01";
		compcode201.outPoint = 0.625;
		compcode201.moveToEnd();
		compcode201.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode201.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode201.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode201.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode201.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode201Path = compcode201.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode201Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode201Path_object = {};
				compcode201Path_object.closed = true;
				compcode201Path_object.vertices = [[[127.757843017578, -153], [127.757827758789, 0.00003051757812], [127.757827758789, 158], [-19.7577972412109, 158], [-19.7577972412109, -1.75003051757812], [-19.7577819824219, -153]], [[-8.24215698242188, -153], [-8.24217224121094, 0.00003051757812], [-8.24217224121094, 158], [-95.7578125, 158], [-95.7578125, -1.75003051757812], [-95.7577972412109, -153]], [[-8.24215698242188, -153], [-8.24217224121094, 0.00003051757812], [-8.24217224121094, 158], [-95.7578125, 158], [-95.7578125, -1.75003051757812], [-95.7577972412109, -153]], [[38.7578430175781, -153], [38.7578277587891, 0.00003051757812], [38.7578277587891, 158], [-68.7578125, 158], [-68.7578125, -1.75003051757812], [-68.7577972412109, -153]]];
			addShapeKeyframes(compcode201Path, compcode201Path_keyTimesArray, compcode201Path_object);
			var compcode201Path_easeInSpeedArray = [0,0,0,0];
			var compcode201Path_easeInInfluArray = [16.666666667,100,16.666666667,0.1];
			var compcode201Path_easeOutSpeedArray = [0,0,0,0];
			var compcode201Path_easeOutInfluArray = [0.1,16.666666667,100,16.666666667];
			var compcode201Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode201Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode201Path, compcode201Path_keyTimesArray, [compcode201Path_easeInSpeedArray, compcode201Path_easeInInfluArray], [compcode201Path_easeOutSpeedArray, compcode201Path_easeOutInfluArray], [compcode201Path_keyInInterpolationType, compcode201Path_keyOutInterpolationType]);

		compcode201.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode201.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode201.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode201.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode201.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode201.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode201.property("ADBE Root Vectors Group").property(1).property(2).property(3).enabled = false;
		compcode201.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode201.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-166.2421875,-29]);
		compcode201.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode201.property("ADBE Transform Group").property("ADBE Position").setValue([479.7578125,497,0]);
		compcode201.selected = false;
	// Add Shape Layer "2 02", varName "compcode202";
	var compcode202 = compcode2_comp.layers.addShape();
		compcode202.name = "2 02";
		compcode202.enabled = false;
		compcode202.outPoint = 0.625;
		compcode202.moveToEnd();
		compcode202.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode202.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode202.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode202.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode202.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode202Path = compcode202.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode202Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode202Path_object = {};
				compcode202Path_object.closed = true;
				compcode202Path_object.vertices = [[[127.757843017578, -153], [127.757827758789, 0.00003051757812], [127.757827758789, 158], [-19.7577972412109, 158], [-19.7577972412109, -1.75003051757812], [-19.7577819824219, -153]], [[-8.24215698242188, -153], [-8.24217224121094, 0.00003051757812], [-8.24217224121094, 158], [-95.7578125, 158], [-95.7578125, -1.75003051757812], [-95.7577972412109, -153]], [[-8.24215698242188, -153], [-8.24217224121094, 0.00003051757812], [-8.24217224121094, 158], [-95.7578125, 158], [-95.7578125, -1.75003051757812], [-95.7577972412109, -153]], [[38.7578430175781, -153], [38.7578277587891, 0.00003051757812], [38.7578277587891, 158], [-68.7578125, 158], [-68.7578125, -1.75003051757812], [-68.7577972412109, -153]]];
			addShapeKeyframes(compcode202Path, compcode202Path_keyTimesArray, compcode202Path_object);
			var compcode202Path_easeInSpeedArray = [0,0,0,0];
			var compcode202Path_easeInInfluArray = [16.666666667,100,16.666666667,0.1];
			var compcode202Path_easeOutSpeedArray = [0,0,0,0];
			var compcode202Path_easeOutInfluArray = [0.1,16.666666667,100,16.666666667];
			var compcode202Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode202Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode202Path, compcode202Path_keyTimesArray, [compcode202Path_easeInSpeedArray, compcode202Path_easeInInfluArray], [compcode202Path_easeOutSpeedArray, compcode202Path_easeOutInfluArray], [compcode202Path_keyInInterpolationType, compcode202Path_keyOutInterpolationType]);

		compcode202.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode202.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode202.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode202.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-166.2421875,-29]);
		compcode202.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode202.property("ADBE Transform Group").property("ADBE Position").setValue([479.7578125,497,0]);
		compcode202.selected = false;
	// Add Shape Layer "2 03", varName "compcode203";
	var compcode203 = compcode2_comp.layers.addShape();
		compcode203.name = "2 03";
		compcode203.startTime = 0.04166666666667;
		compcode203.inPoint = 0.41666666666667;
		compcode203.outPoint = 0.625;
		compcode203.moveToEnd();
		compcode203.trackMatteType = TrackMatteType.ALPHA;
		compcode203.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode203.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode203.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode203.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode203Path = compcode203.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode203Path_keyTimesArray = [0.41666666666667, 0.45833333333333, 0.5, 0.54166666666667, 0.58333333333333];
			var compcode203Path_object = {};
				compcode203Path_object.closed = false;
				compcode203Path_object.vertices = [[[130.776062011719, -165.819946289062], [122.613525390625, -165.819946289062], [122.613525390625, -165.578247070312], [122.613525390625, -10.3044738769531], [130.776031494141, -10.3044738769531], [208.473358154297, -86.64208984375], [130.776031494141, -165.820007324219]], [[133.776062011719, -165.819946289062], [125.613525390625, -165.819946289062], [125.613525390625, -165.578247070312], [125.613525390625, -10.3044738769531], [133.776031494141, -10.3044738769531], [211.473358154297, -86.64208984375], [133.776031494141, -165.820007324219]], [[151.823699951172, -165.819946289062], [143.661163330078, -165.819946289062], [143.661163330078, -165.578247070312], [143.661163330078, -10.3044738769531], [151.823669433594, -10.3044738769531], [229.52099609375, -86.64208984375], [151.823669433594, -165.820007324219]], [[189.990447998047, -165.819946289062], [181.827911376953, -165.819946289062], [181.827911376953, -165.578247070312], [181.827911376953, -10.3044738769531], [189.990417480469, -10.3044738769531], [267.687744140625, -86.64208984375], [189.990417480469, -165.820007324219]], [[224.776062011719, -165.819946289062], [216.613525390625, -165.819946289062], [216.613525390625, -165.578247070312], [216.613525390625, -10.3044738769531], [224.776031494141, -10.3044738769531], [302.473358154297, -86.64208984375], [224.776031494141, -165.820007324219]]];
				compcode203Path_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 42.9061889648438], [42.9104614257812, 0]]];
				compcode203Path_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [42.9104919433594, 0], [0, -42.9062194824219], [0, 0]]];
			addShapeKeyframes(compcode203Path, compcode203Path_keyTimesArray, compcode203Path_object);
			var compcode203Path_easeInSpeedArray = [0,0,1,1,0];
			var compcode203Path_easeInInfluArray = [16.666666667,16.666666667,16.666666667,16.666666667,0.1];
			var compcode203Path_easeOutSpeedArray = [0,0,1,1,0];
			var compcode203Path_easeOutInfluArray = [100,100,16.666666667,16.666666667,16.666666667];
			var compcode203Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode203Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode203Path, compcode203Path_keyTimesArray, [compcode203Path_easeInSpeedArray, compcode203Path_easeInInfluArray], [compcode203Path_easeOutSpeedArray, compcode203Path_easeOutInfluArray], [compcode203Path_keyInInterpolationType, compcode203Path_keyOutInterpolationType]);

		compcode203.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode203.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode203.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode203.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode203.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		compcode203.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode203.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode203Path3 = compcode203.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode203Path3_keyTimesArray = [0.41666666666667, 0.45833333333333, 0.5, 0.54166666666667, 0.58333333333333];
			var compcode203Path3_object = {};
				compcode203Path3_object.closed = false;
				compcode203Path3_object.vertices = [[[130.007720947266, -204.897369384766], [85.2851257324219, -204.897369384766], [85.3473968505859, 29.0929565429688], [122.613494873047, 28.5485229492188], [130.007690429688, 28.5485229492188], [247.321990966797, -87.4061126708984], [130.007675170898, -204.897430419922]], [[133.007720947266, -204.897369384766], [88.2851257324219, -204.897369384766], [88.3473968505859, 29.0929565429688], [125.613494873047, 28.5485229492188], [133.007690429688, 28.5485229492188], [250.321990966797, -87.4061126708984], [133.007675170898, -204.897430419922]], [[151.055358886719, -204.897369384766], [106.332763671875, -204.897369384766], [106.39501953125, 29.0929565429688], [143.6611328125, 28.5485229492188], [151.055328369141, 28.5485229492188], [268.36962890625, -87.4061126708984], [151.055297851562, -204.897430419922]], [[189.222106933594, -204.897369384766], [144.49951171875, -204.897369384766], [144.561767578125, 29.0929565429688], [181.827880859375, 28.5485229492188], [189.222076416016, 28.5485229492188], [306.536376953125, -87.4061126708984], [189.222061157227, -204.897430419922]], [[224.007720947266, -204.897369384766], [179.285125732422, -204.897369384766], [179.347381591797, 29.0929565429688], [216.613494873047, 28.5485229492188], [224.007690429688, 28.5485229492188], [341.321990966797, -87.4061126708984], [224.007690429688, -204.897430419922]]];
				compcode203Path3_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7866058349609], [64.7909393310547, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7866058349609], [64.7909393310547, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7866058349609], [64.7909545898438, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7866058349609], [64.7909393310547, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 64.7866058349609], [64.7909240722656, 0]]];
				compcode203Path3_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909393310547], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909393310547], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909393310547], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909393310547], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [64.7909240722656, 0], [0, -64.7909393310547], [0, 0]]];
			addShapeKeyframes(compcode203Path3, compcode203Path3_keyTimesArray, compcode203Path3_object);
			var compcode203Path3_easeInSpeedArray = [0,0,1,1,0];
			var compcode203Path3_easeInInfluArray = [16.666666667,16.666666667,16.666666667,16.666666667,0.1];
			var compcode203Path3_easeOutSpeedArray = [0,0,1,1,0];
			var compcode203Path3_easeOutInfluArray = [100,100,16.666666667,16.666666667,16.666666667];
			var compcode203Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode203Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode203Path3, compcode203Path3_keyTimesArray, [compcode203Path3_easeInSpeedArray, compcode203Path3_easeInInfluArray], [compcode203Path3_easeOutSpeedArray, compcode203Path3_easeOutInfluArray], [compcode203Path3_keyInInterpolationType, compcode203Path3_keyOutInterpolationType]);

		compcode203.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode203.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode203.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode203.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([51.5184326171875,-85.2260284423828,0]);
		compcode203.property("ADBE Transform Group").property("ADBE Position").setValue([119.518432617188,442.773971557617,0]);
		compcode203.property("ADBE Transform Group").property("ADBE Scale").setValue([100,-100,100]);
		compcode203.selected = false;
	// Add Shape Layer "2 04", varName "compcode204";
	var compcode204 = compcode2_comp.layers.addShape();
		compcode204.name = "2 04";
		compcode204.outPoint = 0.625;
		compcode204.moveToEnd();
		compcode204.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode204.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode204.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode204.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode204.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode204Path = compcode204.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode204Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode204Path_object = {};
				compcode204Path_object.closed = true;
				compcode204Path_object.vertices = [[[127.484405517578, 79.0000305175781], [127.757827758789, 158], [-19.7577972412109, 158], [-20.0312194824219, 78.9999389648438]], [[-8.51559448242188, 79.0000305175781], [-8.24217224121094, 158], [-95.7578125, 158], [-96.0312347412109, 78.9999389648438]], [[-8.51559448242188, 79.0000305175781], [-8.24217224121094, 158], [-95.7578125, 158], [-96.0312347412109, 78.9999389648438]], [[39.4844055175781, 79.0000305175781], [39.7578277587891, 158], [-67.7578125, 158], [-68.0312347412109, 78.9999389648438]]];
			addShapeKeyframes(compcode204Path, compcode204Path_keyTimesArray, compcode204Path_object);
			var compcode204Path_easeInSpeedArray = [0,0,0,0];
			var compcode204Path_easeInInfluArray = [16.666666667,100,16.666666667,0.1];
			var compcode204Path_easeOutSpeedArray = [0,0,0,0];
			var compcode204Path_easeOutInfluArray = [0.1,16.666666667,100,16.666666667];
			var compcode204Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode204Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode204Path, compcode204Path_keyTimesArray, [compcode204Path_easeInSpeedArray, compcode204Path_easeInInfluArray], [compcode204Path_easeOutSpeedArray, compcode204Path_easeOutInfluArray], [compcode204Path_keyInInterpolationType, compcode204Path_keyOutInterpolationType]);

		compcode204.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode204.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode204.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode204.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode204.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode204.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode204.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode204.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-166.2421875,-29]);
		compcode204.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode204.property("ADBE Transform Group").property("ADBE Position").setValue([479.7578125,497,0]);
		compcode204.selected = false;
	// Add Shape Layer "2 05", varName "compcode205";
	var compcode205 = compcode2_comp.layers.addShape();
		compcode205.name = "2 05";
		compcode205.outPoint = 0.625;
		compcode205.moveToEnd();
		compcode205.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode205.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode205.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode205.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode205.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode205Path = compcode205.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode205Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.58333333333333];
			var compcode205Path_object = {};
				compcode205Path_object.closed = true;
				compcode205Path_object.vertices = [[[127.757843017578, -153], [127.757827758789, 0.00003051757812], [127.757827758789, 158], [-19.7577972412109, 158], [-19.7577972412109, -1.75003051757812], [-19.7577819824219, -153]], [[-8.24215698242188, -153], [-8.24217224121094, 0.00003051757812], [-8.24217224121094, 158], [-95.7578125, 158], [-95.7578125, -1.75003051757812], [-95.7577972412109, -153]], [[-8.24215698242188, -153], [-8.24217224121094, 0.00003051757812], [-8.24217224121094, 158], [-95.7578125, 158], [-95.7578125, -1.75003051757812], [-95.7577972412109, -153]], [[38.7578430175781, -153], [38.7578277587891, 0.00003051757812], [38.7578277587891, 158], [-68.7578125, 158], [-68.7578125, -1.75003051757812], [-68.7577972412109, -153]]];
			addShapeKeyframes(compcode205Path, compcode205Path_keyTimesArray, compcode205Path_object);
			var compcode205Path_easeInSpeedArray = [0,0,0,0];
			var compcode205Path_easeInInfluArray = [16.666666667,100,16.666666667,0.1];
			var compcode205Path_easeOutSpeedArray = [0,0,0,0];
			var compcode205Path_easeOutInfluArray = [0.1,16.666666667,100,16.666666667];
			var compcode205Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode205Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode205Path, compcode205Path_keyTimesArray, [compcode205Path_easeInSpeedArray, compcode205Path_easeInInfluArray], [compcode205Path_easeOutSpeedArray, compcode205Path_easeOutInfluArray], [compcode205Path_keyInInterpolationType, compcode205Path_keyOutInterpolationType]);

		compcode205.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode205.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode205.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode205.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode205.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode205.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode205.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode205.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-166.2421875,-29]);
		compcode205.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode205.property("ADBE Transform Group").property("ADBE Position").setValue([479.7578125,497,0]);
		compcode205.selected = false;
	// Add Shape Layer "2 06", varName "compcode206";
	var compcode206 = compcode2_comp.layers.addShape();
		compcode206.name = "2 06";
		compcode206.inPoint = 0.625;
		compcode206.outPoint = 30;
		compcode206.moveToEnd();
		compcode206.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode206.property("ADBE Root Vectors Group").property(1).name = "Group 2";
		compcode206.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode206.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode206Path = compcode206.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode206Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode206Path_object = {};
				compcode206Path_object.closed = true;
				compcode206Path_object.vertices = [[[-11.0938873291016, 68.880126953125], [-11.0938873291016, 1.38275146484375], [-63.6473846435547, 108.117248535156], [-15.8549041748047, 108.117248535156], [-15.8549041748047, 108.173400878906], [94.3844604492188, 108.173400878906], [94.3844604492188, 68.880126953125]], [[-11.0938720703125, 68.880126953125], [-11.0938720703125, 1.38275146484375], [-75.6473999023438, 108.117248535156], [-27.8549194335938, 108.117248535156], [-27.8549194335938, 108.173400878906], [106.384460449219, 108.173400878906], [106.384460449219, 68.880126953125]]];
			addShapeKeyframes(compcode206Path, compcode206Path_keyTimesArray, compcode206Path_object);
			var compcode206Path_easeInSpeedArray = [0,0];
			var compcode206Path_easeInInfluArray = [0.1,100];
			var compcode206Path_easeOutSpeedArray = [0,0];
			var compcode206Path_easeOutInfluArray = [0.1,0.1];
			var compcode206Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode206Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode206Path, compcode206Path_keyTimesArray, [compcode206Path_easeInSpeedArray, compcode206Path_easeInInfluArray], [compcode206Path_easeOutSpeedArray, compcode206Path_easeOutInfluArray], [compcode206Path_keyInInterpolationType, compcode206Path_keyOutInterpolationType]);

		compcode206.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode206.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode206.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode206.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode206.property("ADBE Root Vectors Group").property(2).name = "Group 3";
		compcode206.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode206.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode206Path3 = compcode206.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode206Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode206Path3_object = {};
				compcode206Path3_object.closed = false;
				compcode206Path3_object.vertices = [[[29.4684448242188, -164.306793212891], [29.4684448242188, -9.65460205078125], [29.4684448242188, 11.1207885742188], [29.4684448242188, 26.8199462890625], [29.4684448242188, 27.3206787109375], [78.8133544921875, -9.65463256835938], [96.4161071777344, -48.8356628417969], [98.3844299316406, -68.4801635742188], [96.4160766601562, -88.1246337890625], [78.8132934570312, -127.301361083984], [29.4683837890625, -164.306884765625]], [[29.4684448242188, -164.306793212891], [29.4684448242188, -9.65460205078125], [29.4684448242188, 11.1207885742188], [29.4684448242188, 26.8199462890625], [29.4684448242188, 27.3206787109375], [86.8133544921875, -9.65463256835938], [104.416107177734, -48.8356628417969], [106.384429931641, -68.4801635742188], [104.416076660156, -88.1246337890625], [86.8132934570312, -127.301361083984], [29.4683837890625, -164.306884765625]]];
				compcode206Path3_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-13.8387451171875, 18.4617614746094], [-2.93954467773438, 14.4689636230469], [0, 6.7294921875], [1.2906494140625, 6.34527587890625], [8.54238891601562, 11.3912963867188], [23.300537109375, 5.14959716796875]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-13.8387451171875, 18.4617614746094], [-2.93954467773438, 14.4689636230469], [0, 6.7294921875], [1.2906494140625, 6.34527587890625], [8.54238891601562, 11.3912963867188], [23.300537109375, 5.14959716796875]]];
				compcode206Path3_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [23.300537109375, -5.1409912109375], [8.54238891601562, -11.3955993652344], [1.29061889648438, -6.349609375], [0, -6.72943115234375], [-2.9395751953125, -14.4732971191406], [-13.8387451171875, -18.4703979492188], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [23.300537109375, -5.1409912109375], [8.54238891601562, -11.3955993652344], [1.29061889648438, -6.349609375], [0, -6.72943115234375], [-2.9395751953125, -14.4732971191406], [-13.8387451171875, -18.4703979492188], [0, 0]]];
			addShapeKeyframes(compcode206Path3, compcode206Path3_keyTimesArray, compcode206Path3_object);
			var compcode206Path3_easeInSpeedArray = [0,0];
			var compcode206Path3_easeInInfluArray = [0.1,100];
			var compcode206Path3_easeOutSpeedArray = [0,0];
			var compcode206Path3_easeOutInfluArray = [0.1,0.1];
			var compcode206Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode206Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode206Path3, compcode206Path3_keyTimesArray, [compcode206Path3_easeInSpeedArray, compcode206Path3_easeInInfluArray], [compcode206Path3_easeOutSpeedArray, compcode206Path3_easeOutInfluArray], [compcode206Path3_keyInInterpolationType, compcode206Path3_keyOutInterpolationType]);

		compcode206.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode206.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode206.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode206.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode206.property("ADBE Root Vectors Group").property(3).name = "Group 4";
		compcode206.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		compcode206.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var compcode206Path5 = compcode206.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var compcode206Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode206Path5_object = {};
				compcode206Path5_object.closed = false;
				compcode206Path5_object.vertices = [[[-11.0981750488281, -164.725494384766], [-58.3984985351562, -127.305603027344], [-76.0012512207031, -88.12890625], [-77.9696044921875, -68.4844360351562], [-76.0012817382812, -48.8399658203125], [-75.6947937011719, -47.536376953125], [-11.0982055664062, -47.536376953125], [-11.0982055664062, -164.725524902344]], [[-11.0981750488281, -164.725494384766], [-70.3984985351562, -127.305603027344], [-88.0012512207031, -88.12890625], [-89.9696044921875, -68.4844360351562], [-88.0012817382812, -48.8399658203125], [-87.6947937011719, -47.536376953125], [-11.0982055664062, -47.536376953125], [-11.0982055664062, -164.725524902344]]];
				compcode206Path5_object.inTangents = [[[0, 0], [14.2272338867188, -18.979736328125], [2.93954467773438, -14.4689331054688], [0, -6.72512817382812], [-1.29061889648438, -6.34527587890625], [-0.09927368164062, -0.43597412109375], [0, 0], [0, 0]], [[0, 0], [14.2272338867188, -18.979736328125], [2.93954467773438, -14.4689331054688], [0, -6.72512817382812], [-1.29061889648438, -6.34527587890625], [-0.09927368164062, -0.43597412109375], [0, 0], [0, 0]]];
				compcode206Path5_object.outTangents = [[[-24.1250305175781, 4.81289672851562], [-8.54238891601562, 11.3955993652344], [-1.2906494140625, 6.349609375], [0, 6.72946166992188], [0.09066772460938, 0.4403076171875], [0, 0], [0, 0], [0, 0]], [[-24.1250305175781, 4.81289672851562], [-8.54238891601562, 11.3955993652344], [-1.2906494140625, 6.349609375], [0, 6.72946166992188], [0.09066772460938, 0.4403076171875], [0, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode206Path5, compcode206Path5_keyTimesArray, compcode206Path5_object);
			var compcode206Path5_easeInSpeedArray = [0,0];
			var compcode206Path5_easeInInfluArray = [0.1,100];
			var compcode206Path5_easeOutSpeedArray = [0,0];
			var compcode206Path5_easeOutInfluArray = [0.1,0.1];
			var compcode206Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode206Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode206Path5, compcode206Path5_keyTimesArray, [compcode206Path5_easeInSpeedArray, compcode206Path5_easeInInfluArray], [compcode206Path5_easeOutSpeedArray, compcode206Path5_easeOutInfluArray], [compcode206Path5_keyInInterpolationType, compcode206Path5_keyOutInterpolationType]);

		compcode206.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode206.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		compcode206.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode206.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode206.property("ADBE Root Vectors Group").property(4).name = "Group 1";
		compcode206.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		compcode206.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var compcode206Path7 = compcode206.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var compcode206Path7_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode206Path7_object = {};
				compcode206Path7_object.closed = true;
				compcode206Path7_object.vertices = [[[133.565551757812, 29.6430053710938], [96.2909545898438, 29.6430053710938], [137.565490722656, -68.4757690429688], [8.20960998535156, -205.831695556641], [-117.146331787109, -68.4757690429688], [-103.929168701172, -9.64599609375], [-50.5382232666016, -9.58987426757812], [-133.151977539062, 147.358703613281], [-133.130401611328, 147.358703613281], [133.625854492188, 147.302612304688]], [[145.565536499023, 29.6430053710938], [104.290954589844, 29.6430053710938], [145.565475463867, -68.4757690429688], [8.2095947265625, -205.831695556641], [-129.146331787109, -68.4757690429688], [-115.929168701172, -9.64599609375], [-50.5382385253906, -9.58987426757812], [-145.151992797852, 147.358703613281], [-145.130416870117, 147.358703613281], [145.625839233398, 147.302612304688]]];
				compcode206Path7_object.inTangents = [[[0, 0], [0, 0], [0, 38.4472045898438], [75.8584442138672, 0], [0, -75.8585205078125], [-8.46469116210938, -17.8358612060547], [0, 0], [0, 0], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 38.4472045898438], [75.8584594726562, 0], [0, -75.8585205078125], [-8.46469116210938, -17.8358612060547], [0, 0], [0, 0], [0, 0], [0, 0]]];
				compcode206Path7_object.outTangents = [[[0, 0], [25.4588012695312, -24.9322357177734], [0, -75.8628234863281], [-75.8585510253906, 0], [0, 21.0516357421875], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]], [[0, 0], [25.4587860107422, -24.9322357177734], [0, -75.8628234863281], [-75.8585357666016, 0], [0, 21.0516357421875], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode206Path7, compcode206Path7_keyTimesArray, compcode206Path7_object);
			var compcode206Path7_easeInSpeedArray = [0,0];
			var compcode206Path7_easeInInfluArray = [0.1,100];
			var compcode206Path7_easeOutSpeedArray = [0,0];
			var compcode206Path7_easeOutInfluArray = [0.1,0.1];
			var compcode206Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode206Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode206Path7, compcode206Path7_keyTimesArray, [compcode206Path7_easeInSpeedArray, compcode206Path7_easeInInfluArray], [compcode206Path7_easeOutSpeedArray, compcode206Path7_easeOutInfluArray], [compcode206Path7_keyInInterpolationType, compcode206Path7_keyOutInterpolationType]);

		compcode206.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode206.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		compcode206.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode206.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode206.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode201.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode201.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode203.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode203.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode204.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode204.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode205.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode205.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode206.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode206.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode206.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode206.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode2_comp.openInViewer();

return {
	compItem : compcode2_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

