// Created using compCode v2.0
// 201801030 from composition "3" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode3();
function utopian_201801030_094309() {

// app.beginUndoGroup("3");

try {

// ANIMATION PRESETS START
	// 3 -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var numbers_folder_properties = {"name":"03 Numbers","typeName":"Folder","label":9,"comment":""};
	var numbers_folder = findProjectItem(utopian_folder, false, numbers_folder_properties);
	if (numbers_folder === null) {
		numbers_folder = app.project.items.addFolder(numbers_folder_properties.name);
		numbers_folder.label = numbers_folder_properties.label;
		numbers_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode3_comp_properties = {"name":"3","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":5,"frameRate":24};
	var compcode3_comp = app.project.items.addComp(compcode3_comp_properties.name, compcode3_comp_properties.width, compcode3_comp_properties.height, 1, 30, 24);
		compcode3_comp.time = 0.91666666666667;
		compcode3_comp.bgColor = compcode3_comp_properties.bgColor;
		compcode3_comp.label = compcode3_comp_properties.label;
		compcode3_comp.resolutionFactor = [1, 1];
		compcode3_comp.parentFolder = numbers_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode3_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "3", varName "compcode3_comp";
	compcode3_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode3_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([243.876998901367,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([556.122985839844,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode3_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "3 01", varName "compcode301";
	var compcode301 = compcode3_comp.layers.addShape();
		compcode301.name = "3 01";
		compcode301.startTime = 0.04166666666667;
		compcode301.inPoint = 0;
		compcode301.outPoint = 0.58333333333333;
		compcode301.moveToEnd();
		compcode301.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode301.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode301.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode301.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode301.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode301Path = compcode301.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode301Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode301Path_object = {};
				compcode301Path_object.closed = true;
				compcode301Path_object.vertices = [[[48, -17.1796875], [46.89453125, 109.1796875], [-47.89453125, 109.1796875], [-46.7890625, -17.1796875]], [[46.7890625, 79.8203125], [45.89453125, 156.1796875], [-47.89453125, 156.1796875], [-47, 79.8203125]], [[46.7890625, 79.8203125], [45.89453125, 156.1796875], [-47.89453125, 156.1796875], [-47, 79.8203125]], [[51.7890625, 79.8203125], [58.89453125, 156.1796875], [-55.89453125, 156.1796875], [-55, 79.8203125]]];
			addShapeKeyframes(compcode301Path, compcode301Path_keyTimesArray, compcode301Path_object);
			var compcode301Path_easeInSpeedArray = [0,0,0,0];
			var compcode301Path_easeInInfluArray = [16.666666667,100,16.666666667,0.1];
			var compcode301Path_easeOutSpeedArray = [0,0,0,0];
			var compcode301Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode301Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode301Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode301Path, compcode301Path_keyTimesArray, [compcode301Path_easeInSpeedArray, compcode301Path_easeInInfluArray], [compcode301Path_easeOutSpeedArray, compcode301Path_easeOutInfluArray], [compcode301Path_keyInInterpolationType, compcode301Path_keyOutInterpolationType]);

		compcode301.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode301.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode301.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode301.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode301.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode301.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode301.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode301.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		compcode301.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([6.10546875,-28.1796875,0]);
		compcode301.property("ADBE Transform Group").property("ADBE Position").setValue([406.10546875,498.8203125,0]);
		compcode301.property("ADBE Transform Group").property("ADBE Scale").setValue([100,-100,100]);
		compcode301.selected = false;
	// Add Shape Layer "3 02", varName "compcode302";
	var compcode302 = compcode3_comp.layers.addShape();
		compcode302.name = "3 02";
		compcode302.startTime = 0.04166666666667;
		compcode302.inPoint = 0;
		compcode302.outPoint = 0.58333333333333;
		compcode302.moveToEnd();
		compcode302.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode302.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode302.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode302.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode302.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode302Path = compcode302.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode302Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode302Path_object = {};
				compcode302Path_object.closed = true;
				compcode302Path_object.vertices = [[[47.89453125, -129.1796875], [46.89453125, 241.1796875], [-47.89453125, 241.1796875], [-46.89453125, -129.1796875]], [[47.89453125, -156.1796875], [46.89453125, 156.1796875], [-47.89453125, 156.1796875], [-46.89453125, -156.1796875]], [[47.89453125, -156.1796875], [46.89453125, 156.1796875], [-47.89453125, 156.1796875], [-46.89453125, -156.1796875]], [[51.89453125, -156.1796875], [50.89453125, 156.1796875], [-47.89453125, 156.1796875], [-58.89453125, -156.1796875]]];
			addShapeKeyframes(compcode302Path, compcode302Path_keyTimesArray, compcode302Path_object);
			var compcode302Path_easeInSpeedArray = [0,0,0,0];
			var compcode302Path_easeInInfluArray = [16.666666667,100,16.666666667,0.1];
			var compcode302Path_easeOutSpeedArray = [0,0,0,0];
			var compcode302Path_easeOutInfluArray = [0.1,0.1,100,16.666666667];
			var compcode302Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode302Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode302Path, compcode302Path_keyTimesArray, [compcode302Path_easeInSpeedArray, compcode302Path_easeInInfluArray], [compcode302Path_easeOutSpeedArray, compcode302Path_easeOutInfluArray], [compcode302Path_keyInInterpolationType, compcode302Path_keyOutInterpolationType]);

		compcode302.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode302.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode302.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode302.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode302.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode302.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode302.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode302.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([6.10546875,-30.1796875]);
		compcode302.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([6.10546875,-28.1796875,0]);
		compcode302.property("ADBE Transform Group").property("ADBE Position").setValue([406.10546875,498.8203125,0]);
		compcode302.property("ADBE Transform Group").property("ADBE Scale").setValue([100,-100,100]);
		compcode302.selected = false;
	// Add Shape Layer "3 04", varName "compcode304";
	var compcode304 = compcode3_comp.layers.addShape();
		compcode304.name = "3 04";
		compcode304.inPoint = 0.58333333333333;
		compcode304.outPoint = 30;
		compcode304.moveToEnd();
		compcode304.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode304.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode304.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode304.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode304Path = compcode304.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode304Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode304Path_object = {};
				compcode304Path_object.closed = false;
				compcode304Path_object.vertices = [[[56.7811889648438, -162.864532470703], [-53.63232421875, -162.864532470703], [-53.63232421875, -123.631713867188], [36.9324340820312, -123.631713867188], [56.7811889648438, -162.864562988281]], [[64.7811889648438, -162.864532470703], [-61.63232421875, -162.864532470703], [-61.63232421875, -123.631713867188], [40.9324340820312, -123.631713867188], [64.7811889648438, -162.864562988281]]];
			addShapeKeyframes(compcode304Path, compcode304Path_keyTimesArray, compcode304Path_object);
			var compcode304Path_easeInSpeedArray = [0,0];
			var compcode304Path_easeInInfluArray = [0.1,100];
			var compcode304Path_easeOutSpeedArray = [0,0];
			var compcode304Path_easeOutInfluArray = [0.1,0.1];
			var compcode304Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode304Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode304Path, compcode304Path_keyTimesArray, [compcode304Path_easeInSpeedArray, compcode304Path_easeInInfluArray], [compcode304Path_easeOutSpeedArray, compcode304Path_easeOutInfluArray], [compcode304Path_keyInInterpolationType, compcode304Path_keyOutInterpolationType]);

		compcode304.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode304.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode304.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode304.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode304.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		compcode304.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode304.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode304Path3 = compcode304.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode304Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode304Path3_object = {};
				compcode304Path3_object.closed = false;
				compcode304Path3_object.vertices = [[[-22.6628112792969, -58.6810607910156], [-83.7357177734375, 59.9052124023438], [-73.6696166992188, 76.5540161132812], [-22.6585083007812, 109.904846191406], [-22.6585083007812, -58.6810913085938]], [[-22.6628112792969, -58.6810607910156], [-91.7357177734375, 55.9052124023438], [-81.6696166992188, 72.5540161132812], [-22.6585083007812, 109.904846191406], [-22.6585083007812, -58.6810913085938]]];
				compcode304Path3_object.inTangents = [[[0, 0], [0, 0], [-3.88055419921875, -5.17547607421875], [-24.004150390625, -4.86041259765625], [0, 0]], [[0, 0], [0, 0], [-3.88055419921875, -5.17547607421875], [-24.004150390625, -4.86041259765625], [0, 0]]];
				compcode304Path3_object.outTangents = [[[0, 0], [2.80572509765625, 5.8963623046875], [14.1668090820312, 18.9020385742188], [0, 0], [0, 0]], [[0, 0], [2.80572509765625, 5.8963623046875], [14.1668090820312, 18.9020385742188], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode304Path3, compcode304Path3_keyTimesArray, compcode304Path3_object);
			var compcode304Path3_easeInSpeedArray = [0,0];
			var compcode304Path3_easeInInfluArray = [0.1,100];
			var compcode304Path3_easeOutSpeedArray = [0,0];
			var compcode304Path3_easeOutInfluArray = [0.1,0.1];
			var compcode304Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode304Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode304Path3, compcode304Path3_keyTimesArray, [compcode304Path3_easeInSpeedArray, compcode304Path3_easeInInfluArray], [compcode304Path3_easeOutSpeedArray, compcode304Path3_easeOutInfluArray], [compcode304Path3_keyInInterpolationType, compcode304Path3_keyOutInterpolationType]);

		compcode304.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode304.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode304.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode304.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode304.property("ADBE Root Vectors Group").property(3).name = "Group 3";
		compcode304.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		compcode304.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var compcode304Path5 = compcode304.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var compcode304Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode304Path5_object = {};
				compcode304Path5_object.closed = false;
				compcode304Path5_object.vertices = [[[16.5743408203125, -82.4478149414062], [16.5743408203125, 109.900512695312], [71.5293273925781, 72.558349609375], [89.132080078125, 33.3773193359375], [91.1004028320312, 13.7327880859375], [89.132080078125, -5.91168212890625], [71.529296875, -45.0927124023438], [16.5742797851562, -82.4478454589844]], [[16.5743408203125, -82.4478149414062], [16.5743408203125, 109.900512695312], [75.5293273925781, 72.558349609375], [93.132080078125, 33.3773193359375], [95.1004028320312, 13.7327880859375], [93.132080078125, -5.91168212890625], [75.529296875, -45.0927124023438], [16.5742797851562, -82.4478454589844]]];
				compcode304Path5_object.inTangents = [[[0, 0], [0, 0], [-14.1538696289062, 18.884765625], [-2.93954467773438, 14.4689331054688], [0, 6.72515869140625], [1.29061889648438, 6.34530639648438], [8.54238891601562, 11.3956298828125], [23.9868774414062, 4.8690185546875]], [[0, 0], [0, 0], [-14.1538696289062, 18.884765625], [-2.93954467773438, 14.4689331054688], [0, 6.72515869140625], [1.29061889648438, 6.34530639648438], [8.54238891601562, 11.3956298828125], [23.9868774414062, 4.8690185546875]]];
				compcode304Path5_object.outTangents = [[[0, 0], [23.9825439453125, -4.87762451171875], [8.54238891601562, -11.3956298828125], [1.2906494140625, -6.349609375], [0, -6.72943115234375], [-2.9395751953125, -14.4732666015625], [-14.1538696289062, -18.897705078125], [0, 0]], [[0, 0], [23.9825439453125, -4.87762451171875], [8.54238891601562, -11.3956298828125], [1.2906494140625, -6.349609375], [0, -6.72943115234375], [-2.9395751953125, -14.4732666015625], [-14.1538696289062, -18.897705078125], [0, 0]]];
			addShapeKeyframes(compcode304Path5, compcode304Path5_keyTimesArray, compcode304Path5_object);
			var compcode304Path5_easeInSpeedArray = [0,0];
			var compcode304Path5_easeInInfluArray = [0.1,100];
			var compcode304Path5_easeOutSpeedArray = [0,0];
			var compcode304Path5_easeOutInfluArray = [0.1,0.1];
			var compcode304Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode304Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode304Path5, compcode304Path5_keyTimesArray, [compcode304Path5_easeInSpeedArray, compcode304Path5_easeInInfluArray], [compcode304Path5_easeOutSpeedArray, compcode304Path5_easeOutInfluArray], [compcode304Path5_keyInInterpolationType, compcode304Path5_keyOutInterpolationType]);

		compcode304.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode304.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		compcode304.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode304.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode304.property("ADBE Root Vectors Group").property(4).name = "Group 4";
		compcode304.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		compcode304.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var compcode304Path7 = compcode304.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var compcode304Path7_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode304Path7_object = {};
				compcode304Path7_object.closed = false;
				compcode304Path7_object.vertices = [[[126.268493652344, -202.106018066406], [86.996826171875, -202.106018066406], [-93.1889038085938, -202.106018066406], [-93.2450256347656, -84.4463806152344], [-93.1889038085938, -84.4463806152344], [-91.0824584960938, -84.4463806152344], [-53.2712707519531, -84.4463806152344], [-53.2539978027344, -84.4463806152344], [-53.2885437011719, -84.3902587890625], [-127.151306152344, 55.4073486328125], [-127.14697265625, 55.4202880859375], [-125.321105957031, 61.3209838867188], [-3.06587219238281, 151.088684082031], [130.2900390625, 13.7327880859375], [72.8400573730469, -100.741271972656], [126.289978027344, -202.101776123047], [126.268356323242, -202.101776123047]], [[134.268493652344, -202.106018066406], [94.996826171875, -202.106018066406], [-101.188903808594, -202.106018066406], [-101.245025634766, -84.4463806152344], [-101.188903808594, -84.4463806152344], [-99.0824584960938, -84.4463806152344], [-53.2712707519531, -84.4463806152344], [-53.2539978027344, -84.4463806152344], [-53.2885437011719, -84.3902587890625], [-135.151306152344, 51.4073638916016], [-135.14697265625, 51.4202880859375], [-133.321105957031, 57.3209838867188], [-3.06585693359375, 151.088684082031], [134.2900390625, 13.7327880859375], [72.8400573730469, -100.741271972656], [134.289978027344, -202.101776123047], [134.268371582031, -202.101776123047]]];
				compcode304Path7_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-0.65179443359375, -1.9510498046875], [-60.6211700439453, 0], [0, 75.8584594726562], [37.0270538330078, 24.6084594726562], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-0.65179443359375, -1.9510498046875], [-60.6211853027344, 0], [0, 75.8584594726562], [37.0270538330078, 24.6084594726562], [0, 0], [0, 0]]];
				compcode304Path7_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0.56976318359375, 1.9813232421875], [18.2286682128906, 54.4830932617188], [75.8584899902344, 0], [0, -47.7925109863281], [0, 0], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0.56976318359375, 1.9813232421875], [18.2286682128906, 54.4830932617188], [75.8584594726562, 0], [0, -47.7925109863281], [0, 0], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode304Path7, compcode304Path7_keyTimesArray, compcode304Path7_object);
			var compcode304Path7_easeInSpeedArray = [0,0];
			var compcode304Path7_easeInInfluArray = [0.1,100];
			var compcode304Path7_easeOutSpeedArray = [0,0];
			var compcode304Path7_easeOutInfluArray = [0.1,0.1];
			var compcode304Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode304Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode304Path7, compcode304Path7_keyTimesArray, [compcode304Path7_easeInSpeedArray, compcode304Path7_easeInInfluArray], [compcode304Path7_easeOutSpeedArray, compcode304Path7_easeOutInfluArray], [compcode304Path7_keyInInterpolationType, compcode304Path7_keyOutInterpolationType]);

		compcode304.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode304.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		compcode304.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode304.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode304.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode301.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode301.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode302.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode302.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode304.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode304.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode304.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode304.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode3_comp.openInViewer();

return {
	compItem : compcode3_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

