// Created using compCode v2.0
// 201801030 from composition "8" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode8();
function utopian_201801030_094309() {

// app.beginUndoGroup("8");

try {

// ANIMATION PRESETS START
	// 8 -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var numbers_folder_properties = {"name":"03 Numbers","typeName":"Folder","label":9,"comment":""};
	var numbers_folder = findProjectItem(utopian_folder, false, numbers_folder_properties);
	if (numbers_folder === null) {
		numbers_folder = app.project.items.addFolder(numbers_folder_properties.name);
		numbers_folder.label = numbers_folder_properties.label;
		numbers_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode8_comp_properties = {"name":"8","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":6,"frameRate":24};
	var compcode8_comp = app.project.items.addComp(compcode8_comp_properties.name, compcode8_comp_properties.width, compcode8_comp_properties.height, 1, 30, 24);
		compcode8_comp.time = 0.95833333333333;
		compcode8_comp.bgColor = compcode8_comp_properties.bgColor;
		compcode8_comp.label = compcode8_comp_properties.label;
		compcode8_comp.resolutionFactor = [1, 1];
		compcode8_comp.parentFolder = numbers_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode8_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "8", varName "compcode8_comp";
	compcode8_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode8_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([259.81298828125,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([540.684997558594,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode8_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "8 01", varName "compcode801";
	var compcode801 = compcode8_comp.layers.addShape();
		compcode801.name = "8 01";
		compcode801.outPoint = 0.58333333333333;
		compcode801.moveToEnd();
		compcode801.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode801.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode801.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode801.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode801.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode801Path = compcode801.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode801Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode801Path_object = {};
				compcode801Path_object.closed = true;
				compcode801Path_object.vertices = [[[70.537109375, 41.81640625], [70.537109375, 156.18359375], [-67.537109375, 156.18359375], [-67.537109375, 41.81640625]], [[100.537109375, 61.81640625], [100.537109375, 156.18359375], [-97.537109375, 156.18359375], [-97.537109375, 61.81640625]], [[100.537109375, 61.81640625], [100.537109375, 156.18359375], [-97.537109375, 156.18359375], [-97.537109375, 61.81640625]], [[70.537109375, 31.81640625], [70.537109375, 156.18359375], [-67.537109375, 156.18359375], [-67.537109375, 31.81640625]]];
			addShapeKeyframes(compcode801Path, compcode801Path_keyTimesArray, compcode801Path_object);
			var compcode801Path_easeInSpeedArray = [0,0,0,0];
			var compcode801Path_easeInInfluArray = [16.666666667,100,16.666666667,0.1];
			var compcode801Path_easeOutSpeedArray = [0,0,0,0];
			var compcode801Path_easeOutInfluArray = [0.1,16.666666667,100,16.666666667];
			var compcode801Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode801Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode801Path, compcode801Path_keyTimesArray, [compcode801Path_easeInSpeedArray, compcode801Path_easeInInfluArray], [compcode801Path_easeOutSpeedArray, compcode801Path_easeOutInfluArray], [compcode801Path_keyInInterpolationType, compcode801Path_keyOutInterpolationType]);

		compcode801.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode801.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode801.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode801.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode801.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode801.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode801.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode801.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1.462890625,-26.81640625]);
		compcode801.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode801.selected = false;
	// Add Shape Layer "8 02", varName "compcode802";
	var compcode802 = compcode8_comp.layers.addShape();
		compcode802.name = "8 02";
		compcode802.outPoint = 0.58333333333333;
		compcode802.moveToEnd();
		compcode802.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode802.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode802.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode802.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode802.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode802Path = compcode802.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode802Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode802Path_object = {};
				compcode802Path_object.closed = true;
				compcode802Path_object.vertices = [[[70.537109375, -158.1328125], [70.537109375, 156.234375], [1.462890625, 156.05078125], [1.462890625, -158.31640625]], [[100.537109375, -158.1328125], [100.537109375, 156.234375], [1.462890625, 156.05078125], [1.462890625, -158.31640625]], [[100.537109375, -158.1328125], [100.537109375, 156.234375], [1.462890625, 156.05078125], [1.462890625, -158.31640625]], [[70.537109375, -158.1328125], [70.537109375, 156.234375], [1.462890625, 156.05078125], [1.462890625, -158.31640625]]];
			addShapeKeyframes(compcode802Path, compcode802Path_keyTimesArray, compcode802Path_object);
			var compcode802Path_easeInSpeedArray = [0,0,0,0];
			var compcode802Path_easeInInfluArray = [16.666666667,100,16.666666667,0.1];
			var compcode802Path_easeOutSpeedArray = [0,0,0,0];
			var compcode802Path_easeOutInfluArray = [0.1,16.666666667,100,0.1];
			var compcode802Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode802Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode802Path, compcode802Path_keyTimesArray, [compcode802Path_easeInSpeedArray, compcode802Path_easeInInfluArray], [compcode802Path_easeOutSpeedArray, compcode802Path_easeOutInfluArray], [compcode802Path_keyInInterpolationType, compcode802Path_keyOutInterpolationType]);

		compcode802.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode802.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode802.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode802.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode802.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode802.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode802.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode802.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1.462890625,-26.81640625]);
		compcode802.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode802.selected = false;
	// Add Shape Layer "8 03", varName "compcode803";
	var compcode803 = compcode8_comp.layers.addShape();
		compcode803.name = "8 03";
		compcode803.outPoint = 0.58333333333333;
		compcode803.moveToEnd();
		compcode803.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode803.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode803.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode803.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode803.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode803Path = compcode803.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode803Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode803Path_object = {};
				compcode803Path_object.closed = true;
				compcode803Path_object.vertices = [[[70.537109375, -158.18359375], [70.537109375, 156.18359375], [-67.537109375, 156.18359375], [-67.537109375, -158.18359375]], [[100.537109375, -158.18359375], [100.537109375, 156.18359375], [-97.537109375, 156.18359375], [-97.537109375, -158.18359375]], [[100.537109375, -158.18359375], [100.537109375, 156.18359375], [-97.537109375, 156.18359375], [-97.537109375, -158.18359375]], [[70.537109375, -158.18359375], [70.537109375, 156.18359375], [-67.537109375, 156.18359375], [-67.537109375, -158.18359375]]];
			addShapeKeyframes(compcode803Path, compcode803Path_keyTimesArray, compcode803Path_object);
			var compcode803Path_easeInSpeedArray = [0,0,0,0];
			var compcode803Path_easeInInfluArray = [16.666666667,100,16.666666667,0.1];
			var compcode803Path_easeOutSpeedArray = [0,0,0,0];
			var compcode803Path_easeOutInfluArray = [0.1,16.666666667,100,100];
			var compcode803Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode803Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode803Path, compcode803Path_keyTimesArray, [compcode803Path_easeInSpeedArray, compcode803Path_easeInInfluArray], [compcode803Path_easeOutSpeedArray, compcode803Path_easeOutInfluArray], [compcode803Path_keyInInterpolationType, compcode803Path_keyOutInterpolationType]);

		compcode803.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode803.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode803.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode803.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode803.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode803.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode803.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode803.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-1.462890625,-26.81640625]);
		compcode803.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode803.selected = false;
	// Add Shape Layer "8 04", varName "compcode804";
	var compcode804 = compcode8_comp.layers.addShape();
		compcode804.name = "8 04";
		compcode804.inPoint = 0.58333333333333;
		compcode804.outPoint = 30;
		compcode804.moveToEnd();
		compcode804.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode804.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode804.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode804.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode804Path = compcode804.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode804Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode804Path_object = {};
				compcode804Path_object.closed = false;
				compcode804Path_object.vertices = [[[19.723388671875, -44.397705078125], [19.723388671875, 108.817077636719], [74.9761962890625, 32.2118530273438], [19.7233581542969, -44.397705078125]], [[19.723388671875, -44.397705078125], [19.723388671875, 108.817077636719], [78.9761962890625, 32.2118530273438], [19.7233581542969, -44.397705078125]]];
				compcode804Path_object.inTangents = [[[0, 0], [0, 0], [0, 36.85009765625], [34.0702819824219, 8.874755859375]], [[0, 0], [0, 0], [0, 36.85009765625], [34.0702819824219, 8.874755859375]]];
				compcode804Path_object.outTangents = [[[0, 0], [34.0702514648438, -8.87042236328125], [0, -36.8501281738281], [0, 0]], [[0, 0], [34.0702514648438, -8.87042236328125], [0, -36.8501281738281], [0, 0]]];
			addShapeKeyframes(compcode804Path, compcode804Path_keyTimesArray, compcode804Path_object);
			var compcode804Path_easeInSpeedArray = [0,0];
			var compcode804Path_easeInInfluArray = [0.1,100];
			var compcode804Path_easeOutSpeedArray = [0,0];
			var compcode804Path_easeOutInfluArray = [0.1,0.1];
			var compcode804Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode804Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode804Path, compcode804Path_keyTimesArray, [compcode804Path_easeInSpeedArray, compcode804Path_easeInInfluArray], [compcode804Path_easeOutSpeedArray, compcode804Path_easeOutInfluArray], [compcode804Path_keyInInterpolationType, compcode804Path_keyOutInterpolationType]);

		compcode804.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode804.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode804.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode804.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode804.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		compcode804.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode804.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode804Path3 = compcode804.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
			var compcode804Path3_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode804Path3_object = {};
				compcode804Path3_object.closed = false;
				compcode804Path3_object.vertices = [[[-20.2734680175781, -44.397705078125], [-75.5306396484375, 32.20751953125], [-20.2734985351562, 108.812744140625], [-20.2734985351562, -44.397705078125]], [[-20.2734680175781, -44.397705078125], [-79.5306396484375, 32.20751953125], [-20.2734985351562, 108.812744140625], [-20.2734985351562, -44.397705078125]]];
				compcode804Path3_object.inTangents = [[[0, 0], [0, -36.85009765625], [-34.0702514648438, -8.874755859375], [0, 0]], [[0, 0], [0, -36.85009765625], [-34.0702514648438, -8.874755859375], [0, 0]]];
				compcode804Path3_object.outTangents = [[[-34.0659484863281, 8.874755859375], [0, 36.85009765625], [0, 0], [0, 0]], [[-34.0659484863281, 8.874755859375], [0, 36.85009765625], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode804Path3, compcode804Path3_keyTimesArray, compcode804Path3_object);
			var compcode804Path3_easeInSpeedArray = [0,0];
			var compcode804Path3_easeInInfluArray = [0.1,100];
			var compcode804Path3_easeOutSpeedArray = [0,0];
			var compcode804Path3_easeOutInfluArray = [0.1,0.1];
			var compcode804Path3_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode804Path3_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode804Path3, compcode804Path3_keyTimesArray, [compcode804Path3_easeInSpeedArray, compcode804Path3_easeInInfluArray], [compcode804Path3_easeOutSpeedArray, compcode804Path3_easeOutInfluArray], [compcode804Path3_keyInInterpolationType, compcode804Path3_keyOutInterpolationType]);

		compcode804.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode804.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode804.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.91372549533844,0.04705882444978,0.1843137294054,1]);
		compcode804.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode804.property("ADBE Root Vectors Group").property(3).name = "Group 3";
		compcode804.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Shape - Group");
		compcode804.property("ADBE Root Vectors Group").property(3).property(2).property(1).name = "Path 1";
		var compcode804Path5 = compcode804.property("ADBE Root Vectors Group").property(3).property(2).property(1).property("ADBE Vector Shape");
			var compcode804Path5_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode804Path5_object = {};
				compcode804Path5_object.closed = false;
				compcode804Path5_object.vertices = [[[-0.27505493164062, -162.920654296875], [-35.9006958007812, -123.295043945312], [-0.27938842773438, -86.66943359375], [-0.27508544921875, -86.66943359375], [-0.2664794921875, -86.66943359375], [35.3548583984375, -123.295074462891], [-0.27511596679688, -162.920715332031]], [[-0.27505493164062, -165.920654296875], [-39.9006958007812, -126.295043945312], [-0.27938842773438, -86.66943359375], [-0.27508544921875, -86.66943359375], [-0.2664794921875, -86.66943359375], [39.3548583984375, -126.295074462891], [-0.27511596679688, -165.920715332031]]];
				compcode804Path5_object.inTangents = [[[0, 0], [0, -21.8890380859375], [-21.8804321289062, 0], [0, 0], [0, 0], [0, 21.884765625], [21.8847351074219, 0]], [[0, 0], [0, -21.8890380859375], [-21.8804321289062, 0], [0, 0], [0, 0], [0, 21.884765625], [21.8847351074219, 0]]];
				compcode804Path5_object.outTangents = [[[-21.8847351074219, 0], [0, 21.8890380859375], [0, 0], [0, 0], [21.8804321289062, -0.00430297851562], [0, -21.884765625], [0, 0]], [[-21.8847351074219, 0], [0, 21.8890380859375], [0, 0], [0, 0], [21.8804321289062, -0.00430297851562], [0, -21.884765625], [0, 0]]];
			addShapeKeyframes(compcode804Path5, compcode804Path5_keyTimesArray, compcode804Path5_object);
			var compcode804Path5_easeInSpeedArray = [0,0];
			var compcode804Path5_easeInInfluArray = [0.1,100];
			var compcode804Path5_easeOutSpeedArray = [0,0];
			var compcode804Path5_easeOutInfluArray = [0.1,0.1];
			var compcode804Path5_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode804Path5_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode804Path5, compcode804Path5_keyTimesArray, [compcode804Path5_easeInSpeedArray, compcode804Path5_easeInInfluArray], [compcode804Path5_easeOutSpeedArray, compcode804Path5_easeOutInfluArray], [compcode804Path5_keyInInterpolationType, compcode804Path5_keyOutInterpolationType]);

		compcode804.property("ADBE Root Vectors Group").property(3).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode804.property("ADBE Root Vectors Group").property(3).property(2).property(2).name = "Fill 1";
		compcode804.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode804.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode804.property("ADBE Root Vectors Group").property(4).name = "Group 4";
		compcode804.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Shape - Group");
		compcode804.property("ADBE Root Vectors Group").property(4).property(2).property(1).name = "Path 1";
		var compcode804Path7 = compcode804.property("ADBE Root Vectors Group").property(4).property(2).property(1).property("ADBE Vector Shape");
			var compcode804Path7_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode804Path7_object = {};
				compcode804Path7_object.closed = false;
				compcode804Path7_object.vertices = [[[80.2423706054688, -51.3688659667969], [56.5403442382812, -69.9342041015625], [53.1648254394531, -71.7989501953125], [74.9718627929688, -123.290710449219], [-0.2794189453125, -202.5419921875], [-75.5306701660156, -123.290740966797], [-53.6934204101562, -71.7644958496094], [-80.8011474609375, -51.3646240234375], [-115.156311035156, 32.2118225097656], [-0.2794189453125, 151.088623046875], [114.601745605469, 32.2118225097656], [80.2422485351562, -51.3689575195312]], [[84.2423706054688, -51.3688659667969], [60.5403442382812, -69.9342041015625], [57.1648254394531, -71.7989501953125], [78.9718627929688, -126.290710449219], [-0.2794189453125, -205.5419921875], [-79.5306701660156, -126.290740966797], [-57.6934204101562, -71.7644958496094], [-84.8011474609375, -51.3646240234375], [-119.156311035156, 32.2118072509766], [-0.2794189453125, 151.088623046875], [118.601745605469, 32.2118072509766], [84.2422485351562, -51.3689575195312]]];
				compcode804Path7_object.inTangents = [[[0, 0], [8.67620849609375, 5.17547607421875], [1.12661743164062, 0.62158203125], [0, 21.1293640136719], [43.76953125, 0], [0, -43.7695007324219], [-13.4977416992188, -14.2099914550781], [7.96829223632812, -8.05462646484375], [0, -32.5854339599609], [-65.6542358398438, 0], [0, 65.6584777832031], [21.2372741699219, 21.4746704101562]], [[0, 0], [8.67620849609375, 5.17547607421875], [1.12661743164062, 0.62158203125], [0, 21.1293640136719], [43.76953125, 0], [0, -43.7695007324219], [-13.4977416992188, -14.2099914550781], [7.96829223632812, -8.05462646484375], [0, -32.5854187011719], [-65.6542358398438, 0], [0, 65.6584930419922], [21.2372741699219, 21.4746704101562]]];
				compcode804Path7_object.outTangents = [[[-7.06182861328125, -7.1395263671875], [-1.1007080078125, -0.6561279296875], [13.4847717285156, -14.2100067138672], [0, -43.7695007324219], [-43.7651672363281, 0], [0, 21.1509246826172], [-9.98410034179688, 5.52081298828125], [-21.2329406738281, 21.4746398925781], [0, 65.6541442871094], [65.6542053222656, 0], [0.00433349609375, -32.5897979736328], [0, 0]], [[-7.06182861328125, -7.1395263671875], [-1.1007080078125, -0.6561279296875], [13.4847717285156, -14.2099914550781], [0, -43.7695007324219], [-43.7651672363281, 0], [0, 21.1509399414062], [-9.98410034179688, 5.52081298828125], [-21.2329406738281, 21.4746398925781], [0, 65.6541595458984], [65.6542053222656, 0], [0.00433349609375, -32.5897674560547], [0, 0]]];
			addShapeKeyframes(compcode804Path7, compcode804Path7_keyTimesArray, compcode804Path7_object);
			var compcode804Path7_easeInSpeedArray = [0,0];
			var compcode804Path7_easeInInfluArray = [0.1,100];
			var compcode804Path7_easeOutSpeedArray = [0,0];
			var compcode804Path7_easeOutInfluArray = [0.1,0.1];
			var compcode804Path7_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode804Path7_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode804Path7, compcode804Path7_keyTimesArray, [compcode804Path7_easeInSpeedArray, compcode804Path7_easeInInfluArray], [compcode804Path7_easeOutSpeedArray, compcode804Path7_easeOutInfluArray], [compcode804Path7_keyInInterpolationType, compcode804Path7_keyOutInterpolationType]);

		compcode804.property("ADBE Root Vectors Group").property(4).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode804.property("ADBE Root Vectors Group").property(4).property(2).property(2).name = "Fill 1";
		compcode804.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode804.property("ADBE Transform Group").property("ADBE Position").setValue([400,526,0]);
		compcode804.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode801.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode801.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode802.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode802.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode803.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode803.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode804.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode804.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 03\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode804.property("ADBE Root Vectors Group").property(3).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode804.property("ADBE Root Vectors Group").property(4).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode8_comp.openInViewer();

return {
	compItem : compcode8_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

