// Created using compCode v2.0
// 201801030 from composition "@" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode();
function utopian_201801030_094309() {

// app.beginUndoGroup("@");

try {

// ANIMATION PRESETS START
	// eta -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var specialCharacters_folder_properties = {"name":"05 Special Characters","typeName":"Folder","label":9,"comment":""};
	var specialCharacters_folder = findProjectItem(utopian_folder, false, specialCharacters_folder_properties);
	if (specialCharacters_folder === null) {
		specialCharacters_folder = app.project.items.addFolder(specialCharacters_folder_properties.name);
		specialCharacters_folder.label = specialCharacters_folder_properties.label;
		specialCharacters_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode_comp_properties = {"name":"@","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":5,"frameRate":24};
	var compcode_comp = app.project.items.addComp(compcode_comp_properties.name, compcode_comp_properties.width, compcode_comp_properties.height, 1, 30, 24);
		compcode_comp.time = 3.08333333333333;
		compcode_comp.bgColor = compcode_comp_properties.bgColor;
		compcode_comp.label = compcode_comp_properties.label;
		compcode_comp.resolutionFactor = [1, 1];
		compcode_comp.parentFolder = specialCharacters_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "@", varName "compcode_comp";
	compcode_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([204.285995483398,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([595.713989257812,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "@ 01", varName "compcode01";
	var compcode01 = compcode_comp.layers.addShape();
		compcode01.name = "@ 01";
		compcode01.outPoint = 0.58333333333333;
		compcode01.moveToEnd();
		compcode01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode01.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode01Path = compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var compcode01Path_newShape = new Shape();
			compcode01Path_newShape.vertices = [[57.5516357421875, -15.5927124023438], [7.45413208007812, 34.5047607421875], [-57.7598266601562, -30.7091674804688], [-7.66229248046875, -80.8067016601562], [57.5516357421875, -15.5927734375]];
			compcode01Path_newShape.inTangents = [[0, 0], [25.9120788574219, -3.267578125], [-4.79132080078125, 38.0285034179688], [-25.9120788574219, 3.2633056640625], [4.79132080078125, -38.0285034179688]];
			compcode01Path_newShape.outTangents = [[-3.267578125, 25.90771484375], [-38.0285339355469, 4.79132080078125], [3.26760864257812, -25.9077453613281], [38.0328063964844, -4.795654296875], [0, 0]];
			compcode01Path_newShape.closed = false;
		compcode01Path.setValue(compcode01Path_newShape);
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99607843160629,0.78823530673981,0.00392156885937,1]);
		compcode01.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-0.10406875610352,-23.1513500213623,0]);
		compcode01.property("ADBE Transform Group").property("ADBE Position").setValue([399.895931243896,502.848649978638,0]);
		var compcode01Scale = compcode01.property("ADBE Transform Group").property("ADBE Scale");
			var compcode01Scale_keyTimesArray = [0,0.33333333333333,0.41666666666667,0.54166666666667];
			var compcode01Scale_valuesArray = [[75,75,100],[100,100,100],[100,100,100],[90,90,100]];
			compcode01Scale.setValuesAtTimes(compcode01Scale_keyTimesArray, compcode01Scale_valuesArray);
			var compcode01Scale_easeInSpeedArray = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			var compcode01Scale_easeInInfluArray = [[0.1,0.1,0.1],[100,100,100],[0.1,0.1,0.1],[0.1,0.1,0.1]];
			var compcode01Scale_easeOutSpeedArray = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			var compcode01Scale_easeOutInfluArray = [[0.1,0.1,0.1],[100,100,100],[100,100,100],[0.1,0.1,0.1]];
			var compcode01Scale_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode01Scale_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode01Scale, compcode01Scale_keyTimesArray, [compcode01Scale_easeInSpeedArray, compcode01Scale_easeInInfluArray], [compcode01Scale_easeOutSpeedArray, compcode01Scale_easeOutInfluArray], [compcode01Scale_keyInInterpolationType, compcode01Scale_keyOutInterpolationType]);

		compcode01.selected = false;
	// Add Shape Layer "@ 02", varName "compcode02";
	var compcode02 = compcode_comp.layers.addShape();
		compcode02.name = "@ 02";
		compcode02.outPoint = 0.58333333333333;
		compcode02.moveToEnd();
		compcode02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode02.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode02Path = compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var compcode02Path_newShape = new Shape();
			compcode02Path_newShape.vertices = [[57.5516357421875, -15.5927124023438], [7.45413208007812, 34.5047607421875], [-57.7598266601562, -30.7091674804688], [-7.66229248046875, -80.8067016601562], [57.5516357421875, -15.5927734375]];
			compcode02Path_newShape.inTangents = [[0, 0], [25.9120788574219, -3.267578125], [-4.79132080078125, 38.0285034179688], [-25.9120788574219, 3.2633056640625], [4.79132080078125, -38.0285034179688]];
			compcode02Path_newShape.outTangents = [[-3.267578125, 25.90771484375], [-38.0285339355469, 4.79132080078125], [3.26760864257812, -25.9077453613281], [38.0328063964844, -4.795654296875], [0, 0]];
			compcode02Path_newShape.closed = false;
		compcode02Path.setValue(compcode02Path_newShape);
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode02.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-0.10406875610352,-23.1513500213623,0]);
		compcode02.property("ADBE Transform Group").property("ADBE Position").setValue([399.895931243896,502.848649978638,0]);
		var compcode02Scale = compcode02.property("ADBE Transform Group").property("ADBE Scale");
			var compcode02Scale_keyTimesArray = [0,0.33333333333333,0.41666666666667,0.54166666666667];
			var compcode02Scale_valuesArray = [[110,110,100],[150,150,100],[150,150,100],[130,130,100]];
			compcode02Scale.setValuesAtTimes(compcode02Scale_keyTimesArray, compcode02Scale_valuesArray);
			var compcode02Scale_easeInSpeedArray = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			var compcode02Scale_easeInInfluArray = [[0.1,0.1,0.1],[100,100,100],[0.1,0.1,0.1],[0.1,0.1,0.1]];
			var compcode02Scale_easeOutSpeedArray = [[0,0,0],[0,0,0],[0,0,0],[0,0,0]];
			var compcode02Scale_easeOutInfluArray = [[0.1,0.1,0.1],[100,100,100],[100,100,100],[0.1,0.1,0.1]];
			var compcode02Scale_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode02Scale_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode02Scale, compcode02Scale_keyTimesArray, [compcode02Scale_easeInSpeedArray, compcode02Scale_easeInInfluArray], [compcode02Scale_easeOutSpeedArray, compcode02Scale_easeOutInfluArray], [compcode02Scale_keyInInterpolationType, compcode02Scale_keyOutInterpolationType]);

		compcode02.selected = false;
	// Add Shape Layer "@ 03", varName "compcode03";
	var compcode03 = compcode_comp.layers.addShape();
		compcode03.name = "@ 03";
		compcode03.inPoint = 0.58333333333333;
		compcode03.outPoint = 30;
		compcode03.moveToEnd();
		compcode03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode03.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode03Path = compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var compcode03Path_newShape = new Shape();
			compcode03Path_newShape.vertices = [[57.5516357421875, -15.5927124023438], [7.45413208007812, 34.5047607421875], [-57.7598266601562, -30.7091674804688], [-7.66229248046875, -80.8067016601562], [57.5516357421875, -15.5927734375]];
			compcode03Path_newShape.inTangents = [[0, 0], [25.9120788574219, -3.267578125], [-4.79132080078125, 38.0285034179688], [-25.9120788574219, 3.2633056640625], [4.79132080078125, -38.0285034179688]];
			compcode03Path_newShape.outTangents = [[-3.267578125, 25.90771484375], [-38.0285339355469, 4.79132080078125], [3.26760864257812, -25.9077453613281], [38.0328063964844, -4.795654296875], [0, 0]];
			compcode03Path_newShape.closed = false;
		compcode03Path.setValue(compcode03Path_newShape);
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode03.property("ADBE Root Vectors Group").property(2).name = "Group 2";
		compcode03.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Shape - Group");
		compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(1).name = "Path 1";
		var compcode03Path3 = compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(1).property("ADBE Vector Shape");
		var compcode03Path3_newShape = new Shape();
			compcode03Path3_newShape.vertices = [[-0.10404968261719, -201.496520996094], [-174.500015258789, -25.1279296875], [-0.10409545898438, 151.244995117188], [58.0264282226562, 141.170227050781], [58.0264282226562, 97.759033203125], [-1.83935546875, 112.055297851562], [-135.746368408203, -23.3711395263672], [-1.83935546875, -158.793273925781], [132.020126342773, -25.1279907226562], [132.063278198242, -23.3711395263672], [132.063278198242, 16.5393676757812], [114.421615600586, 34.1809844970703], [96.7800140380859, 16.539306640625], [96.7800140380859, -23.1553649902344], [96.7800140380859, -25.1280212402344], [96.7325286865234, -25.1280212402344], [-6.803466796875, -119.810852050781], [-96.7942199707031, -29.3970947265625], [-0.10858154296875, 73.7374267578125], [58.0219573974609, 54.3562469482422], [66.7974243164062, 47.3893890380859], [114.140975952148, 72.947509765625], [174.283004760742, 13.63427734375], [174.283004760742, -25.1324157714844], [-0.10430908203125, -201.496704101562]];
			compcode03Path3_newShape.inTangents = [[0, 0], [0, -97.4065551757812], [-96.3187561035156, 0], [-18.1854858398438, 6.5050048828125], [0, 0], [21.5221557617188, 0], [0, 74.7923431396484], [-73.9548950195312, 0], [-0.932373046875, -73.9765014648438], [0, -0.59138488769531], [0, 0], [9.742431640625, 0], [0, 9.742431640625], [0, 0], [0, 0], [0, 0], [55.8730163574219, -3.75967407226562], [3.01290893554688, -48.0341796875], [-55.5751342773438, 0], [-16.1912536621094, 12.1682891845703], [0, 0], [-23.356689453125, 0], [0, 33.189697265625], [0, 0], [96.3187713623047, 0]];
			compcode03Path3_newShape.outTangents = [[-96.3144683837891, 0], [0, 97.4108276367188], [20.3869018554688, 0], [0, 0], [-18.0171508789062, 9.1251220703125], [-73.9548950195312, 0], [0, -74.7923126220703], [73.3721313476562, 0], [0.00860595703125, 0.59136962890625], [0, 0], [0, 9.7467041015625], [-9.74664306640625, 0], [0, 0], [0, 0], [0, 0], [-1.1007080078125, -54.7981872558594], [-48.0255737304688, 3.22872924804688], [-3.53524780273438, 56.3391723632812], [21.8113555908203, 0], [0, 0], [9.522216796875, 14.9783477783203], [33.189697265625, 0], [0, 0], [0.00860595703125, -97.4022216796875], [0, 0]];
			compcode03Path3_newShape.closed = false;
		compcode03Path3.setValue(compcode03Path3_newShape);
		compcode03.property("ADBE Root Vectors Group").property(2).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(2).name = "Fill 1";
		compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode03.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([0,-22,0]);
		compcode03.property("ADBE Transform Group").property("ADBE Position").setValue([400,504,0]);
		var compcode03Scale = compcode03.property("ADBE Transform Group").property("ADBE Scale");
			var compcode03Scale_keyTimesArray = [0.58333333333333,0.91666666666667];
			var compcode03Scale_valuesArray = [[95,95,100],[100,100,100]];
			compcode03Scale.setValuesAtTimes(compcode03Scale_keyTimesArray, compcode03Scale_valuesArray);
			var compcode03Scale_easeInSpeedArray = [[0,0,0],[0,0,0]];
			var compcode03Scale_easeInInfluArray = [[0.1,0.1,0.1],[100,100,100]];
			var compcode03Scale_easeOutSpeedArray = [[0,0,0],[0,0,0]];
			var compcode03Scale_easeOutInfluArray = [[0.1,0.1,0.1],[0.1,0.1,0.1]];
			var compcode03Scale_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode03Scale_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode03Scale, compcode03Scale_keyTimesArray, [compcode03Scale_easeInSpeedArray, compcode03Scale_easeInInfluArray], [compcode03Scale_easeOutSpeedArray, compcode03Scale_easeOutInfluArray], [compcode03Scale_keyInInterpolationType, compcode03Scale_keyOutInterpolationType]);

		compcode03.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(2).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode_comp.openInViewer();

return {
	compItem : compcode_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

