// Created using compCode v2.0
// 201801030 from composition "£" in project "/HD 1/ANIMOGRAPHY/01 Typefaces/Utopian/Workfiles/JSX 3/Utopian JSX.aep"
//
// aescripts.com/compCode

// compcode();
function utopian_201801030_094309() {

// app.beginUndoGroup(File.decode("%C2%A3"));

try {

// ANIMATION PRESETS START
	// £ -> Controller -> Effects -> Utopian Controller;
	// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
	var ap_PE_UtopianController = File(File($.fileName).parent.parent.parent.fsName + "/Animation Presets" + "/" + "Utopian PE.ffx");
// ANIMATION PRESETS END

// CREATE FOLDER HIERARCHY START
	var utopian_folder_properties = {"name":"Utopian","typeName":"Folder","label":9,"comment":"Typeface Utopian [JSX]"};
	var utopian_folder = findProjectItem(app.project.rootFolder, false, utopian_folder_properties);
	if (utopian_folder === null) {
		utopian_folder = app.project.items.addFolder(utopian_folder_properties.name);
		utopian_folder.label = utopian_folder_properties.label;
		utopian_folder.comment = utopian_folder_properties.comment;
	}
	var specialCharacters_folder_properties = {"name":"05 Special Characters","typeName":"Folder","label":9,"comment":""};
	var specialCharacters_folder = findProjectItem(utopian_folder, false, specialCharacters_folder_properties);
	if (specialCharacters_folder === null) {
		specialCharacters_folder = app.project.items.addFolder(specialCharacters_folder_properties.name);
		specialCharacters_folder.label = specialCharacters_folder_properties.label;
		specialCharacters_folder.parentFolder = utopian_folder;
	}
	var solids_folder_properties = {"name":"Solids","typeName":"Folder","label":0,"comment":""};
	var solids_folder = findProjectItem(app.project.rootFolder, false, solids_folder_properties);
	if (solids_folder === null) {
		solids_folder = app.project.items.addFolder(solids_folder_properties.name);
		solids_folder.label = solids_folder_properties.label;
	}
// CREATE FOLDER HIERARCHY END

// CREATE COMPOSITIONS START
	var compcode_comp_properties = {"name":"£","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":7,"frameRate":24};
	var compcode_comp = app.project.items.addComp(compcode_comp_properties.name, compcode_comp_properties.width, compcode_comp_properties.height, 1, 30, 24);
		compcode_comp.time = 3.08333333333333;
		compcode_comp.bgColor = compcode_comp_properties.bgColor;
		compcode_comp.label = compcode_comp_properties.label;
		compcode_comp.resolutionFactor = [1, 1];
		compcode_comp.parentFolder = specialCharacters_folder;
	var utopianMetrics_comp_properties = {"name":"Utopian Metrics","typeName":"Composition","label":9,"comment":"","height":1000,"width":800,"pixelAspect":1,"bgColor":[0.85098039215686,0.85098039215686,0.85098039215686],"duration":30,"numLayers":8,"frameRate":24};
	var utopianMetrics_comp = findProjectItem(utopian_folder, false, utopianMetrics_comp_properties);
	var utopianMetrics_comp_populate = false;
	if (utopianMetrics_comp === null) {
		utopianMetrics_comp = app.project.items.addComp(utopianMetrics_comp_properties.name, utopianMetrics_comp_properties.width, utopianMetrics_comp_properties.height, 1, 30, 24);
		utopianMetrics_comp.time = 0.95833333333333;
		utopianMetrics_comp.bgColor = utopianMetrics_comp_properties.bgColor;
		utopianMetrics_comp.label = utopianMetrics_comp_properties.label;
		utopianMetrics_comp.resolutionFactor = [1, 1];
		utopianMetrics_comp.parentFolder = utopian_folder;
		utopianMetrics_comp_populate = true;
	}
// CREATE COMPOSITIONS END

// CREATE NULL LAYERS START
	var null10_null_properties = {"name":"Null 10","typeName":"Footage","comment":"","label":1,"height":100,"width":100,"mainSource":{"color":[1,1,1]}};
	var null10_null = findProjectItem(solids_folder, false, null10_null_properties);
	if (null10_null === null) {
		var null10_tempNull = compcode_comp.layers.addNull();
			null10_null = null10_tempNull.source;
			null10_null.name = null10_null_properties.name;
			null10_null.label = null10_null_properties.label;
			null10_null.mainSource.color = null10_null_properties.mainSource.color;
			null10_null.parentFolder = solids_folder;
		null10_tempNull.remove();
	}
// CREATE NULL LAYERS END

// Working with comp "£", varName "compcode_comp";
	compcode_comp.openInViewer();
	// Add existing composition "Utopian Metrics", varName "utopianMetrics_comp";
	var utopianMetrics = compcode_comp.layers.add(utopianMetrics_comp);
		utopianMetrics.label = 1;
		utopianMetrics.guideLayer = true;
		utopianMetrics.moveToEnd();
		utopianMetrics.property("ADBE Effect Parade").addProperty("ADBE Grid");
		utopianMetrics.property("ADBE Effect Parade").property(1).name = "Grid";
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([274.752990722656,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([525.247009277344,999]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([0,1,0.41999998688698,1]);
		utopianMetrics.property("ADBE Effect Parade").property(1).property("ADBE Grid-0014").setValue(2);
		utopianMetrics.selected = false;
	//Create new Null layer "controller" and replace its source with varName "null10_null";
	var controller = compcode_comp.layers.addNull();
	var controller_source = controller.source;
		controller.replaceSource(null10_null, true);
		controller_source.remove();
		controller.name = "Controller";
		controller.label = 9;
		controller.enabled = false;
		controller.moveToEnd();
		///// Placeholder for ANIMATION PRESET - START
		///// Pseudo Effect "Utopian Controller" (Pseudo/PSE Effect Name)
			if (!controller.property("ADBE Effect Parade").canAddProperty("Pseudo/PSE Effect Name")) {
				if (typeof ap_PE_UtopianController !== "undefined" && ap_PE_UtopianController.exists) {
					makePseudoEffectLive(ap_PE_UtopianController);
				} else {
					alert("Cannot apply \"Utopian Controller\" (Pseudo/PSE Effect Name) effect to layer \"" + controller.name + "\" because you don't have this effect installed on your system.");
					return;
				}
			}
			controller.property("ADBE Effect Parade").addProperty("Pseudo/PSE Effect Name");
		///// Placeholder for ANIMATION PRESET - END
		controller.property("ADBE Effect Parade").property(1).name = "Utopian Controller";
		controller.property("ADBE Transform Group").property("ADBE Position").setValue([960,960,0]);
		controller.selected = false;
	// Add Shape Layer "£ 01", varName "compcode01";
	var compcode01 = compcode_comp.layers.addShape();
		compcode01.name = File.decode("%C2%A3%2001");
		compcode01.outPoint = 0.58333333333333;
		compcode01.moveToEnd();
		compcode01.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode01.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode01Path = compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode01Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode01Path_object = {};
				compcode01Path_object.closed = true;
				compcode01Path_object.vertices = [[[75.7577972412109, 38.0000305175781], [75.7577972412109, 156.75], [-71.7578277587891, 156.75], [-71.7578277587891, 36.2499694824219]], [[106.757797241211, 38.0000305175781], [106.757797241211, 156.5], [15.2421722412109, 156.5], [15.2421722412109, 37.8749694824219]], [[106.757797241211, 38.0000305175781], [106.757797241211, 156.5], [15.2421722412109, 156.5], [15.2421722412109, 37.8749694824219]], [[103.757797241211, 38.0000305175781], [103.757797241211, 156.5], [-10.7578277587891, 156.5], [-10.7578277587891, 37.8749694824219]]];
			addShapeKeyframes(compcode01Path, compcode01Path_keyTimesArray, compcode01Path_object);
			var compcode01Path_easeInSpeedArray = [0,0,0,0];
			var compcode01Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var compcode01Path_easeOutSpeedArray = [0,0,0,0];
			var compcode01Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var compcode01Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode01Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode01Path, compcode01Path_keyTimesArray, [compcode01Path_easeInSpeedArray, compcode01Path_easeInInfluArray], [compcode01Path_easeOutSpeedArray, compcode01Path_easeOutInfluArray], [compcode01Path_keyInInterpolationType, compcode01Path_keyOutInterpolationType]);

		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.00392156885937,0.45882353186607,0.73725491762161,1]);
		compcode01.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		compcode01.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode01.property("ADBE Transform Group").property("ADBE Position").setValue([406.726583437008,497,0]);
		compcode01.property("ADBE Transform Group").property("ADBE Scale").setValue([-100,100,100]);
		compcode01.selected = false;
	// Add Shape Layer "£ 02", varName "compcode02";
	var compcode02 = compcode_comp.layers.addShape();
		compcode02.name = File.decode("%C2%A3%2002");
		compcode02.outPoint = 0.58333333333333;
		compcode02.moveToEnd();
		compcode02.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode02.property("ADBE Root Vectors Group").property(1).name = "Rectangle 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape Direction").setValue(2);
		var compcode02Path = compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode02Path_keyTimesArray = [0, 0.33333333333333, 0.41666666666667, 0.54166666666667];
			var compcode02Path_object = {};
				compcode02Path_object.closed = true;
				compcode02Path_object.vertices = [[[75.7577972412109, -153], [75.7577972412109, 38.0000305175781], [-71.7578277587891, 36.2499694824219], [-71.7578277587891, -153]], [[106.757797241211, -153], [106.757797241211, 39.0000305175781], [15.2421722412109, 38.4999694824219], [15.2421722412109, -153]], [[106.757797241211, -153], [106.757797241211, 39.0000305175781], [15.2421722412109, 38.4999694824219], [15.2421722412109, -153]], [[103.757797241211, -153], [103.757797241211, 39.0000305175781], [7.24217224121094, 38.4999694824219], [7.24217224121094, -153]]];
			addShapeKeyframes(compcode02Path, compcode02Path_keyTimesArray, compcode02Path_object);
			var compcode02Path_easeInSpeedArray = [0,0,0,0];
			var compcode02Path_easeInInfluArray = [16.666666667,100,100,0.1];
			var compcode02Path_easeOutSpeedArray = [0,0,0,0];
			var compcode02Path_easeOutInfluArray = [0.1,100,100,16.666666667];
			var compcode02Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode02Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode02Path, compcode02Path_keyTimesArray, [compcode02Path_easeInSpeedArray, compcode02Path_easeInInfluArray], [compcode02Path_easeOutSpeedArray, compcode02Path_easeOutInfluArray], [compcode02Path_keyInInterpolationType, compcode02Path_keyOutInterpolationType]);

		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Width").setValue(40);
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").setValue([0.99607849121094,0.79607849121094,0,1]);
		compcode02.property("ADBE Root Vectors Group").property(1).property(3).property("ADBE Vector Position").setValue([-74.2421875,-29]);
		compcode02.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([-74.2421875,-29,0]);
		compcode02.property("ADBE Transform Group").property("ADBE Position").setValue([406.726583437008,497,0]);
		compcode02.property("ADBE Transform Group").property("ADBE Scale").setValue([-100,100,100]);
		compcode02.selected = false;
	// Add Shape Layer "£ 04", varName "compcode04";
	var compcode04 = compcode_comp.layers.addShape();
		compcode04.name = File.decode("%C2%A3%2004");
		compcode04.inPoint = 0.58333333333333;
		compcode04.outPoint = 30;
		compcode04.moveToEnd();
		compcode04.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode04.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode04Path = compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode04Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode04Path_object = {};
				compcode04Path_object.closed = true;
				compcode04Path_object.vertices = [[[107.751037597656, 19.8672332763672], [107.751037597656, 28.7478485107422], [107.751037597656, 28.8672332763672], [134.438720703125, 28.8672332763672], [134.438720703125, 19.8672332763672]], [[107.751037597656, 19.8672332763672], [107.751037597656, 28.7478485107422], [107.751037597656, 28.8672332763672], [134.438720703125, 28.8672332763672], [134.438720703125, 19.8672332763672]]];
			addShapeKeyframes(compcode04Path, compcode04Path_keyTimesArray, compcode04Path_object);
			var compcode04Path_easeInSpeedArray = [0,0];
			var compcode04Path_easeInInfluArray = [0.1,100];
			var compcode04Path_easeOutSpeedArray = [0,0];
			var compcode04Path_easeOutInfluArray = [0.1,0.1];
			var compcode04Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode04Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode04Path, compcode04Path_keyTimesArray, [compcode04Path_easeInSpeedArray, compcode04Path_easeInInfluArray], [compcode04Path_easeOutSpeedArray, compcode04Path_easeOutInfluArray], [compcode04Path_keyInInterpolationType, compcode04Path_keyOutInterpolationType]);

		compcode04.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.99609375,0.796875,0,1]);
		compcode04.property("ADBE Transform Group").property("ADBE Position").setValue([-122.5,434,0]);
		compcode04.property("ADBE Transform Group").property("ADBE Scale").setValue([430,430,100]);
		compcode04.selected = false;
	// Add Shape Layer "£ 05", varName "compcode05";
	var compcode05 = compcode_comp.layers.addShape();
		compcode05.name = File.decode("%C2%A3%2005");
		compcode05.inPoint = 0.58333333333333;
		compcode05.outPoint = 30;
		compcode05.moveToEnd();
		compcode05.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode05.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 1";
		var compcode05Path = compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode05Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode05Path_object = {};
				compcode05Path_object.closed = true;
				compcode05Path_object.vertices = [[[134.676818847656, -3.75019836425781], [121.363830566406, -16.2521514892578], [108.050842285156, -3.75019836425781], [108.007873535156, -2.89619445800781], [115.044372558594, 10.8672332763672], [126.900512695312, 10.8672332763672]], [[134.676818847656, -3.75019836425781], [121.363830566406, -16.2521514892578], [108.050842285156, -3.75019836425781], [108.007873535156, -2.89619445800781], [115.044372558594, 10.8672332763672], [126.900512695312, 10.8672332763672]]];
				compcode05Path_object.inTangents = [[[0, 0], [7.087890625, 0], [0.4423828125, -6.9765625], [0, -0.2880859375], [-2.80120849609375, -3.02783203125], [0, 0]], [[0, 0], [7.087890625, 0], [0.4423828125, -6.9765625], [0, -0.2880859375], [-2.80120849609375, -3.02783203125], [0, 0]]];
				compcode05Path_object.outTangents = [[[-0.4423828125, -6.9765625], [-7.087890625, 0], [-0.01806640625, 0.28369140625], [0, 5.38525390625], [0, 0], [0, 0]], [[-0.4423828125, -6.9765625], [-7.087890625, 0], [-0.01806640625, 0.28369140625], [0, 5.38525390625], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode05Path, compcode05Path_keyTimesArray, compcode05Path_object);
			var compcode05Path_easeInSpeedArray = [0,0];
			var compcode05Path_easeInInfluArray = [0.1,100];
			var compcode05Path_easeOutSpeedArray = [0,0];
			var compcode05Path_easeOutInfluArray = [0.1,0.1];
			var compcode05Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode05Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode05Path, compcode05Path_keyTimesArray, [compcode05Path_easeInSpeedArray, compcode05Path_easeInInfluArray], [compcode05Path_easeOutSpeedArray, compcode05Path_easeOutInfluArray], [compcode05Path_keyInInterpolationType, compcode05Path_keyOutInterpolationType]);

		compcode05.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0.1328125,0.5078125,1,1]);
		compcode05.property("ADBE Transform Group").property("ADBE Position").setValue([-122.5,434,0]);
		compcode05.property("ADBE Transform Group").property("ADBE Scale").setValue([430,430,100]);
		compcode05.selected = false;
	// Add Shape Layer "£ 03", varName "compcode03";
	var compcode03 = compcode_comp.layers.addShape();
		compcode03.name = File.decode("%C2%A3%2003");
		compcode03.inPoint = 0.58333333333333;
		compcode03.outPoint = 30;
		compcode03.moveToEnd();
		compcode03.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		compcode03.property("ADBE Root Vectors Group").property(1).name = "Group 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "Path 3";
		var compcode03Path = compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
			var compcode03Path_keyTimesArray = [0.58333333333333, 0.91666666666667];
			var compcode03Path_object = {};
				compcode03Path_object.closed = true;
				compcode03Path_object.vertices = [[[142.508483886719, 10.8672332763672], [135.180480957031, 10.8672332763672], [135.222595214844, 10.7876434326172], [142.908203125, -3.75019836425781], [121.363830566406, -25.2521514892578], [99.3289489746094, -2.75215148925781], [103.632171630859, 10.4753875732422], [103.895294189453, 10.8672332763672], [99.0335998535156, 10.8672332763672], [99.0335998535156, 37.8672332763672], [113.41162109375, 37.8672332763672], [99.2571716308594, 46.7478485107422], [99.2571716308594, 46.8271942138672], [98.9687194824219, 46.8271942138672], [98.9687194824219, 55.8271942138672], [142.573364257812, 55.8271942138672], [142.573364257812, 46.8271942138672], [116.868713378906, 46.7478485107422], [123.854858398438, 37.8672332763672], [142.508483886719, 37.8672332763672]], [[143.438720703125, 10.8672332763672], [136.110717773438, 10.8672332763672], [136.15283203125, 10.7876434326172], [143.838439941406, -3.75019836425781], [121.363830566406, -25.2521514892578], [98.8638305664062, -2.75215148925781], [103.167053222656, 10.4753875732422], [103.43017578125, 10.8672332763672], [98.5684814453125, 10.8672332763672], [98.5684814453125, 37.8672332763672], [113.41162109375, 37.8672332763672], [98.7920532226562, 46.7478485107422], [98.7920532226562, 46.8271942138672], [98.5036010742188, 46.8271942138672], [98.5036010742188, 55.8271942138672], [143.503601074219, 55.8271942138672], [143.503601074219, 46.8271942138672], [116.868713378906, 46.7478485107422], [123.854858398438, 37.8672332763672], [143.438720703125, 37.8672332763672]]];
				compcode03Path_object.inTangents = [[[0, 0], [0, 0], [0, 0], [0, 0], [12.091796875, 0], [0, -12.42626953125], [-2.70361328125, -3.71337890625], [-0.0860595703125, -0.13330078125], [0, 0], [0, 0], [0, 0], [6.3052978515625, -1.711181640625], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-1.39495849609375, 3.342041015625], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, 0], [12.091796875, 0], [0, -12.42626953125], [-2.70361328125, -3.71337890625], [-0.0860595703125, -0.13330078125], [0, 0], [0, 0], [0, 0], [6.3052978515625, -1.711181640625], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [-1.39495849609375, 3.342041015625], [0, 0]]];
				compcode03Path_object.outTangents = [[[0, 0], [0, 0], [0, 0], [0, -12.422607421875], [-12.42626953125, 0], [0, 4.94482421875], [0.08447265625, 0.135986328125], [0, 0], [0, 0], [0, 0], [-3.0711669921875, 3.825927734375], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [3.2425537109375, -2.43310546875], [0, 0], [0, 0]], [[0, 0], [0, 0], [0, 0], [0, -12.422607421875], [-12.42626953125, 0], [0, 4.94482421875], [0.08447265625, 0.135986328125], [0, 0], [0, 0], [0, 0], [-3.0711669921875, 3.825927734375], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [3.2425537109375, -2.43310546875], [0, 0], [0, 0]]];
			addShapeKeyframes(compcode03Path, compcode03Path_keyTimesArray, compcode03Path_object);
			var compcode03Path_easeInSpeedArray = [0,0];
			var compcode03Path_easeInInfluArray = [0.1,100];
			var compcode03Path_easeOutSpeedArray = [0,0];
			var compcode03Path_easeOutInfluArray = [0.1,0.1];
			var compcode03Path_keyInInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			var compcode03Path_keyOutInterpolationType = [KeyframeInterpolationType.BEZIER,KeyframeInterpolationType.BEZIER];
			applyEasing(compcode03Path, compcode03Path_keyTimesArray, [compcode03Path_easeInSpeedArray, compcode03Path_easeInInfluArray], [compcode03Path_easeOutSpeedArray, compcode03Path_easeOutInfluArray], [compcode03Path_keyInInterpolationType, compcode03Path_keyOutInterpolationType]);

		compcode03.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Fill 1";
		compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").setValue([0,0,0,1]);
		compcode03.property("ADBE Transform Group").property("ADBE Position").setValue([-122.5,434,0]);
		compcode03.property("ADBE Transform Group").property("ADBE Scale").setValue([430,430,100]);
		compcode03.selected = false;
// Working with comp "Utopian Metrics", varName "utopianMetrics_comp";
if (utopianMetrics_comp_populate === true) {
	// Add Shape Layer "A Outlines", varName "aOutlines";
	var aOutlines = utopianMetrics_comp.layers.addShape();
		aOutlines.name = "A Outlines";
		aOutlines.guideLayer = true;
		aOutlines.moveToEnd();
		aOutlines.property("ADBE Root Vectors Group").addProperty("ADBE Vector Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).name = "A";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Shape - Group");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).name = "A";
		var aOutlinesPath = aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(1).property("ADBE Vector Shape");
		var aOutlinesPath_newShape = new Shape();
			aOutlinesPath_newShape.vertices = [[21.8771667480469, -326.379364013672], [1.01065063476562, -373.302429199219], [-19.8558654785156, -326.379364013672], [-154.971496582031, -22.5914611816406], [156.985198974609, -22.5914611816406]];
			aOutlinesPath_newShape.closed = true;
		aOutlinesPath.setValue(aOutlinesPath_newShape);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Stroke");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).name = "Stroke 1";
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).enabled = false;
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").setValue([0,0,0,1]);
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).addProperty("ADBE Vector Graphic - Fill");
		aOutlines.property("ADBE Root Vectors Group").property(1).property(2).property(3).name = "Fill 1";
		aOutlines.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([1.00685119628906,-197.94694519043,0]);
		aOutlines.property("ADBE Transform Group").property("ADBE Opacity").setValue(50);
		aOutlines.selected = false;
	// Add Shape Layer "Settings", varName "settings";
	var settings = utopianMetrics_comp.layers.addShape();
		settings.name = "Settings";
		settings.label = 2;
		settings.moveToEnd();
		settings.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		settings.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		settings.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(1).name = "Font Size";
		settings.property("ADBE Effect Parade").property(1).property("ADBE Slider Control-0001").setValue(498);
		settings.property("ADBE Effect Parade").addProperty("ADBE Slider Control");
		settings.property("ADBE Effect Parade").property(2).name = "Default Space";
		settings.property("ADBE Effect Parade").property(2).property("ADBE Slider Control-0001").setValue(142.427993774414);
		settings.selected = false;
	// Add Shape Layer "Grid", varName "grid";
	var grid = utopianMetrics_comp.layers.addShape();
		grid.name = "Grid";
		grid.label = 1;
		grid.moveToEnd();
		grid.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		grid.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		grid.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([0,0]);
		grid.property("ADBE Effect Parade").addProperty("ADBE Grid");
		grid.property("ADBE Effect Parade").property(1).name = "Grid";
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0001").setValue([244.02165222168,1]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0003").setValue([555.978332519531,999]);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0006").setValue(1);
		grid.property("ADBE Effect Parade").property(1).property("ADBE Grid-0012").setValue([1,0,0.30000001192093,1]);
		grid.selected = false;
	// Add Shape Layer "Caps", varName "caps";
	var caps = utopianMetrics_comp.layers.addShape();
		caps.name = "Caps";
		caps.label = 1;
		caps.moveToEnd();
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		caps.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		caps.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		caps.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		caps.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		caps.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		caps.property("ADBE Transform Group").property("ADBE Position").setValue([400,326,0]);
		caps.selected = false;
	// Add Shape Layer "Baseline", varName "baseline";
	var baseline = utopianMetrics_comp.layers.addShape();
		baseline.name = "Baseline";
		baseline.label = 1;
		baseline.moveToEnd();
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		baseline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		baseline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		baseline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		baseline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		baseline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([1,0,0.30000001192093,1]);
		baseline.property("ADBE Transform Group").property("ADBE Position").setValue([400,674,0]);
		baseline.selected = false;
	// Add Shape Layer "Ascender", varName "ascender";
	var ascender = utopianMetrics_comp.layers.addShape();
		ascender.name = "Ascender";
		ascender.moveToEnd();
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		ascender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		ascender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		ascender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		ascender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		ascender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		ascender.property("ADBE Transform Group").property("ADBE Position").setValue([400,100,0]);
		ascender.selected = false;
	// Add Shape Layer "Midline", varName "midline";
	var midline = utopianMetrics_comp.layers.addShape();
		midline.name = "Midline";
		midline.moveToEnd();
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		midline.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		midline.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		midline.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		midline.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		midline.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		midline.selected = false;
	// Add Shape Layer "Descender", varName "descender";
	var descender = utopianMetrics_comp.layers.addShape();
		descender.name = "Descender";
		descender.moveToEnd();
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Shape - Rect");
		descender.property("ADBE Root Vectors Group").property(1).name = "Rectangle Path 1";
		descender.property("ADBE Root Vectors Group").property(1).property("ADBE Vector Rect Size").setValue([800,1]);
		descender.property("ADBE Root Vectors Group").addProperty("ADBE Vector Graphic - Fill");
		descender.property("ADBE Root Vectors Group").property(2).name = "Fill 1";
		descender.property("ADBE Root Vectors Group").property(2).property("ADBE Vector Fill Color").setValue([0,0.64999997615814,1,1]);
		descender.property("ADBE Transform Group").property("ADBE Position").setValue([400,900,0]);
		descender.selected = false;
}

// Remove empty Solids folder
	var tempNullComp = app.project.items.addComp("tempNullComp", 100, 100, 1, 1, 24);
	var tempNullLayer = tempNullComp.layers.addNull();
	var nullFolder = tempNullLayer.source.parentFolder;
		tempNullLayer.source.remove();
		tempNullComp.remove();
	if (nullFolder.numItems === 0)
		nullFolder.remove();


	// Apply expressions to properties
		try {
			compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode01.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Stroke Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode02.property("ADBE Root Vectors Group").property(1).property(2).property(3).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode04.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 02\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode05.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 01\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}
		try {
			compcode03.property("ADBE Root Vectors Group").property(1).property(2).property(2).property("ADBE Vector Fill Color").expression = "try{" + "\n" + 
				"var FM_controllerComp = thisComp;" + "\n" + 
				"var FM_controllerLayer = FM_controllerComp.layer(\"Controller\");" + "\n" + 
				"FM_controllerLayer.effect(\"Utopian Controller\")(\"Color 04\")" + "\n" + 
				"}catch(e){ value }";
		} catch (err) {}

compcode_comp.openInViewer();

return {
	compItem : compcode_comp
};

} catch (e) {
	alert (e.toString() + "\nScript File: " + File.decode(e.fileName).replace(/^.*[\|\/]/, '') + 
		"\nFunction: " + arguments.callee.name + 
		"\nError on Line: " + e.line.toString());
}
// app.endUndoGroup();


function findProjectItem(searchFolder, recursion, userData) {
	var folderItem;
	for (var i = 1, il = searchFolder.items.length; i <= il; i++) {
		folderItem = searchFolder.items[i];
			if (propertiesMatch(folderItem, userData))
				return folderItem;
			else if (recursion === true && folderItem instanceof FolderItem && folderItem.numItems > 0) {
				var item = findProjectItem(folderItem, recursion, userData);
				if (item !== null) return item;
			}
		}
	return null;
}

function propertiesMatch(projectItem, userData) {
	if (typeof userData === "undefined") return true;

	for (var propertyName in userData) {
		if (!userData.hasOwnProperty(propertyName)) continue;

		if (typeof userData[propertyName] !== typeof projectItem[propertyName])
			return false;

		if (isArray(userData[propertyName]) && isArray(projectItem[propertyName])) {
			if (userData[propertyName].toString() !== projectItem[propertyName].toString()) {
				return false;
			}
		} else if (typeof userData[propertyName] === "object" && typeof projectItem[propertyName] === "object") {
			if (!propertiesMatch(projectItem[propertyName], userData[propertyName])) {
				return false;
			}
		} else if (projectItem[propertyName] !== userData[propertyName]) {
			return false;
		}
	}
	return true;
}

function isArray(object) {
	return Object.prototype.toString.apply(object) === "[object Array]";
}

function applyEasing(property, keyTimesArray, easeInArray, easeOutArray, keyInterpolationArray) {
	var easeIn, easeOut, easeIn0, easeOut0, easeIn1, easeOut1, easeIn2, easeOut2;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		if (property.propertyValueType === PropertyValueType.TwoD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1], [easeOut0, easeOut1]);
		} else if (property.propertyValueType === PropertyValueType.ThreeD) {
			easeIn0 = new KeyframeEase(easeInArray[0][i][0], easeInArray[1][i][0]);
			easeOut0 = new KeyframeEase(easeOutArray[0][i][0], easeOutArray[1][i][0]);
			easeIn1 = new KeyframeEase(easeInArray[0][i][1], easeInArray[1][i][1]);
			easeOut1 = new KeyframeEase(easeOutArray[0][i][1], easeOutArray[1][i][1]);
			easeIn2 = new KeyframeEase(easeInArray[0][i][2], easeInArray[1][i][2]);
			easeOut2 = new KeyframeEase(easeOutArray[0][i][2], easeOutArray[1][i][2]);
			property.setTemporalEaseAtKey(i+1, [easeIn0, easeIn1, easeIn2], [easeOut0, easeOut1, easeOut2]);
		} else {
			easeIn = new KeyframeEase(easeInArray[0][i], easeInArray[1][i]);
			easeOut = new KeyframeEase(easeOutArray[0][i], easeOutArray[1][i]);
			if (keyInterpolationArray[1][i] !== KeyframeInterpolationType.HOLD) {
				property.setTemporalEaseAtKey(i+1, [easeIn], [easeOut]);
			} else {
				property.setTemporalEaseAtKey(i+1, [easeIn]);
			}
		}
		property.setInterpolationTypeAtKey(i+1, keyInterpolationArray[0][i], keyInterpolationArray[1][i]);
	}
}

function addShapeKeyframes(myPath, keyTimesArray, myShapeObject) {
	var valuesArray = [], newShape;
	for (var i = 0, il = keyTimesArray.length; i < il; i ++) {
		newShape = new Shape();
		for (var prop in myShapeObject) {
			if (myShapeObject[prop] instanceof Array) { newShape[prop] = myShapeObject[prop][i]; }
			else { newShape[prop] = myShapeObject[prop]; }
		}
		valuesArray.push(newShape);
	}
	myPath.setValuesAtTimes(keyTimesArray, valuesArray);
}

function makePseudoEffectLive(pathToFFX) {
	var tempComp = app.project.items.addComp("tempComp", 100, 100, 1, 1, 24);
	var tempLayer = tempComp.layers.addShape();
		tempLayer.applyPreset(File(pathToFFX));
	tempComp.remove();
}
}

